package composant_saisie.wCalendar;

import java.util.ArrayList;
import java.util.Date;

import a_doc.doc.Licence;

import composant_saisie.wPtime.Day;
import composant_saisie.wSaisieFormat.CcsFmt;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class CalendarValues{
	ArrayList<Day> calendarDays;
	ArrayList<Object> calendarValues;
	ArrayList<Object> calendarValueWeeks;
	Day dayMonth;
	Day dayTmp;
	int daysBefore;
	int type=JPCalendar.DAY;
	JTableCalendar jtc=null;
	LinkTableDate linktable=null;
	int week=0;
	int day=0;
	public CalendarValues(JTableCalendar jtc) {
		this.jtc=jtc;
		this.type=jtc.type;	
		this.linktable=jtc.lt;
		dayMonth=new Day();
		dayTmp=new Day();
		createCalendarDaysValues();
	}
	private void createCalendarDaysValues() {
		calendarDays = new ArrayList<Day>();
		calendarValues = new ArrayList<Object>();
		calendarValueWeeks = new ArrayList<Object>();
		linktable.resetValueForWeek();
		week=0;
		day=0;
		switch (type){
		case JPCalendar.DAY:
			fillBefore();
			fillCurrent();
			fillAfter();
			break;
		case JPCalendar.MONTH:
			fillCurrentMonth();
			break;
		}
	}
	private void fillBefore() {
		// on dmarre au 1 du mois choisi
		dayTmp.set(dayMonth.getYear(), dayMonth.getMonth(), 1);
		daysBefore = dayTmp.getDayOfWeek() - dayTmp.getFirstDayOfWeek();
		if (daysBefore < 0) {
			daysBefore += jtc.nbDayofWeek;
		}
		dayTmp.addDay(-daysBefore);
		for (int i = 0; i < daysBefore; i++) {
			addValue(true);
			dayTmp.addDay( 1);
		}
	}
	private void fillCurrent() {
		dayTmp.set(dayMonth.getYear(), dayMonth.getMonth(), dayMonth.getDate());
		int daysCurrent = dayMonth.getActualMaximum();
		for (int i = 0; i < daysCurrent; i++) {
			int day = i + 1;
			dayTmp.setDate(day);
			addValue(false);
		}
	}
	private void fillAfter() {
		int daysCurrent = dayMonth.getActualMaximum();
		int daysAfter = (jtc.nbDayofWeek*jtc.nbWeek) - daysBefore - daysCurrent;
		dayTmp.set(dayMonth.getYear(), dayMonth.getMonth(), daysCurrent);
		dayTmp.addDay( 1);
		for (int i = 0; i < daysAfter; i++) {
			addValue(true);
			dayTmp.addDay( 1);
		}
	}
	private void fillCurrentMonth() {
		for (int i = 0; i < 12; i++) {
			dayTmp.set(dayMonth.getYear(), i,1);
			addValue(false);
		}
	}
	private void addValue(boolean isOutMonth){
		calendarDays.add(new Day(dayTmp.getDateOnly(),isOutMonth));
		calendarValues.add(linktable.getValueForDate(dayTmp));
		day++;
		if (day<jtc.nbDayofWeek){
		} else {
			day=0;
			week++;
			calendarValueWeeks.add(linktable.getValueForWeek());
		}
	}
	/////////////////////////
	public void nextMonth() {
		dayMonth.addMonth(1);
		createCalendarDaysValues();
	}
	public void previousMonth() {
		dayMonth.addMonth(-1);
		createCalendarDaysValues();
	}
	public void nextYear() {
		dayMonth.addYear(1);
		createCalendarDaysValues();
	}
	public void previousYear() {
		dayMonth.addYear(-1);
		createCalendarDaysValues();
	}
	public boolean setCurrentMonth(Date date) {
		boolean ret=true; // Changement de mois
		Day tmpdate=new Day();
		tmpdate.setTime(date.getTime());
		if (tmpdate.getSMonthSYear().equals(dayMonth.getSMonthSYear())){
			dayMonth.setTime(date.getTime());
			ret=false;
		} else {
			dayMonth.setTime(date.getTime());
			createCalendarDaysValues();
		}
		return ret;
	}
	///////////////////////////////
	public String getSelectedDate() {
		return Day.geSDate(dayMonth.getDateOnly());
	}
	public int getSelectedWeek() {
		return Day.getWeekOfYear(dayMonth.getDateOnly(), dayMonth.getYear());
	}
	public String getDisplayMonth() {
		return Day.getStrMonthYear(dayMonth.getDateOnly());
	}
	public int getMonth() {
		return Day.getMonth(dayMonth.getDateOnly())+1;
	}
	public Object getCalendarValue(int index){
		return calendarValues.get(index);
	}
	public Day getCalendarDay(int index){
		return calendarDays.get(index);
	}
	public Object getWeek(int index){
		return CcsFmt.ligLig(""+((Day)calendarDays.get(index)).getWeekOfYear(dayMonth.getYear()),2);
	}
	public Object getTotWeek(int row) {
		return calendarValueWeeks.get(row);
	}
	public ArrayList<Day> getWeekInMonth() {
		ArrayList <Day>  weekInMonth=new ArrayList <Day>();
		for (int i=0;i<calendarDays.size();i++){
			Day tmpJour=calendarDays.get(i);
			if (tmpJour.getSMonthSYear().equals(dayMonth.getSMonthSYear())){ // Mettre  jour que les jours du mois
				if (getSelectedWeek()==tmpJour.getWeekOfYear( tmpJour.getYear() ) ){
					weekInMonth.add(tmpJour);
				}
			}
		}
		return weekInMonth;
	}
	public ArrayList<Day> getDaysInMonth() {
		ArrayList <Day>  daysInMonth=new ArrayList <Day>(32);
		for (int i=0;i<calendarDays.size();i++){
			Day tmpJour=calendarDays.get(i);
			if (tmpJour.getSMonthSYear().equals(dayMonth.getSMonthSYear())){ // Mettre  jour que les jours du mois
				daysInMonth.add(tmpJour);
			}
		}
		return daysInMonth;
	}
	public void dispose() {
		if (calendarDays!=null){
			calendarDays.clear();
			calendarDays=null;
		}
		if (calendarValues!=null){
			calendarValues.clear();
			calendarValues=null;
		}
		if (calendarValueWeeks!=null){
			calendarValueWeeks.clear();
			calendarValueWeeks=null;
		}
		dayMonth=null;
		dayTmp=null;
		jtc=null;
		linktable=null;
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}