package composant_saisie.wCalendar;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.Date;
import java.util.Set;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.KeyStroke;
import javax.swing.SwingConstants;

import persistance.wGlobalParam.Gp;
import template_applicatif.wVue.VueIMoveListener;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JButtonArrow;
import composant_saisie.wComposant.JPopup;
import composant_saisie.wComposant.JTextLabel;
import composant_saisie.wPtime.Day;
import composant_saisie.wPtime.ListDate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JPCalendar extends JPanel implements ActionListener, VueIMoveListener, KeyListener, LinkTableDate, PropertyChangeListener {
	static final long serialVersionUID = 1L;
	public JTableCalendar dateTable;
	public JTextLabel head;
	JPanel headPanel;
	JButtonArrow btPreviousMonth;
	JButtonArrow btNextMonth;
	JButtonArrow btPreviousYear;
	JButtonArrow btNextYear;
	ListDate listDate=null;

	public static final int DAY=0;
	public static final int MONTH=1;
	
	public static final int AT_SDAY=0;
	public static final int AT_SMONTH=1;
	public static final int AT_SDATE=2;
	public static final int AT_SPOINTAGE=50;

	public JPCalendar() {
		adapte();
	}
	private void adapte() {
		this.setLayout(new BorderLayout(0,0));{
			dateTable = new JTableCalendar();{
				dateTable.setForcedFocus(false);
				listDate=new ListDate();{
					dateTable.setListDate(listDate);
				}
				dateTable.addKeyListener(this);
				dateTable.setPanelToNotify(this);
			}
			this.add(new JScrollPane(dateTable), BorderLayout.CENTER);
		}
		this.setBorder(BorderFactory.createLineBorder(Color.GRAY));
		this.addPropertyChangeListener(JTableCalendar.SELECTEDDATE,this);
	}
	public void setType(int type,int attribut) {
		setType(type, attribut,this);
	}
	public void setType(int type,int attribut,LinkTableDate lt){
		dateTable.setType(type, attribut,lt);
		adapteTitre();{
			switch (type){
			case JPCalendar.DAY:
				btPreviousMonth.setVisible(true);
				btNextMonth.setVisible(true);
				break;
			case JPCalendar.MONTH:
				btPreviousMonth.setVisible(false);
				btNextMonth.setVisible(false);
				break;
			}
			switch (attribut){
			case JPCalendar.AT_SPOINTAGE:
				btPreviousMonth.setVisible(false);
				btNextMonth.setVisible(false);
				btPreviousYear.setVisible(false);
				btNextYear.setVisible(false);
				break;
			}
		}
		dateTable.setListDate(listDate);
	}
	private void adapteTitre(){
		headPanel = new JPanel(new BorderLayout(0,0));{
			head = new JTextLabel();{
				head.adapteTitre();
			}
			Dimension preferredButtonDim= new Dimension(Gp.HEIGHTCHAR+4,Gp.HEIGHTCHAR+4);
			JPanel pprevious=new JPanel(new FlowLayout(0,0,0));{
				btPreviousYear = new JButtonArrow();{
					btPreviousYear.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_END,0), "");
					btPreviousYear.setPreferredSize(preferredButtonDim);
					btPreviousYear.setFleche(SwingConstants.SOUTH,JButtonArrow.END);
					btPreviousYear.setFocusable(false);
					btPreviousYear.setMargin(new Insets(0, 0, 0, 0));
					btPreviousYear.addActionListener(this);
				}
				btPreviousMonth = new JButtonArrow();{
					btPreviousMonth.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_PAGE_DOWN,0), "");
					btPreviousMonth.setPreferredSize(preferredButtonDim);
					btPreviousMonth.setFleche(SwingConstants.SOUTH,JButtonArrow.PAGE);
					btPreviousMonth.setFocusable(false);
					btPreviousMonth.setMargin(new Insets(0, 0, 0, 0));
					btPreviousMonth.addActionListener(this);
				}
				pprevious.add(btPreviousYear);
				pprevious.add(btPreviousMonth);
			}
			JPanel pnext=new JPanel(new FlowLayout(0,0,0));{
				btNextYear = new JButtonArrow();{
					btNextYear.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_HOME,0), "");
					btNextYear.setPreferredSize(preferredButtonDim);
					btNextYear.setFleche(SwingConstants.NORTH,JButtonArrow.END);
					btNextYear.setFocusable(false);
					btNextYear.setMargin(new Insets(0, 0, 0, 0));
					btNextYear.addActionListener(this);
				}
				btNextMonth = new JButtonArrow();{
					btNextMonth.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_PAGE_UP,0), "");
					btNextMonth.setPreferredSize(preferredButtonDim);
					btNextMonth.setFleche(SwingConstants.NORTH,JButtonArrow.PAGE);
					btNextMonth.setFocusable(false);
					btNextMonth.setMargin(new Insets(0, 0, 0, 0));
					btNextMonth.addActionListener(this);
				}
				pnext.add(btNextMonth);
				pnext.add(btNextYear);
			}
			headPanel.add(pnext, BorderLayout.EAST);
			headPanel.add(head, BorderLayout.CENTER);
			headPanel.add(pprevious, BorderLayout.WEST);
		}
		if (dateTable.attribut==JPCalendar.AT_SPOINTAGE){
			//add(headPanel, BorderLayout.SOUTH);
		} else {
			add(headPanel, BorderLayout.NORTH);
		}
	}
	public void dateSelected(Day day) {
		// RAF 
	}
	public void dateEnter() {
		this.putClientProperty(JPopup.T_RETURN,getDateValue());
	}
	public void dateEscape() {
		this.putClientProperty(JPopup.ESCAPE, "ok");
	}
	public void resetValueForWeek() {
		// RAF
	}
	public Object getValueForWeek() {
		// RAF 
		return null;
	}
	public Object getValueForDate(Day day) {
		Object ret=null;
		switch (dateTable.type){
		case JPCalendar.DAY:
			switch (dateTable.attribut){
			case JPCalendar.AT_SDAY:
				ret=day.getSDay();
				break;
			case JPCalendar.AT_SDATE:
				ret=day.getSDate();
				break;
			case JPCalendar.AT_SPOINTAGE:
				ret=day.getSDate();
				break;
			}
			break;
		case JPCalendar.MONTH:
			switch (dateTable.attribut){
			case JPCalendar.AT_SMONTH:
				ret=day.getStrMonth();
				break;
			}
			break;
		}
		return ret;
	}
	public ArrayList<Object> getCalendarValuesWeeks(){
		return dateTable.cv.calendarValueWeeks;
	}
	public ArrayList<Object> getCalendarValues(){
		return dateTable.cv.calendarValues;
	}
	public ArrayList<Day> getCalendarDays(){
		return dateTable.cv.calendarDays;
	}
	public ArrayList<Day> getWeekInMonth() {
		return dateTable.getWeekInMonth();
	}
	public ArrayList<Day> getDaysInMonth() {
		return dateTable.getDaysInMonth();
	}
	////////////////////////////
	public void add(Date date) {
		if (listDate!=null){
			listDate.add(date);
			dateTable.fireTableDataChanged();
		}
	}
	public Set<Date> getSelectedDates() {
		if (listDate!=null){
			return listDate.getSelectedDates();
		} else {
			return null;
		}
	}
	public void clearSelections() {
		if (listDate!=null){
			listDate.clear();
			dateTable.fireTableDataChanged();
		}
	}
	public String getSelectedDate() {
		return dateTable.getSelectedDate();
	}
	public int getSelectedWeek() {
		return dateTable.getSelectedWeek();
	}
	public void setDate(Date date) {
		dateTable.setCurrentMonth(date);
	}
	public void setSDate(String sdate) {
		dateTable.setCurrentMonth(Day.parseDate(sdate));
	}
	public String getSDate(){
		return getDateValue().getSDate();
	}
	public String getSReverseDate(){
		return getDateValue().getSReverseDate();
	}
	public String getSQuan() {
		return getDateValue().getSQuan();
	}
	public long getTime() {
		return getDateValue().getTime();
	}

	public String getSMonthSYear() {
		return getDateValue().getSMonthSYear();
	}
	public Day getDateValue() {
		return dateTable.getDateValue();
	}
	public int getMonth() {
		return dateTable.getMonth();
	}
	public void setDateValue(Day day) {
		this.dateTable.setDateValue(day);
	}
	public void propertyChange(PropertyChangeEvent evt) {
		if (evt.getPropertyName().equals(JTableCalendar.SELECTEDDATE)){
			head.setText(dateTable.getDisplayMonth().trim());
		}
	}
	//////////////////////////
	public void actionPerformed(final ActionEvent e) {
		Object source = e.getSource();
		if (source == btPreviousMonth) {
			pageSuivante();
		} else if (source == btNextMonth){
			pagePrecedente();
		} if (source == btPreviousYear) {
			dbFin();
		} else if (source == btNextYear){
			debut();
		}
	}
	public void keyTyped(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {}
	public void keyPressed(KeyEvent e) {
		switch (e.getKeyCode()){
		case KeyEvent.VK_ESCAPE:
			dateTable.lt.dateEscape();
			e.consume();
			break;
		case KeyEvent.VK_ENTER:
		case KeyEvent.VK_F2:
			dateTable.lt.dateEnter();
			e.consume();
			break;
		case KeyEvent.VK_HOME:
			debut();
			e.consume();
			break;
		case KeyEvent.VK_END:
			dbFin();
			e.consume();
			break;
		case KeyEvent.VK_PAGE_UP:
			pagePrecedente();
			e.consume();
			break;
		case KeyEvent.VK_PAGE_DOWN:
			pageSuivante();
			e.consume();
			break;
		}
	}
	public void incrValue() {
		dateTable.incrValue();
	}
	public void decrValue() {
		dateTable.decrValue();
	}
	public void incrValueWeek() {
		dateTable.incrValueWeek();
	}
	public void decrValueWeek() {
		dateTable.decrValueWeek();
	}
	//////////////////////////
	public boolean isMovable(){
		return true;
	}
	public void debut() {
		if (btNextYear.isShowing()){
			dateTable.nextYear();
		}
	}
	public void dbFin() {
		if (btPreviousYear.isShowing()){
			dateTable.previousYear();
		}
	}
	public void pageSuivante() {
		if (btPreviousMonth.isShowing()){
			dateTable.previousMonth();
		}
	}
	public void pagePrecedente() {
		if (btNextMonth.isShowing()){
			dateTable.nextMonth();
		}
	}
	public void precedent(int nb) {}
	public void suivant(int nb) {}
	public void dispose() {
		if (dateTable!=null){
			dateTable.dispose();
			dateTable=null;
		}
		head=null;
		headPanel=null;
		btPreviousMonth=null;
		btNextMonth=null;
		btPreviousYear=null;
		btNextYear=null;
		if (listDate!=null){
			listDate.dispose();
			listDate=null;
		}
	}
	protected void finalize()  {
//		Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}