package composant_saisie.wCalendar;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;
import java.util.TreeMap;

import javax.swing.JPanel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellRenderer;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTableDb;
import composant_saisie.wPtime.Day;
import composant_saisie.wPtime.ListDate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JTableCalendar extends JTableDb implements  MouseListener, KeyListener, MouseWheelListener  {
	static final long serialVersionUID = 1L;
	public static final String SELECTEDDATE = "selecteddate";
	CalendarValues cv;
	ListDate listDate=null;
	DefaultTableModel defaultmodel;
	public int nbWeek=6;
	public int nbDayofWeek=7;
	public int dispWeek=1;
	public int dispTotal=0;
	public int heightColumn=23;
	public int widthColumn=heightColumn;
	public int widthColumnWeek=heightColumn;
	public int heightHeadColumn=heightColumn;
	JPanel jpParent=null;
	Day day=null;
	public int type=JPCalendar.DAY;
	public int attribut=JPCalendar.AT_SDAY;
	LinkTableDate lt=null;
	public JTableCalendar() {
		adapteTable();
		day=new Day();
	}
	private void adapteTable(){
		setFont(Gp.FONTTEXT12);
		setCellSelectionEnabled(true);
		addMouseListener(this);
		this.addKeyListener(this);
		this.addMouseWheelListener(this);
	}
	public void setType(int type,int attribut,LinkTableDate lt) {
		this.type=type;
		this.attribut=attribut;
		this.lt=lt;
		Dimension size=null;
		JTableHeader jth=null;
		switch (type){
		case JPCalendar.DAY:
			nbWeek=6;
			nbDayofWeek=7;
			dispWeek=1;
			dispTotal=0;
			switch (attribut){
			case JPCalendar.AT_SDAY:
				widthColumn=heightColumn;
				widthColumnWeek=heightColumn;
				break;
			case JPCalendar.AT_SDATE:
				widthColumn=heightColumn*3;
				widthColumnWeek=heightColumn*3;
				break;
			case JPCalendar.AT_SPOINTAGE:
				widthColumn=heightColumn*4;
				widthColumnWeek=heightColumn;
				heightColumn=heightColumn*2;
				dispTotal=1;
				break;
			}
			defaultmodel=new DefaultTableModel(0, dispWeek+nbDayofWeek+dispTotal);{
				this.setModel(defaultmodel);
			}
			jth=adapteCalHeader();
			break;
		case JPCalendar.MONTH:
			nbWeek=4;
			nbDayofWeek=3;
			dispWeek=0;
			dispTotal=0;
			switch (attribut){
			case JPCalendar.AT_SMONTH:
				widthColumn=heightColumn*3;
				widthColumnWeek=heightColumn*3;
				break;
			}
			defaultmodel=new DefaultTableModel(0, dispWeek+nbDayofWeek+dispTotal);{
				this.setModel(defaultmodel);
			}
			jth=null;
			break;
		}
		size = new Dimension((dispWeek*widthColumnWeek)+(nbDayofWeek*widthColumn)+(dispTotal*widthColumn), nbWeek*heightColumn);
		setPreferredScrollableViewportSize(size);
		this.setTableHeader(jth);
		cv = new CalendarValues(this);
		setRowHeight(heightColumn);
		adapteCell();
		fill();
		requestFocusInWindow();
	}
	private JTableHeader adapteCalHeader() {
		this.adapteHeader();
		JTableHeader jth=this.getTableHeader();
		CellRendererHeader hcr=new CellRendererHeader();{
			jth.setDefaultRenderer(hcr);
		}
		Object[] dayOfWeek = getDaysOfWeek(Calendar.LONG);
		if (dispWeek==1){
			jth.getColumnModel().getColumn(0).setHeaderValue("nS");
		}		
		for (int i=(0+dispWeek);i<(this.getColumnCount()-dispTotal);i++){
			jth.getColumnModel().getColumn(i).setHeaderValue(dayOfWeek[i-dispWeek]);
		}
		if (dispTotal==1){
			jth.getColumnModel().getColumn(this.getColumnCount()-1).setHeaderValue("Total");
		}		
		return jth;
	}
	private String[] getDaysOfWeek(int calendarField) {
		Calendar cal = Calendar.getInstance();
		String[] daysOfWeek = new String[nbDayofWeek];
		Locale locale = Locale.getDefault();
		Map<String, Integer> displayNamesMap = cal.getDisplayNames(Calendar.DAY_OF_WEEK, calendarField, locale);
		Set<String> displayNames = displayNamesMap.keySet();
		SortedMap<Integer, String> displayNamesSorted = new TreeMap<Integer, String>();
		for (String key : displayNames) {
			displayNamesSorted.put(displayNamesMap.get(key), key);//
		}
		Set<Integer> displayNamesKeys = displayNamesSorted.keySet();
		int first = cal.getFirstDayOfWeek();
		String titre=null;
		for (Integer key : displayNamesKeys) {
			if (key >= first) {
				switch (attribut){
				case JPCalendar.AT_SPOINTAGE:
				case JPCalendar.AT_SDATE:
					titre=displayNamesSorted.get(key);
					break;
				default:
					titre=displayNamesSorted.get(key).substring(0, 2);
				break;
				}
				daysOfWeek[key - first] = titre;
			}
		}
		int index = 8 - first;
		for (Integer key : displayNamesKeys) {
			if (key < first) {
				switch (attribut){
				case JPCalendar.AT_SPOINTAGE:
				case JPCalendar.AT_SDATE:
					titre=displayNamesSorted.get(key);
					break;
				default:
					titre=displayNamesSorted.get(key).substring(0, 2);
				break;
				}
				daysOfWeek[index++] = titre;
			}
		}
		return daysOfWeek;
	}

	private void adapteCell() {
		TableCellRenderer wcr=new CellRendererWeek();
		TableCellRenderer lcr=new CellRendererDate();
		TableCellRenderer twcr=new CellRendererTothWeek();
		if (dispWeek==1){
			getColumnModel().getColumn(0).setCellRenderer(wcr);
		}		
		for (int i=(0+dispWeek);i<(getColumnCount()-dispTotal);i++){
			getColumnModel().getColumn(i).setCellRenderer(lcr);
		}
		if (dispTotal==1){
			getColumnModel().getColumn(this.getColumnCount()-1).setCellRenderer(twcr);
		}		
	}
	private void fill() {
		defaultmodel.setRowCount(0);
		Object[] rowData = new Object[dispWeek+nbDayofWeek+dispTotal];
		for (int week = 0; week < nbWeek; week++) {
			int j = week * nbDayofWeek;
			if (dispWeek==1){
				switch (type){
				case JPCalendar.DAY:
					rowData [0]=cv.getWeek(j+1);
					break;
				case JPCalendar.MONTH:
					rowData [0]=" Trimestre "+(week+1);
					break;
				}
			}
			for (int i=0;i<nbDayofWeek;i++){
				rowData [i+dispWeek]=cv.getCalendarValue(j++);
			}
			if (dispTotal==1){
				rowData [rowData.length-1]="Total";
			}		
			defaultmodel.addRow(rowData);
		}
		fireTableDataChanged();
	}
	public void setListDate(ListDate listDate){
		this.listDate=listDate;
		for (int i=(0+dispWeek);i<getModel().getColumnCount()-dispTotal;i++){
			((CellRendererDate) getColumnModel().getColumn(i).getCellRenderer()).setListDate(listDate);
		}
	}
	public void setPanelToNotify(JPanel jp){
		this.jpParent=jp;
	}

	public boolean isCellEditable(final int row, final int column) {
		return false;
	}
	public void mouseReleased(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {
		Point point = e.getPoint();
		int row = rowAtPoint(point);
		int column = columnAtPoint(point);
		if ((dispWeek==1 && column==0) || (dispTotal==1 && column==this.getColumnCount()-1)){
		} else {
			if (e.getClickCount()==2){
				setF2();
			} else {
				Day dayHere =cv.getCalendarDay((row*nbDayofWeek)+column-dispWeek);
				day.setTime(dayHere.getTime());
				//setSelectedDate(day);
				setCurrentMonth(day.getDateOnly());
			}
		}
	}
	private void setSelectedDate(Day day){
		Date date = day.getDateOnly();
		if (listDate!=null){
			if (listDate.contains(date)) {
				//	listDate.remove(date);
				//	fireTableDataChanged();
			} else {
				listDate.clear();
				listDate.add(date);
				lt.dateSelected(day);
				fill();
				//fireTableDataChanged();
			}
		}
	}
	public void setF2(){
		lt.dateEnter();
	}
	public String getSelectedDate() {
		return cv.getSelectedDate();
	}
	public ArrayList<Day> getWeekInMonth() {
		return cv.getWeekInMonth();
	}
	public ArrayList<Day> getDaysInMonth() {
		return cv.getDaysInMonth();
	}
	public int getSelectedWeek() {
		return cv.getSelectedWeek();
	}
	public int getMonth() {
		return cv.getMonth();
	}
	public Day getDateValue() {
		return day;
	}
	public void setDateValue(Day date) {
		this.day.setTime(date.getTime());
		setSelectedDate(day);
	}
	public void incrValue() {
		switch (type){
		case JPCalendar.DAY:
			day.addDay(1);
			//setSelectedDate(day);
			break;
		case JPCalendar.MONTH:
			day.addMonth(1);
			//setSelectedDate(day);
			break;
		}
		setCurrentMonth(day.getDateOnly());
	}
	public void incrValueWeek() {
		switch (type){
		case JPCalendar.DAY:
			day.addDay(nbDayofWeek);
			//setSelectedDate(day);
			break;
		case JPCalendar.MONTH:
			day.addMonth(nbDayofWeek);
			//setSelectedDate(day);
			break;
		}
		setCurrentMonth(day.getDateOnly());
	}
	public void decrValue() {
		switch (type){
		case JPCalendar.DAY:
			day.addDay(-1);
			//setSelectedDate(day);
			break;
		case JPCalendar.MONTH:
			day.addMonth(-1);
			//setSelectedDate(day);
			break;
		}
		setCurrentMonth(day.getDateOnly());
	}
	public void decrValueWeek() {
		switch (type){
		case JPCalendar.DAY:
			day.addDay(nbDayofWeek*-1);
			//setSelectedDate(day);
			break;
		case JPCalendar.MONTH:
			day.addMonth(nbDayofWeek*-1);
			//setSelectedDate(day);
			break;
		}
		setCurrentMonth(day.getDateOnly());
	}
	////////////////////////////////////////
	public void setCurrentMonth(Date date) {
		boolean changedMonth=false;
		cv.setCurrentMonth(date);
		day.setTime(date.getTime());
		setSelectedDate(day);
		if (jpParent!=null){
			jpParent.putClientProperty(JTableCalendar.SELECTEDDATE,cv.getDisplayMonth());
		}
		if (changedMonth){
			fill();
		}
	}
	public void nextMonth() {
		cv.nextMonth();
		if (jpParent!=null){
			jpParent.putClientProperty(JTableCalendar.SELECTEDDATE,cv.getDisplayMonth());
		}
		fill();
	}
	public void previousMonth() {
		cv.previousMonth();
		if (jpParent!=null){
			jpParent.putClientProperty(JTableCalendar.SELECTEDDATE,cv.getDisplayMonth());
		}
		fill();
	}
	public void nextYear() {
		cv.nextYear();
		if (jpParent!=null){
			jpParent.putClientProperty(JTableCalendar.SELECTEDDATE,cv.getDisplayMonth());
		}
		fill();
	}
	public void previousYear() {
		cv.previousYear();
		if (jpParent!=null){
			jpParent.putClientProperty(JTableCalendar.SELECTEDDATE,cv.getDisplayMonth());
		}
		fill();
	}
	public String getDisplayMonth() {
		return cv.getDisplayMonth();
	}
	public void fireTableDataChanged(){
		defaultmodel.fireTableDataChanged();
	}
	public void mouseWheelMoved(MouseWheelEvent e) {
		if (isEnabled()){
			if (e.getWheelRotation()>0){
				incrValue();
			} else {
				decrValue();
			}
		}
	}
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) {
		switch (e.getKeyCode()){
		case KeyEvent.VK_LEFT:
			decrValue();
			e.consume();
			break;
		case KeyEvent.VK_UP:
			decrValueWeek();
			e.consume();
			break;
		case KeyEvent.VK_SPACE:
		case KeyEvent.VK_RIGHT:
			incrValue();
			e.consume();
			break;
		case KeyEvent.VK_DOWN:
			incrValueWeek();
			e.consume();
			break;
		}
	}
	public void dispose() {
		if (cv!=null){
			cv.dispose();
			cv=null;
		}
		if (listDate!=null){
			listDate.dispose();
			listDate=null;
		}
		defaultmodel=null;
		jpParent=null;
		day=null;
		lt=null;
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}