package composant_saisie.wComposant;

import java.awt.Dimension;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JArea extends JEditorPane  implements FicheIEditableColumns, KeyListener, FocusListener {
	private static final long serialVersionUID = 1L;
	FicheIEditableColumns fe;
	ListeIEditableColumn fl;
	JTextField jt=null;
	JScrollPane jscp=null;
	boolean debugDisposeTrace=false;
	public JArea(){
		super();
		adapte();
	}
	private void adapte(){
		putClientProperty(Edit.TYPE_FIELD,Edit.AREA);
		this.setDisabledTextColor(Gp.VERTFONCE_FG);
		jt=new JTextField();
		this.setFont(Gp.FONTTEXT12);
		//this.setWrapStyleWord(true);
		//this.setLineWrap(true);
		this.setAutoscrolls(true);
	}
	public JScrollPane getPanel(int width, int height){
		jscp=new JScrollPane();{
			setDimChar(jscp,width,height);
			jscp.add(this);
		}
		return jscp;
	}
	public void setDimChar(int width,int height){
		setDimChar(this,width,height);
	}
	public void setDimChar(JComponent jc,int width,int height){
		Dimension dim=new Dimension((width*Gp.WIDTHCHAR),height*Gp.HEIGHTCHAR+2+2);
		jc.setPreferredSize(dim);
		jc.setMaximumSize  (dim);
		jc.setMinimumSize  (dim);
		jc.validate();
	}
	public void setEnabled(boolean enable){
		if (!this.isEditable())
			enable=false;
		super.setEnabled(enable);
	}
	public void setEditable(boolean enable){
		super.setEditable(enable);
		if (!enable)
			this.setEnabled(enable);
	}
	// FICHEFASTEDIT //
	public void setEditableColumns(FicheIEditableColumns tfe,ListeIEditableColumn fl){
		this.fe=tfe;
		this.fl=fl;
		if (fl!=null){
			fl.addEditableColumn(this);
		}
	}
	public void removeEditableColumn() {
		if (fl!=null){
			fl.removeEditableColumn(getName());
		}		
	}
	public void enableEditableColumn(boolean enable) {
		if (fl!=null){
			setEditable(enable);
			setEnabled(enable);
			fl.enableEditableColumn(getName(),enable);
		}
	}
	public void fireEditableColumnUpdate(String nameField,Object value) {
		if (nameField==null){

		} else {
			if (nameField.equals(getName())){
				if (value!=null){
					this.setText((String) value);
					userRecordByFireEditableColumn();
				} else {
					this.addKeyListener(this);
					this.addFocusListener(this);
					this.requestFocus();
				}
			}
		}
	}

	public void userRecordByFireEditableColumn() {
		if (fe!=null){
			fe.userRecordByFireEditableColumn();
		}
	}
	// FICHEFASTEDIT //
	public void keyReleased(KeyEvent arg0) {}
	public void keyTyped(KeyEvent arg0) {}
	public void keyPressed(KeyEvent arg0) {
		switch (arg0.getKeyCode()) {
		case KeyEvent.VK_UP:
		case KeyEvent.VK_DOWN:
		case KeyEvent.VK_ENTER: userRecordByFireEditableColumn();arg0.consume(); break;
		default:
			break; }
	}
	public void focusGained(FocusEvent arg0) {
		//this.setBackground(Gp.UPDATE_BG_JAUNE);
		this.selectAll();
	}
	public void focusLost(FocusEvent arg0) {
		this.setBackground(Gp.MOVE_BG_LVERT);
		this.setSelectionStart(0);
		this.setSelectionEnd(0);
		this.removeKeyListener(this);
		this.removeFocusListener(this);
	}
	public void setSelectedAll() {
		if (this.getText()!=null)
			if (this.getText().length()!=0){
				this.setSelectionStart(0);
				this.setSelectionEnd(this.getText().length());
			}
	}
	public void dispose() {
		fe=null;
		fl=null;
	}
	protected void finalize()  {
		if (debugDisposeTrace){
			Gp.ad("finalize : "+this.getName());
		}
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
