package composant_saisie.wComposant;

import java.awt.AlphaComposite;
import java.awt.BorderLayout;
import java.awt.Composite;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.TexturePaint;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JPanelImage extends JPanel {
	private static final long serialVersionUID = 1L;
	Gp gp=null;
	String image=null;
	private int mode=Gp.JPGNULL;
	private boolean gradientSens=false;
	private int gradientValue=45;
	private TexturePaint texture; 
	private TexturePaint textureGrayed; 
	private BufferedImage bufferedImage; 
	private BufferedImage bufferedImageGrayed; 
	public JPanelImage(){
		super();
		setFocusable(false);
	}
	public JPanelImage(BorderLayout borderLayout) {
		super(borderLayout);
		setFocusable(false);
	}
	public JPanelImage(GridBagLayout gridbaglayout) {
		super(gridbaglayout);
		setFocusable(false);
	}
	public JPanelImage(FlowLayout flowLayout) {
		super(flowLayout);
		setFocusable(false);
	}
	public JPanelImage(Gp gp,String image,int mode){
		super();
		setFocusable(false);
		setImage(gp,image,mode);
	}
	public void setMode(int mode){
		this.mode=mode;
	}
	public void setModeGradient(int value,boolean sens){
		this.mode=Gp.JPGGRADIENT;
		this.gradientSens=sens;
		this.gradientValue=value;
	}
	public void setImage(Gp gp,String image,int mode){
		this.gp=gp;
		this.image=image;
		this.mode = mode;
		Image jpg=gp.getImage(image,false);
		if (jpg!=null){
			this.bufferedImage = gp.toBufferedImage(jpg);
			this.bufferedImageGrayed = gp.grayedImage(gp.toBufferedImage(jpg));
			this.texture = new TexturePaint(bufferedImage,new Rectangle(0, 0, bufferedImage.getWidth(), bufferedImage.getHeight()));
			this.textureGrayed= new TexturePaint(bufferedImageGrayed,new Rectangle(0, 0, bufferedImageGrayed.getWidth(), bufferedImageGrayed.getHeight()));
			jpg=null;
		} else {
			mode=Gp.JPGNULL;
			texture=null; 
			textureGrayed=null; 
			bufferedImage=null; 
			bufferedImageGrayed=null; 
		}
	}
	public void paintComponent(Graphics g) {	
		super.paintComponent(g);
		switch( mode )
		{	case Gp.JPGTEXTURE :
			if(texture!=null){
				g.setColor(this.getBackground());
				g.fillRect(0,0,getWidth(), getHeight() );
				Graphics2D g2d = (Graphics2D)g;

				Composite c = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1.f);
				g2d.setComposite(c);

				if (this.isEnabled())
					g2d.setPaint(texture);
				else
					g2d.setPaint(textureGrayed);
				g2d.fillRect(0, 0, getWidth(), getHeight() );

				c = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1.f);
				g2d.setComposite(c);
			}

			break;
		case Gp.JPGFILL :
			if(bufferedImage!=null){
				g.setColor(this.getBackground());
				g.fillRect(0,0,getWidth(), getHeight() );
				Graphics2D g2d=(Graphics2D) g;
				double w=(double) getWidth()/ (double) bufferedImage.getWidth();
				double h=(double) getHeight()/ (double)bufferedImage.getHeight();
				g2d.scale(w,h);
				if (this.isEnabled())
					g2d.drawImage(bufferedImage,0,0,null);
				else
					g2d.drawImage(bufferedImageGrayed,0,0,null);

				w=(double) bufferedImage.getWidth()/ (double) getWidth();
				h=(double) bufferedImage.getHeight()/ (double)getHeight();
				g2d.scale(w,h);
			}
			break;
		case Gp.JPGCENTER:
			if(bufferedImage!=null){
				g.setColor(this.getBackground());
				g.fillRect(0,0,getWidth(), getHeight() );
				if (this.isEnabled())
					g.drawImage(bufferedImage,(getWidth()-bufferedImage.getWidth())/2,(getHeight()-bufferedImage.getHeight())/2,null);
				else
					g.drawImage(bufferedImageGrayed,(getWidth()-bufferedImageGrayed.getWidth())/2,(getHeight()-bufferedImageGrayed.getHeight())/2,null);
			}
			break;
		case Gp.JPGGRADIENT:
			if (Gp.USEPANELGRADIENT)
				g.setColor(this.getBackground());
				g.fillRect(0,0,getWidth(), getHeight() );
				if (this.isEnabled()){
					Gp.setBackgroundGradient(g,this,gradientValue,gradientSens);
				}
			break;
		}
	}
}
