package composant_saisie.wComposant;

import java.awt.Color;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.util.EventObject;

import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.event.AncestorEvent;
import javax.swing.event.AncestorListener;
import javax.swing.table.JTableHeader;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JTableDb extends JTable implements FocusListener {
	private static final long serialVersionUID = 1L;
	boolean forcedFocus=true;
	JTableHeader th=null;
	public JTableDb(){
		adapte();
	}
	public JTableDb(Object[][] data, String[] header) {
		super(data,header);
		adapte();
	}
	private void adapte() {
		this.setSelectionBackground(Gp.FILIGRANE_LGRAY);
		this.setSelectionForeground(Gp.VERTFONCE_FG);
		// Bug du jtable ne rcupere pas le focus
		this.addAncestorListener( new AncestorListener(){
			public void ancestorAdded(AncestorEvent e){
				if(forcedFocus)
					requestFocusInWindow();
			}
			public void ancestorMoved(AncestorEvent arg0) {}
			public void ancestorRemoved(AncestorEvent arg0) {}
		});
		setShowHorizontalLines(true);
		setShowVerticalLines(true);
		addFocusListener(this);
		setFocusable(true);
		requestFocusInWindow();
	}
	public void adapteHeader() {
		th=this.getTableHeader();
		th.setFocusable(false);
		th.setReorderingAllowed(false);
		th.setOpaque(true);
		th.setResizingAllowed(false);
		th.setCursor(null);
		th.setAutoscrolls(true);
		th.setRequestFocusEnabled(false);
		th.setBorder(null);
		th.setFont(Gp.FONTTEXT12);
	}
	public void adapteHeader(String[] header) {
		adapteHeader() ;
		for (int i=0;i<header.length;i++){
			th.getColumnModel().getColumn(i).setHeaderValue(header[i]);
		}
	}
	public void setForcedFocus(boolean forced){
		this.forcedFocus=forced;
	}
	public boolean getForcedFocus() {
		return this.forcedFocus;
	}
	public boolean editCellAt(int row ,int column){
		boolean ret=false;
		ret=super.editCellAt(row, column);
		requestFocusEditableComponent();
		return ret;
	}
	public boolean editCellAt(int row ,int column, EventObject e){
		boolean ret=false;
		ret=super.editCellAt(row, column, e);
		requestFocusEditableComponent();
		return ret;
	}
	public void requestFocusEditableComponent(){
		if (this.getEditorComponent()!=null){
			this.getEditorComponent().requestFocusInWindow();
		}
	}
	public void focusGained(FocusEvent arg0) {
		if (UIManager.getColor("TextEdit.selectionBackground")!=null){
			this.setSelectionBackground(UIManager.getColor("TextEdit.selectionBackground"));
			this.setSelectionForeground(UIManager.getColor("TextEdit.selectionForeground"));
		} else {
			this.setSelectionBackground(Color.LIGHT_GRAY);
			this.setSelectionForeground(Color.GRAY);
		}
	}
	public void focusLost(FocusEvent arg0) {
		this.setSelectionBackground(Gp.FILIGRANE_LGRAY);
		this.setSelectionForeground(Gp.VERTFONCE_FG);
	}
}
