package composant_saisie.wComposant;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.awt.image.FilteredImageSource;
import java.awt.image.ImageFilter;
import java.awt.image.ImageProducer;
import java.awt.image.RGBImageFilter;

import javax.swing.ActionMap;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.InputMap;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.KeyStroke;
import javax.swing.SwingUtilities;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JTextButton extends JButton implements MouseListener  {
	private static final long serialVersionUID = 1L;
	public static final String CLICK_RIGHT = "CLICK_RIGHT";
	Font font=null;
	Color colorForeground=Gp.VERTFONCE_FG;
	Color color=Gp.VERTFONCE_FG;
	Icon icon=null;
	Icon iconp=null;
	public JTextButton(String ActionCommand) {
		super(ActionCommand);
		adapte();
	}

	public JTextButton() {
		super();
		adapte();
	}
	public JTextButton(String ActionCommand, char keyChar) {
		super(ActionCommand);
		this.setMnemonic(keyChar);
		setAccelerator(KeyStroke.getKeyStroke(keyChar),this.getActionCommand());
		adapte();
	}
	public JTextButton(String ActionCommand, int keyCode) {
		super(ActionCommand);
		this.setMnemonic(keyCode);
		switch (keyCode){
			case KeyEvent.VK_7:
			case KeyEvent.VK_NUMPAD7:
				setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_7,0),this.getActionCommand());
				setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_NUMPAD7,0),this.getActionCommand());
				break;
			case KeyEvent.VK_0:
			case KeyEvent.VK_NUMPAD0:
				setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_0,0),this.getActionCommand());
				setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_NUMPAD0,0),this.getActionCommand());
				break;
			default:
				setAccelerator(KeyStroke.getKeyStroke(keyCode,0,false),this.getActionCommand());
		}
		adapte();
	}
	private void adapte(){
		setFont(Gp.FONTTEXT12);
		setFocusable(false);
		setColor();
		this.addMouseListener(this);
	}
	public void setEnabled(boolean enable){
		super.setEnabled(enable);
		setColor();
	}
	public void setForeground(Color color){
		colorForeground=color;
	}
	public void setImageIconPressed(Image img,boolean rotate){
		Icon icon=null;
		Icon iconp=null;
		if (img!=null){
			Image tmpIm=img.getScaledInstance(Gp.HEIGHTCHAR+0,Gp.HEIGHTCHAR+0,Image.SCALE_AREA_AVERAGING);
			if (tmpIm!=null){
				icon=new ImageIcon(tmpIm);
				if (icon!=null){
					if (rotate){
						tmpIm=img.getScaledInstance(Gp.HEIGHTCHAR+1,Gp.HEIGHTCHAR+1,Image.SCALE_AREA_AVERAGING);
						if (tmpIm!=null){
							tmpIm=RotateImage(tmpIm);
							if (tmpIm!=null){
								tmpIm=makeColorTransparent(tmpIm,Color.WHITE);
								if (tmpIm!=null){
									iconp=new ImageIcon(tmpIm);
								}
							}
						}
					} else {
						iconp=icon;
					}
				}
			}
		}
		setIcon(icon);
		setPressedIcon(iconp);
	}
	public void setIcon(Icon icon){
		this.icon=icon;
		Icon icn=null;
		if (Gp.USEBUTTONICONE){
			icn=this.icon;
		}
		super.setIcon(icn);
		if (icn!=null)
			this.setIconTextGap(icn.getIconWidth()/3*2);
	}
	public void setPressedIcon(Icon icon){
		this.iconp=icon;
		Icon icn=null;
		if (Gp.USEBUTTONICONE){
			icn=this.iconp;
		}
		super.setPressedIcon(icn);
	}
	public void setColor(){
		if (this.isEnabled()){
			color=colorForeground;
			font=Gp.FONTTEXT11;
			if (this.getActionCommand().length()==1){
				this.setBorder(BorderFactory.createEmptyBorder());
				this.setMargin(new Insets(0,0,1,0));
				font=Gp.FONTTEXT18;
			} else if (this.getActionCommand().length()==2){
				this.setBorder(BorderFactory.createEmptyBorder());
				this.setMargin(new Insets(0,0,1,0));
				font=Gp.FONTTEXT12;
			} else if (this.getActionCommand().length()==3){
				this.setBorder(BorderFactory.createEmptyBorder());
				this.setMargin(new Insets(0,0,1,0));
				font=Gp.FONTTEXT12;
			}
		} else {
			color=Gp.LABEL_BORDER;
			//font=this.getFont();
			font=Gp.FONTTEXT11;
		}
		super.setForeground(color);
		this.setFont(font);
	}
	// ------------ TRANSFORME IMAGE
	public Image makeColorTransparent(Image im, final Color color) {
		ImageFilter filter = new RGBImageFilter() {
			// the color we are looking for... Alpha bits are set to opaque
			public int markerRGB = color.getRGB() | 0xFF000000;

			public final int filterRGB(int x, int y, int rgb) {
				if ( ( rgb | 0xFF000000 ) == markerRGB ) {
					// Mark the alpha bits as zero - transparent
					return 0x00FFFFFF & rgb;
				}
				else {
					// nothing to do
					return rgb;
				}
			}
		}; 
		ImageProducer ip = new FilteredImageSource(im.getSource(), filter);
		im=null;
		filter=null;
		return Toolkit.getDefaultToolkit().createImage(ip);
	}
	public BufferedImage RotateImage(Image colorimage){
		BufferedImage ret=null;
		Image colorImage = new ImageIcon(colorimage).getImage();
		colorimage=null;
		if (colorImage!=null){
			if(!(colorImage.getWidth(null)<=0 || colorImage.getHeight(null)<=0)){
				ret = new BufferedImage( colorImage.getWidth(null), colorImage.getHeight(null), BufferedImage.TYPE_INT_RGB);
				Graphics2D g2d = ret.createGraphics(); 
				g2d.setColor(Color.white); 
				g2d.fillRect(0,0, colorImage.getWidth(null), colorImage.getHeight(null));
				g2d.rotate(Math.PI / 2d);
				g2d.translate(0, -colorImage.getHeight(null));
				g2d.drawImage(colorImage, 0, 0, null);
				g2d.dispose();
				colorImage=null;
			}
		}
		return ret;

	}
	public void setAccelerator(KeyStroke ks,String actionCommand){
		// On rcupre la Map de la touche qui s'appliquera
		//  tous les lments fils lorsqu'ils auront le focus :
		InputMap inputMap = this.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW);
		// On associe la touche avec comme identifiant le nom de l'action
		inputMap.put(ks,actionCommand);
		// On rcupre la Map des actions qui associe une action  un identifiant :
		ActionMap actionMap = this.getActionMap();
		// Et on associe notre action  notre identifiant :
		actionMap.put(actionCommand,new TouchAction(this));
	}
	public void setActionCommand(String actioncommand){
		String ancAC=getActionCommand();
		if (getActionMap().get(ancAC)!=null){
			TouchAction ancTA=(TouchAction) getActionMap().get(ancAC);
			getActionMap().put(ancAC,null);
			getActionMap().put(actioncommand,ancTA);

			InputMap inputMap = this.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW);
			KeyStroke[] ks=inputMap.allKeys();
			for (int i=0;i<ks.length;i++){
				if (inputMap.get(ks[i]).equals(ancAC)){
					inputMap.put(ks[i], actioncommand);
				}
			}
		}
		super.setActionCommand(actioncommand);
	}
	public void setNoBorder(boolean disabled) {
		//setFocusPainted(!disabled);
		//setBorderPainted(!disabled); 
		setBorder(null);
		setContentAreaFilled(!disabled);
	}

	public void mouseClicked(MouseEvent e) {
		if ( SwingUtilities.isRightMouseButton(e) ){
			if (this.isEnabled()){
				String ancAc=getActionCommand();
				setActionCommand(JTextButton.CLICK_RIGHT+ancAc);
				doClick();
				setActionCommand(ancAc);
			}
		}
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
	//	protected void finalize()  {
	//	Gp.af("finalize : "+this.getActionCommand());
	//	try {
	//		super.finalize();
	//	} catch (Throwable arg0) {
	//		// TODO Auto-generated catch block
	//		arg0.printStackTrace();
	//	}
	//}
}

