package composant_saisie.wComposant;


import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

import javax.swing.JCheckBox;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.CcsFmt;
import composant_saisie.wSaisieFormat.Fma;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JTextCheck extends JCheckBox implements FicheIEditableColumns,ActionListener, MouseWheelListener    {
	private static final long serialVersionUID = 1L;
	FicheIEditableColumns fe;
	ListeIEditableColumn fl;
	String checked=null;
	String unchecked=null;
	boolean editable=true;
	UserUpdate userupdate=null;
	public JTextCheck(String checked){
		super();
		this.checked=checked;
		this.unchecked=checked;
		adapte();
	}
	public JTextCheck(String checked,String unchecked){
		super();
		this.checked=checked;
		this.unchecked=unchecked;
		adapte();
	}
	private void adapte(){
		userupdate=new UserUpdate(this);
		checked=CcsFmt.ligSpace(checked,Math.max(checked.length(),unchecked.length()));
		unchecked=CcsFmt.ligSpace(unchecked,Math.max(checked.length(),unchecked.length()));
		setTextCheck();
		this.setBorderPainted(true);
		putClientProperty(Edit.TYPE_FIELD,Edit.CHECK);
		this.setHorizontalAlignment(Ccs.getHorizontalAlignement(Fma.CHECK));
		this.addActionListener(this);
		this.addMouseWheelListener(this);
	}
	public void setSelected(boolean enable){
		super.setSelected(enable);
		setTextCheck();
	}
	public void setEnabled(boolean enable){
		if (enable){
			this.setForeground(Color.black); 	
		} else {
			this.setForeground(Gp.VERTFONCE_FG); 	
		}
		super.setEnabled(enable);
	}
	public void setEditable(boolean enable){
		if (enable){
			this.setForeground(Color.black); 	
		} else {
			this.setForeground(Gp.VERTFONCE_FG); 	
		}
		this.setFocusable(enable);
		this.editable=enable;
	}
	public void adapteTextLibe() {
		setEditable(false);
	}
	public void adapteTextField() {
		setEditable(true);
	}
	
	public void setBackground(Color color){
		if (editable){
			super.setBackground(color);
		} else {
			super.setBackground(Gp.MOVE_BG_LVERT);
		}
	}
	public void setAlert(boolean alert) {
		Color colorF=null;
		Color colorB=null;
		if (alert){
			colorF=Gp.INVALIDE_FG_RED;
			colorB=Gp.MOVE_BG_LRED;
		} else {
			colorF=Gp.VERTFONCE_FG;
			colorB=Gp.MOVE_BG_LVERT;
		}
		setForeground(colorF);
		setBackground(colorB);
	}
	public void checkUncheck(){
		setSelected(!isSelected());
		userUpdate();
	}
	public void check(boolean b) {
		setSelected(b);
	}
	private void setTextCheck(){
		if (isSelected()){
			setText(checked);
		} else {
			setText(unchecked);
		}
	}
	public void actionPerformed(ActionEvent arg0) {
		if (editable){
			userUpdate();
			setTextCheck();
		} else {
			this.setSelected(!isSelected());
		}
	}
	private void userUpdate(){
		userupdate.userUpdate();
	}

	// FICHEFASTEDIT //
	public void setEditableColumns(FicheIEditableColumns tfe,ListeIEditableColumn fl) {
		this.fe=tfe;
		this.fl=fl;
		if (fl!=null){
			fl.addEditableColumn(this);
		}
	}
	public void removeEditableColumn() {
		if (fl!=null){
			fl.removeEditableColumn(getName());
		}
	}
	public void enableEditableColumn(boolean enable) {
		if (fl!=null){
			setEditable(enable);
			setEnabled(enable);
			fl.enableEditableColumn(getName(),enable);
		}
	}
	public void fireEditableColumnUpdate(String nameField,Object value) {
		if (nameField==null){

		} else {
			if (nameField.equals(getName())){
				if (value!=null){
					checkUncheck();
					userRecordByFireEditableColumn();
				} else {
					this.requestFocus();
				}
			}
		}
	}
	public void userRecordByFireEditableColumn() {
		if (fe!=null)
			fe.userRecordByFireEditableColumn();
	}
	public void mouseWheelMoved(MouseWheelEvent e) {
		if (isEnabled()){
			checkUncheck();
		}
	}
}
