package composant_saisie.wComposant;



import java.awt.Color;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.font.TextAttribute;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.Map;

import javax.swing.JTextField;
import javax.swing.ToolTipManager;
import javax.swing.TransferHandler;

import module_standard.wSerial.AbstractMS1204;
import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.ListeIEditableColumn;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.CcsFmt;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JTextDb extends JTextField implements FicheIEditableColumns, FocusListener, MouseListener, KeyListener, Runnable {
	private static final long serialVersionUID = 1L;

	int rotation=-1;
	int x=0;
	int y=0;
	Color colorBorderHeader=Gp.LABEL_FG_BLACK;
	Color color=Gp.LABEL_FG_BLACK;
	String superText="";
	public String libelleHelpText="";

	FicheIEditableColumns fe;
	ListeIEditableColumn fl;
	boolean selectAllOnFocus=true;

	public boolean borderHeader=false;
	public boolean libelleFiche=false;
	boolean web=false;
	boolean mailTo=false;
	String mail="";
	String subject="";
	String body="";
	String urlsiteWeb;
	private AbstractMS1204 ms1204=null;
	boolean debugSetText=false;
	boolean debugSetTextTrace=false;
	boolean debugDisposeTrace=false;
	TransferHandler th=null;

	public JTextDb(){
		adapte();
	}
	public JTextDb(String txt){
		super(txt);
		adapte();
	}
	private void adapte(){
		putClientProperty(Edit.TYPE_FIELD,Edit.TEXT);
		this.setDisabledTextColor(Gp.VERTFONCE_FG);
		this.setFont(Gp.FONTTEXT12);
		this.addFocusListener(this);
		this.addKeyListener(this);
	}
	public void setText(String string){
		super.setText(string);
		if (debugSetText){
			Gp.af(getName()+":"+string);
		}
		if (debugSetTextTrace){
			Gp.af();
		}
	}
	public boolean isSelectAllOnFocus() {
		return selectAllOnFocus;
	}
	public boolean isEmpty(){
		boolean ret=true;
		if (getText()!=null){
			if(getText().trim().length()>0){
				ret=false;
			}
		}
		return ret;
	}
	public void setEnableClipboard(boolean enable){
		if (th==null){
			th=this.getTransferHandler();
		}
		if (enable){
			this.setTransferHandler(th);
		} else {
			this.setTransferHandler(null);
		}
	}
	public boolean isEnableClipboard(){
		boolean ret=true;
		if (this.getTransferHandler()==null){
			ret=false;
		} 
		return ret;
	}
	public void setSelectAllOnFocus(boolean selectAllOnFocus) {
		this.selectAllOnFocus = selectAllOnFocus;
	}

	public void setDebugSetText(boolean enable){
		debugSetText=enable;
	}
	public void setDebugSetTextTrace(boolean enable){
		debugSetTextTrace=enable;
	}
	public void setDebugDisposeTrace(boolean enable){
		debugDisposeTrace=enable;
		if (debugDisposeTrace){
			Gp.ad("initialize : "+this.getClass().getSimpleName());
		}
	}
	public void setSuperText(String txt, int rotation,int x,int y,Color color){
		this.superText=txt;
		this.rotation=rotation;
		this.color=color;
		this.y=y;
		this.x=x;
		this.repaint();
	}
	public void setLibelleHelpText(String libelleHelpText) {
		putClientProperty(Edit.TYPE_FIELD, Edit.LIBE);

		if (libelleHelpText.length()>0)
			this.libelleFiche=true;
		this.libelleHelpText=libelleHelpText;

		if(libelleFiche){
			if (Gp.TOOLTIP){
				ToolTipManager.sharedInstance().setInitialDelay((int) (Gp.TOOLTIPINITIALDELAY*1000)); 
				ToolTipManager.sharedInstance().setDismissDelay((int) (Gp.TOOLTIPDELAY*1000));
				ToolTipManager.sharedInstance().setReshowDelay( (int) (Gp.TOOLTIPINITIALDELAY*1000/10) );
				ToolTipManager.sharedInstance().registerComponent( this );
				String s="&#160;";
				this.setToolTipText("<html><b>" +
						"<br>" +
						"<FONT  color=#000000 size=3>" +
						s+s+s+s+libelleHelpText+s+s+s+s+
						"<FONT/>"+
						"<br>" +
						"<FONT  color=#C0C0C0 size=2>Aide, exemple<FONT/>" +
				"<html/>");
			}
		}
	}	
	public String getLibelleHelpText(){
		return this.libelleHelpText;
	}
	public void setUnderline(boolean enable){
		Font font = getFont();
		@SuppressWarnings({"unchecked"})
		Map<TextAttribute, Object> map =(Map<TextAttribute, Object>) font.getAttributes();
		if (enable) {
			map.put(TextAttribute.UNDERLINE, TextAttribute.UNDERLINE_ON);
		} else {
			web=false;
			mailTo=false;
			map.put(TextAttribute.UNDERLINE,null);
		}
		setFont(font.deriveFont(map));
	}
	public void setWidthChar(int width){
		Dimension dim;
		dim=new Dimension(((width+2)*Gp.WIDTHCHAR),Gp.HEIGHTTEXT);
		setPreferredSize(dim);
		setMaximumSize  (dim);
		setMinimumSize  (dim);
		validate();
	}
	public void reduceHeightDim(int height){
		Dimension dim;
		dim=new Dimension(this.getPreferredSize().width,height);
		setPreferredSize(dim);
		setMaximumSize  (dim);
		setMinimumSize  (dim);
		validate();
	}
	public void setEnabled(boolean enable){
		if (!this.isEditable()){
			enable=false;
		}
		super.setEnabled(enable);
	}
	public void setEditable(boolean enable){
		super.setEditable(enable);
		setFocusable(enable);
		this.setEnabled(enable);
	}
	// FICHEFASTEDIT //
	public void setEditableColumns(FicheIEditableColumns fe,ListeIEditableColumn fl){
		this.fe=fe;
		this.fl=fl;
		if (fl!=null){
			fl.addEditableColumn(this);
		}
	}
	public void removeEditableColumn() {
		if (fl!=null){
			fl.removeEditableColumn(getName());
		}		
	}
	public void enableEditableColumn(boolean enable) {
		if (fl!=null){
			setEditable(enable);
			fl.enableEditableColumn(getName(),enable);
		}
	}
	public void fireEditableColumnUpdate(String nameField,Object value) {
		if (nameField==null){

		} else {
			if (nameField.equals(getName())){
				if (value!=null){
					this.setText((String) value);
					userRecordByFireEditableColumn();
				} else {
					this.requestFocus();
				}
			}
		}
	}
	public void userRecordByFireEditableColumn() {
		if (fe!=null){
			fe.userRecordByFireEditableColumn();
		}
	}
	// FICHEFASTEDIT //
	public double getDouble(){
		double ret=0.0;
		String strret=CcsFmt.clearStringDigit(getText());
		ret=Gp.parseDouble(strret);
		return ret;
	}
	public int getInt(){
		int ret=0;
		String strret=CcsFmt.clearStringDigit(getText());
		ret=Gp.parseInt(strret);
		return ret;
	}
	public String getSSeparator(String separator){
		String strret=CcsFmt.clearStringDigit(getText());
		strret=""+Gp.parseDouble(strret);
		return CcsFmt.clearStringDigit(strret,separator);
	}
	public void adapteTextLibe(){
		putClientProperty(Edit.TYPE_FIELD, Edit.LIBE);
		setForeground(Gp.VERTFONCE_FG);
		setBackground(Gp.MOVE_BG_LVERT);
		setBorder(Gp.getBorder(Gp.LABEL_BORDER));
		setEditable(false);
	}
	public void adapteTextField(){
		putClientProperty(Edit.TYPE_FIELD,Edit.TEXT);
		setForeground(Gp.LABEL_FG_BLACK);
		setBackground(Gp.UPDATE_BG_JAUNE);
		setBorder(Gp.getBorder(Gp.LABEL_FG_BLACK));
		setEditable(true);
	}
	public void setColor(Color color){
		setDisabledTextColor(color);
	}
	public void setAlert(boolean alert){
		Color colorF=null;
		Color colorB=null;
		if (alert){
			colorF=Gp.INVALIDE_FG_RED;
			colorB=Gp.MOVE_BG_LRED;
		} else {
			colorF=Gp.VERTFONCE_FG;
			colorB=Gp.MOVE_BG_LVERT;
		}
		if (isEditable()){

		} else {
			this.setColor(colorF);
			this.setBackground(colorB);
		}
	}
	public void paint(Graphics g){
		// dessine le text
		super.paint(g);
		Graphics2D g2=(Graphics2D) g;
		g2.rotate(Math.toRadians(90 * rotation));

		if (borderHeader){
			headerBorderPaint(g);
		}

		// dessine le superText
		surPaint(g,superText,x,y);{
			surPaintText(g,superText,color);
		}
		g2.rotate(Math.toRadians(90 * (rotation*-1)));
	}
	
    public Point getToolTipLocation(MouseEvent event) {
        return new Point(getWidth()/2, getHeight()+(Gp.HEIGHTCHAR/2));
    }


	public void headerBorderPaint(Graphics g){
		Color saveColor=g.getColor();
		g.setColor(colorBorderHeader);
		g.drawLine(0,0,getWidth(),0);
		g.drawLine(0,getHeight()-1,getWidth(),getHeight()-1);
		g.drawLine(getWidth(),1,getWidth(),getHeight());
		g.setColor(saveColor);
	}
	public void surPaint(Graphics g,String txt, int x,int y){
		int width	=  g.getFontMetrics(g.getFont()).stringWidth(txt);
		int height	=  g.getFontMetrics(g.getFont()).getHeight();

		switch (x){
			case JTextDb.LEFT:
				this.x=0+this.getInsets().left; break;
			case JTextDb.RIGHT:
				this.x=this.getWidth()-(width+this.getInsets().right); break;
			case JTextDb.CENTER:
				this.x=((this.getWidth()-(width))/2)-this.getInsets().left; break;
			default:
				this.x=x;
		}
		switch (y){
			case JTextDb.TOP:
				this.y=0+this.getInsets().top; break;
			case JTextDb.BOTTOM:
				this.y=this.getHeight()-this.getInsets().top-height; break;
			case JTextDb.CENTER:
				this.y=(this.getHeight()/2)+this.getInsets().top; break;
			default:
				this.y=y;
		}
	}
	public void surPaintText(Graphics g,String txt,Color color){
		Color saveColor=g.getColor();
		if (this.getText().length()==0){
			g.setColor(color);
			if (txt.length()>0){
				if (this.getWidth()>txt.length()*Gp.WIDTHCHAR) {
					g.drawString(txt,this.x,this.y);
				} else {
					g.drawString(txt,this.getInsets().left,this.y);
				}
			}
		}
		g.setColor(saveColor);
	}
	public void setWebBrowse(String nondusite,String urlsiteweb) {
		if (urlsiteweb!=null){
			if (!web) { 
				addMouseListener(this);
				web=true;
			}
			setUrlWebBrowse(urlsiteweb);
			setText(nondusite);
			adapteTextLibe();
			setUnderline(true);
		}
	}
	public void setUrlWebBrowse(String urlsiteweb){
		if (urlsiteweb!=null){
			this.urlsiteWeb=urlsiteweb;
		}		
	}
	public void setWebMailto(String mailto) {
		if (mailto!=null){
			if (!mailTo){
				addMouseListener(this);
				mailTo=true;
			}
			setText(mailto);
			adapteTextLibe();
			setUnderline(true);
		}
	}
	public String getSubject() {
		return subject;
	}
	public void setSubject(String subject) {
		this.subject = subject;
	}
	public String getBody() {
		return body;
	}
	public void setBody(String body) {
		this.body = body;
	}
	boolean clicked=false;
	public void mouseClicked(MouseEvent e) {
		if (web){
			if(Desktop.isDesktopSupported()){
				if(Desktop.getDesktop().isSupported(Desktop.Action.BROWSE)){
					URI uri;
					try {
						if (urlsiteWeb.contains("http://")){
							uri = new URI(urlsiteWeb);
						} else {
							uri = new URI("http://"+urlsiteWeb);
						}
						Desktop.getDesktop().browse(uri);
						uri=null;
					} catch (URISyntaxException arg0) {
						arg0.printStackTrace();
					} catch (IOException arg0) {
						arg0.printStackTrace();
					}
				}
			}
		}
		if (mailTo){
			if(Desktop.isDesktopSupported()){		
				if(Desktop.getDesktop().isSupported(Desktop.Action.MAIL)){
					try {
						mail=getText();
						URI uri = new URI("mailto",mail+"?SUBJECT="+subject+"&BODY="+body,null);
						Desktop.getDesktop().mail(uri);
						uri=null;
					} catch (IOException arg0) {
						arg0.printStackTrace();
					} catch (URISyntaxException arg0) {
						arg0.printStackTrace();
					}
				}
			}
		}
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
	public void keyPressed(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
	public void dispose() {
		ms1204=null;
		fe=null;
		fl=null;
	}
	// Gestion du lecteur CB
	public void setCbMS1204(AbstractMS1204 ms1204){
		if (ms1204!=null){
			this.ms1204=ms1204;
			//			if (ms1204!=null){
			//				addMouseListener(this);
			//			}
			setUnderline(true);
		}
	}
	public void focusGained(FocusEvent arg0) {
		if (selectAllOnFocus){
			this.selectAll();
		}
		if (ms1204!=null){
			startWaitCodeCb();
		}
	}
	public boolean startWaitCodeCb(){
		boolean ret=true;
		if (ms1204!=null){
			if (this.isEditable()){
				if (this.isEnabled()){
					if (this.isShowing()){
						ms1204.setCbOn(true);

						new Thread(this).start();
						if (selectAllOnFocus){
							this.selectAll();
						}
					}
				}
			}
		}
		return ret;
	}
	public void run() {
		ms1204.waitCodeCb();
		while (ms1204.isWaitCodeCb()==true){
			try {  
				Thread.sleep(ms1204.getSleepSerial());
			} catch (InterruptedException arg0) { arg0.printStackTrace(); } 

		}
		// Fin du run  rception d'un code barre
		String codeCb=ms1204.readCodeCb();
		//System.out.println("ms1204 :"+codeCb);
		if (codeCb!=null){
			setText(codeCb);
			ms1204.setCbOff(false);
		}
	}
	public void focusLost(FocusEvent arg0) {
		Color saveColor=this.getBackground();
		this.setBackground(Gp.MOVE_BG_LVERT);
		this.setSelectionStart(0);
		this.setSelectionEnd(0);
		this.setBackground(saveColor);
		if (ms1204!=null){
			ms1204.stopWaitCodeCb();
			ms1204.setCbOff(false);
		}
	}
	protected void finalize()  {
		if (debugDisposeTrace){
			Gp.ad("finalize : "+this.getName());
		}
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
