package composant_saisie.wComposant;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wCalendar.JPCalendar;
import composant_saisie.wCalendar.LinkTableDate;
import composant_saisie.wPtime.Day;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JTextDbDate extends JTextDb implements MouseListener, JPopupIClicked, MouseWheelListener   {
	private static final long serialVersionUID = 1L;
	int type=JPCalendar.DAY;
	int attribut=JPCalendar.AT_SDAY;
	JPopup jpopup=null;
	Sql sql=null;
	Color colorfondfleche=null;
	Color colorfondflechesave=new Color(230,230,230);
	Color colortraitgauche=null;
	Color colorcadrefond=null;
	JPCalendar jpcalendar=null;
	int x=0;
	int y=0;
	int width=0;
	int height=0;
	public int calctable=0;
	public JTextDbDate() {
		// Rien pour le moment juste pour le cellRenderer de la table
		colortraitgauche=Color.GRAY;
		colorfondfleche=colorfondflechesave;
		colorcadrefond=Color.GRAY;
		calctable=0;
	}
	public JTextDbDate(Sql sql) {
		this.sql=sql;
		calctable=1;
		adapte();
	}
	private void adapte(){
		addMouseListener(this);
		this.addMouseWheelListener(this);
		this.setDisabledTextColor(Gp.VERTFONCE_FG);
		//this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
		setCursor(Cursor.getPredefinedCursor(Cursor.TEXT_CURSOR));
		this.setWidthChar(10+4);
		this.setHorizontalAlignment(SwingConstants.RIGHT);
		colortraitgauche=Color.LIGHT_GRAY;
		colorfondfleche=colorfondflechesave;
		colorcadrefond=Color.DARK_GRAY;
		jpopup=new JPopup();{
			jpcalendar =new JPCalendar();{
				setType(type,attribut);
			}
			jpopup.addComposant(jpcalendar,this);
			jpopup.validateDebut();
		}
	}
	public void setType(int type,int attribut){
		setType(type,attribut,null);
	}
	public void setText(String str){
		setSDate(str);
	}
	public void setType(int type,int attribut,LinkTableDate lt){
		this.type=type;
		this.attribut=attribut;
		switch (type){
			case JPCalendar.DAY:
				putClientProperty(Edit.TYPE_FIELD,Edit.DATE);
				break;
			case JPCalendar.MONTH:
				putClientProperty(Edit.TYPE_FIELD,Edit.MONTH);
				break;
		}
		if (lt==null){
			jpcalendar.setType(type,attribut);
		} else {
			jpcalendar.setType(type,attribut,lt);
		}
	}
	/*///////////////
	// UTILISATEUR //
	///////////////*/
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent arg0) {
		if (arg0.isControlDown()){
			switch (arg0.getKeyCode()) {
				case KeyEvent.VK_UP: 
					jpcalendar.incrValue();
					setTextType(jpcalendar.getSDate());
					arg0.consume();
					break; 
				case KeyEvent.VK_DOWN: 
					jpcalendar.decrValue();
					setTextType(jpcalendar.getSDate());
					arg0.consume(); 
					break;
			}
		} else {
			switch (arg0.getKeyCode()) {
				case KeyEvent.VK_UP:
				case KeyEvent.VK_DOWN:
				case KeyEvent.VK_ENTER: 
					arg0.consume(); break;
				case KeyEvent.VK_F2:
					arg0.consume(); 
					jpopup.isTrigger=false;
					jpopup.openPopup(); 
					checkAndRoundText();
					break; }
		}
	}
	public void mouseClicked(MouseEvent arg0) {
		if (isEnabled()){
			if ( SwingUtilities.isLeftMouseButton(arg0) ){ 
				if (arg0.getClickCount()==2) {
					jpopup.openPopup();
					checkAndRoundText();
				} else if (arg0.getClickCount()==1){ 				
					if (clickedInFleche(getMousePosition())){
						jpopup.openPopup();
						checkAndRoundText();
					}
				}
			}  else 	if ( SwingUtilities.isRightMouseButton(arg0) ){
				if (arg0.getClickCount()==1) {
					setSDate(Day.getCurrentSDate());
				} else if (arg0.getClickCount()==2) {
					setSDate("01/"+Day.getCurrentSDate().substring(3,10));
				}
			}
		}
	}
	public void mouseWheelMoved(MouseWheelEvent e) {
		if (isEnabled()){
			if (e.getWheelRotation()>0){
				jpcalendar.incrValue();
			} else {
				jpcalendar.decrValue();
			}
			setTextType(jpcalendar.getSDate());
		}
	}
	private void setTextType(String text){
		switch (type){
			case JPCalendar.DAY:
				super.setText(text);
				break;
			case JPCalendar.MONTH:
				String month=text;
				super.setText( month.substring(3,10) );
				break;
		}
	}
	// Interface JPopupIClicked
	public boolean clickedInFleche(Point point){
		boolean ret=false;
		int xmin=0;
		int xmax=getHeight()-1;
		int ymin=0;
		int ymax=getHeight()-1;
		if (point!=null){
			int x=point.x;
			int y=point.y;
			if ((xmin<x && x<xmax) && (ymin < y && y < ymax) )
				ret=true;
		}
		return ret;
	}
	public void setComputedSDate(String date, int nbjour) {
		Day tmp=new Day();
		tmp.setSDate(date);
		tmp.addDay(nbjour);
		setSDate(tmp.getSDate());
	}
	public void setSDate(String date) {
		super.setText(date);
		checkAndRoundText();
	}
	public String getSDate(){
		return jpcalendar.getSDate();
	}
	public long getNDate() {
		Day tmp=new Day();
		tmp.setSDate(jpcalendar.getSDate());
		return tmp.getNDate();
	}
	public String getSReverseDate(){
		return jpcalendar.getSReverseDate();
	}
	public String getSQuan() {
		return jpcalendar.getSQuan();
	}
	public String getSMonthSYear(){
		return jpcalendar.getSMonthSYear();
	}
	public long getTime() {
		return jpcalendar.getTime();
	}
	public int getMonth() {
		return jpcalendar.getMonth();
	}
	public ArrayList<Object> getCalendarValuesWeeks(){
		return jpcalendar.getCalendarValuesWeeks();
	}
	public ArrayList<Object> getCalendarValues(){
		return jpcalendar.getCalendarValues();
	}
	public ArrayList<Day> getCalendarDays(){
		return jpcalendar.getCalendarDays();
	}
	private void checkAndRoundText(){		
		setValueChild();
	}
	public boolean isDayTrue() {
		boolean ret=true;
		if (getText().equals("00/00/2000") || getText().isEmpty()){
			ret=false;
		}
		return ret;
	}

	public void setValueChild() {
		switch (type){
			case JPCalendar.DAY:
				//			if (getText().trim().length()==10){
				//				System.out.println(Calendar.getInstance().getTime());
				jpcalendar.setSDate(getText());
				//			}
				break;
			case JPCalendar.MONTH:
				//			if (("01/"+getText()).trim().length()==10){
				jpcalendar.setSDate("01/"+getText());
				//			}
				break;
		}
	}

	public void setValueFromChild(Object obj) {
		setTextType(((Day) obj).getSDate());
	}
	public JFrame getMainFrame() {
		return sql.getMf();
	}
	// Interface JPopupIClicked
	public void setPlage(String timedeb,String timefin) {
		//		Point deb=Day.parseTime(timedeb);
		//		Point fin=Day.parseTime(timefin);
		//		jpcalendar.setPlage(deb,fin);
		//		setText(jpcalendar.getSTime());
	}

	/*/////////////////////////
	// INTERFACE UTILISATEUR //
	/////////////////////////*/
	public void mouseExited(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mousePressed(MouseEvent arg0) {
		if (this.isEnabled()){
			if (clickedInFleche(getMousePosition())){
				colorfondfleche=getSelectionColor();
				repaint();
			}
		}
	}
	public void mouseReleased(MouseEvent arg0) {
		if (this.isEnabled()){
			if (clickedInFleche(getMousePosition())){
				colorfondfleche=colorfondflechesave;
				repaint();
			}
		}
	}
	public void paint(Graphics g){
		super.paint(g);
		flechePaint(g);
		super.surPaint(g,getText(),JTextDb.RIGHT, JTextDb.CENTER);
		paintBorder(g); // le text deborde sur le cadre
	}
	private void flechePaint(Graphics g) {
		int xx=getWidth ()-(getHeight ());
		xx=2;
		Color saveColor=g.getColor();
		// Trait Verticale gauche
		g.setColor(colortraitgauche);
		x=xx;
		y=0;
		width=1;
		height=getHeight ();
		g.fillRect(x, y, width,height );

		// carr gris
		g.setColor(colorfondfleche);
		x=xx;
		y=2;
		width=getHeight ()-3;
		height=getHeight ()-4;
		g.fillRect(x, y, width,height );

		// Ombre Cadre du carr gris
		x=xx;
		y=2;
		width=getHeight ()-2;
		height=getHeight ()-4;
		g.setColor(Color.GRAY);
		g.drawRect(x, y, width,height );
		// Cadre du carr gris
		x=xx;
		y=2;
		width=getHeight ()-3;
		height=getHeight ()-5;
		g.setColor(Gp.VERTFONCE_FG);
		g.drawRect(x, y, width,height );


		if (calctable==1) {
			// cadrillage 
			g.setColor(Color.GRAY);
			g.drawLine(xx+2, y+4 , xx+2+12,y+4 ); // Horizontal 
			g.drawLine(xx+2, y+5 , xx+2+12,y+5 ); // Horizontal 

			g.setColor(Color.DARK_GRAY);
			g.drawLine(xx+2, y+3 , xx+2+12,y+3 ); // Horizontal 
			g.drawLine(xx+2, y+6 , xx+2+12,y+6 );
			g.drawLine(xx+2, y+9 , xx+2+12,y+9 );
			g.drawLine(xx+2, y+12, xx+2+12,y+12);

			g.drawLine(xx+2+0 , y+3 , xx+2+0 ,y+12 ); // Vertical 
			g.drawLine(xx+2+4 , y+3 , xx+2+4 ,y+12 );
			g.drawLine(xx+2+8 , y+3 , xx+2+8 ,y+12 );
			g.drawLine(xx+2+12, y+3 , xx+2+12,y+12 );

		} else {
		}
		g.setColor(saveColor);
	}
	public void dispose(){
		if (jpopup!=null){
			jpopup.disposePopup();
			jpopup=null;
		}
		if (jpcalendar!=null){
			jpcalendar.dispose();
			jpcalendar=null;
		}
		sql=null;
		super.dispose();
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+this.getName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
