package composant_saisie.wComposant;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JLabel;
import javax.swing.UIManager;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JTextLabel extends JLabel {
	private static final long serialVersionUID = 1L;
	String txt="essai";
	int x=0;
	int y=0;
	public JTextLabel (String str){
		super();
		adapte();
		this.txt=str;
	}
	public JTextLabel() {
		super();
		adapte();
		this.txt="";
	}
	public void setText(String txt){
		this.txt=txt;
		repaint();
	}
	private void adapte(){
		this.setFont(Gp.FONTTEXT12);
	}
	public void adapteTitre(){
		this.setFont(Gp.FONTTEXT12);
		this.setHorizontalAlignment(JLabel.CENTER);
		this.setOpaque(true);
		this.setPreferredSize(new Dimension(0,Gp.HEIGHTCHAR+4));
		repaint();
	}
	public void paintComponent(Graphics g){
		super.paintComponent(g);
		if (this.getText().isEmpty()){
		Color saveColor=g.getColor();
		Graphics2D g2=(Graphics2D) g;
		g2.setColor(UIManager.getColor("Table.selectionBackground"));
		g2.fillRoundRect(0,0, getWidth()-1,getHeight()-1,2,2);
		g.setColor(saveColor);
		}
		
		// dessine le superText
		surPaint(g,txt,JTextDb.CENTER,JTextDb.CENTER);{
			surPaintText(g,txt,Color.WHITE);
		}
	}
	public void append(String string) {
		String str="<html><b><br>"+string+"<br></b></html>";
		super.setText(str);
		revalidate();
	}
	public void setSizeChar(int width,int height){
		Dimension dim=new Dimension(((width+2)*Gp.WIDTHCHAR),(height+4)*Gp.HEIGHTCHAR);
		setPreferredSize(dim);
		setMaximumSize  (dim);
		setMinimumSize  (dim);
		validate();
	}
	public void surPaint(Graphics g,String txt, int x,int y){
		int width	=  g.getFontMetrics(g.getFont()).stringWidth(txt);
		int height	=  g.getFontMetrics(g.getFont()).getHeight();
		int descent	=  g.getFontMetrics(g.getFont()).getDescent();

		switch (x){
		case JTextDb.LEFT:
			this.x=0+this.getInsets().left; break;
		case JTextDb.RIGHT:
			this.x=this.getWidth()-(width+this.getInsets().right); break;
		case JTextDb.CENTER:
			this.x=((this.getWidth()-(width))/2)-this.getInsets().left; break;
		default:
			this.x=x;
		}
		switch (y){
		case JTextDb.TOP:
			this.y=0+this.getInsets().top; break;
		case JTextDb.BOTTOM:
			this.y=this.getHeight()-this.getInsets().top-height; break;
		case JTextDb.CENTER:
			this.y=(this.getHeight()/2)+(height/2)-descent-this.getInsets().top; break;
		default:
			this.y=y;
		}
	}
	public void surPaintText(Graphics g,String txt,Color color){
		Color saveColor=g.getColor();
		g.setColor(color);
		if (this.getText().length()==0){
			if (this.getWidth()>txt.length()*Gp.WIDTHCHAR) {
				g.drawString(txt,this.x,this.y);
			} else {
				g.drawString(txt,this.getInsets().left,this.y);
			}
		}
		g.setColor(saveColor);
	}
}
