package composant_saisie.wPtime;
import java.awt.Point;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.CcsFmt;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class Day  {
	private static final long serialVersionUID = 1L;
	private Date date;
	private boolean inNeighbourMonth;

	public Day() {
		this.date = getCurrentDate();
		this.inNeighbourMonth = false;
	}
	public Day(Date date, boolean neighbour) {
		this.date = date;
		this.inNeighbourMonth = neighbour;//if the day is in the month before or after the current month
	}


	///////////////////////////////
	public boolean isCurrent() {
		return date.equals(getCurrentDate());
	}
	public boolean isCurrentMonth() {
		boolean ret=false;
		if (getMonth(date)==getMonth(getCurrentDate()))
			ret=true;
		return ret;
	}
	public boolean isInNeighbourMonth() {
		return inNeighbourMonth;
	}
	public void setSDate(String sdate) {
		this.date.setTime(Day.parseDate(sdate).getTime());
	}
	public void setTime(long time) {
		this.date.setTime(time);
	}
	public void setDate(int day) {
		this.date=setDate(date,day);
	}
	public void setMonth(int month) {
		this.date=setMonth(date,month);
	}
	public void setYear(int year) {
		this.date=setYear(date,year);
	}
	public void set(int year, int month, int date) {
		this.date=setset(year,month,date);
	}
	public void setHour(int hour) {
		this.date=setHour(date,hour);
	}
	public void setMinu(int minu) {
		this.date=setMinu(date,minu);
	}
	public void setSeco(int seco) {
		this.date=setSeco(date,seco);
	}
	////////////////////////////////
	public Date addYear(int nbYear) {
		date=addYear(date,nbYear);
		return date;
	}
	public Date addMonth(int nbMonth) {
		date=addMonth(date,nbMonth);
		return date;
	}
	public Date addDay(int nbJour) {
		date=addDay(date,nbJour);
		return date;
	}
	public Date addHour(int nbHeu) {
		date=addHeu(date,nbHeu);
		return date;
	}
	public Date addMinu(int nbMin) {
		date=addMin(date,nbMin);
		return date;
	}
	public Date addSec(int nbSec) {
		date=addSec(date,nbSec);
		return date;
	}
	////////////////////////////////
	public int getActualMaximum() {
		return getActualMaxim(date);
	}
	public int getYear() {
		return getYear(date);
	}
	public int getMonth() {
		return getMonth(date);
	}
	public int getDay(){
		return getDay(date);
	}
	public int getDate() {
		return getDate(date);
	}
	public Date getDateDate() {
		return date;
	}
	public int getHour() {
		return getHour(date);
	}
	public int getMinu() {
		return getMinu(date);
	}
	public int getSeco() {
		return getSeco(date);
	}
	public int getDayOfWeek() {
		return getDayOfWeek(date);
	}
	public int getWeekOfYear(int year) {
		return getWeekOfYear(date,year);
	}
	public int getFirstDayOfWeek() {
		return getFirstDayOfWeek(date);
	}
	public Date getDateOnly() {
		return convertToDateOnly(date);
	}
	public long getTime(){
		return date.getTime();
	}
	public Point getPTime(){
		return getPTime(date);
	}
	public long getNDate() {
	    // The number of milliseconds in one day
	    long ONE_DAY = 1000 * 60 * 60 * 24;
	    return Math.round(date.getTime()/ONE_DAY);
	}
	public String getSDay() {
		return CcsFmt.ligLig(""+getDay(date),2);
	}
	public String getSMonth() {
		return CcsFmt.ligLig(""+getMonth(date),2);
	}
	public String getSYear() {
		return CcsFmt.ligLig(""+getYear(date),4);
	}
	public String getSTime() {
		return CcsFmt.ligLig(""+getHour(date),2)+":"+CcsFmt.ligLig(""+getMinu(date),2);
	}
	public  String getSseco() {
		return CcsFmt.ligLig(""+getSeco(date),2);
	}
	public  String getSminu() {
		return CcsFmt.ligLig(""+getMinu(date),2);
	}
	public  String getShour() {
		return CcsFmt.ligLig(""+getHour(date),2);
	}
	public String getSDate() {
		return geSDate(date);
	}
	public String getSReverseDate() {
		return geSReverseDate(date);
	}
	public String getSQuan() {
		return geSQuan(date);
	}
	public String getSMonthSYear() {
		return getSMonthSYear(date);
	}
	public String getSYearSMonth() {
		return getSYearSMonth(date);
	}
	public String getStrMonth() {
		return getStrMonth(date);
	}
	public String getReverseDate() {
		return getReverseDate(date);
	}
	/////////////////////////////////////////////////////
	/////////////////////////////////////////////////////
	private static Calendar cal = Calendar.getInstance();

	public static Date convertToDateOnly(Date date) {
		cal.setTime(date);
		Calendar temp = Calendar.getInstance();
		temp.clear();
		temp.set(cal.get(Calendar.YEAR), cal.get(Calendar.MONTH), cal.get(Calendar.DATE));
		return temp.getTime();
	}
	public static Date setDate(Date date, int day) {
		cal.setTime(date);
		cal.set(Calendar.DATE,day);
		return cal.getTime();
	}
	public static Date setYear(Date date, int year) {
		cal.setTime(date);
		cal.set(Calendar.YEAR,year);
		return cal.getTime();
	}
	public static Date setMonth(Date date, int month) {
		cal.setTime(date);
		cal.set(Calendar.MONTH,month);
		return cal.getTime();
	}
	public static Date setset(int year, int month, int date) {
		cal.set(year,month,date);
		return cal.getTime();
	}
	public static Date setHour(Date date, int hour) {
		cal.setTime(date);
		cal.set(Calendar.HOUR_OF_DAY,hour);
		return cal.getTime();
	}
	public static Date setMinu(Date date, int minu) {
		cal.setTime(date);
		cal.set(Calendar.MINUTE,minu);
		return cal.getTime();
	}
	public static Date setSeco(Date date, int seco) {
		cal.setTime(date);
		cal.set(Calendar.SECOND,seco);
		return cal.getTime();
	}

	public static Date addYear(Date date, int nbYear) {
		cal.setTime(date);
		cal.add(Calendar.YEAR,nbYear);
		return convertToDateOnly(cal.getTime());
	}
	public static Date addMonth(Date date, int nbMonth) {
		cal.setTime(date);
		cal.add(Calendar.MONTH,nbMonth);
		return convertToDateOnly(cal.getTime());
	}
	public static Date addDay(Date date, int nbDate) {
		cal.setTime(date);
		cal.add(Calendar.DATE,nbDate);
		return convertToDateOnly(cal.getTime());
	}
	public static Date addHeu(Date date, int nbHeu) {
		cal.setTime(date);
		cal.add(Calendar.HOUR,nbHeu);
		return cal.getTime();
	}
	public static Date addMin(Date date, int nbMin) {
		cal.setTime(date);
		cal.add(Calendar.MINUTE,nbMin);
		return cal.getTime();
	}
	public static Date addSec(Date date, int nbSec) {
		cal.setTime(date);
		cal.add(Calendar.SECOND,nbSec);
		return cal.getTime();
	}

	public static String getCurrentSDate() {
		Day ret=new Day();
		return ret.getSDate();
		
	}
	public static String getDebYearSDate(int deca) {
		Day ret=new Day();
		ret.addDay(deca);
		ret.setSDate("01/01/"+ret.getSDate().substring(6,10));
		return ret.getSDate();
	}
	public static String getFinYearSDate(int deca) {
		Day ret=new Day();
		ret.addDay(deca);
		ret.setSDate("31/12/"+ret.getSDate().substring(6,10));
		return ret.getSDate();
	}
	public static String getDebWeekSDate(int deca) {
		Day ret=new Day();
		ret.addDay(deca);
		for (;ret.getDayOfWeek()!=2;){
			ret.addDay(-1);
		}
		return ret.getSDate();
	}
	public static String getFinWeekSDate(int deca) {
		Day ret=new Day();
		ret.addDay(deca);
		for (;ret.getDayOfWeek()!=7;){
			ret.addDay(1);
		}
		return ret.getSDate();
	}
	public static String getDebMonthSDate(int deca) {
		Day ret=new Day();
		ret.addDay(deca);
		for (String month=ret.getSMonth();ret.getSMonth().equals(month);){
			ret.addDay(-1);
		}
		ret.addDay(1);
		return ret.getSDate();
	}
	public static String getFinMonthSDate(int deca) {
		Day ret=new Day();
		ret.addDay(deca);
		for (String month=ret.getSMonth();ret.getSMonth().equals(month);){
			ret.addDay(1);
		}
		ret.addDay(-1);
		return ret.getSDate();
	}
	public static String getCurrentSTime() {
		Day ret=new Day();
		ret.setTime(Calendar.getInstance().getTime().getTime());
		return ret.getSTime();
	}
	public static String geSDate(Date date) {
		return CcsFmt.ligLig(""+getDay(date),2)+"/"+CcsFmt.ligLig(""+(getMonth(date)+1),2)+"/"+CcsFmt.ligLig(""+getYear(date),4);
	}
	public static String geSReverseDate(Date date) {
		return CcsFmt.ligLig(""+getYear(date),4)+"/"+CcsFmt.ligLig(""+(getMonth(date)+1),2)+"/"+CcsFmt.ligLig(""+getDay(date),2);
	}
	public static String geSQuan(Date date) {
		int ret=0;
		Day tmp=new Day();
		tmp.setTime(date.getTime());
		tmp.setDate(1);
		tmp.setMonth(0);
		tmp.addDay(-1);
		ret=getInterval(tmp.getDateDate(),date);
		return CcsFmt.ligLig(""+ret,3);
	}
	public static int getInterval(Date dateMin,Date dateMax) {
		int ret=0;
		long MILLISECONDS_PER_DAY = 1000 * 60 * 60 * 24; 
		long delta = dateMax.getTime() - dateMin.getTime();
		ret=(int) (delta / (MILLISECONDS_PER_DAY));
		return ret;
	}

	public static String getSMonthSYear(Date date) {
		return CcsFmt.ligLig(""+(getMonth(date)+1),2)+"/"+CcsFmt.ligLig(""+getYear(date),4);
	}
	public static String getSYearSMonth(Date date) {
		return CcsFmt.ligLig(""+CcsFmt.ligLig(""+getYear(date),4)+"/"+(getMonth(date)+1),2);
	}
	public static String getStrDate(Date date){
		SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy");
		return df.format(date);
	}
	public static String getStrMonthYear(Date date) {
		SimpleDateFormat mf = new SimpleDateFormat("MMMM yyyy");
		return mf.format(date);
	}
	public static String getStrMonth(Date date) {
		SimpleDateFormat mf = new SimpleDateFormat("MMMM");
		return mf.format(date);
	}
	public String getReverseDate(Date date2) {
		SimpleDateFormat df = new SimpleDateFormat("yyyy/MM/dd");
		return df.format(date);
	}
	public static Calendar getCalendar(Date date){
		cal.setTime(date);
		return cal;
	}
	public static Date getCurrentDate(){
		return convertToDateOnly(Calendar.getInstance().getTime());
	}    
	public static int getActualMaxim(Date date) {
		cal.setTime(date);
		return cal.getActualMaximum(Calendar.DATE);
	}
	public static int getYear(Date date) {
		cal.setTime(date);
		return cal.get(Calendar.YEAR);
	}
	public static int getMonth(Date date) {
		cal.setTime(date);
		return cal.get(Calendar.MONTH);
	}
	public static int getDay(Date date) {
		cal.setTime(date);
		return cal.get(Calendar.DAY_OF_MONTH);
	}
	public static int getDate(Date date) {
		cal.setTime(date);
		return cal.get(Calendar.DATE);
	}

	public static int getHour(Date date) {
		cal.setTime(date);
		return cal.get(Calendar.HOUR_OF_DAY);
	}
	public static int getMinu(Date date) {
		cal.setTime(date);
		return cal.get(Calendar.MINUTE);
	}
	public static int getSeco(Date date) {
		cal.setTime(date);
		return cal.get(Calendar.SECOND);
	}
	public static int getDayOfWeek(Date date) {
		cal.setTime(date);
		return cal.get(Calendar.DAY_OF_WEEK);
	}
	public static int getDayOfWeekShift(int numjour){
		int ret=numjour;
		if (ret==1)
			ret=7;
		else
			ret--;
		return ret;
	}
	public static int getWeekOfYear(Date date,int year) {
		cal.setTime(date);
		//		Day tmp=new Day();
		//		tmp.setTime(date.getTime());
		//		tmp.setDate(1);
		//		long  nbjour=(cal.getTime()
		//				-tmp.getTime())/1000/60/60/24;
		////        cal.setFirstDayOfWeek(Calendar.MONDAY);
		////        cal.setMinimalDaysInFirstWeek(4);


		int ret=cal.get(Calendar.WEEK_OF_YEAR);
		//		if (ret==1 && cal.get(Calendar.MONTH)==12-1 && year==cal.get(Calendar.YEAR))
		//			ret=53;
		return ret;
	}

	public static int getFirstDayOfWeek(Date date) {
		cal.setTime(date);
		return cal.getFirstDayOfWeek();
	}
	public static Point getPTime(Date date) {
		cal.setTime(date);
		return new Point(cal.get(Calendar.HOUR_OF_DAY),cal.get(Calendar.MINUTE));
	}
	public static Point parseTime(String time){
		String splitter=":";
		String tab[]=time.split(splitter);
		int hour=0;
		int minute=0;
		for (int i=0;i< tab.length;i++){
			if (i==0 && tab[0].length()>0){
				hour=Gp.parseInt(CcsFmt.getDigit(tab[0]));
			}
			if (i==1 && tab[1].length()>0){
				minute=Gp.parseInt(CcsFmt.getDigit(tab[1]));
			}
		}
		Point ret=new Point(hour,minute);
		return ret;
	}
	public static int parseTimeMin(String time){
		int ret=0;
		Point point=Day.parseTime(time);
		ret=point.x*60+point.y;
		return ret;
	}
	public static String parseMinTime(int minutes){
		String ret="";
		int hour=minutes/60;
		int minu=minutes-(hour*60);
		ret=CcsFmt.ligLig(""+hour, 2)+":"+CcsFmt.ligSpace(""+minu, 2,"0");
		return ret;
	}
	public static Date parseDate(String date) {
		Day ret=new Day();
		String value=CcsFmt.formatStrDate(date,true);
		int day=Gp.parseInt(CcsFmt.formatStrDecimal(value.substring(0, 2),"99",true));
		int month=Gp.parseInt(CcsFmt.formatStrDecimal(value.substring(3, 5),"99",true))-1;
		int year=Gp.parseInt(CcsFmt.formatStrDecimal(value.substring(6, 10),"9999",true));
		ret.set(year, month, day);
		return ret.getDateOnly();
	}
	public static String minTime(String time1, String time2) {
		String ret="";
		Point vartime1=parseTime(time1);
		Point vartime2=parseTime(time2);
		if (vartime1.x*60+vartime1.y<vartime2.x*60+vartime2.y)
			ret=time1;
		else
			ret=time2;
		return ret;
	}
	public static String maxTime(String time1, String time2) {
		String ret="";
		Point vartime1=parseTime(time1);
		Point vartime2=parseTime(time2);
		if (vartime1.x*60+vartime1.y<vartime2.x*60+vartime2.y)
			ret=time2;
		else
			ret=time1;
		return ret;
	}
	public static double minuToCentieme(int minute){
		return ((double)minute)/60;
	}
	public static double parseTimeDouble(String time) {
		Double ret=0.0;
		Point vartime=parseTime(time);
		ret=vartime.x+minuToCentieme(vartime.y);
		return ret;
	}
	public static String getSJour(int jour) {
		switch (jour) {
		case 1:
			return "Lundi";
		case 2:
			return "Mardi";
		case 3:
			return "Mercredi";
		case 4:
			return "Jeudi";
		case 5:
			return "Vendredi";
		case 6:
			return "Samedi";
		case 7:
			return "Dimanche";
		default :
			return null;
		}
	}
	public static String getSMois(int mois) {
		switch (mois) {
		case 1:
			return "Janvier";
		case 2:
			return "Fvrier";
		case 3:
			return "Mars";
		case 4:
			return "Avril";
		case 5:
			return "Mai";
		case 6:
			return "Juin";
		case 7:
			return "Juillet";
		case 8:
			return "Aot";
		case 9:
			return "Septembre";
		case 10:
			return "Octobre";
		case 11:
			return "Novembre";
		case 12:
			return "Dcembre";
		default :
			return null;
		}
	}
	public static double getDWeekWork(String sdate,int mois) {
		//		Day daydeb=new Day();
		//		daydeb.setSDate(sdate);
		//		daydeb.setMonth(mois-1);
		//		daydeb.setDate(1);
		//		Day dayfin=new Day();
		//		dayfin.setSDate(sdate);
		//		dayfin.setMonth(mois-1);
		//		dayfin.addMonth(1);
		//		dayfin.setDate(1);
		//		dayfin.addDate(-1);
		//		double ret=((dayfin.getDay()-daydeb.getDay()+1)/7.0)+0.005;
		//		Gp.af(daydeb.getSDate()+" "+dayfin.getSDate()+" "+(dayfin.getDay()-daydeb.getDay()+1)+" "+ret);
		//		return ret;
		switch (mois) {
		case 1:
			return 4.5;
		case 2:
			return 4;
		case 3:
			return 4.5;
		case 4:
			return 4;
		case 5:
			return 4.5;
		case 6:
			return 4.5;
		case 7:
			return 5;
		case 8:
			return 4;
		case 9:
			return 4.5;
		case 10:
			return 4.5;
		case 11:
			return 4;
		case 12:
			return 4;
		default :
			return 0;
		}
	}
}