package composant_saisie.wPtime;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JPopup;
import composant_saisie.wSaisieFormat.CcsFmt;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class JTime extends JPanel implements MouseListener, MouseMotionListener, MouseWheelListener {
	private static final long serialVersionUID = 1L;
	int orientation=SwingConstants.HORIZONTAL;
	private Time time=null;
	private Time timeMouse=null;
	ArrayList <Time> times=null;
	int periode=5;
	int pminute=60/periode;
	int pheure=24;
	int npixel=3;
	int echelleLong=(pminute*pheure*npixel)+npixel;
	int echelleLarg=80;
	int deborsDemiFrame=6;
	int retraitTime=12;
	JPanel jpParent=null;
	boolean clickable=true;
	public JTime(){
		super();
		adapte();
	}
	private void adapte(){
		setOrientation(orientation);
		this.setLayout(null);
		this.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		this.addMouseListener(this);
		this.addMouseMotionListener(this);
		this.addMouseWheelListener(this);
		this.time=new Time();
		this.times=new ArrayList<Time>();
	}
	public void setPanelToNotify(JPanel jp){
		this.jpParent=jp;
	}
	public boolean isVertical(){
		if (orientation==SwingConstants.VERTICAL){
			return true;
		} else {
			return false;
		}
	}
	public void paint(Graphics g){
		super.paint(g);
		drawEchelle(g);
		drawHourMouse(g);
		drawHour(g);
		drawDemiFrame(g);
	}
	private void drawDemiFrame(Graphics g){
		g.setColor(Gp.UPDATE_BG_JAUNE);
		if (clickable){
			if (isVertical()){
				g.fillRect(this.getWidth()/2,0+1, this.getWidth()/2, this.getHeight()-2);
				g.setColor(Color.BLACK);
				g.drawLine(this.getWidth()/2,0, this.getWidth()/2, this.getHeight());
			} else {
				g.fillRect(0+1,this.getHeight()/2+deborsDemiFrame, this.getWidth()-2, this.getHeight()/2-deborsDemiFrame);
				g.setColor(Color.BLACK);
				g.drawLine(0,this.getHeight()/2+deborsDemiFrame, this.getWidth(), this.getHeight()/2+deborsDemiFrame);
			}
		}
	}
	private void drawEchelle(Graphics g){
		if (!clickable && times.size()==0){
			g.setColor(Gp.FILIGRANE_LGRAY);
		} else {
			g.setColor(Color.BLACK);
		}
		int len=12;
		int hdraw=0;
		for (int heure=0;heure<pheure;heure++){
			for (int minute=0;minute<pminute;minute++){
				hdraw=(heure*(pminute*npixel))+(minute*npixel);
				if (minute==0){
					len=24;
					if (isVertical()){
						g.drawString(CcsFmt.ligLig(""+heure,2), len+4, hdraw);
					} else {
						g.drawString(CcsFmt.ligLig(""+heure,2), hdraw,len+12);
					}
				} else if (minute==pminute/2){
					len=18;
				} else {
					len=12;
				}
				if (isVertical()){
					g.drawLine(0, hdraw, len, hdraw);
				} else {
					g.drawLine(hdraw, 0, hdraw, len);
				}
			}

			// la derniere borne
			hdraw=pheure*(pminute*npixel);
			len=24;
			if (isVertical()){
				g.drawLine(0, hdraw, len, hdraw);
			} else {
				g.drawLine(hdraw, 0, hdraw, len);
			}
		}
	}
	private void drawHourMouse(Graphics g){
		if (clickable){
			g.setColor(Color.BLACK);
			if (timeMouse!=null){
				Font font=g.getFont();
				if (isPlage()){
					if (timeMouse.fin.getTime()==time.debut.getTime()){
						g.setColor(Gp.INVALIDE_FG_RED);
					}
				} else {
					g.setFont(Gp.FONTTEXT12);
				}
				if (timeMouse.fin.getTime()==time.fin.getTime()){
					g.setColor(Gp.INVALIDE_FG_RED);
				}
				if (isVertical()){
					g.drawString(timeMouse.getSTime(),echelleLarg-35,Math.max(pTimeToNbPixel(timeMouse.getPTime())-retraitTime,12));
				} else {
					g.drawString(timeMouse.getSTime(),Math.min(pTimeToNbPixel(timeMouse.getPTime())-retraitTime,echelleLong-30),60);
				}
				g.setFont(font);
			}
		}
	}
	private void drawHour(Graphics g){
		Font font=g.getFont();
		g.setFont(Gp.FONTTEXT12);
		int deb=pTimeToNbPixel(time.debut.getPTime());
		int fin=pTimeToNbPixel(time.fin.getPTime());
		if (time.debut.getDate()!=time.fin.getDate()){
			fin=pminute*pheure*npixel;
		}
		if (isPlage()){
			((JPTime)jpParent).jtdeb.setText(time.debut.getSTime());
			((JPTime)jpParent).jtfin.setText(time.fin.getSTime());
			g.setColor(Gp.VERTFONCE_FG);
			if (clickable){
				drawCursPlage(g,deb,fin);
				if (isVertical()){
					g.drawString(time.getSTime(),50-3,Math.min(deb+((fin-deb)/2)-retraitTime,echelleLong-30));
				} else {
					g.drawString(time.getSTime(),Math.min(deb+((fin-deb)/2)-retraitTime,echelleLong-30),50);
				}
			} else {
				g.setColor(Gp.INVALIDE_FG_RED);
				for (int i=0;i<times.size();i++){
					int timesdeb=pTimeToNbPixel(times.get(i).getDebPTime());
					int timesfin=pTimeToNbPixel(times.get(i).getFinPTime());
					drawCursPlage(g,timesdeb,timesfin);
				}
			}
		} else {
			g.setColor(Gp.VERTFONCE_FG);
			if (isVertical()){
				g.fillRect(  18-2,fin-1, 3+2+2, 3); // Curseur
				//g.setColor(Gp.INVALIDE_FG_RED);
				g.drawString(time.getSTime(),echelleLarg-35,Math.max(pTimeToNbPixel(time.getPTime())-retraitTime,12));
			} else {
				g.fillRect( fin-1, 18-2, 3, 3+2+2); // curseur
				//g.setColor(Gp.INVALIDE_FG_RED);
				g.drawString(time.getSTime(),Math.min(pTimeToNbPixel(time.getPTime())-retraitTime,echelleLong-30),50);
			}
		}
		g.setColor(Color.BLACK);
		g.setFont(font);
	}
	private void drawCursPlage(Graphics g,int deb,int fin){
		if (isVertical()){
			g.fillRect(18,deb, 3,  fin-deb); // plage
			g.fillRect(  18-2,deb+((fin-deb)/2)-1, 3+2+2, 3); // Curseur
		} else {
			g.fillRect(deb, 18, fin-deb, 3); // plage
			g.fillRect( deb+((fin-deb)/2)-1, 18-2, 3, 3+2+2); // curseur
		}
	}
	public boolean isPlage(){
		return time.isPlage();
	}
	public int getPeriode(){
		return periode;
	}
	public void setPeriode(int periode){
		this.periode=periode;
		pminute=60/periode;
	}
	private int pTimeToNbPixel(Point time){
		int ret=0;
		ret=time.x*pminute*npixel;
		ret=ret+( (time.y/periode)*npixel);
		return ret;
	}
	private int getTimeFromPixel(int time){
		int ret=time/npixel;
		if (ret>=pheure*pminute)
			ret=pheure*pminute;
		return ret;
	}
	private int getHeure(int time){
		int ret=time/pminute;
		return ret;
	}
	private int getMinut(int time){
		int ret=getHeure(time);
		ret=(time - (ret*pminute))*periode;
		return ret;
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {
		timeMouse=null;
		repaint();
	}
	public void setVisible(boolean visible){
		if (!visible){
			timeMouse=null;
		}
		super.setVisible(visible);
		repaint();
	}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
		if (clickable){
			if ( SwingUtilities.isLeftMouseButton(e) ){ 
				if (e.getClickCount()==2) {
					timeMouse=null;
					repaint();
					setF2();
				} else {
					if (timeMouse!=null){
						if (isDemiFrame(e)){
							if (isPlage()){
								if (timeMouse.fin.getTime()>time.getLMilTime()){
									time.fin.setTime(timeMouse.fin.getTime());
								} else {
									time.debut.setTime(timeMouse.fin.getTime());
								}
							} else {
								time.fin.setTime(timeMouse.fin.getTime());
							}
						} else {
							timeMouse=null;
						}
						repaint();
					} 
				}
			}
		}
	}

	public void setF2(){
		if (jpParent!=null)
			jpParent.putClientProperty(JPopup.T_RETURN, getTimeValue());
	}
	public void mouseWheelMoved(MouseWheelEvent e) {
		if (isEnabled()){
			if (clickable){
				if (e.getWheelRotation()>0){
					incrValue();
				} else {
					decrValue();
				}
			}
		}
	}
	public void incrValue() {
		if (isPlage()){
			if (timeMouse!=null){ 
				if (timeMouse.fin.getTime()>time.getLMilTime()){
					time.incrMinFin(pheure,periode);
				} else {
					time.incrMinDebut(pheure,periode);
				}
			}
		} else {
			time.incrMinFin(pheure,periode);
		}
		if (isVisible()){
			repaint();
		}
	}
	public void decrValue() {
		if (isPlage()){
			if (timeMouse!=null){ 
				if (timeMouse.fin.getTime()>time.getLMilTime()){
					time.decrMinFin(pheure,periode);
				} else {
					time.decrMinDebut(pheure,periode);
				}
			}
		} else {
			time.decrMinFin(pheure,periode);
		}
		if (isVisible()){
			repaint();
		}
	}
	public void mouseDragged(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {
		if (isDemiFrame(e)){
			int time;
			if (isVertical()){
				time=getTimeFromPixel(e.getY());
			} else {
				time=getTimeFromPixel(e.getX());
			}
			if (timeMouse==null)
				timeMouse=new Time();
			timeMouse.setPTime(new Point(getHeure(time),getMinut(time)));
			repaint();
		} else {
			timeMouse=null;
			repaint();
		}
	}
	private boolean isDemiFrame(MouseEvent e){
		boolean ret=false;
		if (isVertical()){
			if (e.getX()<echelleLarg/2)
				ret=true;
		} else {
			if (e.getY()<(echelleLarg/2)+deborsDemiFrame)
				ret=true;
		}
		return ret;
	}
	// ITime
	public void setOrientation(int orientation){
		if (orientation==SwingConstants.VERTICAL){
			this.orientation=SwingConstants.VERTICAL;
			this.echelleLarg=80;
			this.npixel=2;
			this.retraitTime=-4;
		} else {
			this.orientation=SwingConstants.HORIZONTAL;
			this.echelleLarg=65;
			this.npixel=3;
			this.retraitTime=12;
		}
		this.echelleLong=(pminute*pheure*npixel)+npixel;
		Dimension dim=null;
		if (isVertical()){
			dim = new Dimension(echelleLarg,echelleLong);
		} else {
			dim = new Dimension(echelleLong,echelleLarg);
		}
		this.setSize(dim);
		this.setPreferredSize(dim);
		this.setMaximumSize(dim);
		this.setMinimumSize(dim);
		this.validate();
	}
	public void setPTime(Point temps){
		time.setPTime(temps);
		time.roundTime(pheure,periode);
	}
	public String getSTime() {
		return time.getSTime();
	}
	public String getDebSTime() {
		return time.getDebSTime();
	}
	public String getFinSTime() {
		return time.getFinSTime();
	}
	public void setTimeValue(Time time) {
		this.time.setTimeValue(time);
	}
	public int getTimeDelayMinutes() {
		return time.getTimeDelayMinutes();
	}
	public Time getTimeValue() {
		return time;
	}
	public void setPlage(String timedeb, String timefin) {
		time.setPlage(timedeb,timefin);
	}
	public String getTimeDelay() {
		return time.getTimeDelay();
	}
	public String getSTimeDelay() {
		return time.getSTimeDelay();
	}
	public void setPlage(String timetot) {
		time.setPlage(timetot);
	}
	public int getOrientation() {
		return orientation;
	}
	public void incrMinDebut() {
		time.incrMinDebut(pheure, periode);
	}
	public void incrMinFin() {
		time.incrMinFin(pheure, periode);
	}
	public void decrMinDebut() {
		time.decrMinDebut(pheure, periode);
	}
	public void decrMinFin() {
		time.decrMinFin(pheure, periode);
	}
	public void setClickable(boolean clickable) {
		this.clickable=clickable;
		((JPTime)jpParent).jpbutton.setVisible(false);
		((JPTime)jpParent).jplabel.setVisible(false);

		Dimension dim=getPreferredSize();
		if (isVertical()){
			dim.width=dim.width/3*2;
		} else {
			dim.height=dim.height/3*2;
		}
		setPreferredSize(dim);
		setSize(dim);
		validate();
	}
	public void clearPlage(){
		times.clear();
		repaint();
	}
	public void addPlage(Time time){
		times.add(time);
		repaint();
	}
	public void dispose() {
		time=null;
		timeMouse=null;
		if (times!=null){
			times.clear();
			times=null;
		}
		jpParent=null;
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
