package composant_saisie.wPtime;

import java.awt.Point;

import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.CcsFmt;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class Time {
	Day debut;
	Day fin;
	boolean plage;
	int stimeout=0;
	public Time(){
		debut=new Day();
		fin=new Day();
		plage=false;
	}
	public Time(String timedeb, String timefin){
		debut=new Day();
		fin=new Day();
		plage=false;
		setPlage(timedeb,timefin);
	}
	public boolean isPlage(){
		return plage;
	}
	public Point getPTime(){
		long time=fin.getTime()-debut.getTime(); //nombre de milli-secondes coules 
		time=time/1000;//nombre de secondes coules
		time=time/60;//nombre de minute coules
		int heure=(int)(time/60); //nombre d'heure coules
		int minut=(int)(time-(heure*60));
		return new Point(heure,minut);
	}
	public Point getDebPTime(){
		long time=debut.getTime()-debut.getDateOnly().getTime(); //nombre de milli-secondes coules 
		time=time/1000;//nombre de secondes coules
		time=time/60;//nombre de minute coules
		int heure=(int)(time/60); //nombre d'heure coules
		int minut=(int)(time-(heure*60));
		return new Point(heure,minut);
	}
	public Point getFinPTime(){
		long time=fin.getTime()-fin.getDateOnly().getTime(); //nombre de milli-secondes coules 
		time=time/1000;//nombre de secondes coules
		time=time/60;//nombre de minute coules
		int heure=(int)(time/60); //nombre d'heure coules
		int minut=(int)(time-(heure*60));
		if (fin.getDateOnly().equals(debut.getDateOnly()))
			return new Point(heure,minut);
		else
			return new Point(24,0);
	}
	public long getLMilTime(){
		long timeMil=fin.getTime()-debut.getTime();
		timeMil=debut.getTime()+(timeMil/2);
		return timeMil;
	}
	public long getTime(){
		return fin.getTime();
	}
	public String getHour(int hour){
		return CcsFmt.ligLig(""+hour,2);
	}
	public String getMinu(int minu){
		return CcsFmt.ligLig(""+minu,2);
	}
	public String getSTime(){
		return getHour(getPTime().x)+":"+getMinu(getPTime().y);
	}
	public String getDebSTime() {
		return getHour(getDebPTime().x)+":"+getMinu(getDebPTime().y);
	}
	public String getFinSTime() {
		return getHour(getFinPTime().x)+":"+getMinu(getFinPTime().y);
	}
	public void setTimeValue(Time time) {
		debut.setTime(time.debut.getTime());
		fin.setTime(time.fin.getTime());
	}
	public void setSTime(String time) {
		setHour(Integer.parseInt(time.substring(0,1+1)));
		setMinu(Integer.parseInt(time.substring(3,4+1)));
	}
	public void setPTime(Point point){
		if (point.x*60+point.y>=24*60){
			point.x=24;
			point.y=0;
		}

		fin.setTime(debut.getTime());
		fin.addHour(point.x);
		fin.addMinu(point.y);
	}
	public void setPlage(String timedeb, String timefin) {
		Point pointdeb=Day.parseTime(timedeb);
		Point pointfin=Day.parseTime(timefin);
		if (pointdeb.x*60+pointdeb.y>pointfin.x*60+pointfin.y){
			pointdeb=Day.parseTime(timefin);
			pointfin=Day.parseTime(timedeb);
		}
		debut.setHour(pointdeb.x);
		debut.setMinu(pointdeb.y);
		fin.setTime(debut.getTime());
		fin.setHour(pointfin.x);
		fin.setMinu(pointfin.y);
		plage=true;
	}
	public void setHour(int x) {
		fin.setHour(x);
	}
	public void setMinu(int y) {
		fin.setMinu(y);
	}
	public void addHour(int x) {
		fin.addHour(x);
	}
	public void addMinu(int y) {
		fin.addMinu(y);
	}
	public void roundTime(int pheure,int periode) {
		Point point=getPTime();
		if (point.x>=pheure){
			fin.setTime(debut.getTime());
			fin.addHour(pheure);
		}
		if (point.x<0 || point.y<0){
			fin.setTime(debut.getTime());
		}
		// round
		point=debut.getPTime();
		point.y=point.y/periode;		
		point.y=point.y*periode;
		debut.setMinu(point.y);

		point=fin.getPTime();
		point.y=point.y/periode;		
		point.y=point.y*periode;
		fin.setMinu(point.y);
	}
	public void incrMinFin(int pheure, int periode) {
		Point point=fin.getPTime();
		if (point.x*60+point.y+periode<=pheure*60){
			fin.addMinu(periode);
			roundTime(pheure,periode);
		}
	}
	public void incrMinDebut(int pheure, int periode) {
		if (debut.getTime()+(periode*1000*60)<=fin.getTime()){
			debut.addMinu(periode);
			roundTime(pheure,periode);
		}
	}
	public void decrMinDebut(int pheure, int periode) {
		Day temp=new Day();
		temp.setTime(debut.getTime());
		temp.addMinu(-periode);
		if (debut.getDate()==temp.getDate()){
			debut.addMinu(-periode);
			roundTime(pheure,periode);
		}
	}
	public void decrMinFin(int pheure, int periode) {
		if (fin.getTime()-(periode*1000*60)>=debut.getTime()){
			fin.addMinu(-periode);
			roundTime(pheure,periode);
		}
	}
	public void setPlage(String timetot) {
		Point ptot=Day.parseTime(timetot);
		if (ptot.x*60+ptot.y>=24*60){
			ptot.x=24;
			ptot.y=00;
			debut.setHour(0);
			debut.setMinu(0);
			fin.setTime(debut.getTime());
			fin.addHour(ptot.x);
			fin.addMinu(ptot.y);
		} else {
			fin.setTime(debut.getTime());
			fin.addHour(ptot.x);
			fin.addMinu(ptot.y);
			while (!debut.getDateOnly().equals(fin.getDateOnly())){
				debut.addMinu(-1);
				fin.addMinu(-1);
			}
		}
	}
	public String getSTimeDelay() {
		return getDebSTime()+"-"+getFinSTime()+"="+getSTime();
	}
	public String getTimeDelay() {
		return getDebSTime()+getFinSTime()+getSTime();
	}
	public int getTimeDelayMinutes() {
		return (fin.getHour()*60+fin.getMinu())-(debut.getHour()*60+debut.getMinu());
	}
}
