package composant_saisie.wSaisieFormat;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Window;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.event.DocumentListener;
import javax.swing.text.JTextComponent;

import module_standard.wToolTip.JDialogToolTip;
import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import template_applicatif.wListe.AbstractDbListe;
import a_doc.doc.Licence;

import composant_saisie.wCalculator.JTextDbCalc;
import composant_saisie.wComposant.JPlageTimes;
import composant_saisie.wComposant.JRadio;
import composant_saisie.wComposant.JTextCheck;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wComposant.JTextDbDate;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wComposant.JTextDbTime;
import composant_saisie.wComposant.JTimeDelay;
import composant_saisie.wPtime.Day;
import composant_saisie.wPtime.Time;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class Ccs  implements PropertyChangeListener, MouseListener, FocusListener {

	public static Color COLOR_TABLE_SELECTIONBACKGROUND = null;
	public static String alerte="Voir la zone encadre en rouge\n\n ";

	// Controle de saisie fiche
	public static String DISPOSE_PCL="PCL";
	public static String DISPOSE_KL="KL";
	public static String PCLTYPE="PCLTYPE";
	
	public static String CCS_UPDATE="ccsupdate";
	public static String CCS_TYPE="CCSTYPE";
	public static String CCS_NOTIFIER="ccsnotifier";
	
	public static String DEFAULTVALUE = "defaultValue";
	public static String MSG_CTRL_FALSE = "msg_ctrl_false";
	public static String NOTEMPTY = "notempty";
	public static String DATE = "date";
	public static String DATEEMPTY = "dateempty";
	public static String MONTH = "month";
	public static String YEAR = "year";
	public static String TIME = "time";
	public static String PHONE = "phone";
	public static String SECU = "secu";
	public static String URSS = "urss";
	public static String POSTAL = "postal";
	public static String JTPARENTDOC = "Parent";
	public static String INTERO = "intero";
	public static String CODEINF2 = "codeinF2";
	public static String NEWCODEF2 = "newcodef2";
	public static String LIKEINF2 = "likeinF2";
	public static String CONSULTF2 = "consultF2";
	public static String CHECKED = "checked";
	public static String RADIO = "radiochecked";
	public static String TIMEDELAY = "timedelay";
	public static String PLAGETIMES = "plagetimes";
	public static String RANGEDOUBLE = "rangedouble";
	public static String RANGEINT = "rangeint";
	public static String RANGELEN = "rangelen";
	public static String RANGEDATE = "rangedate";
	public static String RANGEDATEEMPTY = "rangedateempty";
	public static String RANGETIME = "rangetime";
	public static String NOTZERO = "notzero";


	public int indicecol=0;
	private ArrayList< JComponent > textFields=null;
	private ArrayList< JComponent > textLibes=null;
	private ArrayList< JComponent[] > dependant=null;
	boolean debug = false;
	boolean debugDependant=false;

	boolean modeUpdatable = false;
	String status="";
	Sql sql=null;
	public Ccs(Sql sqlTable){
		this.sql=sqlTable;
		this.textFields=new ArrayList<JComponent>(Gp.MAXFIELDS);
		this.textLibes=new ArrayList<JComponent>(Gp.MAXFIELDS);
		this.dependant=new ArrayList<JComponent[]>(Gp.MAXFIELDS);
	}
	////////////////////////
	// adapte les LIBELLES  //
	////////////////////////
	/**
	 *  map un Label et une dsignation d'un champs de table <br> 
	 * @param jp Panel Standard des libells ( Gauche)
	 * @param jt le label
	 * @param numField le numro de champs
	 */
	public void mapL(JPanel jp, JTextDb jt,int numField){
		jt.setText(sql.fields.get(numField).t_lib);
		jt.setName(sql.fields.get(numField).t_field);
		jt.setLibelleHelpText(sql.fields.get(numField).t_libHelp);
		if (Gp.TOOLTIP)
			if (jt.libelleHelpText.length()>0){
				jt.setText(jt.getText()+" ");
			}
		adapteL(jp,jt);
	}
	public void adapteL(JPanel jp, JTextDb jt){
		jt.putClientProperty(Edit.TYPE_FIELD, Edit.LIBE);
		jt.addMouseListener(this);
		jt.setBackground(jp.getBackground());
		TexttoLibe(jt);
		textLibes.add(jt);
	}
	/**
	 * aligne les Labels de la fiche
	 * @param sc SwingConstants
	 */
	public void alignL(int sc){
		for (int i=0;i<textLibes.size();i++){
			((JTextDb)textLibes.get(i)).setHorizontalAlignment(sc);
		}
	}
	/**
	 * ajoute les Label au panel label
	 * @param jpDbL
	 */
	public void addL(JPanel jpDbL){
		for (int i=0;i<textLibes.size();i++){
			jpDbL.add(textLibes.get(i),Gp.gety());
		}
	}
	/**
	 * ajoute les Edits au panel Edit
	 * @param jpDbL
	 */
	public void addE(JPanel jpDbE){
		for (int i=0;i<textFields.size();i++){
			jpDbE.add(textFields.get(i),Gp.gety());
		}
	}
	/**
	 * ajoute les Edits au panel Edit en ligne saisie du dtail
	 * @param jpDbL
	 */
	public void addEDetail(JPanel jpDbE){
		for (int i=0;i<textFields.size();i++){
			jpDbE.add(textFields.get(i),Gp.getx());
		}
	}
	public void setPreferredSizeELikeListe(AbstractDbListe dbListe) {
		if (dbListe!=null){
			for (int i=0;i<textFields.size();i++){
				((JComponent)textFields.get(i)).setPreferredSize(dbListe.getSizeCol(((JComponent)textFields.get(i))));
			}
		}
	}
	public void reduceLHeight(int height) {
		for (int i=0;i<textLibes.size();i++)
			((JTextDb)textLibes.get(i)).reduceHeightDim(height);
	}
	////////////////////////////////
	// adapte les zones de saisie //
	////////////////////////////////
	public void mapE(PropertyChangeListener pcl, JTextCheck jc,int field,String defaultValue){
		// Check
		adapteE(pcl,jc,defaultValue,sql.getFieldDef(field).t_fieldLength,sql.getFieldDef(field).t_field);
	}
	public void adapteE(PropertyChangeListener pcl, JTextCheck jc,String defaultValue, int length, String name){
		// Check
		jc.putClientProperty(PCLTYPE,UserUpdate.UPDATE);
		jc.putClientProperty(DISPOSE_PCL,pcl);
		jc.addPropertyChangeListener((String) jc.getClientProperty(PCLTYPE),pcl);
		adapteComponent(jc,name,defaultValue,length);
		setEListener((DocumentListener)pcl,jc);
	}

	public void adapteE(PropertyChangeListener pcl, JTimeDelay jc,int field, Fmt fmt) {
		// TimeDelay
		jc.putClientProperty(PCLTYPE,UserUpdate.UPDATE);
		jc.putClientProperty(DISPOSE_PCL,pcl);
		jc.addPropertyChangeListener((String) jc.getClientProperty(PCLTYPE),pcl);
		adapteComponent(jc,sql.getFieldDef(field).t_field,sql.getFieldDef(field).t_fieldDefaultValue,sql.getFieldDef(field).t_fieldLength);
		setEListener((DocumentListener)pcl,jc);
	}

	public void adapteE(PropertyChangeListener pcl, JPlageTimes jc,int field, Fmt fmt) {
		// plageTimes
		jc.putClientProperty(PCLTYPE,UserUpdate.UPDATE);
		jc.putClientProperty(DISPOSE_PCL,pcl);
		jc.addPropertyChangeListener((String) jc.getClientProperty(PCLTYPE),pcl);
		adapteComponent(jc,sql.getFieldDef(field).t_field,sql.getFieldDef(field).t_fieldDefaultValue,sql.getFieldDef(field).t_fieldLength);
		setEListener((DocumentListener)pcl,jc);
	}

	public void mapE(DocumentListener dl, JTextDbF2 jt, int field, String defaultValue) {
		//  F2, intero
		mapE(dl,jt,defaultValue,sql.getFieldDef(field).t_fieldLength,sql.getFieldDef(field).t_field);
	}

	/**
	 *  map un Edit et un champs de table <br> 
	 * @param dl Panel de notification
	 * @param jt l'Edit
	 * @param numField le numro de champs
	 */
	public void mapE(DocumentListener dl, JTextComponent jt, int field) {
		// champ String
		mapE(dl,jt,sql.getFieldDef(field).t_fieldDefaultValue,sql.getFieldDef(field).t_fieldLength,sql.getFieldDef(field).t_field);
	}
	public void mapE(DocumentListener dl, JTextComponent jt,String defaultValue, int length, String name){
		// champ String, F2, intero
		jt.setDocument(new CcsFmt(jt,length));
		adapteEF(dl,jt,name,defaultValue,length);
	}

	public void mapE(DocumentListener dl, JTextComponent jt,int field, Fmt fmt) {
		//Champ utilisant un Format
		String defaultValue="";
		adapteE(dl,jt,defaultValue,fmt,sql.getFieldDef(field).t_field);
	}
	public void adapteT(DocumentListener dl, JTextComponent jt,String name, Fmt fmt) {
		//Champ utilisant un Format
		String defaultValue="";
		adapteE(dl,jt,defaultValue,fmt,name);
	}
	public void mapE(DocumentListener dl, JTextComponent jt,int field, String dFormat) {
		//Champ numrique, utilisant un DecimalFormat
		sql.getFieldDef(field).t_fieldFormat=dFormat;
		String defaultValue="";
		adapteE(dl, jt,defaultValue,dFormat,sql.getFieldDef(field).t_field);
	}
	public void adapteE(DocumentListener dl, JTextComponent jt,String defaultValue, Fmt fmt,String name) {
		//Champ utilisant un DecimalFormat, Date
		if (sql.getFieldDef(name)!=null)
			sql.getFieldDef(name).t_fieldFormat=fmt.getFmt();
		jt.setDocument(new CcsFmt(jt,fmt.getFmt()));
		adapteEF(dl,jt,name,defaultValue,fmt.getFmt().length());
	}
	public void mapE(DocumentListener dl, JTextComponent jt,int field,String defaultValue, String dFormat) {
		adapteE(dl, jt,defaultValue,dFormat,sql.getFieldDef(field).t_field);		
	}
	public void adapteE(DocumentListener dl, JTextComponent jt,String defaultValue, String dFormat,String name) {
		//Champ numrique, utilisant un DecimalFormat, Date
		if (sql.getFieldDef(name)!=null)
			sql.getFieldDef(name).t_fieldFormat=dFormat;
		jt.setDocument(new CcsFmt(jt,dFormat));
		adapteEF(dl,jt,name,defaultValue,dFormat.length());
	}

	// Mise en place des listeners
	private void adapteEF(DocumentListener dl, JTextComponent jt,String name,String defaultValue,int length) {
		jt.setName(name);
		jt.getDocument().putProperty(JTPARENTDOC, jt);
		jt.getDocument().addDocumentListener(dl);
		adapteComponent(jt,name,defaultValue,length);
		setEListener(dl,jt);
	}
	private void setEListener(DocumentListener dl,JComponent jc){
		jc.putClientProperty(CCS_UPDATE,"ok");
		jc.addPropertyChangeListener(CCS_UPDATE, this);
		jc.putClientProperty(DISPOSE_KL,dl);
		jc.addKeyListener((KeyListener) dl);
		jc.addFocusListener(this);
		textFields.add(jc);
	}


	// Mise en forme 
	private void adapteComponent(JComponent jc,String name,String defaultValue,int length){
		jc.setName(name);
		jc.putClientProperty(DEFAULTVALUE,defaultValue);

		int align=1;
		Edit fieldType=null;
		Fma fma=null;
		if (sql.getFieldDef(name)!=null){
			align=getHorizontalAlignement(sql.getFieldDef(name).t_Fma);
			fieldType=sql.getFieldDef(name).t_EditType;
			fma=sql.getFieldDef(name).t_Fma;
		}
		if ( fieldType==null) {
			fieldType=(Edit) jc.getClientProperty(Edit.TYPE_FIELD);
			if (fieldType.equals(Edit.F2)){
				fma=Fma.F2;
			}
			if (fieldType.equals(Edit.TIME)){
				fma=Fma.TIME;
			}
		}

		// Modifie la taille et la valeur par dfaut pour les composant spcifiques
		boolean isSetFont=true;
		if (fieldType.equals(Edit.LIBE)){
			((JTextDb)jc).adapteTextLibe();
			if (sql.getFieldDef(name)!=null)
				((JTextDb)jc).setHorizontalAlignment(align);
			isSetFont=false;
		} 


		int widthchar=Gp.WIDTHCHAR;
		Dimension dim=new Dimension(((length+3)*widthchar),Gp.HEIGHTTEXT);
		switch (fma){
		case F2:
		case INTERO:
			dim=new Dimension(((length+2)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case TIMEDELAY:
			dim=new Dimension(((length+2+2+2+2+2+9)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case PLAGETIMES:
			dim=new Dimension(((length+2+2+2)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case CHECK:
			dim=new Dimension(((length+ ((JTextCheck)jc).getText().length()+1)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			if (defaultValue.equals("0"))
				jc.putClientProperty(DEFAULTVALUE,"0");
			else
				jc.putClientProperty(DEFAULTVALUE,"1");
			break;
		case RADIO:
			dim=new Dimension(((length+ ((JRadio)jc).getWidthChar())*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case NUM:
		case NUMSPACE:
		case NUMGRAS:
		case NUMGRASSPACE:
			((JTextDb)jc).setHorizontalAlignment(align);
			dim=new Dimension(((length+2)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case FIELD:
		case NORMAL:
		case GRAS:
		case LIBEMAX:
			break;
		case DATE:
			dim=new Dimension(((length+3)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case MONTH:
		case YEAR:
		case TIME:
			dim=new Dimension(((length+3)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case PHONE:
			dim=new Dimension(((length+0)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case SECU:
			dim=new Dimension(((length+0)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case URSS:
			dim=new Dimension(((length+2)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case POSTAL:
			dim=new Dimension(((length+0)*widthchar)+Gp.HEIGHTTEXT,Gp.HEIGHTTEXT);
			break;
		case INVISIBLE:
		case CACHE:
			break;
		default:
			break;

		}
		jc.setPreferredSize(dim);
		jc.setMaximumSize  (dim);
		jc.setMinimumSize  (dim);
		if (isSetFont){
			jc.setFont(Gp.FONTTEXT12);
		}
		jc.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
	}
	//////////////////
	public static int getHorizontalAlignement(Fma fma){
		int ret=SwingConstants.CENTER;
		switch (fma){
		case INTERO:
		case TIMEDELAY:
		case RADIO:
		case CHECK:
			ret=SwingConstants.CENTER;
			break;
		case TIME:
		case PLAGETIMES:
		case DATE:
		case MONTH:
		case YEAR:
		case PHONE:
		case SECU:
		case POSTAL:
		case URSS:
		case NUM:
		case NUMSPACE:
		case NUMGRAS:
		case NUMGRASSPACE:
			ret=(SwingConstants.RIGHT);
			break;
		case LIBEMAX:
		case F2:
		case GRAS:
		case NORMAL:
		case INVISIBLE:
		case CACHE:
		case FIELD:
		default :
			ret=SwingConstants.LEFT;
		break;
		}
		return ret;
	}
	///////////////////////////////////
	// ABONNEMENT PAR TYPE DE SAISIE //
	///////////////////////////////////
	public void addTextCheckListener(JRadio jc) {
		//RADIOCHECKED
		// Radio pas de saisie
		setCcsListener(jc,RADIO);
	}
	public void addTextCheckListener(JTextCheck jc) {
		//CHECKED
		// CheckBox pas de saisie
		setCcsListener(jc,CHECKED);
	}

	public void addInteroListener(JTextComponent jt, String choix) {
		setCcsListener(jt,INTERO);
		jt.putClientProperty(INTERO+"Param",choix );
	}
	public void addF2Listener(JTextComponent jt, String ccs) {
		//CODEINF2
		//NEWCODEF2
		//LIKEINF2
		setCcsListener(jt,ccs);
		jt.putClientProperty(ccs+"Param",((JTextDbF2)jt).sqlF2 );
	}
	public void addRangeDoubleListener(JComponent jc, double min, double max) {
		setCcsListener(jc,RANGEDOUBLE);
		setRangeDoubleListener(jc,min,max);
	}
	public void setRangeDoubleListener(JComponent jc, double min, double max) {
		double [] param=new double []{min,max};
		jc.putClientProperty(RANGEDOUBLE+"Param", param);
	}
	public void addRangeIntListener(JComponent jc, int min, int max) {
		setCcsListener(jc,RANGEINT);
		setRangeIntListener(jc,min,max);
	}
	public void setRangeIntListener(JComponent jc, int min, int max) {
		int [] param=new int []{min,max};
		jc.putClientProperty(RANGEINT+"Param", param);
	}
	public void addRangeLenListener(JComponent jc, int min, int max) {
		setCcsListener(jc,RANGELEN);
		setRangeLenListener(jc,min,max);
	}
	public void setRangeLenListener(JComponent jc, int min, int max) {
		int [] param=new int []{min,max};
		jc.putClientProperty(RANGELEN+"Param", param);
	}
	public void addRangeDateListener(JComponent jc, String min, int max) {
		Day maxday=new Day();
		maxday.setSDate(min);
		maxday.addDay(max);
		addRangeDateListener(jc,min,maxday.getSDate());
	}
	public void addRangeDateListener(JComponent jc, String min, String max) {
		setCcsListener(jc,RANGEDATE);
		setRangeDateListener(jc,min,max);
	}
	public void setRangeDateListener(JComponent jc, String min, String max) {
		String [] param=new String []{min,max};
		jc.putClientProperty(RANGEDATE+"Param", param);
	}
	public void addRangeDateEmptyListener(JComponent jc, String min, String max) {
		setCcsListener(jc,RANGEDATEEMPTY);
		setRangeDateEmptyListener(jc,min,max);
	}
	public void setRangeDateEmptyListener(JComponent jc, String min, String max) {
		String [] param=new String []{min,max};
		jc.putClientProperty(RANGEDATEEMPTY+"Param", param);
	}
	public void addRangeTimeListener(JComponent jc, String min, String max) {
		setCcsListener(jc,RANGETIME);
		setRangeTimeListener(jc,min,max);
	}
	public void setRangeTimeListener(JComponent jc, String min, String max) {
		String [] param=new String []{min,max};
		jc.putClientProperty(RANGETIME+"Param", param);
	}
	public void addNotZeroListener(JComponent jc) {
		setCcsListener(jc,NOTZERO);
	}
	public void addEditListener(JComponent jc, String ccsType) {
		// NOTEMPTY
		// PHONE
		// SECU
		// DATE
		// TIME
		// URSS
		// POSTAL
		// PLAGETIME
		// PLAGETIMES
		// MONTH
		// YEAR
		setCcsListener(jc,ccsType);
	}

	private void setCcsListener(JComponent jc, String ccsType){
		jc.putClientProperty(MSG_CTRL_FALSE,"La fiche n'est pas correcte"+alerte);
		jc.putClientProperty(ccsType,"basculeOn" );

		jc.putClientProperty(CCS_TYPE,ccsType);
		jc.addPropertyChangeListener((String) jc.getClientProperty("CCSTYPE"),this);
	}

	//////////////////////////////
	// ACTIVATION PAR PROGRAMME //
	//////////////////////////////
	public void setDebug(boolean enable){
		debug=enable;
	}
	/**
	 * Dclenche le contrle d'un Edit<br>
	 * @param jc Edit  dclencher <br>
	 * @param ccsType  Identifiant du contrl a executer <br>
	 */
	public void fireT(JComponent jc,String ccsType) {
		if (isModeUpdate()){
			if (jc.isEnabled()){
				// Change la valeur d'une proprit pour une controle de saisie
				if (jc.getClientProperty(ccsType)==null){
					Gp.af(1,ccsType+" "+jc.getName());
				}
				if (debug){
					if (jc instanceof JTextComponent ){
						Gp.af(1,"Debug "+jc.getName()+" !"+((JTextComponent) jc).getText()+"! "+ccsType);
					} else {
						Gp.af(1,"Debug "+jc.getName()+" "+ccsType);
					}
				}
				if (jc.getClientProperty(ccsType).equals("basculeOn")){
					jc.putClientProperty(ccsType,"basculeOff" );
				} else {
					jc.putClientProperty(ccsType,"basculeOn" );
				}
			}
		}
	}

	//////////////////////////
	// LISTENER DES SAISIES //
	//////////////////////////
	public void propertyChange(PropertyChangeEvent arg0) {
		String property=arg0.getPropertyName();
		JComponent jc=((JComponent) arg0.getSource());
		Edit type_field=(Edit) jc.getClientProperty(Edit.TYPE_FIELD);
		//////////////////////////////////////////
		switch (type_field){
			case CHECK:
			case RADIO:
			case LIBE:
				property="nocontrol";
				break;
		}
		//////////////////////////////////////////



		//////////////////////////////////////////
		if (property.equals("nocontrol")){
			// pas de notification sur ces saisie ou en auto controle
		} else if (property.equals(NOTEMPTY)){
			// suite au control bascule l'autre proprit Update pour le raffichage
			setEUpdate(isNotEmpty(jc),jc,"Saisie Obligatoire");
		} else if (property.equals(DATE)){
			setEUpdate(isDate(jc),jc,"Saisie d'une date JJ/MM/AAAA, (Date du jour click droit)");
		} else if (property.equals(DATEEMPTY)){
			setEUpdate(isDateEmpty(jc),jc,"Saisie d'une date JJ/MM/AAAA ou vide, (Date du jour click droit)");
		} else if (property.equals(MONTH)){
			setEUpdate(isMonth(jc),jc,"Saisie d'un mois pour une anne MM/AAAA");
		} else if (property.equals(YEAR)){
			setEUpdate(isYear(jc),jc,"Saisie d'une anne AAAA");
		} else if (property.equals(TIME)){
			setEUpdate(isTime(jc),jc,"Saisie d'un temps HH:MM , (Heure actuelle click droit)");
		} else if  (property.equals(TIMEDELAY)){
			setEUpdate(isTimeDelay(jc),jc,"Saisie de l'heure de dbut HH:MM  l'heure de fin HH:MM temps total HH:MM");
		} else if  (property.equals(PLAGETIMES)){
			setEUpdate(isPlageTimes(jc),jc,"Saisie d'un temps HH:MM");
		} else if (property.equals(PHONE)){
			setEUpdate(isPhone(jc),jc,"Saisie d'un temps HH:MM");
		} else if (property.equals(SECU)){
			setEUpdate(isSecu(jc),jc,"Saisie d'un numro de Scurite Social S-AA-MM-DP-COM-ORD-CL");
		} else if (property.equals(URSS)){
			setEUpdate(isUrss(jc),jc,"Saisie d'un numro URSSAF ORG-999999999999999");
		} else if (property.equals(POSTAL)){
			setEUpdate(isPostal(jc),jc,"Saisie d'un code postal DDCCC");
		} else if (property.equals(INTERO)){
			String string=(String) jc.getClientProperty(INTERO+"Param");
			String mes="";
			String virgule="";
			for(int i=0;i<string.length();i++){
				mes=mes+virgule+string.charAt(i);
				virgule=",";
			}
			setEUpdate(isIntero(jc),jc,"Saisie Obligatoire, Choix possible '"+mes+"'");
		} else if (property.equals(RANGEDOUBLE)){
			double [] param=(double[]) jc.getClientProperty(RANGEDOUBLE+"Param");
			setEUpdate(isRangeDouble(jc),jc,"Saisie Obligatoire, la valeur doit tre comprise entre : '"+param[0]+"' et '"+param[1]+"'");
		} else if (property.equals(RANGEINT)){
			int [] param=(int[]) jc.getClientProperty(RANGEINT+"Param");
			setEUpdate(isRangeInt(jc),jc,"Saisie Obligatoire, la valeur doit tre comprise entre : '"+param[0]+"' et '"+param[1]+"'");
		} else if (property.equals(RANGELEN)){
			int [] param=(int[]) jc.getClientProperty(RANGELEN+"Param");
			String str="";
			if (param[0]==param[1] && param[0]!=0){
				str="Saisie Obligatoire, Nombre de caractres obligatoires : '"+param[0]+"'";
			} else if (param[0]+param[1]!=0){
				str="Saisie Obligatoire, Le nombre de caratres tre compris entre : '"+param[0]+"' et '"+param[1]+"'";
			} 
			setEUpdate(isRangeLen(jc),jc,str);
		} else if (property.equals(RANGEDATE)){
			String [] param=(String[]) jc.getClientProperty(RANGEDATE+"Param");
			setEUpdate(isRangeDate(jc),jc,"Saisie Obligatoire, la date doit tre comprise entre : '"+param[0]+"' et '"+param[1]+"'");
		} else if (property.equals(RANGEDATEEMPTY)){
			String [] param=(String[]) jc.getClientProperty(RANGEDATEEMPTY+"Param");
			setEUpdate(isRangeDateEmpty(jc),jc,"Saisie Obligatoire, la date doit tre comprise entre : '"+param[0]+"' et '"+param[1]+"' ou vide");
		} else if (property.equals(RANGETIME)){
			String [] param=(String[]) jc.getClientProperty(RANGETIME+"Param");
			setEUpdate(isRangeTime(jc),jc,"Saisie Obligatoire, l'heure doit tre comprise entre : '"+param[0]+"' et '"+param[1]+"'");
		} else if (property.equals(NOTZERO)){
			setEUpdate(isNotZero(jc),jc,"Saisie Obligatoire, la valeur doit tre diffrente de 0");
		} else if (property.equals(CODEINF2)){
			JTextDbF2 jt=(JTextDbF2) jc;
			jt.reactivateLibeSeek();
			String table=jt.sqlF2.t_table;
			if(isEof(jc)){
				String str="";
				if (table.equals("s_intero")){
					str="Saisie Obligatoire, F2 pour choisir,  Ctrl+Flche pour trouver le code Suivant Prcdent";
				} else {
					str="F2, Choix d'un code '"+table+"' existant,  Ctrl+Flche pour trouver le code Suivant Prcdent";
				}
				setEUpdateFalse(jc, str);
			} else {
				setEUpdateTrue(jc,"F2 liste");
			}
			jt.repaintLibe();
		} else if (property.equals(NEWCODEF2)){
			if(isCodeNewAble(jc)){
				setEUpdateTrue(jc,"F2 liste");
			} else {
				setEUpdateFalse(jc,"Cration d'un nouveau code '"+((JTextDbF2) jc).sqlF2.t_table+"'");
			}
		} else if (property.equals(LIKEINF2)){
			if(isCodeUpdatable(jc)){
				setEUpdateTrue(jc,"F2 liste");
			} else {
				setEUpdateFalse(jc,"Modification d'un nouveau code '"+((JTextDbF2) jc).sqlF2.t_table+"'");
			}
		} else if (property.equals(CONSULTF2)){
			setEUpdate(true,jc,"F2 consultation de liste");
		}


		//////////////////////////////////////////
		if (property.equals(CCS_UPDATE)){
			if (arg0.getNewValue().equals("ok")) {
				jc.setForeground(Gp.LABEL_FG_BLACK);
				jc.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
			} else if (arg0.getNewValue().equals("notok")) {
				jc.setForeground(Gp.INVALIDE_FG_RED);
				jc.setBorder(Gp.getBorder(Gp.INVALIDE_FG_RED));
			} else if (arg0.getNewValue().equals("null")) {
			}
			jc.repaint();		
		} 
		//////////////////////////////////////////
	}

	private void setEUpdate(boolean ok,JComponent jc,String status){
		if (Gp.TOOLTIP){
			jc.setToolTipText(status);
		}
		jc.putClientProperty(CCS_UPDATE,"reinit");
		if (ok){
			jc.putClientProperty(CCS_UPDATE,"ok");
		} else {
			jc.putClientProperty(CCS_UPDATE,"notok");
		}
	}
	private void setEUpdateTrue(JComponent jc,String status){
		setEUpdate(true,jc,status);
	}
	private void setEUpdateFalse(JComponent jc,String status){
		setEUpdate(false,jc,status);
	}
	public void setEEnabled(JComponent jc, boolean enable) {
		jc.setEnabled(enable);
		if (isModeUpdate()){
			if (enable){
				jc.setBackground(Gp.UPDATE_BG_JAUNE);
				jc.setBorder(Gp.getBorder(Gp.LABEL_FG_BLACK));
			} else {
				setEUpdate(jc,true);
				jc.setBackground(Gp.MOVE_BG_LVERT);
				jc.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
			}
		} else {
			jc.setBackground(Gp.MOVE_BG_LVERT);
			jc.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
		}
	}
	public void setEUpdate(JComponent jc,boolean enable){
		if (enable){
			setEUpdateTrue(jc,"Saisie conforme");
		} else {
			setEUpdateFalse(jc,"Saisie incorrecte");
		}
	}
	public boolean isModeUpdate(){
		return modeUpdatable;
	}
	public void setModeUpdate(boolean updatable){
		modeUpdatable=updatable;
	}
	//////////////////////////////////////////////////
	// CONTROLEUR DE VALIDITE DES SAISIES PAR TYPES //
	//////////////////////////////////////////////////
	public void setCcsNotifier(JComponent jc) {
		jc.putClientProperty(CCS_NOTIFIER,CCS_NOTIFIER);
	}
	public boolean isENotifier(JComponent jc) {
		boolean ret=false;
		if (jc.getClientProperty(CCS_NOTIFIER)!=null){
			ret=true;
		}
		return ret;
	}

	public boolean isEUpdatable(JComponent jc){
		boolean ret=true;
		if (jc.getClientProperty(Ccs.CCS_UPDATE).equals("notok")){
			ret=false;
		}
		return ret;
	}
	public boolean isTime(JComponent jc){
		JTextDbTime jt=(JTextDbTime) jc;
		String tab[]=jt.getText().split(Fmt.TIME.splitter());
		String test=CcsFmt.formatStrTime(jt.getText(),true);
		//Gp.af(1,"!"+test+"!"+jt.getSTime()+"!");
		if (!test.equals(jt.getSTime())||tab.length!=Fmt.TIME.nbPart()){
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"Cette heure n'est pas conforme");
			return false;
		} else {
			return true;
		}
	}
	public boolean isTimeDelay(JComponent jc) {
		JTimeDelay jt=(JTimeDelay) jc;
		if (jt.getTimeDelayMinutes()==0) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"le total d'heure  00:00 n'est pas conforme\n");
			return false;
		} else {
			return true;
		}
	}
	public boolean isPlageTimes(JComponent jc) {
		JPlageTimes jt=(JPlageTimes) jc;
		String tab[]=jt.getSTime().split(Fmt.TIME.splitter());
		if (Day.parseTime(jt.getSTime()).x+Day.parseTime(jt.getSTime()).y==0||tab.length!=Fmt.TIME.nbPart()) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"le total d'heure  00:00 n'est pas conforme\n Cette plage d'heure chevauche une autre plage d'heure");
			return false;
		} else {
			return true;
		}
	}
	public boolean isDate(JComponent jc){
		JTextComponent jt=(JTextComponent) jc;
		String tab[]=jt.getText().split(Fmt.DATE.splitter());
		String test=CcsFmt.formatStrDate(jt.getText(),true);
		Day day=new Day();
		day.setSDate(jt.getText());
		//Gp.af("!"+test+"!"+day.getSDate()+"!");
		if (!test.equals(day.getSDate())||tab.length!=Fmt.DATE.nbPart()) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"Cette date n'est pas conforme");
			return false;
		} else {
			JTextDbDate jd=(JTextDbDate) jc;
			jd.setValueChild();
			return true;
		}
	}
	public boolean isDateEmpty(JComponent jc){
		JTextDbDate jt=(JTextDbDate) jc;
		String tab[]=jt.getText().split(Fmt.DATE.splitter());
		String test=CcsFmt.formatStrDate(jt.getText(),true);
		Day day=new Day();
		day.setSDate(jt.getText());
		//Gp.af("!"+test+"!"+day.getSDate()+"!");
		if ((!test.equals(day.getSDate())||tab.length!=Fmt.DATE.nbPart())&& !jt.isEmpty()) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"Cette date n'est pas conforme");
			return false;
		} else {
			JTextDbDate jd=(JTextDbDate) jc;
			jd.setValueChild();
			return true;
		}
	}
	public boolean isMonth(JComponent jc){
		JTextComponent jt=(JTextComponent) jc;
		String tab[]=jt.getText().split(Fmt.MONTH.splitter());
		String test="01/"+CcsFmt.formatStrMonth(jt.getText(),true);
		Day day=new Day();
		day.setSDate("01/"+jt.getText());
		if (!test.equals(day.getSDate())||tab.length!=Fmt.MONTH.nbPart()) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"Ce mois n'est pas conforme");
			return false;
		} else {
			JTextDbDate jd=(JTextDbDate) jc;
			jd.setValueChild();
			return true;
		}
	}
	public boolean isYear(JComponent jc){
		JTextComponent jt=(JTextComponent) jc;
		String test="01/01/"+CcsFmt.formatStrYear(jt.getText(),true);
		Day day=new Day();
		day.setSDate("01/01/"+jt.getText());
		if (!test.equals(day.getSDate())) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"Cette anne n'est pas conforme");
			return false;
		} else {
			JTextDbDate jd=(JTextDbDate) jc;
			jd.setValueChild();
			return true;
		}
	}
	public boolean isPhone(JComponent jc){
		JTextComponent jt=(JTextComponent) jc;
		String tab[]=jt.getText().split(Fmt.PHONE.splitter());
		if (tab.length!=Fmt.PHONE.nbPart() || CcsFmt.formatStrPhone(jt.getText(),false).length()!=Fmt.PHONE.length()) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"Ce numro de tlphone n'est pas conforme");
			return false;
		} else {
			return true;
		}
	}
	public boolean isSecu(JComponent jc){
		JTextComponent jt=(JTextComponent) jc;
		String tab[]=jt.getText().split(Fmt.SECU.splitter());
		if (tab.length!=Fmt.SECU.nbPart() || CcsFmt.formatStrSecu(jt.getText(),false).length()!=Fmt.SECU.length()) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"Ce numro de scurit sociale n'est pas conforme");
			return false;
		} else {
			return true;
		}
	}
	public boolean isUrss(JComponent jc){
		JTextComponent jt=(JTextComponent) jc;
		String tab[]=jt.getText().split(Fmt.URSS.splitter());
		if (tab.length!=Fmt.URSS.nbPart() ) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"Ce numro d'urssaf n'est pas conforme");
			return false;
		} else {
			return true;
		}
	}
	public boolean isPostal(JComponent jc) {
		JTextComponent jt=(JTextComponent) jc;
		String tmp=jt.getText();
		if (tmp==null)
			tmp="";
		tmp=CcsFmt.getDigit(tmp); 
		if (tmp.length()!=5 || CcsFmt.formatStrPostal(jt.getText(),true).length()!=Fmt.POSTAL.length()) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"Ce numro de code postal n'est pas conforme");
			return false;
		} else {
			return true;
		}
	}
	public boolean isNotEmpty(JComponent jc){
		boolean ret=true;
		JTextComponent jt=(JTextComponent) jc;
		if (jt.getText().trim().isEmpty()) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"La saisie est obligatoire");
			ret=false;
		}
		return ret;
	}
	public boolean isIntero(JComponent jc) {
		JTextComponent jt=(JTextComponent) jc;
		String interoParam=(String) jc.getClientProperty(INTERO+"Param" );
		String value=jt.getText().trim();
		String mes="";
		String virgule="";
		for(int i=0;i<interoParam.length();i++){
			mes=mes+virgule+interoParam.charAt(i);
			virgule="],[";
		}
		if (value.length()!=1 || !interoParam.contains(value)) {
			jc.putClientProperty(MSG_CTRL_FALSE,"Saisie incorrecte !\n "+alerte+"Choix possible :   ["+mes+"]  ");
			return false;
		} else {
			return true;
		}
	}
	private boolean isRangeDouble(JComponent jc) {
		JTextDb jt=(JTextDb) jc;
		double [] param=(double[]) jc.getClientProperty(RANGEDOUBLE+"Param");
		if (jt.getDouble()>=param[0] && jt.getDouble() <= param[1]){
			return true;
		} else {
			jc.putClientProperty(MSG_CTRL_FALSE,"la valeur doit tre comprise entre : \n\t["+param[0]+"] et ["+param[1]+"]\n "+alerte);
			return false;
		}
	}
	private boolean isRangeInt(JComponent jc) {
		JTextDb jt=(JTextDb) jc;
		int [] param=(int[]) jc.getClientProperty(RANGEINT+"Param");
		if (debug){
			Gp.MB(jt.getInt()+">="+param[0]+" && <="+param[1]);
		}
		if (jt.getInt()>=param[0] && jt.getInt() <= param[1]){
			return true;
		} else {
			jc.putClientProperty(MSG_CTRL_FALSE,"la valeur doit tre comprise entre : \n\t["+param[0]+"] et ["+param[1]+"]\n "+alerte);
			return false;
		}
	}
	private boolean isRangeLen(JComponent jc) {
		JTextDb jt=(JTextDb) jc;
		int [] param=(int[]) jc.getClientProperty(RANGELEN+"Param");
		if (debug){
			Gp.MB(jt.getInt()+">="+param[0]+" && <="+param[1]);
		}
		String test=jt.getText().trim();
		if (test.length()>=param[0] && test.length() <= param[1]){
			return true;
		} else if (param[0]+param[1]==0){
			return true;
		} else {
			jc.putClientProperty(MSG_CTRL_FALSE,"la longuer doit tre comprise entre : \n\t["+param[0]+"] et ["+param[1]+"]\n "+alerte);
			return false;
		}
	}
	private boolean isRangeDate(JComponent jc) {
		boolean ret=true;
		JTextDbDate jt=(JTextDbDate) jc;
		String [] param=(String[]) jc.getClientProperty(RANGEDATE+"Param");
		Day day1=new Day();
		Day day2=new Day();
		Day day=new Day();
		day1.setSDate(param[0]);
		day2.setSDate(param[1]);
		day.setSDate(CcsFmt.formatStrDate(jt.getText(),true));
		if (day.getTime()>=day1.getTime() && day.getTime() <= day2.getTime() && isDate(jt)){
			ret=true;
		} else {
			jc.putClientProperty(MSG_CTRL_FALSE,"la valeur doit tre comprise entre : \n\t["+param[0]+"] et ["+param[1]+"]\n "+alerte);
			ret=false;
		}
		return ret;
	}
	private boolean isRangeDateEmpty(JComponent jc) {
		boolean ret=true;
		JTextDbDate jt=(JTextDbDate) jc;
		String [] param=(String[]) jc.getClientProperty(RANGEDATEEMPTY+"Param");
		Day day1=new Day();
		Day day2=new Day();
		Day day=new Day();
		day1.setSDate(param[0]);
		day2.setSDate(param[1]);
		day.setSDate(CcsFmt.formatStrDate(jt.getText(),true));
		if ((day.getTime()>=day1.getTime() && day.getTime() <= day2.getTime() && isDate(jt))|| jt.getText().trim().length()==0){
			ret=true;
		} else {
			jc.putClientProperty(MSG_CTRL_FALSE,"la valeur doit tre comprise entre : \n\t["+param[0]+"] et ["+param[1]+"]\n ou vide \n"+alerte);
			ret=false;
		}
		return ret;
	}
	private boolean isRangeTime(JComponent jc) {
		boolean ret=true;
		JTextDbTime jt=(JTextDbTime) jc;
		String [] param=(String[]) jc.getClientProperty(RANGETIME+"Param");
		Time time1=new Time();
		Time time2=new Time();
		Time time0=new Time();
		time1.setSTime(param[0]);
		time2.setSTime(param[1]);
		time0.setSTime(CcsFmt.formatStrTime(jt.getText(),true));
		if (time0.getTime()>=time1.getTime() && time0.getTime() <= time2.getTime() && isTime(jt)){
			ret=true;
		} else {
			jc.putClientProperty(MSG_CTRL_FALSE,"la valeur doit tre comprise entre : \n\t["+param[0]+"] et ["+param[1]+"]\n "+alerte);
			ret=false;
		}
		return ret;
	}
	private boolean isNotZero(JComponent jc) {
		boolean ret=true;
		JTextDb jt=(JTextDb) jc;
		if (jt.getDouble()==0){
			jc.putClientProperty(MSG_CTRL_FALSE,"la valeur doit tre diffrente de 0, "+alerte);
			ret=false;
		}
		return ret;
	}
	private boolean isEof(JComponent jc) {
		boolean ret=false;
		JTextDbF2 jt=(JTextDbF2) jc;
		Sql sql=(Sql) jc.getClientProperty(CODEINF2+"Param" );
		jt.approche();
		if (sql.t_eof) {
			jc.putClientProperty(MSG_CTRL_FALSE,"F2 pour choisir un code ["+sql.t_table+"], "+alerte);
			ret=true;
		}
		return ret;
	}
	private boolean isCodeNewAble(JComponent jc) {
		JTextComponent jt=(JTextComponent) jc;
		Sql sql=(Sql) jc.getClientProperty(NEWCODEF2+"Param" );
		String value=jt.getText().trim(); // limine les espaces sur les codes lors de la cration
		if (value.length()==0){
			jc.putClientProperty(MSG_CTRL_FALSE,alerte+"Saisie obligatoire");
			return false;
		} else {
			sql.dBSeekByIndex(value);
			if (sql.t_eof) {
				return true;
			} else {
				jc.putClientProperty(MSG_CTRL_FALSE,alerte+"Ce code xiste dj, dans le fichier ["+sql.t_table+"]");
				return false;
			}
		}
	}
	private boolean isCodeUpdatable(JComponent jc) {
		JTextComponent jt=(JTextComponent) jc;
		Sql sql=(Sql) jc.getClientProperty(LIKEINF2+"Param" );
		String value=jt.getText().trim(); // limine les espaces sur les codes lors de la recherche
		if (value.length()==0){
			jc.putClientProperty(MSG_CTRL_FALSE,alerte+"Code vide interdit");
			return false;
		} else {
			sql.dBSeekByIndex(value);
			if (sql.t_eof) {
				return true;
			} else {
				return true;
			}
		}
	}
	public void focusGained(FocusEvent e) {
		setStatusFicheEdit((JComponent) e.getComponent());
	}
	public void focusLost(FocusEvent e) {
		setStatusFicheEdit(null);
	}
	/**
	 * Affiche une aide dans la barre de status
	 * @param jc Edit en cours de modification
	 */
	public void setStatusFicheEdit(JComponent jc){
		if (sql!=null){
			String txt="";
			if (jc!=null){
				if (sql.getFieldDef(jc.getName())!=null){
					txt=sql.getFieldDef(jc.getName()).t_libHelp;
					if (txt.length()==0){
						txt=sql.getFieldDef(jc.getName()).t_lib;
					}
				}
				if (jc.getToolTipText()==null){
				} else {
					txt=txt+", "+jc.getToolTipText();
				}
			}
			sql.setTextStatusFicheEdit(txt);
		}
	}
	public void mousePressed(MouseEvent arg0) {}
	public void mouseReleased(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}
	public void mouseClicked(MouseEvent arg0) {
		if(SwingUtilities.isRightMouseButton(arg0)) {
			if (arg0.getComponent().getClass()==JTextDb.class){ 
				if (((JTextDb)arg0.getComponent()).getClientProperty(Edit.TYPE_FIELD).equals(Edit.LIBE)){
					updateToolTip((JTextDb)arg0.getComponent());
				}
			}
		} 
	}
	private void updateToolTip(JTextDb jt) {
		if (jt.getName()!=null){
			if (sql!=null){
				new JDialogToolTip((Window) SwingUtilities.getRoot(jt),sql,jt);
			}
		}
	}
	public void setModeMovable(boolean movable) {
		setModeUpdate(!movable);
		JComponent jc=null;
		Edit edit=null;
		for (int field=0;field<textFields.size();field++){
			jc=(JComponent) textFields.get(field);
			edit=(Edit) jc.getClientProperty(Edit.TYPE_FIELD);
			if (edit!=Edit.LIBE){
				jc.putClientProperty(Ccs.CCS_UPDATE,"ok");
				if (isModeUpdate()){
					if (jc.isEnabled()){
						jc.setBackground(Gp.UPDATE_BG_JAUNE);
						jc.setBorder(Gp.getBorder(Gp.LABEL_FG_BLACK));
					}
				} else {
					// Remet toutes les zones comme valide
					jc.setBackground(Gp.MOVE_BG_LVERT);
					jc.setBorder(Gp.getBorder(Gp.LABEL_BORDER));
				}
			}
		}
	}
	public void setDefaultDatas() {
		JComponent jc=null;
		int numfield=-1;
		for (int field=0;field<textFields.size();field++) {
			jc=textFields.get(field);
			numfield=sql.getNumField(jc.getName());
			sql.datas.get(0)[numfield]=jc.getClientProperty(Ccs.DEFAULTVALUE);
		}
	}
	public void setEEnable(boolean enable) {
		JComponent jc=null;
		for (int field=0;field<textFields.size();field++){
			jc=(JComponent) textFields.get(field);
			jc.setEnabled(enable);
		}
	}
	public int getESize(){
		return textFields.size();
	}
	public JComponent getE(int field){
		return textFields.get(field);
	}
	public void addE(JComponent jc){
		textFields.add(jc);
	}
	public void moveFocus(JComponent jt) {
		JComponent jc=null;
		for (int i=0;i<textFields.size();i++){ // parcours les zones de saisie pour trouver la zone qui a fait enter
			jc=textFields.get(i);
			if (jt==jc){ // Depuis la zone sur laquelle on vient de faire enter
				for (int n=i+1;n<textFields.size();n++){ // parcours le reste des zones pour trouver une zone valide
					jc=textFields.get(n);
					if (isFocusable(jc)){ // Zone trouv elle fait le request Focus
						jc.requestFocus();
						n=textFields.size();
						i=textFields.size();
					}
				}
				if (i<textFields.size()){ // pas de zone enableb aprs la zone qui a fait enter
					for (int n=0;n<=i;n++){ // reprend le parcours de puis le dbut pour trouver une zone valide
						jc=textFields.get(n);
						if (isFocusable(jc)){ // Zone trouv elle fait le request Focus
							jc.requestFocus();
							n=textFields.size();
							i=textFields.size();
						}
					}					
				}
			}
		}

	}
	public JComponent findLastFocus(){
		JComponent jt=null;
		for (int i=0;i<textFields.size();i++){ // parcours le zones de saisie pour trouver la dernire zone saisisable
			if (isFocusable(textFields.get(i))){
				jt=textFields.get(i);
			}
		}
		return jt;
	}
	/**
	 * Dfini le premier Edit focusable d'une fiche
	 * @param jc Edit
	 */
	public void setDefFocus(JComponent jc) {
		if (jc.isEnabled()){
			jc.requestFocus();
		} else {
			moveFocus(jc);
		}

	}
	private boolean isFocusable(JComponent jc){
		boolean ret=false;
		if (jc.isShowing()){
			if (jc.isVisible()){
				if (jc.isEnabled()){
					if (jc.isFocusable()){
						ret=true;
					}
				}
			}
		}
		return ret;
	}
	public JComponent isUpdatable() {
		JComponent ret=null;
		for (int i=0;i<textFields.size();i++) {
			if (textFields.get(i).getClientProperty(Ccs.CCS_UPDATE).equals("notok")){
				ret=textFields.get(i);
				break;
			}
		}
		return ret;
	}
	/////////
	private int SOURCE=0;
	private int DEST=1;
	private int FINAL=2;
	private int COMPUTE=3;
		
	public void addDependant(JComponent child, JComponent parent) {
		//if (parent==null) System.out.println("Ccs.addDependant() parent null");
		//if (child==null) System.out.println("Ccs.addDependant() child null");
		dependant.add(new JComponent[]{parent,child,null,null});
	}
	public boolean isDependant(JComponent jc) {
		boolean ret=false;
		for (int i=0;i<dependant.size();i++){
			if (dependant.get(i)[SOURCE]==jc){
				ret=true;
				break;
			}
		}
		return ret;
	}
	public int getDependantSize() {
		return dependant.size();
	}
	public JComponent getDependantSour(int i) {
		return dependant.get(i)[SOURCE];
	}
	public JComponent getDependantDest(int i) {
		return dependant.get(i)[DEST];
	}
	public JComponent getDependantFinal(int i) {
		return dependant.get(i)[FINAL];
	}
	public JComponent getDependantCompute(int i) {
		return dependant.get(i)[COMPUTE];
	}
	private String getDependantNSour(int i) {
		String ret=null;
		if (dependant.get(i)[SOURCE]!=null){
			ret=dependant.get(i)[SOURCE].getName();
		}
		return ret;
	}
	private String getDependantNDest(int i) {
		String ret=null;
		if (dependant.get(i)[DEST]!=null){
			ret=dependant.get(i)[DEST].getName();
		}
		return ret;
	}
	private String getDependantNFinal(int i) {
		String ret=null;
		if (dependant.get(i)[FINAL]!=null){
			ret=dependant.get(i)[FINAL].getName();
		}
		return ret;
	}
	public String getDependantNCompute(int i) {
		String ret=null;
		if (dependant.get(i)[COMPUTE]!=null){
			ret=dependant.get(i)[COMPUTE].getName();
		}
		return ret;
	}
	public void setDependantDest(int i, JComponent jc) {
		dependant.get(i)[DEST]=jc;
	}
	public void setDependantFinal(int i, JComponent jc) {
		dependant.get(i)[FINAL]=jc;
	}
	public void setDependantCompute(int i, JComponent jc) {
		dependant.get(i)[COMPUTE]=jc;
	}
	/**
	 * Recalcule les dpendances d'un Edit
	 * @param jc Edit
	 */
	public void setDependant(JComponent jc) {
		if (debugDependant) System.out.println("Initial");
		if (debugDependant) debugListDependantSource(jc);
		setDependantClearFinalCompute();
		if (debugDependant) System.out.println("clear");
		if (debugDependant) debugListDependantSource(jc);
		flagDependantFinal(jc,jc);
		if (debugDependant) System.out.println("flag");
		if (debugDependant) debugListDependantFinale(jc);
		dedoubleDependantCompute(jc);
		if (debugDependant) System.out.println("dedouble");
		if (debugDependant) debugListDependantFinale(jc);
	}
	private void setDependantClearFinalCompute() {
		for (int i=0;i<dependant.size();i++){
			dependant.get(i)[FINAL]=null;
			dependant.get(i)[COMPUTE]=null;
		}
	}
	private void flagDependantFinal(JComponent jcOrigine,JComponent jcRecherche) {
		if (jcRecherche!=null ){
			for (int i=0;i<getDependantSize();i++){
				if (getDependantSour(i)==jcRecherche && getDependantFinal(i)==null){
					setDependantFinal(i,jcOrigine);
					flagDependantFinal(jcOrigine,getDependantDest(i));
				}
			}
		}
	}
	private void dedoubleDependantCompute(JComponent jc) {
		for (int i=0;i<getDependantSize();i++){
			if (getDependantFinal(i)==jc){
				JComponent dest=getDependantDest(i);
				boolean unique=true;
				for (int j=0;j<getDependantSize();j++){
					if (getDependantCompute(j)==dest){
						unique=false;
					}
				}
				if (unique){ // Suprimme l'appel  lui-meme dans le cas de rcursion de saisie
					if (dest==jc){
						unique=false;
					}
				}
				if (unique){
					setDependantCompute(i, dest);
				}
			}
		}
	}
	public void setDebugDependant(boolean debugDependant) {
		this.debugDependant=debugDependant;
	}
	public boolean isDebugDependant() {
		return debugDependant;
	}
	public void debugListDependantSource(JComponent jc) {
		System.out.println("Source ! "+"SOURCE"+" "+"DESTIN"+"!"+"FINALE"+" "+"COMPUT");
		for (int i=0;i<getDependantSize();i++){
			if (getDependantSour(i)==jc){
				System.out.println("Source ! "+getDependantNSour(i)+" "+getDependantNDest(i)+"!"+getDependantNFinal(i)+" "+getDependantNCompute(i));
			}
		}
	}
	public void debugListDependantFinale(JComponent jc) {
		System.out.println("Finale ! "+"SOURCE"+" "+"DESTIN"+"!"+"FINALE"+" "+"COMPUT");
		for (int i=0;i<getDependantSize();i++){
			if (getDependantFinal(i)==jc){
				System.out.println("Finale ! "+getDependantNSour(i)+" "+getDependantNDest(i)+"!"+getDependantNFinal(i)+" "+getDependantNCompute(i));
			}
		}
	}
	public void dispose(){
		if (textFields!=null){
			for (int i=0;i<textFields.size();i++){
				if (textFields.get(i) instanceof JTextDbF2){
					((JTextDbF2)textFields.get(i)).dispose();
				} else 	if (textFields.get(i) instanceof JPlageTimes){
					((JPlageTimes)textFields.get(i)).dispose();
				} else 	if (textFields.get(i) instanceof JTextDbCalc){
					((JTextDbCalc)textFields.get(i)).dispose();
				} else 	if (textFields.get(i) instanceof JTextDbDate){
					((JTextDbDate)textFields.get(i)).dispose();
				} else 	if (textFields.get(i) instanceof JTextDbTime){
					((JTextDbTime)textFields.get(i)).dispose();
				} else 	if (textFields.get(i) instanceof JTextDb){
					((JTextDb)textFields.get(i)).dispose();
				} else 	if (textFields.get(i) instanceof JTimeDelay){
					((JTimeDelay)textFields.get(i)).dispose();
				} 
				textFields.get(i).removeKeyListener((KeyListener)textFields.get(i).getClientProperty(DISPOSE_KL));
				textFields.get(i).removePropertyChangeListener((String)textFields.get(i).getClientProperty(CCS_UPDATE), this);
				textFields.get(i).removePropertyChangeListener((String)textFields.get(i).getClientProperty(CCS_TYPE), this);
				textFields.get(i).removePropertyChangeListener((String)textFields.get(i).getClientProperty(PCLTYPE), (PropertyChangeListener)textFields.get(i).getClientProperty(DISPOSE_PCL));
				textFields.get(i).removePropertyChangeListener(this);
				textFields.get(i).removeFocusListener(this);
				textFields.get(i).putClientProperty(MSG_CTRL_FALSE, null);
				textFields.set(i,null);
			}
			textFields.clear();
			textFields=null;
		}
		if (textLibes!=null){
			for (int i=0;i<textLibes.size();i++){
				textLibes.set(i,null);
			}
			textLibes.clear();
			textLibes=null;
		}
		if (dependant!=null){
			for (int i=0;i<dependant.size();i++){
				dependant.get(i)[0]=null;
				dependant.get(i)[1]=null;
				dependant.get(i)[2]=null;
				dependant.get(i)[3]=null;
				dependant.set(i,null);
			}
			dependant.clear();
			dependant=null;
		}
		status=null;
		sql=null;
	}
	protected void finalize()  {
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
	////////////////////
	// STATIC METHODE  date//
	////////////////////
	public static JPanel getFlow(JComponent jl,JComponent jt,int hgap){
		JPanel ret=new JPanel(new FlowLayout(0,hgap,0));
		ret.add(jl,JPanel.RIGHT_ALIGNMENT);
		ret.add(jt,JPanel.LEFT_ALIGNMENT);
		return ret;
	}
	public static JPanel getFlow(JComponent jl,JComponent jt){
		return getFlow(jl,jt,5);
	}
	public static void TexttoLibe( JTextDb jt ){
		jt.setOpaque(false);
		jt.setBorder(null);
		jt.setDisabledTextColor(Gp.LABEL_FG_BLACK);
		jt.setEditable(false);
		jt.setHorizontalAlignment(JTextDb.TRAILING);
		jt.setWidthChar(jt.getText().length());
	}
}
