package composant_saisie.wSaisieFormat;

import java.awt.Toolkit;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.JTextComponent;
import javax.swing.text.PlainDocument;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class CcsFmt extends PlainDocument {
	private static final long serialVersionUID = 1L;
	// Format  longueur VARIABLE
	private static final int MAXLENGTH = 1;
	private static final int FORMATNUMBER = 2;
	private static final int FORMATSTRING = 3;
	// Format  longueur dfini
	private static final int FORMATDATE = 4;	
	private static final int FORMATMONTH = 5;	
	private static final int FORMATYEAR = 6;	
	private static final int FORMATTIME = 7;	
	private static final int FORMATPHONE = 8;	
	private static final int FORMATSECU = 9;	
	private static final int FORMATURSS = 10;	
	private static final int FORMATPOSTAL = 11;	
	int typeOfTest=0;

	String newstr;
	int newoffset;
	int newlength;
	int maxLength;
	StringBuffer sbTest=null;
	public String format= null;
	JTextComponent jt=null;
	static boolean debug=false;

	public CcsFmt(JTextComponent jt,int maxLength){
		super();
		this.jt=jt;
		this.maxLength=maxLength;
		this.sbTest=new StringBuffer("");
		typeOfTest=MAXLENGTH;
	}
	public CcsFmt(JTextComponent jt,String format){
		super();
		this.jt=jt;
		this.format=format;
		this.sbTest=new StringBuffer("");
		// Format  longueur dfini
		if (format.equals(Fmt.DATE.getFmt())){
			typeOfTest=FORMATDATE;			
		} else 	if (format.equals(Fmt.MONTH.getFmt())){
			typeOfTest=FORMATMONTH;
		} else 	if (format.equals(Fmt.YEAR.getFmt())){
			typeOfTest=FORMATYEAR;
		} else 	if (format.equals(Fmt.TIME.getFmt())){
			typeOfTest=FORMATTIME;
		} else 	if (format.equals(Fmt.PHONE.getFmt())){
			typeOfTest=FORMATPHONE;
		} else 	if (format.equals(Fmt.SECU.getFmt())){
			typeOfTest=FORMATSECU;
		} else 	if (format.equals(Fmt.URSS.getFmt())){
			typeOfTest=FORMATURSS;
		} else 	if (format.equals(Fmt.POSTAL.getFmt())){
			typeOfTest=FORMATPOSTAL;
			// Format  longueur VARIABLE
		} else if (format.contains("!")){
			typeOfTest=FORMATSTRING;
		} else {
			typeOfTest=FORMATNUMBER;
		}
	}
	public void insertString(int offset,String str,AttributeSet attrs){
		putProperty("loc", "true");
		newoffset=offset;
		newstr=str;
		newlength=0;
		setSbTestWithGetText();
		sbTest.insert(offset,str);
		if (isTest()){ // Saisie valide
			try {
				super.insertString(newoffset, newstr, attrs);
			} catch (BadLocationException e) { e.printStackTrace(); }
		} else { // Saisie non Valide
			if (typeOfTest==MAXLENGTH){ // Tronc la saisie 
				setSbTestWithGetText();
				for (int i=0;i<str.length() && sbTest.length()<maxLength;i++){
					sbTest.insert(offset+i,str.subSequence(i,i));
				}
				try {
					super.insertString(0, sbTest.substring(0,maxLength), attrs);
				} catch (BadLocationException e) { e.printStackTrace(); }
			}
		}
		putProperty("loc", "false");
	}
	public void replace(int offset,int length,String str,AttributeSet attrs){
		putProperty("loc", "true");
		newoffset=offset;
		newstr=str;
		newlength=length;
		setSbTestWithGetText();
		sbTest.replace(offset, offset+length,  str);
		int lenFirst=sbTest.length();
		if(isTest()){ // Saisie valide
			try {
				super.replace(newoffset,newlength, newstr, attrs);
			} catch (BadLocationException e) { e.printStackTrace(); }
		} else { // Saisie non Valide
			if (typeOfTest==MAXLENGTH){ // Tronc la saisie 
				setSbTestWithGetText();
				sbTest.replace(offset, offset+length,  str.substring(0,maxLength-sbTest.length()));
				try {
					super.replace(0,this.getLength(),sbTest.substring(0,Math.min(maxLength,sbTest.length())), attrs);
				} catch (BadLocationException e) { e.printStackTrace(); }
			}
		}
		int lenAfter=sbTest.length();
		int pos=offset+str.length()+(lenAfter-lenFirst);
		jt.getCaret().setDot(pos);
		putProperty("loc", "false");
	}
	private void setSbTestWithGetText() {
		sbTest.setLength(0);
		try {
			sbTest.append(this.getText(0,this.getLength()));
		} catch (BadLocationException e1) { e1.printStackTrace(); }
	}
	public boolean isTest(){
		boolean ret=false;
		String stmp=null;
		switch (typeOfTest){
		case MAXLENGTH:
			ret=isLengthUnderMaxLength(sbTest,maxLength);
			break;
		case FORMATSTRING:
			stmp=CcsFmt.formatString(sbTest.toString(),format);
			ret=valid(stmp);
			break;
		case FORMATNUMBER:
			stmp=CcsFmt.formatStrDecimal(sbTest.toString(),format,false);
			ret=valid(stmp);
			break;
		case FORMATDATE:
			ret=isLengthUnderMaxLength(sbTest,format.length());
			if (ret){
				stmp=CcsFmt.formatStrDate(sbTest.toString(),false);
				ret=valid(stmp);
			}
			break;
		case FORMATMONTH:
			ret=isLengthUnderMaxLength(sbTest,format.length());
			if (ret){
				stmp=CcsFmt.formatStrMonth(sbTest.toString(),false);
				ret=valid(stmp);
			}
			break;
		case FORMATYEAR:
			ret=isLengthUnderMaxLength(sbTest,format.length());
			if (ret){
				stmp=CcsFmt.formatStrYear(sbTest.toString(),false);
				ret=valid(stmp);
			}
			break;
		case FORMATTIME:
			ret=isLengthUnderMaxLength(sbTest,format.length());
			if (ret){
				stmp=CcsFmt.formatStrTime(sbTest.toString(),false);
				ret=valid(stmp);
			}
			break;
		case FORMATPHONE:
			ret=isLengthUnderMaxLength(sbTest,format.length());
			if (ret){
				stmp=CcsFmt.formatStrPhone(sbTest.toString(),false);
				ret=valid(stmp);
			}
			break;
		case FORMATSECU:
			ret=isLengthUnderMaxLength(sbTest,format.length());
			if (ret){
				stmp=CcsFmt.formatStrSecu(sbTest.toString(),false);
				ret=valid(stmp);
			}
			break;
		case FORMATURSS:
			ret=isLengthUnderMaxLength(sbTest,format.length());
			if (ret){
				stmp=CcsFmt.formatStrUrss(sbTest.toString(),false);
				ret=valid(stmp);
			}
			break;
		case FORMATPOSTAL:
			ret=isLengthUnderMaxLength(sbTest,format.length());
			if (ret){
				stmp=CcsFmt.formatStrPostal(sbTest.toString(),false);
				ret=valid(stmp);
			}
			break;
		}
		if (!ret){
			if (debug){
			   System.out.println(jt.getName());
			}
		}
		return ret;
	}
	public void setDebug(boolean enable){
		debug=enable;
	}
	private boolean valid(String stmp) {
		boolean ret=false;
		sbTest.setLength(0);
		sbTest.append(stmp);
		ret=isLengthUnderMaxLength(sbTest,format.length());
		if (ret){
			newoffset=0;
			newstr=sbTest.toString();
			newlength=this.getLength();
		}
		return ret;
	}
	public static String textFormat(String str, Fma fma, String format) {
		String ret=null;
		switch (fma){
		case URSS:
			ret=CcsFmt.formatStrUrss(str,true);
			break;
		case POSTAL:
			ret=CcsFmt.formatStrPostal(str,true);
			break;
		case MONTH:
			ret=CcsFmt.formatStrMonth(str,true);
			break;
		case YEAR:
			ret=CcsFmt.formatStrYear(str,true);
			break;
		case SECU:
			ret=CcsFmt.formatStrSecu(str,true);
			break;
		case PHONE:
			ret=CcsFmt.formatStrPhone(str,true);
			break;
		case TIME:
			ret=CcsFmt.formatStrTime(str,true);
			break;
		case DATE:
			ret=CcsFmt.formatStrDate(str,true);
			break;
		case NUM:
		case NUMSPACE:
		case NUMGRAS:
		case NUMGRASSPACE:
			ret=CcsFmt.formatStrDecimal(str, format, true);
			break;
		default :
			ret=str;
		}
		return ret;
	}
	//------------- Format string Date
	public static String formatStrDate(String str,boolean complementZero) {
		if (str==null){
			str="";
		}
		String splitter=Fmt.DATE.splitter();
		String tab[]=str.split(splitter);
		String day="";
		String month="";
		String year="";
		for (int i=0;i< tab.length;i++){
			if (i==0){
				day=CcsFmt.getDigit(tab[0]);
			}
			if (i==1){
				month=CcsFmt.getDigit(tab[1]);
			}
			if (i==2){
				year=CcsFmt.getDigit(tab[2]);
			}
		}
		String ret="";
		if (complementZero){
			day=CcsFmt.ligLig(day,2);
			month=CcsFmt.ligLig(month,2);
			year=CcsFmt.formatStrYear(year,complementZero);
			ret=day+splitter+month+splitter+year;
		} else {
			if (tab.length==3){
				ret=day+splitter+month+splitter+year;
			}
			if (tab.length==2){
				ret=day+splitter+month;
				if (month.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}
			if (tab.length==1){
				ret=day;
				if (day.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}

		}
		if (ret.equals("00/00/2000")){
			ret="          ";
		}
		return ret;
	}
	//------------- Format string Month
	public static String formatStrMonth(String str, boolean complementZero) {
		String splitter=Fmt.MONTH.splitter();
		String tab[]=str.split(splitter);
		String month="";
		String year="";
		for (int i=0;i< tab.length;i++){
			if (i==0){
				month=CcsFmt.getDigit(tab[0]);
			}
			if (i==1){
				year=CcsFmt.getDigit(tab[1]);
			}
		}
		String ret="";
		if (complementZero){
			month=CcsFmt.ligLig(month,2);
			year=CcsFmt.formatStrYear(year,complementZero);
			ret=month+splitter+year;
		} else {
			if (tab.length==2){
				ret=month+splitter+year;
			}
			if (tab.length==1){
				ret=month;
				if (month.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}
		}
		return ret;
	}
	//------------- Format string Code year
	public static String formatStrYear(String str, boolean complement2000 ) {
		String ret="";
		if (complement2000){
			if (CcsFmt.getDigit(str).length()==4){
				ret=CcsFmt.getDigit(str);
			} else {
				int value;
				if (CcsFmt.getDigit(str).length()==0){
					value=2000;
				} else {
					value=Gp.parseInt(CcsFmt.getDigit(str))+2000;
				}
				ret=""+value;
			}
		} else {
			ret=CcsFmt.getDigit(str);
		}
		return ret;
	}
	//------------- Format string phone
	public static String formatStrPhone(String str, boolean complementCheck) {
		String splitter=Fmt.PHONE.splitter();
		String tab[]=str.split(splitter);
		String un="";
		String deux="";
		String trois="";
		String quatre="";
		String cinq="";
		for (int i=0;i< tab.length;i++){
			if (i==0){
				un=CcsFmt.getDigit(tab[i]);
			}
			if (i==1){
				deux=CcsFmt.getDigit(tab[i]);
			}
			if (i==2){
				trois=CcsFmt.getDigit(tab[i]);
			}
			if (i==3){
				quatre=CcsFmt.getDigit(tab[i]);
			}
			if (i==4){
				cinq=CcsFmt.getDigit(tab[i]);
			}
		}
		String ret="";
		if (complementCheck){
			un=CcsFmt.ligLig(un,2,"?");
			deux=CcsFmt.ligLig(deux,2,"?");
			trois=CcsFmt.ligLig(trois,2,"?");
			quatre=CcsFmt.ligLig(quatre,2,"?");
			cinq=CcsFmt.ligLig(cinq,2,"?");
			ret=un+splitter+deux+splitter+trois+splitter+quatre+splitter+cinq;
		} else {
			if (tab.length==5){
				ret=un+splitter+deux+splitter+trois+splitter+quatre+splitter+cinq;
			}
			if (tab.length==4){
				ret=un+splitter+deux+splitter+trois+splitter+quatre;
				if (quatre.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}
			if (tab.length==3){
				ret=un+splitter+deux+splitter+trois;
				if (trois.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}
			if (tab.length==2){
				ret=un+splitter+deux;
				if (deux.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}
			if (tab.length==1){
				ret=un;
				if (un.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}
		}
		return ret;
	}
	//------------- Format string Time
	public static String formatStrTime(String str,boolean complementZero) {
		String splitter=Fmt.TIME.splitter();
		String tab[]=str.split(splitter);
		String hour="";
		String minute="";
		for (int i=0;i< tab.length;i++){
			if (i==0){
				hour=CcsFmt.getDigit(tab[0]);
			}
			if (i==1){
				minute=CcsFmt.getDigit(tab[1]);
			}
		}

		String ret="";
		if (complementZero){
			hour=CcsFmt.ligLig(hour,2);
			minute=CcsFmt.ligSpace(minute,2,"0");
			ret=hour+splitter+minute;
		} else {
			if (tab.length==2){
				ret=hour+splitter+minute;
			}
			if (tab.length==1){
				ret=hour;
				if (hour.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}
		}
		return ret;
	}
	//------------- Format string Urssaf
	public static String formatStrUrss(String str,boolean complementZero) {
		String splitter=Fmt.URSS.splitter();
		String tab[]=str.split(splitter);
		String organisme="";
		String numero="";
		for (int i=0;i< tab.length;i++){
			if (i==0){
				organisme=CcsFmt.getDigit(tab[0]);
			}
			if (i==1){
				numero=CcsFmt.getDigit(tab[1]);
			}
		}
		String ret="";
		if (complementZero){
			organisme=CcsFmt.ligLig(organisme,3);
			ret=organisme+splitter+numero;
		} else {
			if (tab.length==2){
				ret=organisme+splitter+numero;
			}
			if (tab.length==1){
				ret=organisme;
				if (organisme.length()==3||str.endsWith(splitter))
					ret=ret+splitter;
			}
		}
		return ret;
	}
	//------------- Format string secu
	public static String formatStrSecu(String str,boolean complementCheck) {
		String splitter=Fmt.SECU.splitter();
		String tab[]=str.split(splitter);
		String sexe="";
		String annee="";
		String mois="";
		String departement="";
		String commune="";
		String ordre="";
		String cle="";
		for (int i=0;i< tab.length;i++){
			if (i==0){
				sexe=CcsFmt.getDigit(tab[i]);
			}
			if (i==1){
				annee=CcsFmt.getDigit(tab[i]);
			}
			if (i==2){
				mois=CcsFmt.getDigit(tab[i]);
			}
			if (i==3){
				departement=CcsFmt.getDigit(tab[i]);
			}
			if (i==4){
				commune=CcsFmt.getDigit(tab[i]);
			}
			if (i==5){
				ordre=CcsFmt.getDigit(tab[i]);
			}
			if (i==6){
				cle=CcsFmt.getDigit(tab[i]);
			}
		}
		String ret="";
		if (complementCheck){
			sexe=CcsFmt.ligLig(sexe,1,"?");
			annee=CcsFmt.ligLig(annee,2,"?");
			mois=CcsFmt.ligLig(mois,2,"?");
			departement=CcsFmt.ligLig(departement,2,"?");
			commune=CcsFmt.ligLig(commune,3,"?");
			ordre=CcsFmt.ligLig(ordre,3,"?");
			cle=CcsFmt.ligLig(cle,2,"?");
			ret=sexe+splitter+annee+splitter+mois+splitter+departement+splitter+commune+splitter+ordre+splitter+cle;
		} else {
			if (tab.length==7){
				ret=sexe+splitter+annee+splitter+mois+splitter+departement+splitter+commune+splitter+ordre+splitter+cle;
			}
			if (tab.length==6){
				ret=sexe+splitter+annee+splitter+mois+splitter+departement+splitter+commune+splitter+ordre;
				if (ordre.length()==3||str.endsWith(splitter))
					ret=ret+splitter;
			}
			if (tab.length==5){
				ret=sexe+splitter+annee+splitter+mois+splitter+departement+splitter+commune;
				if (commune.length()==3||str.endsWith(splitter))
					ret=ret+splitter;
			}
			if (tab.length==4){
				ret=sexe+splitter+annee+splitter+mois+splitter+departement;
				if (departement.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}
			if (tab.length==3){
				ret=sexe+splitter+annee+splitter+mois;
				if (mois.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}
			if (tab.length==2){
				ret=sexe+splitter+annee;
				if (annee.length()==2||str.endsWith(splitter))
					ret=ret+splitter;
			}
			if (tab.length==1){
				ret=sexe;
				if (sexe.length()==1||str.endsWith(splitter))
					ret=ret+splitter;
			}
		}
		return ret;
	}
	//------------- Format string Code postal
	public static String formatStrPostal(String str, boolean decimalEndedZero) {
		String ret="";
		if (decimalEndedZero){
			ret=CcsFmt.ligLig(CcsFmt.getDigit(str),Fmt.POSTAL.length());
		} else {
			ret=CcsFmt.getDigit(str);
		}
		return ret;
	}
	//------------- Format string numrique decimal
	public static String formatStrDecimal(String str,String format,boolean decimalEndedZero) {
		String separator=".";
		String ret=null;
		if (format!=null){
			// ne garde que les digit de la chaine
			String stmp=clearStringDigit(str);
			// Annule le point et les dcimals en fonction du Format
			stmp=CcsFmt.outPoint(stmp,format);

			// Remplace une saisie direct du Point par '0.'
			if ( (stmp.length()==1 && stmp.equals(separator))){
				stmp="0"+separator;
			}
			// Garde la partie entiere au Maximum du Format Prvu
			stmp=CcsFmt.keepMaxIntMaxDec(stmp,format,decimalEndedZero);
			if (stmp.length()==0) {
				stmp="0";
			}
			ret=stmp;
		} else {
			ret=str;
		}
		return ret;
	}
	//------------- Format string numrique decimal
	public static String keepMaxInt(String stmp,String format){
		String ret="";
		// Coupe la saisie avant la decimale
		String strmaxint="";
		for (int i=0;i<stmp.length();i++){
			if(stmp.charAt(i)=='.')
				break;
			else
				strmaxint=strmaxint+stmp.charAt(i);
		}
		// Coupe le format avant la decimal
		String maxint="";
		for (int i=0;i<format.length();i++){
			if(format.charAt(i)=='.')
				break;
			else
				maxint=maxint+format.charAt(i);
		}
		// Garde la saisie  la longueur du format
		if (strmaxint.length()>maxint.length())
			ret=strmaxint.substring(0, maxint.length());
		else
			ret=strmaxint;
		return ret;
	}
	private static String formatString(String string, String format) {
		return string.toUpperCase();
	}
	public static String clearStringDigit(String strgetTxt, String separator){
		return clearStringDigitSeparator(strgetTxt,separator);
	}
	public static String clearStringDigit(String strgetTxt){
		return clearStringDigitSeparator(strgetTxt,".");
	}
	private static String clearStringDigitSeparator(String strgetTxt, String separator){
		// SqlLite n'accepte que les points
		// Force le decimal format en point 
		String strret="";
		String digit="0123456789";
		char ctest;
		boolean isDigit=false;
		String moins="-";
		if (strgetTxt!=null)
			if (!strgetTxt.isEmpty()){
				for (int i=0;i<strgetTxt.length();i++){ // parcours la chaine finale
					isDigit=false;
					ctest=strgetTxt.charAt(i);
					for (int j=0;j<digit.length();j++) { //parcours les digits possible
						if (digit.charAt(j)==ctest){
							isDigit=true;
							break;
						}
					}
					if (isDigit){ // ajoute un digit
						strret=strret+ctest;
					} else if (ctest==','||ctest=='.'){ // verifie le sparateur et n'ajoute qu'une fois le POINT
						strret=strret+separator;
						separator="";
					} else if (ctest=='-' && strret.length()==0) { // vrifie le signe et ne l'ajoute qu'en premier caractre
						strret=strret+moins;
						moins="";
					}
				}
			}
		return  strret;
	}
	// --------- Complmenent  droite avec des zro
	public static String ligLig(String value, int length) {
		return ligLig(value,length,"0");
	}
	public static String ligLig(String value, int length,String complement) {
		String ret="";
		if (value!=null)
			ret=value;
		else
			ret="";
		for (int i=ret.length();ret.length()<length;i++)
			ret=complement+ret;
		return ret;
	}
	// --------- Complmenent  gauche avec des espace
	public static String ligSpace(String value, int length) {
		return ligSpace(value,length," ");
	}
	public static String ligSpace(String str, int length,String complement) {
		String ret=str;
		for (int i=str.length();i<length;i++)
			ret=ret+complement;
		return ret;
	}
	// --------- Garde que les chiffres
	public static String getDigit(String str){
		String ret="";
		String strtemp="";
		for (int i=0;i<str.length();i++){
			strtemp=""+str.charAt(i);
			if ("0123456789".contains(strtemp)){
				ret=ret+strtemp;
			}
		}
		return ret;
	}
	private boolean isLengthUnderMaxLength(StringBuffer sb,int maxLength){
		if (sb.length()>maxLength){
			Toolkit.getDefaultToolkit().beep();
			return false;
		} else
			return true;
	}
	private static String outPoint(String stmp,String format){
		String separator=".";
		String ret=stmp;
		if (!format.contains(separator)){
			if (stmp.contains(separator)){
				ret="";
				for (int i=0;i<stmp.length();i++){
					if (stmp.charAt(i)=='.') {
						break; // Stop la chaine avant le point
					} else {
						ret=ret+stmp.charAt(i); // Ajoute le digit
					}
				}
			}
		}
		return ret;
	}
	private static String keepMaxIntMaxDec(String stmp,String format,boolean decimalEndedZero){
		String separator=".";
		String ret="";
		if  (format.contains(separator) ){
			if (stmp.contains(separator)||decimalEndedZero)
				ret=keepMaxInt(stmp,format)+separator+keepMaxDec(stmp,format,decimalEndedZero);
			else
				ret = keepMaxInt(stmp,format);
		} else {
			ret = keepMaxInt(stmp,format);
		}
		return ret;
	}
	// --------- Complmenent  droite avec des zro
	private static String keepMaxDec(String stmp,String format,boolean decimalEndedZero){
		String ret="";
		// Coupe la saisie aprs la decimale
		String strmaxdec="";
		boolean isDec=false;
		for (int i=0;i<stmp.length();i++){
			if (stmp.charAt(i)=='.')
				isDec=true;
			else if (isDec)
				strmaxdec=strmaxdec+stmp.charAt(i);
		}
		// Coupe le format aprs la decimale

		String maxdec="";
		isDec=false;
		for (int i=0;i<format.length();i++){
			if (format.charAt(i)=='.')
				isDec=true;
			else if (isDec)
				maxdec=maxdec+format.charAt(i);

		}
		// Garde la saisie  la longueur du format
		if (strmaxdec.length()>maxdec.length()) {
			ret=strmaxdec.substring(0, maxdec.length());
		} else {
			ret=strmaxdec;
			if (decimalEndedZero)
				ret=ret+endDecimalZero(strmaxdec,maxdec);
		}
		return ret;
	}
	private static String endDecimalZero(String dec,String decFormat){
		String ret="";
		for (int i=dec.length();i<decFormat.length();i++)
			ret=ret+"0";
		return ret;
	}
	public static String formatEstampille(String v_esta) {
		String ret="";
		if (v_esta.length()==9){
			// "44.113002"
			ret=v_esta.substring(0,6)+"."+v_esta.substring(6,8);
		} else if (v_esta.length()==8){
			// "49099002"
			// "49099002"
			ret=v_esta.substring(0,2)+"."+v_esta.substring(2,5)+"."+v_esta.substring(5,7);
		} else if (v_esta.length()==7){
			// "6119902"
			ret=v_esta.substring(0,2)+"."+v_esta.substring(2,5)+"."+v_esta.substring(5,6);
		} else {
			// "61.199.02"
			ret=v_esta;
		}
		return ret;
	}
}
