package composant_saisie.wTree;

import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;

public class JTreeDb extends JTree {
	private static final long serialVersionUID = 1L;
	Sql sql=null;
	public JTreeDb(Sql sql) {
		super();
		this.sql=sql;
		adapte();
	}
	
	private void adapte() {
		DefaultTreeModel treeModel = new DefaultTreeModel( menuTree(sql.getGpAbc().m_menuMain,new String[]{"Menu gnral","Arborescence des menus de l'application"} ) );
		this.setModel(treeModel);
		this.setRowHeight(0);
		this.setCellRenderer(new TreeDbCellRenderer());
	}

	public void expandAll() {
		int row = 0;
		while (row < this.getRowCount()) {
			this.expandRow(row);
			row++;
		}
	}
	public void collapseAll() {
		int row = this.getRowCount() - 1;
		while (row >= 0) {
			this.collapseRow(row);
			row--;
		}
	}
	private DefaultMutableTreeNode menuTree(String c_code, String []menu){
		DefaultMutableTreeNode racine = new DefaultMutableTreeNode(menu);
		Sql sqlAbcMenu=new Sql(sql.getSqlAbc());
		sqlAbcMenu.setTable("s_menus");
		try {
			String where="";
			if (sql.isDevFile()){
				where="c_code = '"+c_code+"'";
			} else {
				where="c_code = '"+c_code+"' AND substr(c_smen,1,4) <> substr('"+Gp.DEVNUMM+"',1,4)";
			}
			String query="SELECT c_code,c_cle2,c_smen,c_menu,c_racc,c_opt1,c_opt2,c_opt3,c_aide FROM s_menus WHERE "+where+" ORDER BY  c_cle2;";
			ResultSet rs=sqlAbcMenu.dBExecuteQueryOpen(query);
			while (rs.next()) {
				boolean sousmenu=false;
				if (rs.getString("c_smen")!=null){
					if (rs.getString("c_smen").trim().length()>0){
						sousmenu=true;
					}
				}
				String tmpAide="";
				if (sql.isDevFile()){
					String tmpOpt1=rs.getString("c_opt1");
					if (tmpOpt1.trim().length()>0){
						tmpOpt1="["+tmpOpt1+"] ";
					}
					tmpAide=tmpOpt1+rs.getString("c_aide");
				} else {
					tmpAide=rs.getString("c_aide");
				}
				String[] value=new String []{rs.getString("c_menu"), tmpAide};
				if (sousmenu){
					// Ajoute un sous Menus
					racine.add(menuTree(rs.getString("c_smen"),value));
				} else {
					racine.add(new DefaultMutableTreeNode(value));
				}
			}
			sqlAbcMenu.dBExecuteQuerryClose(rs);
			rs=null;
			sqlAbcMenu=null;
		} catch (SQLException e) { e.printStackTrace(); }
		return racine;
	}

	
}
