package composant_saisie.wTree;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeCellRenderer;

import persistance.wGlobalParam.Gp;

import composant_saisie.wComposant.JTextDb;

public class TreeDbCellRenderer implements TreeCellRenderer {
	JTextDb menu; 
	JTextDb aide;
	JPanel renderer;
	DefaultTreeCellRenderer defaultRenderer = new DefaultTreeCellRenderer();
	Color backgroundSelectionColor;
	Color backgroundNonSelectionColor;

	public TreeDbCellRenderer() {
		renderer = new JPanel();{
			menu = new JTextDb();{
				menu.setBorder(null);
				menu.setFont(Gp.FONTTEXT14);
				menu.setForeground(Gp.VERTFONCE_FG);
			}
			aide = new JTextDb();{
				aide.setBorder(null);
				aide.setFont(Gp.FONTTEXT10);
			}
			renderer.add(menu);
			renderer.add(aide);
		}
		backgroundSelectionColor = defaultRenderer.getBackgroundSelectionColor();
		backgroundNonSelectionColor = defaultRenderer.getBackgroundNonSelectionColor();
	}

	public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected,boolean expanded, boolean leaf, int row, boolean hasFocus) {
		Component returnValue = null;
		if ((value != null) && (value instanceof DefaultMutableTreeNode)) {
			String[] userObject = (String[]) ((DefaultMutableTreeNode) value).getUserObject();

			menu.setText(userObject[0]);
			aide.setText(userObject[1]);

			if (((DefaultMutableTreeNode) value).getChildCount()==0){
				menu.setFont(Gp.FONTTEXT12);
			} else {
				menu.setFont(Gp.FONTTEXT16);
			}

			if (selected) {
				menu.setBackground(backgroundSelectionColor);
				aide.setBackground(backgroundSelectionColor);
				renderer.setBackground(backgroundSelectionColor);
			} else {
				menu.setBackground(backgroundNonSelectionColor);
				aide.setBackground(backgroundNonSelectionColor);
				renderer.setBackground(backgroundNonSelectionColor);
			}
			renderer.setEnabled(tree.isEnabled());
			returnValue = renderer;
		}
		if (returnValue == null) {
			returnValue = defaultRenderer.getTreeCellRendererComponent(tree, value, selected, expanded,leaf, row, hasFocus);
		}
		return returnValue;
	}
}

