package fenetre_menu.wMenu;

import java.awt.BorderLayout;
import java.lang.management.ManagementFactory;
import java.lang.management.MemoryMXBean;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

import module_standard.wArborescence.JDialogArborescence;
import module_standard.wBackup.JDialogBackup;
import module_standard.wConnectPreference.S_prefsConnectVUE;
import module_standard.wInfos.JDialogInfos;
import module_standard.wParamMenus.S_menusParamVUE;
import module_standard.wParamPreference.S_prefsParamVUE;
import module_standard.wRaz.S_filesRazVUE;
import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import table_standard.wS_aide.S_aideVUE;
import table_standard.wS_color.S_colorVUE;
import table_standard.wS_field.S_fieldVUE;
import table_standard.wS_field.S_fieldTaffVUE;
import table_standard.wS_field.S_fieldTvueVUE;
import table_standard.wS_field.S_fieldTypeVUE;
import table_standard.wS_files.S_filesVUE;
import table_standard.wS_intero.S_interoVUE;
import table_standard.wS_menus.S_menusVUE;
import table_standard.wS_prefs.S_prefsVUE;
import table_standard.wS_slcol.S_slcolVUE;
import table_standard.wS_themes.S_themesVUE;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class DbVue extends JPanel {
	private static final long serialVersionUID = 1L;
	Sql sqlAbc=null;
	AbstractVue lastPanel=null;
	public DbVue(Sql sqlAbc)  {
		this.sqlAbc=sqlAbc;
		adapte();
		loadPanel();
		validateDebut();
	}
	private void adapte(){
		this.setLayout(new BorderLayout());
	}
	private void loadPanel(){
		sqlAbc.setCursorWait(true);
		String option=sqlAbc.getOption();
		lastPanel=null;
		AbstractVue jpOption=sqlAbc.getAppliParam().getAbstractVue(sqlAbc, option,sqlAbc.getOpt2(),sqlAbc.getOpt3());
		if (jpOption!=null){
			lastPanel=jpOption;
		} else {
			// OUTILS
			if (option.equals("backup")){
				new JDialogBackup(sqlAbc.getMf(),sqlAbc,JDialogBackup.BACKUP);
			} else if (option.equals("restore")){
				new JDialogBackup(sqlAbc.getMf(),sqlAbc,JDialogBackup.RESTORE);
			} else if (option.equals("razfiles")){
				lastPanel=new S_filesRazVUE(sqlAbc,Sql.t_top,Vue.F3);
				// Aide
			} else if (option.equals("menusParam")){
				lastPanel=new S_menusParamVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("prefsParam")){
				lastPanel=new S_prefsParamVUE(sqlAbc,Sql.t_top,Vue.FICHEDETAIL);
			} else if (option.equals("ChangeUser")){
				lastPanel=new S_prefsConnectVUE(sqlAbc,Sql.t_top,Vue.FICHEDETAIL);
			} else if (option.equals("color")){
				lastPanel=new S_colorVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("slcol")){
				lastPanel=new S_slcolVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("infos")){
				new JDialogInfos(sqlAbc.getMf(),sqlAbc);
			} else if (option.equals("arbo")){
				new JDialogArborescence(sqlAbc.getMf(),sqlAbc);

				// Developpement

			} else if (option.equals("s_intero")){
				lastPanel=new S_interoVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("s_menus")){
				lastPanel=new S_menusVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("s_files")){
				lastPanel=new S_filesVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("s_field")){
				lastPanel=new S_fieldVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("s_fieldTvu")){
				lastPanel=new S_fieldTvueVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("s_fieldTyp")){
				lastPanel=new S_fieldTypeVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("s_fieldTaf")){
				lastPanel=new S_fieldTaffVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("s_themes")){
				lastPanel=new S_themesVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("s_prefs")){
				lastPanel=new S_prefsVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else if (option.equals("s_aide")){
				lastPanel=new S_aideVUE(sqlAbc,Sql.t_top,Vue.F3);
			} else { 
				if (sqlAbc.isDevFile() && !option.equals("Essai")){
					JOptionPane.showMessageDialog(sqlAbc.getMf(), "L'option ["+option+"] n'xiste pas, Revoir le menu ou modifier Version","Attention !!! Option Introuvable", JOptionPane.INFORMATION_MESSAGE);
				}
			}
		}
		if (lastPanel!=null ){
			add(lastPanel);
			this.validate();
		}
		sqlAbc.setCursorWait(false);
	}
	private void validateDebut() {
		Object[] nbComponent=this.getComponents();
		if (nbComponent.length>0){
			if (Gp.USEROUNDEDBORDER)
				this.setBorder(new TitledBorder(null,"", TitledBorder.LEFT, TitledBorder.DEFAULT_POSITION));
			if (Gp.USEPANELVUE){
				this.setBackground(Gp.PANELVUE_BG);
			}
		}
	}
	//	private void majAppli(Sql sql) {
	/*Gp.afficherTrace(1,"0 test si maj table famille_repas");
		sql.t_table="famille_repas";
		if (sql.isTableExist()){
			Gp.afficherTrace(1,"Fin Table prsente pas de mise  jour");
		} else {
			Gp.afficherTrace(1,"2 Augmente la taille des champs planning/Ingrdients)");
			String newFami="  ";
			Sql sqlMaj=new Sql(sql);
			sqlMaj.dBExecuteUpdate("UPDATE ingredient set c_repa='"+newFami+"' || substr(c_repa,1,3);");
			sqlMaj.dBExecuteUpdate("UPDATE planning set c_lund='"+newFami+"' || substr(c_lund,1,3) ;");
			sqlMaj.dBExecuteUpdate("UPDATE planning set c_mard='"+newFami+"' || substr(c_mard,1,3) ;");
			sqlMaj.dBExecuteUpdate("UPDATE planning set c_merc='"+newFami+"' || substr(c_merc,1,3) ;");
			sqlMaj.dBExecuteUpdate("UPDATE planning set c_jeud='"+newFami+"' || substr(c_jeud,1,3) ;");
			sqlMaj.dBExecuteUpdate("UPDATE planning set c_vend='"+newFami+"' || substr(c_vend,1,3) ;");
			sqlMaj.dBExecuteUpdate("UPDATE planning set c_same='"+newFami+"' || substr(c_same,1,3) ;");
			sqlMaj.dBExecuteUpdate("UPDATE planning set c_dima='"+newFami+"' || substr(c_dima,1,3) ;");
		}*/
	//	}
	public void dispose() {
		MemoryMXBean memoryBean = ManagementFactory.getMemoryMXBean();
		double used=(memoryBean.getHeapMemoryUsage().getUsed())/1024;
		if (lastPanel!=null){
			lastPanel.dispose();
			lastPanel=null;
		}
		if (sqlAbc.isDevFile()){
			//System.gc();
			double usedgc=(memoryBean.getHeapMemoryUsage().getUsed())/1024;
			Gp.ad("DbVue : "+(int)used+" "+(int)usedgc);
		}
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
