package module_standard.wBackup;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.nio.channels.FileChannel;
import java.util.prefs.Preferences;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextLabel;

import fenetre_menu.wConteneur.AbstractJDialogDb;
import fenetre_menu.wConteneur.AbstractJPanelDlg;
import fenetre_menu.wConteneur.JDialogDlg;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class Backup extends AbstractJPanelDlg implements ActionListener {
	private static final long serialVersionUID = 1L;
	Sql sql=null;
	JTextLabel jlsource;
	JTextLabel jldest;
	JPanel buttonPanel=null;
	File source=null;
	File backup=null;

	static private final String newline = "<html><br><br>";
	JFileChooserDb jfc=null;
	JTextButton  choisirButton = null;
	JTextButton  backupButton = null;
	String choix="Choisir le fichier";
	int type;
	String tableCsv="article";
	String delimited=";";
	String ext=null;
	String choisir=null;
	String action=null;
	String fichiera=null;
	String pasde=null;
	String la=null;
	String description=null;
	JDialogDlg jd=null;
	Preferences pref=null;
	String messageThread="";
	public Backup(JDialogDlg jd,Sql sqlsys, int type){
		super(jd);
		this.jd=jd;
		this.type=type;
		this.sql=sqlsys.getSql();
		sql.closeCx();
		sql=new Sql(sql.getGp());
		pref=Preferences.userRoot();

		setWithType(type);
		description="Base de donnes "+sql.getAppliParam().TITRE_APPLI+" (*";

		//ext=sql.getGpAbc().base.subSequence(sql.getGpAbc().base., arg1)
		ext="";
		boolean point=false;
		char a;
		String url=sql.getGpAbc().url+sql.getGpAbc().base;
		for (int i=0;i<url.length();i++){
			a=url.charAt(i);
			if (a=='.')
				point=true;
			if(point)
				ext=ext+a;
		}

		jlsource = new JTextLabel("");{
			source=new File(sql.getAppliParam().getAppDirectory()+File.separator+sql.getAppliParam().getNameBaseDATA() );
		}
		jldest = new JTextLabel("");{}

		buttonPanel = new JPanel();{
			backupButton = new JTextButton(action,action.charAt(0));{
				backupButton.addActionListener(this);
				backupButton.setEnabled(false);
			}
			buttonPanel.add(backupButton);
			choisirButton = new JTextButton(choix,choix.charAt(0));{
				choisirButton.addActionListener(this);
				choisirButton.setEnabled(true);
			}
			buttonPanel.add(choisirButton);
		}

		jfc = new JFileChooserDb(type);{
			String path=pref.get(sql.getAppliParam().getNameBase()+"Backup","");
			File file=null;
			if (path.equals("")){
				file=new File("*"+ext);
			} else {
				file=new File(path);
			}
			jfc.setSelectedFile(file);
			jfc.addChoosableFileFilter(new JFileChooserExtensionFilter(description+ext+")", ext));
		}

		if (type==JDialogBackup.BACKUP){
			this.add(jldest, BorderLayout.NORTH);
			this.add(jlsource, BorderLayout.CENTER);
		} else  {
			this.add(jlsource, BorderLayout.NORTH);
			this.add(jldest, BorderLayout.CENTER);
		}
		add(buttonPanel, BorderLayout.SOUTH);
		
		choisirButton.doClick();
	}

	private void setWithType(int type){
		switch(type){
		case JDialogBackup.BACKUP:
			action="Sauvegarder";
			choisir="Choisir le nom de la sauvegarde";
			fichiera="Fichier  sauvegarder :   "+ newline;
			pasde="Pas de sauvegarde";
			la="La sauvegarde";
			break;
		case JDialogBackup.RESTORE: 
			action="Rcuprer";
			choisir="Choisir le fichier de sauvegarde  rcuprer";
			fichiera="Rcupration du fichier :   "+ newline;
			pasde="Pas de rcupration";
			la="La rcupration";
			break;
		}

	}
	private void lanceBackup() {
		int returnVal;
		returnVal = jfc.showDialog(this,choisir);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			choisirButton.setEnabled(false);
			backup = jfc.getSelectedFile();
			if (type==JDialogBackup.BACKUP){
				jldest.append(fichiera + source.getPath()+newline);
				jlsource.append("Sur : "+newline+backup.getPath()+newline);
				backupButton.setEnabled(true);
				backupButton.requestFocusInWindow();
				backupButton.requestFocus();
				pref.put(sql.getAppliParam().getNameBase()+"Backup", backup.getPath());

			} else {
				jlsource.append(fichiera + backup.getPath()+newline);
				jldest.append("Sur : " + newline+ source.getPath()+newline);
				if (isRestorable(backup.getPath(),type)) {
					backupButton.setEnabled(true);
					backupButton.requestFocusInWindow();
					backupButton.requestFocus();
				} else {
					jlsource.append("Type de fichier incompatible,rcupration impossible, Prendre un autre fichier." + newline);
				}
			}
		} else {
			if (type==JDialogBackup.BACKUP){
				jlsource.append(pasde+" faite, penser  la faire plus tard." + newline);
			} else  {
				jldest.append(pasde+" faite, penser  la faire plus tard." + newline);
			}
		}
		jd.pack();
	}

	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getSource() == backupButton) {
			backupRestoreFile(type);
			JOptionPane.showMessageDialog(sql.getMf(), "\n\n"+ la+" est termine, Merci",action, JOptionPane.INFORMATION_MESSAGE);
			this.putClientProperty(AbstractJDialogDb.action,AbstractJDialogDb.closedialog);
		}
		if (arg0.getSource() == choisirButton) {
			jlsource.append(sql.getAppliParam().getAppDirectory()+File.separator+sql.getAppliParam().getNameBaseDATA());
			jldest.append("");
			lanceBackup();
		}
	}

	///////////////////////////////////
	// Lecture criture des fichiers //
	///////////////////////////////////
	private void backupRestoreFile(int type){
		FileChannel in = null; // canal d'entre
		FileChannel out = null; // canal de sortie
		try {
			if (type==JDialogBackup.BACKUP){
				in = new FileInputStream(source).getChannel();
				out = new FileOutputStream(backup).getChannel();
			} else if (type==JDialogBackup.RESTORE) {
				in = new FileInputStream(backup).getChannel();
				out = new FileOutputStream(source).getChannel();
			}
			in.transferTo(0, in.size(), out);
		} catch (Exception e) {
			e.printStackTrace(); 
		} finally { 
			if(in != null) {
				try { in.close(); } catch (IOException e) {}
			}
			if(out != null) {
				try { out.close(); } catch (IOException e) {}
			}
		}
	}

	private boolean isRestorable(String fileIn,int type){
		boolean ret=false;
		String verifFormat="";
		//String verifFormat="SQLite format 3";
		verifFormat=setVerifFormat(type,15);
		ret=isFileRestore(fileIn,verifFormat);
		return ret;
	}

	private boolean isFileRestore(String fileIn,String verifFormat){
		boolean ret=false;
		FileReader in;
		try {
			in = new FileReader(fileIn);
			char [] verif=new char[verifFormat.length()];
			in.read(verif,0,verif.length);
			String verifstring="";
			for (int i=0;i<verif.length;i++)
				verifstring=verifstring+verif[i];
			in.close();
			if (verifstring.equals(verifFormat))
				ret=true;

		} catch (FileNotFoundException e) {e.printStackTrace();
		} catch (IOException e) {e.printStackTrace();}
		return ret;		
	}

	private String setVerifFormat(int type,int lengthSignature){
		String ret="";
		try {
			FileReader in;
			char [] verif;
			in = new FileReader(source);
			verif=new char[lengthSignature];
			in.read(verif,0,verif.length);
			in.close();
			ret="";
			for (int i=0;i<verif.length;i++)
				ret=ret+verif[i];
		} catch (FileNotFoundException e) {e.printStackTrace();
		} catch (IOException e) {e.printStackTrace();}
		return ret;
	}
}
