package module_standard.wDebug;

import java.awt.BorderLayout;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.text.JTextComponent;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextButton;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JDebug extends JDialog implements ActionListener {
	private static final long serialVersionUID = 1L;
	private JTextComponent jc=null;
	private String titre=null;
	JTextButton jbclear,jbclose,jbreport;
	public JDebug(String titre, JTextComponent jc){
		this.jc=jc;
		this.titre=titre;
		adapte();
	}
	private void adapte(){
		this.setName(this.getClass().getSimpleName());
		this.add(new JScrollPane(jc));
		this.getContentPane().setPreferredSize(new Dimension(600,600));
		this.getContentPane().setSize(new Dimension(600,600));
		this.setTitle("Mode : "+titre+", Enclench");
		JPanel jpbutton=new JPanel(new FlowLayout());{
			jbclear=new JTextButton("Effacer");{
				jbclear.addActionListener(this);	
				jpbutton.add(jbclear);
			}
			jbclose=new JTextButton("Fermer");{
				jbclose.addActionListener(this);	
				jpbutton.add(jbclose);
			}
			if(Desktop.isDesktopSupported()){		
				if(Desktop.getDesktop().isSupported(Desktop.Action.MAIL)){
					if (Gp.APPLIPARAM.CONTACT!=null){
						jbreport=new JTextButton("Envoyer un mail, pour recevoir une Mise  jour rapide");{
							jbreport.setFont(Gp.FONTTEXT13);
							jbreport.setForeground(Gp.INVALIDE_FG_RED);
							jbreport.setColor();
							jbreport.addActionListener(this);	
							jpbutton.add(jbreport);
						}
					}
				}
			}
		}
		this.add(jpbutton,BorderLayout.NORTH);
	}
	public void setVisible(boolean enable){
		if (enable){
			Gp.setRelativeLocation(this, getLocation(), this.getSize());
		}
		super.setVisible(enable);
	}
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==jbclear){
			jc.setText("");
			setVisible(false);
		}
		if (e.getSource()==jbreport){
			//mailto:duke@sun.com?SUBJECT=Happy New Year!&BODY=Happy New Year, Duke!
			String mail=Gp.APPLIPARAM.CONTACT;
			String subject="Demande de Mise  jour, "+Gp.APPLIPARAM.TITRE_APPLI+" Version "+Gp.APPLIPARAM.VERSION;
			String attention="Profitez du programme de Mise  jour rapide en envoyant ce Mail, Merci.";
			String body=attention+Gp.LINEFEED+Gp.LINEFEED+parseMail(jc.getText());
			URI uri;
			try {
				uri = new URI("mailto",mail+"?SUBJECT="+subject+"&BODY="+body,null);
				Desktop.getDesktop().mail(uri);
			} catch (IOException arg0) {
				arg0.printStackTrace();
			} catch (URISyntaxException arg0) {
				arg0.printStackTrace();
			}
			jbreport.setEnabled(false);

		}
		if (e.getSource()==jbclose){
			if (titre.equals(Gp.ConsoleErr))
				Gp.setConsoleErr(false);
			else
				Gp.setConsoleDebug(false);
			dispose();
		}
	}
	public String parseMail(String string) {
		String tmp="";
		String lettre="\\";
		char a=lettre.charAt(0);
		for(int len=0;len<string.length();len++){
			if (string.charAt(len)==a) {
				tmp=tmp+"\\";
			} else if (string.charAt(len)==':'){
				tmp=tmp+"!";
			} else if (string.charAt(len)=='"'){
				tmp=tmp+"\"";
			} else {
				tmp=tmp+string.charAt(len);
			}

			if (len>=1024-2)
				break;
		}
		return tmp;
	}
	public void dispose(){
		jc=null;
		titre=null;
		jbclear=jbclose=jbreport=null;
		super.dispose();
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+this.getName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
