package module_standard.wImprime;


import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.print.PageFormat;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.ArrayList;

import javax.swing.JPanel;
import javax.swing.Scrollable;
import javax.swing.SwingConstants;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Field;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.CcsFmt;
import composant_saisie.wSaisieFormat.Fma;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class JPimpListe extends JPanel implements Scrollable {
	private static final long serialVersionUID = 1L;
	Sql sql=null;
	PageFormat pf=null;
	Graphics2D g2d=null;
	// Tableau de coordonne des colonnes de la liste
	int[] pixCol=null;

	double PaperWidth;
	double PaperHeight;
	double panelWidth;
	double panelHeight;
	double panelHeightEntete;
	double pageHeight;
	double pageWidth;
	int listWidth;
	double scale;
	JPEntete jpentete=null;
	//int charWidth=Ctf.charwidth;
	int charWidth=Gp.WIDTHCHAR+4;
	int charHeight=charWidth+(charWidth/2);

	//int decax=(charWidth/2)-3;
	int decax=(charWidth/2)-3;

	//int decay=((charHeight/2)-2)*-1;
	int decay=((charHeight/2)-2)*-1;

	int g_fflg;
	int prow;
	int numpage;
	int numlist;
	String[] libemax=null;
	/**
	 * Impression des ruptures
	 */
	boolean isPrintRuptureEnable=false;
	/**
	 * Impression du detail
	 */
	boolean isPrintDetailEnable=true;
	ArrayList <Field> beforeRupture=null;
	ArrayList <Field> afterRupture=null;
	ArrayList <Double> cumul=null;
	ArrayList <Double> total=null;

	String debut=null;
	String fin=null;
	boolean printWithIndex=false;
	boolean computeSize=false;
	boolean isligneLimited=false;

	// sauve le sql avant dition
	String sauveT_Recno;
	boolean sauveT_eof;
	String sauveV_index;
	String[] sauveT_filtre;
	String[] sauveV_filtre;
	int sauveT_nbLigne;
	String sauveClauseFilter;
	String sauveClauseGroupBy;
	boolean debug=false;

	public JPimpListe(JPEntete jpentete){
		this.jpentete=jpentete;
		adapte();
	}
	public void validateDebut(Sql sql,PageFormat pf,String debut,String fin,boolean printWithIndex){
		this.sql=sql;
		this.pf=pf;
		this.debut=debut;
		this.fin=fin;
		this.printWithIndex=printWithIndex;
		compute();
	}
	public void adapte(){
		//this.setAutoscrolls(true);
		this.setDoubleBuffered(false);
		this.setBackground(Color.WHITE);
		this.setLayout(null);
	}
	public void compute(){
		if (!sql.isTcetorp()){
			isligneLimited=true;
		}
		switch (sql.g_rupture){
		case Sql.RUPTURE_TOTAL:
		case Sql.RUPTURE_TOUS:
			if (sql.ruptures!=null){
				if (sql.g_rupture==Sql.RUPTURE_TOTAL){
					isPrintDetailEnable=false;
				}
				isPrintRuptureEnable=true;
				beforeRupture=new ArrayList<Field>(Gp.MAXFIELDS);
				afterRupture=new ArrayList<Field>(Gp.MAXFIELDS);
				for(int i=0;i<sql.ruptures.size();i++){
					beforeRupture.add(new Field("",0,Fma.FIELD,"",""));
					afterRupture.add(new Field("",0,Fma.FIELD,"",""));
				}
			}
			break;
		case Sql.RUPTURE_DETAIL:
			break;
		}
		libemax=new String [sql.t_height]; // Tableau de wrap t_LIBEMAX

		PaperWidth=pf.getImageableWidth();
		PaperHeight=pf.getImageableHeight();
		pageHeight=PaperHeight;

		pixCol=initPrintPixCol();
		listWidth=pixCol[pixCol.length-1]+(decax);
		// calcule la largeur totale 
		pageWidth=0;
		int colWidthSpace=0;
		for (int i=0;i<sql.g_nbList;i++){
			pageWidth=pageWidth+colWidthSpace+listWidth;
			colWidthSpace=charWidth;
		}

		// calcule un scale pour la largeur
		scale=(PaperWidth)/(pageWidth);
		if (scale>1){
			scale=1;
			pageWidth=PaperWidth;
		}


		// Calcule le nombre de ligne possible pour la hauteur
		g_fflg=(int) (PaperHeight/charHeight);
		if (scale<1){
			g_fflg=(int)(g_fflg/scale);
		}
		g_fflg--;
	}

	public void paintComponent(Graphics g){
		super.paintComponent(g);
		// Set le contexte graphique
		this.g2d=(Graphics2D)g;
		g2d.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
		g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
		g2d.scale(scale,scale);
		g2d.setFont(g2d.getFont().deriveFont( g2d.getFont().getStyle(), charWidth));

		// init la taille totale du panel
		this.panelHeight=0;
		this.panelHeightEntete=0;
		this.panelWidth=pageWidth;

		// imprime la liste
		setDebug(sql.debugPrint);
		saveSql();
		imprimeDb();
		restoreSql();

		setDebug(false);

		// Fixe la hauteur finale du panel
		this.setSize((int)((this.panelWidth+decax)*scale),(int)((this.panelHeight+decay)*scale));
		computeSize=true;
	}

	private void imprimeDb(){
		openDbImpression();
		if (sql.t_eof){
			printEntete();
			printEditionVide();
		}
		while (!sql.t_eof) {
			// Entete
			if (prow==0){
				if (numlist==0) {// incrmente le nombre de page que sur l'entete de la premiere colonne
					numpage++;
				}
				printEntete();
			}

			// Ligne
			if (isPrintDetailEnable){
				printLigne();
			}
			if (isPrintRuptureEnable){
				setRupture(beforeRupture);
				incrCountSumRupture(beforeRupture,afterRupture);
			}

			// Skip
			skipLigne();

			// Rupture aprs le skip
			if (isPrintRuptureEnable){
				setRupture(afterRupture);
				if (!isRuptureEquals(beforeRupture,afterRupture)){
					printRupture(beforeRupture);
					razCountSumRupture(beforeRupture);
				}
				if (sql.t_eof){
					printRupture(afterRupture);
					razCountSumRupture(afterRupture);
				}
			}

			// Fin de page ou fin de Fichier
			if (prow>=g_fflg-sql.t_height || sql.t_eof){
				printCadrePage();
				if (numlist==sql.g_nbList-1 || sql.t_eof ){
					// Ajoute la hauteur de la page lorsqu'on 
					// imprimer la derniere ligne de la derniere colonne
					setEndHeight();
					numlist=0;
				} else {
					numlist++;
				}
			}
		}

		// Derniere page
		if (prow!=0){
			printCadrePage();
			// ATTENTION on fini la page car l'dition n'a pas t au bout
			// il manquerait la Derniere page voir identique sur Cadre;
			setEndHeight();
		}
		closeDbImpression();
	}
	private void printEditionVide() {
		int y=(prow+1)*charHeight;
		g2d.drawString("Edition vide",decax+charWidth,y+decay+charHeight);
	}
	private void printEntete(){
		panelHeightEntete=0;
		if (jpentete!=null ){
			if (jpentete.entete!=null){
				prow=jpentete.drawEntete(g2d,PaperWidth/scale,(int) (charHeight/scale),panelHeight,numpage,numlist);
				prow=(int) (prow/scale);
				panelHeightEntete=prow*charHeight;
			}
		}

		String str="";
		// ligne d'entete
		g2d.setFont(g2d.getFont().deriveFont(Font.BOLD));
		Fma fma=null;
		for (int field=0;field<sql.prints.size();field++){
			fma=sql.prints.get(field).t_Fma;
			if (fma==Fma.INVISIBLE || fma==Fma.CACHE){
				// ne prends pas champs
			} else {
				// rcupere le libelle  imprimer
				str=sql.prints.get(field).t_lib;

				// Mise en forme du text
				if (str.length()>sql.prints.get(field).t_fieldLength)
					str=str.substring(0, sql.prints.get(field).t_fieldLength);

				// coordonnes d'impression
				int x=((listWidth+charWidth)*numlist);
				x=x+pixCol[field];
				int y=(prow+1)*charHeight;
				// imprime le text
				g2d.drawString(str, x+decax,((int)panelHeight)+y+decay);
			}
		}		

		// Rectangle de la ligne
		int rx=((listWidth+charWidth)*numlist);
		rx=rx+0;

		int rwidth=pixCol[pixCol.length-1];
		int ry=(prow)*charHeight;
		int rheight=charHeight;

		// Bidouille la premiere ligne pour cr un espace entre 2 pages
		g2d.drawRect(rx,((int) panelHeight)+ ry , rwidth, rheight);
		// double le cadre pour passer en gras
		g2d.drawRect(rx+1,((int) panelHeight)+ ry+1 , rwidth-2, rheight-2);

		g2d.setFont(g2d.getFont().deriveFont(Font.PLAIN));
		prow++;
	}

	private void printLigne() {
		String str="";
		String format=null;
		Fma fma=null;
		// ligne de corps
		for (int field=0;field<sql.prints.size();field++){
			format=sql.prints.get(field).t_fieldFormat;
			fma=sql.prints.get(field).t_Fma;
			if (fma==Fma.INVISIBLE || fma==Fma.CACHE){
				// ne prends pas champs
			} else {
				// rcupere le champs  imprimer
				str=ligneReadFieldDb(field,sql.prints);

				// Protection d'impression
				if (isligneLimited && prow-((prow/2)+(prow/2))==0)
					//if (isligneLimited)
					if (sql.getAppliParam().PROTECTTABLE!=null)
						if (sql.t_table.toLowerCase().equals(sql.getAppliParam().PROTECTTABLE.toLowerCase()))
							if (sql.prints.get(field).t_field.toLowerCase().contains(Gp.PROTECTFIELD.toLowerCase()))
								if (prow>Gp.PROTECTMAXLINE)
									str=Gp.PROTECTDEMO;

				// Mise en forme du text
				if (str.length()>sql.prints.get(field).t_fieldLength*sql.t_height)
					str=str.substring(0, sql.prints.get(field).t_fieldLength*sql.t_height);

				if (sql.t_height==1){
					int width	=  g2d.getFontMetrics(g2d.getFont()).stringWidth(str);
					for (;width>(pixCol[field+1]-pixCol[field]);){
						str=str.substring(0,str.length()-1);
						width=g2d.getFontMetrics(g2d.getFont()).stringWidth(str);
					}
				}

				// Format le champs
				str=CcsFmt.textFormat(str, fma, format);
				// coordonnes d'impression
				int x=((listWidth+charWidth)*numlist);
				x=x+pixCol[field];
				int y=(prow+1)*charHeight;

				// Gras ou Normal
				switch (fma){
				case RADIO:
				case CHECK:
				case INTERO:
				case TIMEDELAY:
				case F2:
				case NUMGRASSPACE:
				case NUMGRAS:
				case GRAS:
					g2d.setFont(g2d.getFont().deriveFont(Font.BOLD));
					break;
				case PHONE:
				case SECU:
				case URSS:
				case POSTAL:
				case DATE:
				case MONTH:
				case YEAR:
				case TIME:
				case NUM:
				case FIELD:
				case NORMAL:
				default:
					g2d.setFont(g2d.getFont().deriveFont(Font.PLAIN));
				}

				// imprime le text suivant le type
				switch (fma){
				case CHECK:
					// Dessine une case  cocher
					int rx=x+decax;
					int ry=((int)panelHeight)+y-charWidth-1;
					g2d.drawRect(rx,ry, charWidth-2, charWidth-2);
					if (str.contains("1")){
						g2d.drawLine(rx,ry,rx+charWidth-2,ry+charWidth-2);
						g2d.drawLine(rx+charWidth-2,ry,rx,ry+charWidth-2);
					}
					break;
				case LIBEMAX:
					// Ecrit une text sur plusieur ligne
					for (int i=0;i<sql.t_height;i++)
						libemax[i]="";
					wrapLibemax(str,field);
					for (int nbligne=0;nbligne<sql.t_height;nbligne++){
						int posy=nbligne*charHeight;
						g2d.drawString(libemax[nbligne],x+decax,((int)panelHeight)+y+decay+posy);
					}
					break;
				case NUMGRASSPACE:
				case NUMSPACE:
					if (str.trim().equals("0.0")||str.trim().equals("0")){
						;
					} else {
						g2d.drawString(str,x+decax,((int)panelHeight)+y+decay);
					}
					break;
				case TIMEDELAY:
				case RADIO:
				case NUMGRAS:
				case NUM:
				case GRAS:
				case INTERO:
				case F2:
				case FIELD:
				case NORMAL:
				case PHONE:
				case SECU:
				case URSS:
				case POSTAL:
				case DATE:
				case MONTH:
				case YEAR:
				case TIME:
				default:
					g2d.drawString(str,x+decax,((int)panelHeight)+y+decay);
				}
			}
		}
		//System.out.println("ruptureVar :"+ruptureVar+":");

		// Rectangle de la ligne
		int rx=((listWidth+charWidth)*numlist);
		rx=rx+0;
		int rwidth=pixCol[pixCol.length-1];
		int ry=(prow)*charHeight;
		int rheight=charHeight*sql.t_height;

		g2d.setFont(g2d.getFont().deriveFont(Font.PLAIN));
		g2d.drawRect(rx,((int)panelHeight)+ ry, rwidth, rheight);
		prow=prow+sql.t_height;
	}
	private void printRupture( ArrayList <Field> soustotal){
		String str="";
		// ligne de rupture
		g2d.setFont(g2d.getFont().deriveFont(Font.ITALIC));
		for (int nsoustotal=0;nsoustotal<soustotal.size();nsoustotal++){
			if (sql.ruptures.get(nsoustotal).t_Fma==Fma.PRINTCOUNT){
				str=""+soustotal.get(0).t_fieldLength;
			} else if (sql.ruptures.get(nsoustotal).t_Fma==Fma.PRINTSOMME){
				str=soustotal.get(nsoustotal).t_fieldDefaultValue;

				int numInRs=-1;
				for (int nfield=0;nfield<sql.prints.size();nfield++)
					if (sql.prints.get(nfield).t_field.equals(sql.ruptures.get(nsoustotal).t_field)){
						numInRs=nfield;
						break;
					}
				String format=sql.prints.get(numInRs).t_fieldFormat;
				Fma fma=sql.prints.get(numInRs).t_Fma;
				str=CcsFmt.textFormat(str, fma, format);

			} else if (sql.ruptures.get(nsoustotal).t_Fma==Fma.PRINTRUPTUREINVISIBLE){
				str="";
			} else {
				str=soustotal.get(nsoustotal).t_field;
			}
			// coordonnes d'impression
			int x=((listWidth+charWidth)*numlist);
			x=x+pixCol[nsoustotal];
			int y=(prow+1)*charHeight;
			// imprime le text
			g2d.drawString(str, x+decax,((int)panelHeight)+y+decay);
		}		
		g2d.setFont(g2d.getFont().deriveFont(Font.PLAIN));

		// Rectangle de la ligne
		int rx=((listWidth+charWidth)*numlist);
		rx=rx+0;
		int rwidth=pixCol[pixCol.length-1];
		int ry=(prow)*charHeight;
		int rheight=charHeight;
		g2d.drawRect(rx,((int) panelHeight)+ ry, rwidth, rheight);

		g2d.setFont(g2d.getFont().deriveFont(Font.PLAIN));

		prow++;
	}

	private void saveSql() {
		sauveT_Recno=sql.t_Recno;
		sauveV_index=sql.v_index;
		sauveT_eof=sql.t_eof;
		sauveT_filtre=sql.printsFilter.t_filtre;
		sauveT_filtre=sql.printsFilter.v_filtre;
		sauveT_nbLigne=sql.t_nbLigne;
		sauveClauseFilter=sql.clauseFilter;
		sauveClauseGroupBy=sql.clauseGroupBy;
	}
	private void restoreSql() {
		sql.t_Recno=sauveT_Recno;
		sql.v_index=sauveV_index;
		sql.t_eof=sauveT_eof;
		sql.t_filtre=sauveT_filtre;
		sql.v_filtre=sauveV_filtre;
		sql.t_nbLigne=sauveT_nbLigne;
		sql.clauseFilter=sauveClauseFilter;
		sql.clauseGroupBy=sauveClauseGroupBy;
	}
	private void openDbImpression() {

		// Ouvre un nouveau select sans limit d'enregistrement
		sql.t_nbLigne=9999999;

		// repositionne en dbut pour le parcours
		if (printWithIndex) {
			sql.v_index=debut;
		} else {	
			sql.dBGoRecnoByRecno(debut);
		}
		sql.rsSoftSeek();{
			sql.rsSkip(false);
		}

		prow=0;
		numlist=0;
		numpage=0;
	}
	private void closeDbImpression() {
		// Restaure le Sql encours
		try {
			sql.rs.close();
		} catch (SQLException e) { e.printStackTrace(); }
	}
	private int[] initPrintPixCol() {
		String magicStr="LMMJVSDCECI EST LA phrase Magique afin de calculer la largeur moyenne des chaines de caractres";
		String magicStrmax="";
		String magicStrfield="";
		int width=0;

		// Longueur totale de zro  derniere position plus Longueur de derniere position
		int[] tmpPixCol= new int[sql.prints.size()+1];
		int pixWidth=0;
		for (int field=0;field<sql.prints.size();field++){
			tmpPixCol[field]=pixWidth;
			while (sql.prints.get(field).t_fieldLength>magicStrmax.length()){
				magicStrmax=magicStrmax+magicStr;
			}
			magicStrfield=magicStrmax.substring(0,sql.prints.get(field).t_fieldLength-1);	
			Graphics g=sql.getMf().getGraphics();
			width= (charWidth) + g.getFontMetrics(g.getFont()).stringWidth(magicStrfield);
			g=null;
			pixWidth=pixWidth+(width);
		}
		tmpPixCol[sql.prints.size()]=pixWidth;
		return tmpPixCol;
	}

	private void setEndHeight(){
		this.panelHeight=panelHeight+(pageHeight/scale) ;
		//		System.out.println("Paper :"+PaperWidth+"Paper :"+" Panel  :"+PaperHeight+" Panel  :"+panelWidth*scale+" Panel  :"+panelHeight*scale);
		//		Gp.afficherTrace(1,"setEndHeight");
	}

	private void incrCountSumRupture(ArrayList<Field> soustotal, ArrayList<Field> total) {
		soustotal.get(0).t_fieldLength++;
		total.get(0).t_fieldLength++;
		//
		String tmpSoustotal="";
		String tmptotal="";
		double vchamp=0;
		double vcumulsoustotal=0;
		double vcumultotal=0;
		for (int nrupture=0;nrupture<sql.ruptures.size();nrupture++){
			if (sql.ruptures.get(nrupture).t_Fma==Fma.PRINTSOMME){
				int numInRs=-1;
				for (int nfield=0;nfield<sql.fields.size();nfield++)
					if (sql.fields.get(nfield).t_field.equals(sql.ruptures.get(nrupture).t_field)){
						numInRs=nfield;
						break;
					}
				vchamp=Gp.parseDouble(ligneReadFieldDb(numInRs,sql.fields)); // Lit la base
				vcumulsoustotal=Gp.parseDouble(soustotal.get(nrupture).t_fieldDefaultValue);
				vcumultotal=Gp.parseDouble(total.get(nrupture).t_fieldDefaultValue);
				tmpSoustotal=CcsFmt.ligSpace(""+(vcumulsoustotal+vchamp), sql.ruptures.get(nrupture).t_fieldLength);
				tmptotal=CcsFmt.ligSpace(""+(vcumultotal+vchamp), sql.ruptures.get(nrupture).t_fieldLength);
				soustotal.get(nrupture).t_fieldDefaultValue = tmpSoustotal.substring(0, sql.ruptures.get(nrupture).t_fieldLength);
				total.get(nrupture).t_fieldDefaultValue = tmptotal.substring(0, sql.ruptures.get(nrupture).t_fieldLength);
			}
		}		


	}
	private void razCountSumRupture(ArrayList<Field> rupture) {
		rupture.get(0).t_fieldLength=0;
		for (int field=0;field<sql.ruptures.size();field++){
			if (sql.ruptures.get(field).t_Fma==Fma.PRINTSOMME){
				rupture.get(field).t_fieldDefaultValue = "";
			}
		}		
	}
	private boolean isRuptureEquals(ArrayList<Field> rupture1,ArrayList<Field> rupture2) {
		boolean ret=true;
		for (int i=0;i<rupture1.size();i++){
			if (!rupture1.get(i).t_field.equals(rupture2.get(i).t_field)){
				ret=false;
				break;
			}
		}
		return ret;
	}
	private void setRupture(ArrayList<Field> ruptures) {
		String str="";
		//int libType=-1;
		for (int nrupture=0;nrupture<sql.ruptures.size();nrupture++){
			// rcupere le champs  imprimer
			str=ligneReadFieldDb(nrupture,sql.ruptures);
			// rcupere le champs  imprimer
			switch (sql.ruptures.get(nrupture).t_Fma){
			case PRINTCHAMP: {
				int numInRs=-1;
				for (int champ=0;champ<sql.fields.size();champ++)
					if (sql.fields.get(champ).t_field.equals(sql.ruptures.get(nrupture).t_field)){
						numInRs=champ;
						break;
					}
				str=ligneReadFieldDb(numInRs,sql.fields); // Lit la base

				break;}
			case PRINTRUPTUREINVISIBLE:
			case PRINTRUPTURE:{ // Le champs prvu dans la structure fields ruptures
				str=ligneReadFieldDb(nrupture,sql.ruptures);
				break;}
			case PRINTLIBE:{
				str=sql.ruptures.get(nrupture).t_lib;
				break;}
			case PRINTCOUNT:
			case PRINTSOMME:
			case PRINTSPACE:{
				str="";
				for(int i=0;i<sql.ruptures.get(nrupture).t_fieldLength;i++){
					str=str+" ";
				}
				break;}
			}
			//}
			// Mise en forme du text
			if (str.length()>sql.ruptures.get(nrupture).t_fieldLength){
				str=str.substring(0, sql.ruptures.get(nrupture).t_fieldLength);
			}
			ruptures.get(nrupture).t_field=str;
		}		
	}
	private void wrapLibemax(String str,int field){
		int lenwidth=sql.prints.get(field).t_fieldLength;
		String wrap="";
		int cut=lenwidth;
		for (int nbligne=0;nbligne<sql.t_height;nbligne++){
			lenwidth=sql.prints.get(field).t_fieldLength+2;
			if (str.length()<lenwidth){
				lenwidth=str.length();
				cut=lenwidth;
			}
			if ((((str.length()>lenwidth) && str.contains(" "))||str.contains("\n"))&& str.length()>0){
				wrap=str.substring(0, lenwidth-1);
				if ((((str.length()>lenwidth) && str.contains(" "))||str.contains("\n"))){
					for (int i=wrap.length();i>1;i--){
						//for (int i=0;i<wrap.length();i++){
						//if (wrap.substring(i-1,i+1).equals("\n")){
						if (wrap.substring(i-1,i).equals("\n")||((str.length()>lenwidth) && wrap.substring(i-1,i).equals(" "))){
							cut=i-1;
							//i=wrap.length();
							i=0;
						}
					}
				} else {
					cut=lenwidth;
				}
				libemax[nbligne]=str.substring(0, cut);
				if (cut!=lenwidth){
					//Gp.afficherTrace(1, "!"+libe[nbligne]+"!"+cut+"!"+str+"!");
					str=str.substring(cut+1);
				} else {
					//Gp.afficherTrace(1, "!"+libe[nbligne]+"!"+cut+"!"+str+"!");
					if (str.length()-1>=cut){
						str=str.substring(cut);
					} else {
						str="";
					}
				}
			} else {
				libemax[nbligne]=str;
				//Gp.afficherTrace(1, "!"+libe[nbligne]+"!"+cut+"!"+str+"!");
				str="";
			}
		}
	}

	private void printCadrePage(){
		// trait intrieur verticaux sparation des colonnes
		Fma libType=null;
		for( int i=1;i< pixCol.length-1;i++){
			libType=sql.prints.get(i).t_Fma;
			if (libType==Fma.INVISIBLE || libType==Fma.CACHE){
				// ne prends pas champs
			} else {
				int rx=((listWidth+charWidth)*numlist);
				rx=rx+pixCol[i];
				int rwidth=rx; //Largeur du trait vertical un pixel
				int rheight=(prow)*charHeight;
				g2d.drawLine(rx,((int)panelHeight)+((int)panelHeightEntete) , rwidth, ((int)panelHeight)+rheight);
			}
		}

		//Trait gauche
		{int rx=((listWidth+charWidth)*numlist);
		rx=rx+1;
		int rwidth=rx; 
		int rheight=(prow)*charHeight;
		g2d.drawLine(rx,((int)panelHeight)+((int)panelHeightEntete) , rwidth,((int)panelHeight)+rheight);}
		//Trait Droit
		{int rx=((listWidth+charWidth)*numlist);
		rx=rx+pixCol[pixCol.length-1]-1;
		int rwidth=rx; 
		int rheight=(prow)*charHeight;
		g2d.drawLine(rx,((int)panelHeight)+((int)panelHeightEntete) , rwidth, ((int)panelHeight)+rheight);}

		// Trait bas
		{int rx=((listWidth+charWidth)*numlist);
		rx=rx+0;
		int rwidth=pixCol[pixCol.length-1];
		int rheight=(prow)*charHeight;
		g2d.drawLine(rx,((int)panelHeight)+rheight-1 , rx+rwidth, ((int)panelHeight)+rheight-1);}

		prow=0;
	}
	/**
	 * 
	 * @param field numro de champs  imprimer
	 * @param fieldsdef liste des champs
	 * @return valeur finale  imprimer
	 */
	private String ligneReadFieldDb(int field,ArrayList <Field> fieldsdef){
		String ret="";
		if (!sql.t_eof){
			if (fieldsdef.get(field).t_Fma==Fma.PRINTSPACE || field==-1){
				// Imprime une zone vide
				for (int nbcar=0;nbcar<fieldsdef.get(field).t_fieldLength;nbcar++){
					ret=ret+" ";
				}
			} else {
				// retrouve la position de champs dans la table qui sert cette liste
				int numInRs=-1;
				for (int champ=0;champ<sql.fields.size();champ++){
					if (sql.fields.get(champ).t_field.equals(fieldsdef.get(field).t_field)){
						numInRs=champ;
						break;
					}
				}
				if (numInRs==-1) {
					ret=sql.getField(field);
					//	System.out.println(fieldsdef.get(field).t_field+"  !"+ret+"!");
				} else {
					ret=sql.getField(numInRs);
				}
				if(ret==null){
					ret="";
				}
			}
		} 	
		return ret;
	}
	private void skipLigne() {
		if (printWithIndex){
			sql.rsSkip(false);
			if (!sql.t_eof){
				if (Gp.isSup(sql.v_index, fin)){
					sql.t_eof=true;
				}
			}
		} else {
			// Derniere ligne imprime  on quitte l'edition
			if (sql.t_Recno.equals(fin)){
				sql.t_eof=true;
			} else {
				sql.rsSkip(false);
			}
		}
	}
	//////////////////
	//  SCROLLABLE  //
	//////////////////
	private int maxUnitIncrement = charHeight;
	public Dimension getPreferredSize() {
		if (computeSize)
			return this.getSize();
		else
			return new Dimension((int) pageWidth,(int) pageHeight);
	}
	public Dimension getPreferredScrollableViewportSize() {
		return new Dimension((int) pageWidth,(int) pageHeight);
	}
	public int getScrollableUnitIncrement(Rectangle visibleRect, int orientation, int direction) {
		int currentPosition = 0;
		if (orientation == SwingConstants.HORIZONTAL) {
			currentPosition = visibleRect.x;
		} else {
			currentPosition = visibleRect.y;
		}

		if (direction < 0) {
			int newPosition = currentPosition -
			(currentPosition / maxUnitIncrement)
			* maxUnitIncrement;
			return (newPosition == 0) ? maxUnitIncrement : newPosition;
		} else {
			return ((currentPosition / maxUnitIncrement) + 1)
			* maxUnitIncrement
			- currentPosition;
		}
	}
	public int getScrollableBlockIncrement(Rectangle visibleRect, int orientation,int direction) {
		if (orientation == SwingConstants.HORIZONTAL) {
			return visibleRect.width - maxUnitIncrement;
		} else {
			return visibleRect.height - maxUnitIncrement;
		}
	}
	public boolean getScrollableTracksViewportWidth() {
		return false;
	}
	public boolean getScrollableTracksViewportHeight() {
		return false;
	}
	public void setDebug(boolean enable){
		debug=enable;
	}
	String debHtml="<html><head></head><body link=blue vlink=purple><Table border><col>";
	String finHtml="</col></Table></body></html>";
	String debRec="<tr>";
	String finRec="</tr>";
	String debField="<td>";
	String finField="</td>";
	String delimited=";";
	int typeExport;
	public static final int HTML=0;
	public static final int TXT=1;
	public void exportDb(int typeExport, File fExport) {
		this.typeExport=typeExport;
		PrintWriter sortie = null;
		boolean ok;
		try { 
			sortie = new PrintWriter(new FileWriter(fExport));
			ok=true;
		} catch (IOException e) { 
			ok=false;
			String[] option=new String []{"Je vrifie, le chemin ou je libre le fichier"};
			sql.notify("Attention !!!","L'exportation est impossible, \n le fichier n'est pas accessible", option, sql.getAppliParam().JBCANCEL, 0);
		}
		if(ok){
			openDbImpression();
			if (typeExport==HTML){
				sortie.println(debHtml);
			}
			writeHeader(sortie);
			while (!sql.t_eof) {

				// Ligne
				if (isPrintDetailEnable){
					writeLine(sortie);
				}
				if (isPrintRuptureEnable){
					setRupture(beforeRupture);
					incrCountSumRupture(beforeRupture,afterRupture);
				}

				// Skip
				skipLigne();

				// Rupture aprs le skip
				if (isPrintRuptureEnable){
					setRupture(afterRupture);
					if (!isRuptureEquals(beforeRupture,afterRupture)){
						writeRupture(beforeRupture,sortie);
						razCountSumRupture(beforeRupture);
					}
					if (sql.t_eof){
						writeRupture(afterRupture,sortie);
						razCountSumRupture(afterRupture);
					}
				}
			}
			if (typeExport==HTML){
				sortie.println(finHtml);
			}
			closeDbImpression();
			sortie.close();
		}
		sortie=null;
	}
	private void writeHeader(PrintWriter sortie){
		if (typeExport==HTML){
			sortie.println(debRec);
		}
		String record="";
		String separateur="";
		//
		String str="";
		// ligne d'entete
		Fma fma=null;
		for (int field=0;field<sql.prints.size();field++){
			fma=sql.prints.get(field).t_Fma;
			if (fma==Fma.INVISIBLE || fma==Fma.CACHE){
				// ne prends pas champs
			} else {
				// rcupere le libelle  imprimer
				str=sql.prints.get(field).t_lib;

				// Mise en forme du text
				if (str.length()>sql.prints.get(field).t_fieldLength)
					str=str.substring(0, sql.prints.get(field).t_fieldLength);

				switch (typeExport){
				case HTML:
					record=record+debField+str+finField;
					break;
				case TXT:
					record=record+separateur+str;
					separateur=delimited;
					break;
				}
			}
		}		
		//
		sortie.println(record);
		if (typeExport==HTML){
			sortie.println(finRec);
		}
	}

	private void writeLine(PrintWriter sortie){
		if (typeExport==HTML){
			sortie.println(debRec);
		}
		String record="";
		String separateur="";
		//
		String format="";
		Fma  fma=null;
		String str="";
		for (int field=0;field<sql.prints.size();field++){
			format=sql.prints.get(field).t_fieldFormat;
			fma=sql.prints.get(field).t_Fma;
			if (fma==Fma.INVISIBLE || fma==Fma.CACHE){
				// ne prends pas champs
			} else {
				// rcupere le champs  imprimer
				str=ligneReadFieldDb(field,sql.prints);

				// Format le champs
				str=CcsFmt.textFormat(str, fma, format);
				if (typeExport==HTML){
					if (fma==Fma.DATE){ // Bug excel version francaise inverse les jours et les mois
						str=str+"'";
					}
				}

				switch (typeExport){
				case HTML:
					record=record+debField+str+finField;
					break;
				case TXT:
					record=record+separateur+str;
					separateur=delimited;
					break;
				}
			}
		}
		//
		sortie.println(record);
		if (typeExport==HTML){
			sortie.println(finRec);
		}
	}
	private void writeRupture( ArrayList <Field> soustotal, PrintWriter sortie){
		if (typeExport==HTML){
			sortie.println(debRec);
		}
		String record="";
		String separateur="";
		//
		String str="";
		for (int nsoustotal=0;nsoustotal<soustotal.size();nsoustotal++){
			if (sql.ruptures.get(nsoustotal).t_Fma==Fma.PRINTCOUNT){
				str=""+soustotal.get(0).t_fieldLength;
			} else if (sql.ruptures.get(nsoustotal).t_Fma==Fma.PRINTSOMME){
				str=soustotal.get(nsoustotal).t_fieldDefaultValue;

				int numInRs=-1;
				for (int nfield=0;nfield<sql.prints.size();nfield++)
					if (sql.prints.get(nfield).t_field.equals(sql.ruptures.get(nsoustotal).t_field)){
						numInRs=nfield;
						break;
					}
				String format=sql.prints.get(numInRs).t_fieldFormat;
				Fma fma=sql.prints.get(numInRs).t_Fma;
				str=CcsFmt.textFormat(str, fma, format);
				if (typeExport==HTML){
					if (fma==Fma.DATE){ // Bug excel version francaise inverse les jours et les mois
						str=str+"'";
					}
				}

			} else if (sql.ruptures.get(nsoustotal).t_Fma==Fma.PRINTRUPTUREINVISIBLE){
				str="";
			} else {
				str=soustotal.get(nsoustotal).t_field;
			}

			switch (typeExport){
			case HTML:
				record=record+debField+str+finField;
				break;
			case TXT:
				record=record+separateur+str;
				separateur=delimited;
				break;
			}
		}
		//
		sortie.println(record);
		if (typeExport==HTML){
			sortie.println(finRec);
		}
	}

}
