package module_standard.wListChooser;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import template_applicatif.wListe.AbstractDbListe;
import template_applicatif.wListe.HeaderCellRenderer;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTableDb;
import composant_saisie.wComposant.JTextButton;
import composant_saisie.wSaisieFormat.Fma;

import fenetre_menu.wConteneur.AbstractJDialogDb;
import fenetre_menu.wConteneur.JDialogDlg;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class ListChooser extends JPanel implements MouseListener, ActionListener {
	private static final long serialVersionUID = 1L;
	AbstractDbListe dbliste=null;
	Sql sql=null;
	JTableDb jt=null;
	Object[][] data=null;
	Object[][] source=null;
	JTextButton jbQuitter=null;
	JTextButton jbTous=null;
	JTextButton jbDefault=null;
	String Quitter="Quitter";
	String Tous="Tous";
	String Default="Default";
	boolean visibleAll=false;
	public ListChooser( JDialogDlg dlg, AbstractDbListe dbliste){
		this.dbliste=dbliste;
		this.sql=dbliste.sql;
		adapte();
		this.putClientProperty(AbstractJDialogDb.action,"ok");
		this.addPropertyChangeListener(AbstractJDialogDb.action, dlg);
		this.addMouseListener(this);
	}
	private void adapte(){
		initData();
		initTable();
		initUI();
	}
	private void initData() {
		int nbField=0;
		for (int field=0;field<sql.fields.size();field++){
			if (sql.fields.get(field).t_Fma!=Fma.INVISIBLE){
				nbField++;
			}
		}
		data = new Object[nbField][3];
		source = new Object[nbField][2];
		nbField=0;
		for (int field=0;field<sql.fields.size();field++){
			if (sql.fields.get(field).t_Fma!=Fma.INVISIBLE){
				data[nbField][0]=sql.fields.get(field).t_lib;
				source[nbField][0]=sql.fields.get(field).t_field;
				int i=dbliste.getCol(field).getPreferredWidth();
				if (i==0){
					data[nbField][1]="";
					data[nbField][2]=source[nbField][0];
					source[nbField][1]=true;
				} else {
					data[nbField][1]=source[nbField][0];
					data[nbField][2]="";
					source[nbField][1]=false;
				}
				nbField++;
			}
		}
	}
	private void initTable() {
		jt = new JTableDb();{
			String[] header = { "Dsignation", "Visible","Cache"};

			jt.setFont(Gp.FONTTEXT12);
			HeaderCellRenderer hcr=new HeaderCellRenderer(sql);{
				jt.getTableHeader().setDefaultRenderer(hcr);
			}

			jt.setModel(new ListChooserModele(data));
			jt.setRowSelectionInterval(0,0);
			jt.adapteHeader(header);
			jt.addMouseListener(this);
		}
	}
	public void initUI(){
		JPanel jpsouth=new JPanel(new FlowLayout());{
			jbDefault= new JTextButton(Default);{
				jbDefault.addActionListener(this);
			}
			jbTous= new JTextButton(Tous);{
				jbTous.addActionListener(this);
			}
			jbQuitter= new JTextButton(Quitter);{
				jbQuitter.addActionListener(this);
			}
			jpsouth.add(jbDefault);
			jpsouth.add(jbTous);
			jpsouth.add(jbQuitter);
		}
		this.setLayout(new BorderLayout(0,0));
		this.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Color.BLACK));
		this.add(jt.getTableHeader(),BorderLayout.NORTH);
		this.add(jt,BorderLayout.CENTER);
		this.add(jpsouth,BorderLayout.SOUTH);
	}
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}
	public void mousePressed(MouseEvent arg0) {}
	public void mouseReleased(MouseEvent arg0) {}
	public void mouseClicked(MouseEvent arg0) {
		if (arg0.getSource()==jt){
			if ( SwingUtilities.isLeftMouseButton(arg0) ){ 
				if (arg0.getClickCount()==2) {
					int row=jt.rowAtPoint(arg0.getPoint());
					toogleVisibable(row);
					jt.setRowSelectionInterval(row,row);
				}
			}
		} else {
			quitter();
		}
	}
	private void toogleVisibable(int row) {
		setColVisible(row, !isColVisible(row));
	}
	private boolean isColVisible(int row){
		boolean ret=true;
		if (((String)data[row][2]).trim().length()==0){
			ret=false;
		}
		return ret;
	}
	private void setColVisible(int row,boolean visible){
		if (visible){
			jt.getModel().setValueAt(source[row][0], row, 2);
			data[row][1]="";
			dbliste.setColVisible( (String) source[row][0], false);
		} else {
			jt.getModel().setValueAt(source[row][0], row, 1);
			data[row][2]="";
			dbliste.setColVisible( (String) source[row][0] , true);
			forceVisible(row);
		}

	}
	private void forceVisible(int row){
		int numcol=dbliste.getCol((String) source[row][0] );
		if (sql.fields.get(numcol).t_Fma==Fma.CACHE){
			int width=((sql.fields.get(numcol).t_fieldLength+2)*(Gp.WIDTHCHAR+0))+2;
			dbliste.getCol(numcol).setMinWidth(width);
			dbliste.getCol(numcol).setMaxWidth(width);
			dbliste.getCol(numcol).setPreferredWidth(width);
		}
	}
	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals(Quitter)){
			quitter();
		} else if (e.getActionCommand().equals(Tous)){
			tous();
		} else if (e.getActionCommand().equals(Default)){
			Default();
		}
	}
	private void Default() {
		visibleAll=false;
		for (int i=0;i<data.length;i++){
			setColVisible(i,((Boolean) source[i][1]).booleanValue());
		}
	}
	private void tous() {
		for (int i=0;i<data.length;i++){
			setColVisible(i,visibleAll);
		}
		visibleAll=!visibleAll;
	}
	private void quitter(){
		this.putClientProperty(AbstractJDialogDb.action,AbstractJDialogDb.closedialog);
	}
}
