package module_standard.wSerial;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */

public class CodeBarre {
	String name="Lecteur code barre";
	Ms1204 ms1204[];
	String ms1204_port[];
	boolean beep[];
	int max=4;
	Gp gpAbc;
	public CodeBarre(Gp gpAbc){
		this.gpAbc=gpAbc;
		ms1204_port=new String[max];
		beep=new boolean[max];
		ms1204=new Ms1204[max];
	}
	public void setLecteur(String ms1204_port, int num, boolean beep){
		if (getMs1204(num)!=null){
			getMs1204(num).close();
		}
		Serial serial=new Serial(gpAbc,ms1204_port, Serial.ACKCONTROL_BYTE,name);
		Ms1204 ms1204=new Ms1204(serial, beep);{
			ms1204.start();
		}
		while (ms1204.isCbInitInit()){
			;// attends que l'initialisation du lecteur soit termine
		}
		if (ms1204.isCbOpen()){
			setMs1204(num,ms1204, ms1204_port,beep);
		} else {
			setMs1204(num, null,null,false);
		}
	}

	public Ms1204 getMs1204(int num) {
		return this.ms1204[num];
	}
	public boolean isPort(int num) {
		boolean ret =false;
		if (ms1204_port[num]!=null){
			if (ms1204_port[num].trim().length()>0){
				ret=true;
			}
		}
		return ret;
	}
	private void setMs1204(int num, Ms1204 ms1204, String port,boolean beep){
		this.ms1204[num]=ms1204;
		this.ms1204_port[num]=port;
		this.beep[num]=beep;
	}
	public void close() {
		for (int num=0;num<ms1204.length;num++){
			if (ms1204[num]!=null){
				ms1204[num].stopWaitCodeCb();
				ms1204[num].setCbOff(false);
				ms1204[num].close();
			}
			setMs1204(num, null,null,false);
		}
	}
	public boolean getBeep(int num) {
		return this.beep[num];
	}
}
