package module_standard.wSerial;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */

public class ImpDot {
	String name="Imprimante Thermique";
	Serial serial[];
	String impdot_driver[];
	String impdot_port[];
	int max=4;
	Gp gpAbc;
	public ImpDot(Gp gpAbc){
		this.gpAbc=gpAbc;
		impdot_port=new String[max];
		impdot_driver=new String[max];
		serial=new Serial[max];
	}
	public void setPrinter(String impdot_port, int num, String impdot_driver){
		if (getSerial(num)!=null){
			getSerial(num).close();
		}
		Serial serial=new Serial(gpAbc,impdot_port, Serial.ACKCONTROL_BYTE,name);
		if (!serial.isOpenTimeOut()){
			setImpDot(num, null,null,null);
		} else {
			if (serial.isOpen()){
				setImpDot(num,serial, impdot_port,impdot_driver);
			} else {
				setImpDot(num, null,null,null);
			}
		}
	}
	public Serial getSerial(int num) {
		return this.serial[num];
	}
	public boolean isPort(int num) {
		boolean ret =false;
		if (impdot_port[num]!=null){
			if (impdot_port[num].trim().length()>0){
				ret=true;
			}
		}
		return ret;
	}
	private void setImpDot(int num, Serial serial, String port, String driver){
		this.serial[num]=serial;
		this.impdot_port[num]=port;
		this.impdot_driver[num]=driver;
	}
	public void close() {
		for (int num=0;num<serial.length;num++){
			if (impdot_port[num]!=null){
				if (serial[num]!=null){
					serial[num].close();
				}
			}
			setImpDot(num, null,null,null);
		}
	}
	public String getDriver(int num) {
		String ret=null;
		ret=this.impdot_driver[num];
		if (ret!=null){
			ret=ret.trim();
		}
		return ret;
	}
}
