package module_standard.wSerial;


import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.util.Enumeration;
import java.util.TooManyListenersException;

import javax.comm.CommPortIdentifier;
import javax.comm.NoSuchPortException;
import javax.comm.PortInUseException;
import javax.comm.SerialPort;
import javax.comm.SerialPortEvent;
import javax.comm.SerialPortEventListener;
import javax.comm.UnsupportedCommOperationException;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import com.sun.comm.Win32Driver;
import composant_saisie.wPtime.TimeEllaspe;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class Serial extends Thread implements SerialPortEventListener {
	public static int LENGTH_TRAME=1024;
	public static String ACKPF="ackPF";
	// Gestion de la fin de trame
	// Sur une Chaine
	public static final int ACKCONTROL_STRING=0;
	// Sur un CR LF
	public static final int ACKCONTROL_STRINGCRLF=1;
	// Sur un BYTE de controle (souvent 05 ETX)
	public static final int ACKCONTROL_BYTE=2;
	// Sur un Chaine encapsule par des byte de controle
	public static final int ACKCONTROL_STX_BYTES_ETX1_ETX2=3;
	// Sur un BYTE de controle (Simple ACK/NACK)
	public static final int ACKCONTROL_ACKPF=4;
	//
	OutputStream out=null;
	InputStreamReader in=null;
	SerialPort serialPort;
	String portCom=null;
	boolean debug=false;
	boolean init=true;
	boolean open=false;
	boolean trace=false;
	//
	int ackControl;
	boolean ackPF=false;
	byte[] buffRet=new byte[LENGTH_TRAME];
	int prefix;
	int suffix1;
	int suffix2;
	int trameLength;
	private long sleep;
	boolean busy=false;
	String name=null;
	Gp gpAbc;
	public Serial(Gp gpAbc,String portCom,int ackControl, String name){
		this.portCom=portCom.trim();
		this.name=name;
		this.gpAbc=gpAbc;
		if (portCom.length()>0){
			if (this.portCom.charAt(this.portCom.length()-1)==':'){
				this.portCom=this.portCom.substring(0, this.portCom.length()-1);
			}
		}
		this.ackControl=ackControl;
		if (gpAbc.m_user.equals("9000DEVE")){
			this.trace=true;
		}
		buffRet[0]='\0';
		setSleep(150);
		start();
	}
	public void run(){
		open();
	}
	public boolean open(){
		boolean ret=true;
		//	System.out.println("Serial.open() : "+portCom);
		String dll=System.getProperty(Gp.USERDIR)+File.separator+"win32com.dll";
		CommPortIdentifier portId=null;
		if (Gp.isFileExists(dll)){
			Win32Driver w32Driver = new Win32Driver();
			w32Driver.initialize();
		} else {
			Gp.MB("Priphrique : "+name+", \n\n  Driver introuvable = "+dll+".");
			ret=false;
		}
		if (ret){
			if (portCom==null) {
				portCom=listePortsDispo().getName();
				if (portCom==null){
					Gp.MB("Priphrique : "+name+", \n\n Le port est non dtermin.");
					ret=false;
				}
			}
		}
		if (ret){
			try {
				portId=CommPortIdentifier.getPortIdentifier(portCom);
			} catch (NoSuchPortException arg0) { 
				Gp.MB("Priphrique : "+name+", sur "+portCom+", \n\n Le port est occup inconnu ou indisponible.");
				ret=false;
			}
		}
		if (ret){
			try {
				int timeOut=2000;
				serialPort = (SerialPort) portId.open("ModeEvenement", timeOut);
			} catch (PortInUseException e) {
				Gp.MB("Priphrique : "+name+", sur "+portId.getName()+", \n\n Le port est occup.");
				ret=false;
			}
		}
		if (ret){
			serialPort.setOutputBufferSize( 40000 );
			if (!isCTS()){
				if (!gpAbc.ISDEVFILE){
					Gp.MB("Priphrique : "+name+", sur "+portId.getName()+", \n\n Brancher ou Allumer le priphrique, Merci");
				}
				ret=false;
			}
		}
		if (ret){
			try {
				in=new InputStreamReader(serialPort.getInputStream());
			} catch (IOException arg0) { arg0.printStackTrace(); }
		}
		if (ret){
			try {
				serialPort.addEventListener(this);
			} catch (TooManyListenersException arg0) { arg0.printStackTrace(); }
			serialPort.notifyOnDataAvailable(true);
			serialPort.notifyOnBreakInterrupt(true);
			serialPort.notifyOnCarrierDetect(true);
			serialPort.notifyOnCTS(true);
			serialPort.notifyOnDataAvailable(true);
			serialPort.notifyOnDSR(true);
			serialPort.notifyOnFramingError(true);
			serialPort.notifyOnOutputEmpty(true);
			serialPort.notifyOnOverrunError(true);
			serialPort.notifyOnParityError(true);
			serialPort.notifyOnRingIndicator(true);
		}
		init=ret;
		return ret;
	}
	public boolean isOpenTimeOut(){
		if (init){
			TimeEllaspe te=new TimeEllaspe(1);
			while (!te.isTimeOut()){
				te.testTimeOut();
			}
		}
		open=init;
		return open;
	}
	public boolean isOpen() {
		return open;
	}
	public boolean open(int speed, String parity, int nbbit,int nbstop){
		boolean ret=open();
		if (ret){
			setPortParams(speed, parity, nbbit,nbstop);
		}
		return ret;
	}
	public void setPortParams(int speed, String parity, int nbbit,int nbstop){
		int iparity=0;
		if (parity=="N") {
			// SANS
			iparity=SerialPort.PARITY_NONE;
		} else if (parity=="O") {
			// IMPAIR
			iparity=SerialPort.PARITY_ODD;
		} if (parity=="E") {
			// PAIR
			iparity=SerialPort.PARITY_EVEN;
		} 
		try {
			serialPort.setSerialPortParams(speed,nbbit,nbstop,iparity);
		} catch (UnsupportedCommOperationException arg0) { arg0.printStackTrace(); }
	}
	public void setTrameParams(int prefix, int length, int suffix1,int suffix2) {
		this.prefix=prefix;
		this.trameLength=length;
		this.suffix1=suffix1;
		this.suffix2=suffix2;
	}
	public void close(){
		if (open){
			try {
				if (out!=null){
					out.close();
				}
				if (in!=null){
					in.close();
				}
			} catch (IOException arg0) { arg0.printStackTrace(); }
			serialPort.removeEventListener();
			serialPort.close();
			open=false;
			//			System.out.println("Serial.close() : "+portCom);
		}
	}

	public CommPortIdentifier listePortsDispo()
	{
		CommPortIdentifier ret=null;
		CommPortIdentifier tmp;
		Enumeration<?> portList=CommPortIdentifier.getPortIdentifiers();
		if (portList==null)
		{
			System.err.println("Aucun port de communication dtect" );
			return null;
		}
		while (portList.hasMoreElements())
		{
			tmp=(CommPortIdentifier)portList.nextElement();
			if (ret==null){ // Valorise le premier port com trouv
				ret=tmp;
				//break;
			}
		}
		return ret;
	}
	public int getAckControl() {
		return ackControl;
	}
	public void setAckControl(int ackControl) {
		this.ackControl = ackControl;
	}
	public void setDebug(boolean enable){
		debug=enable;
	}
	public void write(String txt) {
		if (debug){
			switch(ackControl){
			case ACKCONTROL_ACKPF:
				Gp.ad(""+txt);
			case ACKCONTROL_BYTE:
				//Gp.ad(""+txt);
				break;
			}
		}
		try {
			out=serialPort.getOutputStream();
			out.write(txt.getBytes());
			if (trace){
				System.out.print(txt.toString());
			}
			out.flush();
		} catch (IOException arg0) { arg0.printStackTrace(); }
	}
	public void write(int i) {
		if (debug){
			switch(ackControl){
			case ACKCONTROL_ACKPF:
				Gp.ad(""+(char)i);
				break;
			case ACKCONTROL_BYTE:
				//Gp.ad(""+i);
				break;
			}
		}
		try {
			out=serialPort.getOutputStream();
			out.write(i);
			if (trace){
				System.out.print((char) i);
			}
			out.flush();
		} catch (IOException arg0) { arg0.printStackTrace(); }
	}
	public void serialEvent(SerialPortEvent ev) {
		switch (ev.getEventType()) {
		case SerialPortEvent.BI :
			//System.out.println("BI");
			break;
		case SerialPortEvent.OE :
			//System.out.println("OE");
			break;
		case SerialPortEvent.FE :
			//System.out.println("FE");
			break;
		case SerialPortEvent.PE :
			//System.out.println("PE");
			break;
		case SerialPortEvent.CD :
			//System.out.println("CD");
			break;
		case SerialPortEvent.CTS :
			//System.out.println("CTS");
			break;
		case SerialPortEvent.DSR :
			//System.out.println("DSR");
			break;
		case SerialPortEvent.RI :
			//System.out.println("RI");
			break;
		case SerialPortEvent.OUTPUT_BUFFER_EMPTY :
			//System.out.println("OBE");
			break;
		case SerialPortEvent.DATA_AVAILABLE :
			readData();
		}
	}
	private void readData() {
		// Transfert les Datas du port vers un buffer interne
		byte[] bufferRead=new byte[128];
		try {  // Laisse du temps pour que TOUTE la trame arrive suite  l'interruption DATA_AVAILABLE
			Thread.sleep(sleep);
		} catch (InterruptedException arg0) { arg0.printStackTrace(); } 

		// TOUTE la trame est l !!!!!
		int ibuffer=0;
		try {
			int c = in.read() & 0xff;
			while(c!=-1 && bufferRead.length>ibuffer){
				bufferRead[ibuffer]=(byte)c;
				ibuffer++;
				if (debug){
					switch(ackControl){
					case ACKCONTROL_STRING:
						Gp.ad("<< "+(char) c);
						break;
					case ACKCONTROL_ACKPF:
						Gp.ad("<< "+(char) c);
						break;
					case ACKCONTROL_BYTE:
						Gp.ad("<< "+ c);
						break;
					case ACKCONTROL_STX_BYTES_ETX1_ETX2:
						Gp.ad("<< "+(char) c);
						break;
					}
				}
				if (in.ready()) {
					c=in.read()& 0xff;
				} else {
					c=-1;
				}
			}
		} catch (IOException arg0) { arg0.printStackTrace(); }

		// Transfert le buffer interne
		switch(ackControl){
		case ACKCONTROL_STRING:
			break;
		case ACKCONTROL_STRINGCRLF:
			break;
		case ACKCONTROL_ACKPF:
			String ctrl=ACKPF+(char) 13+(char) 10;
			buffRet[0]='\0';
			//String retour="";
			boolean comp=true;
			for (int i=0;i<ACKPF.length();i++){
				buffRet[i]=bufferRead[i];
				//retour=retour+(char)bufferRead[i];
				if (ctrl.charAt(i)!=(char)buffRet[i]){
					comp=false;
					break;
				}
			}

			if (comp){
				setAckPF(true);
			}
			break;
		case ACKCONTROL_BYTE:
			for (int i=0;i<bufferRead.length;i++){
				buffRet[i]=bufferRead[i];
			}
			setAckPF(true);
			break;
		case ACKCONTROL_STX_BYTES_ETX1_ETX2:
			buffRet[0]='\0';
			int i;
			for (i=0;i<bufferRead.length;i++){
				if (bufferRead[i]==prefix){
					i++;
					break;
				}
			}
			for (int j=0;j<buffRet.length && i<bufferRead.length;j++){
				if (bufferRead[i]!=suffix1){
					buffRet[j]=bufferRead[i];
					buffRet[j+1]='\0';
					i++;
				} else {
					i++;
					break;
				}
			}
			for (;i<bufferRead.length;i++){
				if (bufferRead[i]==suffix2){
					setAckPF(true);
					break;
				}
			}
			break;
		}
	}
	public long getSleep() {
		return sleep;
	}
	public boolean isBusy() {
		return busy;
	}
	public void setBusy(boolean busy) {
		this.busy = busy;
	}
	public void setSleep(long sleep) {
		this.sleep = sleep;
	}
	public void setRTS(boolean enable){
		if (debug){
			Gp.ad("RTS "+enable+(char) 13);
		}
		serialPort.setRTS(enable);
	}
	public void setDTR(boolean enable){
		if (debug){
			Gp.ad("DTR "+enable+(char) 13);
		}
		serialPort.setDTR(enable);
	}
	public boolean isCTS(){
		boolean ret=false;
		ret=serialPort.isCTS();
		if (debug){
			Gp.ad("isCTS "+ret+(char) 13);
		}
		return ret;
	}
	public byte[] getBTrame(){
		return buffRet;
	}
	public String getSTrame() {
		String ret="";
		for (int i=0;i<trameLength && buffRet[i]!='\0';i++){
			ret=ret+(char)buffRet[i];
		}
		buffRet[0]='\0';
		return ret;
	}
	public void setAckPF(boolean ackPF) {
		this.ackPF = ackPF;
	}
	public boolean isAckPF() {
		return ackPF;
	}
	public boolean isTrace() {
		return trace;
	}
	public void setTrace(boolean trace) {
		this.trace = trace;
	}
	public String getPortCom() {
		isOpenTimeOut();
		return portCom;
	}
}
