package persistance.wGlobalParam;

import persistance.wSql.Sql;
import template_applicatif.wVue.AbstractVue;
import a_doc.doc.Licence;
/**
	<code>AbstractDefaultParam</code> contient les variables static d'initialisation de l'appli<br>
	elles doivent-tre sur-dfini par l'"AppliParam" mtier<br>
	<br>
	a noter<br>
	{@link #getAbstractVue()}<br>
	<br>
	{@link #setAppliParamFromDb()}<br>
	{@link #setUserParamFromDb()}<br>
	<br>
__________________________________________________________________________________
<br>
<br>{@link A_doc}
 <br>{@link Licence}.
	@see #getNameBase
	@see #getNameBaseABC
	@see #getNameBaseDATA
	@see #setBaseParamFromFileRLW
*/
public abstract class AbstractDefaultParam {
	/**
	 *  Numro de version
	 */
	public String VERSION	= "1.00";
	/**
	 *  Prfixe de nom de fichier des bases
	 */
	public String SOC		= "ABC";
	/**
	 *  Nom de fichier des bases
	 */
	public String APPLI		= "Projet";
	/**
	 *  Suffixe de nom de fichier des bases
	 */
	public String PRO		= "";
	/**
	 * Nom du logiciel
	 */
	public String TITRE_APPLI =SOC+" "+APPLI+" "+PRO;
	/**
	 *  Affichage de la version dans le titre de l'appli
	 */
	public boolean TITRE_VERSIONABLE	= true;
	/**
	 *  Affichage du user dans le titre de l'appli
	 */
	public boolean TITRE_USERABLE	= true;
	/**
	 * extension de la base standard
	 */
	public String BASE_ABC	= ".abc";
	/**
	 * extenstion de la base mtier
	 */
	public String BASE_DATA	= ".data";
	/**
	 * Chemin des fichiers d'aide utilisateur
	 */
	public String PATH_HELP;
	/**
	 *  type de driver de la base standard
	 */
	public int SQL_DRIVER_ABC	= Gp.SQLITE;
	/**
	 *  type de driver de la base mtier
	 */
	public int SQL_DRIVER_DATA	= Gp.SQLITE;
	/**
	 * Adresse du site web pour l'appli<br>
	 * Voir {@link module_standard.wInfos.JDialogInfos Boite infos}
	 */
	public String SITEWEB	= "www.abcfamille.fr";
	/**
	 * Adresse mail 
	 * Voir {@link module_standard.wFeedback.JDialogFeedBack Boite infos}
	 */
	public String CONTACT 	= "contact@abcfamille.fr";
	/**
	 * Adresse du forum de l'appli<br>
	 * Voir {@link module_standard.wInfos.JDialogInfos Boite infos}
	 */
	public String FORUM 	= "abcfamille.forumactif.net";
	/**
	 * Image de fentre principale
	 */
	public String FRAMETEXTURE   = null;
	/**
	 * Image de titre des modules<br>
	 * Si null le titre  une couleur gradient<br>
	 * Le titre est dsactivable par l'utilisateur via ses prfrences<br>
	 */
	public String TITRETEXTETURE = null;
	/**
	 *  Deprecated
	 */
	public String LIBELLETEXTETURE = null;
	/**
	 *  Deprecated
	 */
	public String BUTTONTEXTURE   = null;
	/**
	 *  Icon de l'appli
	 */
	public String APPLIICON = null;
	/**
	 *  Icon bouton annuler
	 */
	public String JBCANCEL 	= null;
	/**
	 *  Icon bouton Ajouter
	 */
	public String JBAPPEND 	= null;
	/**
	 *  Deprecated
	 */
	public String JBPAPPEND = null;
	/**
	 *  Icon bouton Effacer
	 */
	public String JBDELETE 	= null;
	/**
	 *  Icon bouton Enregistrer
	 */
	public String JBRECORD 	= null;
	/**
	 *  Icon bouton Imprimer
	 */
	public String JBPRINT 	= null;
	/**
	 *  Icon bouton F3 basculer
	 */
	public String JBBASCULE 	= null;
	/**
	 *  Icon bouton Aide
	 */
	public String JBAIDE 	= null;
	/**
	 *  Icon bouton Option par dfaut
	 */
	public String JBOPTIONDEF   = null;
	/**
	 *  Icon bouton Option suplmentaire
	 */
	public String JBOPTION   = null;
	/**
	 * Nom de la table  protger en version eval
	 */
	public String PROTECTTABLE 		= null;
	/**
	 * Texte de status de la table protge en version eval
	 */
	public String PROTECTTEXT = null;
	/**
	 * Flag de gestion des version light et pro
	 */
	public boolean VERSIONPRO		= true;
	/**
	 * Flag de gestion de version Evaluation/Enregistre
	 */
	public boolean VERSIONEVAL		= true;
	/**
	 * Borne basse de menus autoriss pour la version pro DU code menu
	 */
	public String VERSIONPRONUM_DE	= "99999999";
	/**
	 * Borne haute de menus autoriss pour la version pro AU code menu
	 */
	public String VERSIONPRONUM_A	= "99999999";
	/**
	 *  Disable une key de menu particulire en version Light
	 */
	public String VERSIONPROOPT1		= "null";
	/**
	 * Key de property de sauvegarde du dernier utilisateur <br>
	 * Utilise cette property au lancement suivant de l'appli <br>
	 * ATTENTION NE PAS SURDEFINIR MERCI 
	 */
	public String PREF="map";
	/**
	 *  Url de la base standard
	 */
	public String URL_BASE_ABC	= "";
	/**
	 *  Url de la base Mtier
	 */
	public String URL_BASE_DATA	= "";
	/**
	 * ATTENTION NOM USER IDENTIQUE POUR LES BASES
	 */
	public String USER_BASE		= "";
	/**
	 * ATTENTION MOT DE PASS IDENTIQUE POUR LES BASES
	 */
	public String PASSWORD ="";
	/**
	 * <code> getAbstractVue </code> est le dispastcheur de l'application<br>
	 * @param sql
	 * @param option Key du fichier menu
	 * @param c_opt2 
	 * @param c_opt3
	 * @return Vue  loader dans la fnetre
	 */
	public abstract AbstractVue getAbstractVue(Sql sql,String option, String c_opt2, String c_opt3);
	/**
	 * Mise  jour des parametres de l'appli avant la premiere connection d'un user 
	 * @param gpAbc
	 */
	public void setAppliParamFromDb(Gp gpAbc){}
	/**
	 * Mise  jour des parametres de l'appli apprs la connection d'un user 
	 * @param gpAbc
	 */
	public void setUserParamFromDb(Gp gpAbc) {}
	/**
	 * 
	 * @return le nom complet de la base standard<br>
	 */
	public String getNameBaseABC(){
		return getNameBase()+BASE_ABC;
	}
	/**
	 * 
	 * @return le nom complet de la base metier<br>
	 */
	public String getNameBaseDATA(){
		return getNameBase()+BASE_DATA;
	}
	/**
	 * 
	 * @return le nom gnral des bases
	 */
	public String getNameBase(){
		return SOC+APPLI+PRO;
	}
	/**
	 * La presence d'un fichier "nomBase.RLW"<br> 
	 * surdfini la connection aux bases<br>
	 * permet d'avoir une base dev et une base exploitation<br>
	 */
	public void setBaseParamFromFileRLW() {
		String [] baseName=Gp.readParamFromFile(getNameBase()+".RLW",5);
		if (baseName!=null){
			URL_BASE_ABC	=baseName[0];
			URL_BASE_DATA	=baseName[1];
			USER_BASE		=baseName[2];
			PASSWORD		=baseName[3];
			PATH_HELP		=baseName[4];
			if (URL_BASE_DATA.trim().length()==0){
				URL_BASE_DATA=URL_BASE_ABC;
			}
		}
	}
	public void setExtraParam() {}
	public String getPathHelp(){
		String ret=PATH_HELP;
		if (PATH_HELP==null){
			ret=getAppDirectory();
		} else {
			if (PATH_HELP.trim().length()==0){
				ret=getAppDirectory();
			}
		}
		return ret;
	}
	public String getAppDirectory() {
		return System.getProperty(Gp.USERDIR);
	}

}

