package persistance.wSql;

import java.util.ArrayList;

import persistance.wGlobalParam.Gp;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.Fma;
import composant_saisie.wSaisieFormat.Fmt;
/**
 * <code> AbstractFieldsDef </code> est une fabrique de Structure d'une table, <br>
 * les champs sont dtaills pour les fiches <br>
 * et simplifis pour les listes <br>
<br>
__________________________________________________________________________________
 * {@link A_doc}
 <br>{@link Licence}.
 */
public abstract class AbstractFieldsDef  {
	public boolean debugF2=false;
	public ArrayList <Field> fieldsdef=null;
	public boolean  t_desc=false;
	public String 	t_table="";
	public int 		t_nbLigne=6;
	public int		t_height=1;
	public String[]	t_filtre=null;
	public String[] v_filtre=null;
	public String[] t_index=null;
	public String 	t_moduleIdF2Color="";
	public String 	t_moduleIdAide="";
	public String   g_optionRupture=null;
	Object moduleId=null;
	
	Vue vue;
	// instanci par Gestion de Vue
	public Sql sql=null;
	public AbstractFieldsDef(Sql sql,Vue vue){
		this.vue=vue;
		fieldsdef=new ArrayList <Field>(Gp.MAXFIELDS);
		this.sql=sql;
		moduleId=adapteField(vue);
	}
	/**
	 * Cration du mappage des champs des tables de base de donne
	 * @param vue entier unique de type de vue
	 * @return lui-mme (ncessaire pour gnrer l'identifiant d'aide)
	 */
	public abstract Object adapteField(Vue vue);
	/** 	
	 * Creation des champs avec dfinition des types de donnes
	 * @param t_field
	 * @param fmt
	 * @param t_lib
	 * @param t_libHelp
	 * @param fieldDefaultValue
	 */
	public void addSqlField(String t_field, Fmt fmt, String t_lib,String t_libHelp, String fieldDefaultValue) {
		addSqlField(t_field, fmt.length(), fmt.fma(),t_lib,t_libHelp,fmt.getTypeEdit(),fieldDefaultValue);	
	}
	/**
	 * Creation des champs avec dfinition des types de donnes <br>
	 * appele par xxxxxECRAN pour la cration  la vole des tables
	 * @param t_field
	 * @param t_fieldLength
	 * @param t_Fma
	 * @param t_lib
	 * @param t_libHelp
	 * @param fieldType
	 * @param fieldDefaultValue
	 */
	public void addSqlField(String t_field, int t_fieldLength, Fma t_Fma, String t_lib,String t_libHelp,Edit fieldType,String fieldDefaultValue){
		fieldsdef.add(new Field(t_field,t_fieldLength,t_Fma,t_lib,t_libHelp));
		fieldsdef.get(fieldsdef.size()-1).setStruct(fieldType, fieldDefaultValue);
	}
	/**
	 * Creation des champs avec dfinition des types de donnes <br>
	 * @param t_field
	 * @param fmt
	 * @param t_lib
	 */
	public void addSqlField(String t_field, Fmt fmt, String t_lib){
		addSqlField(t_field,fmt.length(),fmt.fma(),t_lib);
	}
	/**
	 * Creation des champs avec dfinition des types de donnes <br>
	 * cas standard des listes des tables en gnral
	 * @param t_field
	 * @param t_fieldLength
	 * @param t_Fma
	 * @param t_lib
	 */
	public void addSqlField(String t_field, int t_fieldLength, Fma t_Fma, String t_lib){
		fieldsdef.add(new Field(t_field,t_fieldLength,t_Fma,t_lib));
	}
	/**
	 * Creation des champs avec dfinition des types de donnes <br>
	 * @param t_field
	 * @param t_fieldLength
	 * @param t_Fma
	 * @param t_lib
	 * @param t_fieldFormat
	 */
	public void addSqlField(String t_field, int t_fieldLength, Fma t_Fma, String t_lib, String t_fieldFormat) {
		fieldsdef.add(new Field(t_field,t_fieldLength,t_Fma,t_lib));
		fieldsdef.get(fieldsdef.size()-1).setFormat(t_fieldFormat);
	}
	public void addSqlField(Field tmpfield) {
		fieldsdef.add(new Field());
		fieldsdef.get(fieldsdef.size()-1).set(tmpfield);
	}
	public boolean isContainsField(String name){
		boolean ret=false;
		for (int i=0;i<fieldsdef.size();i++){
			if (fieldsdef.get(i).t_field.equals(name)){
				 ret=true;
				 break;
			}
		}
	return ret;
	}
	/**
	 * Ajoute le mappage des left join 
	 * @param sqljoin
	 */
	public void addJoin(FieldsJoin sqljoin){
		sql.addJoin(sqljoin);
	}
	/**
	 *  Valide le mappage des champs<br>
	 *  connect le mappage liste et la table Sql<br> 
	 */
	public void adapteFields(){
		validateFields();
	}
	/**
	 *  Valide le mappage des champs<br>
	 *  connect le mappage liste et la table Sql<br>
	 *  
	 */
	protected void validateFields() {
		sql.fields=fieldsdef;
		sql.setTable(t_table);
		sql.t_nbLigne=t_nbLigne;
		sql.t_height=t_height;
		sql.t_filtre=t_filtre;
		sql.v_filtre=v_filtre;
		sql.t_index=t_index;
		sql.debugF2=debugF2;
		sql.t_moduleIdF2Color=t_moduleIdF2Color;
		if (t_moduleIdAide.equals("")){
			t_moduleIdAide=moduleId.getClass().getSimpleName()+vue+sql.getOption();
		}
		sql.t_moduleIdAide=t_moduleIdAide;
	}

	public void adaptePrints(Sql sql){
		this.sql=sql;
		validatePrints();
	}
	/**
	 * Retire les colonnes invisibles issues des listes standards<br>
	 * Inutile pour les ditions spcifiques
	 */
	public void adapteRemoveInvisible() {
		for (int i=fieldsdef.size()-1;i>-1;i--){
			if (fieldsdef.get(i).t_Fma==Fma.INVISIBLE || fieldsdef.get(i).t_Fma==Fma.CACHE){
				fieldsdef.remove(i);
			}
		}
	}
	private void validatePrints() {
		sql.prints=fieldsdef;
		sql.printsFilter=this;
	}	

	public void adapteRuptures(Sql sql){
		this.sql=sql;
		validateRuptures();
	}
	private void validateRuptures() {
		if (g_optionRupture!=null){
			sql.g_optionRupture=g_optionRupture;
		}
		sql.ruptures=fieldsdef;
	}
	
	public void traceStructure(){
		for (int i=0;i<fieldsdef.size();i++){
			System.out.println(fieldsdef.get(i).t_field);
		}
	}

	public void dispose() {
		if (fieldsdef!=null){
			fieldsdef.clear();
			fieldsdef=null;
		}
		sql=null;
	}
	protected void finalize() {
		//		Gp.af("finalize : "+this.getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}
