package persistance.wSql;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

/**
 * {@link A_doc}
 <br>{@link Licence}.
 */
public class FieldsJoin {

	boolean notspeedable=false;
	String [] origine=null;
	Gp gp=null;
	String baseJoin=null;
	String [] select=null;
	String joinTable=null;
	String aliasTable=null;
	String [] link=null;
	/**
	 * 
	 * @param origine		// champs d'origine
	 * @param gp			// Base de la Table fille
	 * @param joinTable 	// Table fille
	 * @param aliasTable 	// Alias de la Table fille
	 * @param link		    // index de la Table fille en galite avec le champs d'origine
	 * @param select		// champs de la Table fille  lister
	 * <br><br>
	 * Ex : <br>
	 * 	select planning.rowid AS RECNO, planning.c_code,planning.c_heur   <br>  
	 *  from PLANNING  <br>
	 *  LEFT JOIN Repas AS repasLundi ON (planning.c_lund = repas AS repasLundi.c_code) <br>
	 *  ORDER BY planning.c_code||planning.c_heur <br>
	 *  desc limit 1 <br>
	 * 
	 */
	public FieldsJoin(String[] origine ,Gp gp, String joinTable, String aliasTable, String[] link,String[] select){
		this.origine=origine;
		this.gp=gp;
		this.select=select;
		this.joinTable=joinTable;
		switch (gp.sqltype){
		case Gp.MYSQL:
			baseJoin=gp.base+Sql.JoinTableName+joinTable;
			break;
		case Gp.SQLITE:
			baseJoin=joinTable;
			break;
		}
		this.aliasTable=aliasTable;
		if (aliasTable.trim().length()==0){
			this.aliasTable=joinTable;
		}
		this.link=link;
		setNotSpeedable();
	}
	public String getSelect(){
		String ret="";
		for (int i=0;i<select.length;i++){
			ret=ret+","+aliasTable+"."+select[i];
		}
		return ret;
	}

	public String getJoin(){
		String ret="";
		ret=baseJoin+" AS "+aliasTable;
		return ret;
	}

	public String getOnjoin(String table,String SqlPipe, boolean sqlconcat ){
		return "("+getOn(table,SqlPipe,sqlconcat)+" = "+getEgale(SqlPipe,sqlconcat)+")";
	}
	private String getOn(String table,String SqlPipe, boolean sqlconcat ){
		String ret="";
		String pipe="";
		if (sqlconcat){
			if (origine.length>1){
				ret=Sql.CONCAT;
			} else {
				ret="(";
			}
		}
		for (int i=0;i<origine.length;i++){
			if (origine[i].contains(Sql.JoinTableName)){
				ret=ret+pipe+origine[i];
			} else {
				ret=ret+pipe+table+"."+origine[i];
			}
			pipe=SqlPipe;
		}
		if (sqlconcat){
			ret=ret+")";
		}
		return ret;
	}
	private String getEgale(String SqlPipe, boolean sqlconcat){
		String ret="";
		String pipe="";
		if (sqlconcat){
			if (link.length>1){
				ret=Sql.CONCAT;
			} else {
				ret="(";
			}
		}
		for (int i=0;i<link.length;i++){
			ret=ret+pipe+aliasTable+"."+link[i];
			pipe=SqlPipe;
		}
		if (sqlconcat){
			ret=ret+")";
		}
		return ret;
	}
	private void setNotSpeedable() {
		for (int i=0;i<origine.length;i++){
			if (origine[i].contains(Sql.JoinTableName)){
				notspeedable=true;
			}			
		}
	}
	public boolean isNotSpeedable() {
		return notspeedable;
	}
}
