package template_applicatif.wFiche;
import java.awt.BorderLayout;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.Document;
import javax.swing.text.JTextComponent;

import module_standard.wAide.Aide;
import module_standard.wAide.JDialogAide;
import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.VueButtonSLBascule;
import template_applicatif.wVue.VueIAcces;
import template_applicatif.wVue.Vue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JPlageTimes;
import composant_saisie.wComposant.JRadio;
import composant_saisie.wComposant.JTextCheck;
import composant_saisie.wComposant.JTextDbDate;
import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wComposant.JTextDbTime;
import composant_saisie.wComposant.JTimeDelay;
import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.CcsFmt;
import composant_saisie.wSaisieFormat.Fma;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
 * Fabrique de fiche sur une table <br>
__________________________________________________________________________________
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public abstract class AbstractDbFiche extends JPanel implements DocumentListener,PropertyChangeListener,KeyListener, VueIAcces,FicheIAction,FicheIEditableColumns {
	private static final long serialVersionUID = 1L;
	public Sql sql=null;
	public Ccs ccs=null;
	UserUpdate userupdate=null;
	public AbstractVue vue=null;
	// Composant
	public FicheButton jpCrud=null;
	public VueButtonSLBascule jpBascule=null;
	/**
	 *  Panel Labels
	 */
	public JPanel jpDbL=null;
	/**
	 *  Panel des Edits
	 */
	public JPanel jpDbE=null;
	public JPanel jpLibeText=null;
	public JPanel jpFiche=null;
	private boolean ccsEnable;
	boolean isEnable=true;
	int sauveMode=9999;
	boolean autoAppend=false;
	public String c_opt2=null;
	/**
	 * ncessaire lors du chargement de saisie en ligne pour le dtail<br>
	 *  evite le sql.fiche et sql.liste = null
	 */
	boolean validFicheComponent=false;
	boolean debugDisposeTrace=false;

	public AbstractDbFiche(Sql sqlFiche, String c_opt2)  {
		this.c_opt2=c_opt2;
		this.sql=sqlFiche;
	}
	public AbstractDbFiche(Sql sqlFiche)  {
		this.sql=sqlFiche;
	}
	/**
	 *  Launcheur de :<br>
	 *  {@link Ccs}<br>
	 *  {@link #initGlobal()}<br>
	 *  {@link #initLT()}<br>
	 *  {@link #initmapLT()}<br>
	 *  {@link #initFiche()}<br>
	 *  {@link #initUi()}<br>
	 */
	protected void initStart(){
		this.userupdate=new UserUpdate(this);
		setDebugDisposeTrace(debugDisposeTrace);
		ccs=new Ccs(sql);
		initGlobalSql(); 
		initCreateLE();
		initMapLE();
		initGuiLE();
		initGuiFicheCrud();		
	}
	/**
	 * Initialise les buffers et dfinition de table<br>
	 * pour le requteur Sql<br>
	 */
	protected void initGlobalSql() {
		sql.t_nbLigne=1;
		sql.taThis=this;
		sql.v_index=sql.t_seek;
		sql.initFields();
		sql.initData();
		setCcsEnable(true);
	}
	/**
	 * Les composants Labels et Edits sont a crer en tant que membres de la fiche<br>
	 * <br>
	 * Initialise les zones :<br>	
	 * <br>
	 * Label de la fiche<br>
	 * Edit de la fiche<br>
	 */
	protected abstract void initCreateLE();
	/**
	 * Les Labels et les Edits sont a crer en tant que membres de la fiche<br>
	 * <br>
	 * maper les composants par leur indice avec leur table<br>
	 * Adapter le format d'affichage<br>
	 */
	protected abstract void initMapLE();
	/**
	 * 	Constuit le panel d'une FICHE <br>
	 *  Incorpore les membres Label<br>
	 *  Incorpore les membres Edit <br>
	 *  <br>
	 *  Utiliser {@link #jpDbL} pour placer les Labels<br>
	 *  Utiliser {@link #jpDbE} pour placer les Edits<br>
	 */
	//	protected abstract void initGuiLE();
	protected  void initGuiLE(){
		initGuiLSimple();
		initGuiESimple();
	}
	protected void initGuiLSimple(){
		ccs.alignL(SwingConstants.RIGHT);
		jpDbL=new JPanel(Gp.adaptePanelL());
		ccs.addL(jpDbL);
	}
	protected void initGuiESimple(){
		jpDbE=new JPanel(Gp.adaptePanelE());
		ccs.addE(jpDbE);
	}
	protected void initGuiEDetail(){
		jpDbE=new JPanel(Gp.adaptePanelC());
		ccs.addEDetail(jpDbE);
	}
	/**
	 *  Termine la construction du panel de FICHE <br>
	 *  Incorpore le panel des Labels<br>
	 *  Incorpore le panel des Edits <br>
	 *  Incorpore le panel CRUD <br>
	 *  <br>
	 *  Incorpore le titre<br>
	 *  Incorpore les boutons<br>
	 *  Etablie le mode Movable<br>
	 *  Pose les listener sur les Edits<br>
	 */
	protected void initGuiFicheCrud(){
		jpFiche=new JPanel(Gp.adaptePanelC()); {
			jpLibeText=new JPanel(Gp.adaptePanelC()); {
				if (jpDbL!=null){
					Gp.setxy(0,0);
					jpLibeText.add(jpDbL,Gp.gbc);
				}
				if (jpDbE!=null){
					Gp.setxy(1,0);
					jpDbE.setBorder(BorderFactory.createLoweredBevelBorder());
					jpLibeText.add(jpDbE,Gp.gbc);
				}
				Gp.setxy(0,0);
			}
			jpFiche.add(jpLibeText,Gp.gbc);

			jpCrud=new FicheButton(this,sql);{
				Gp.setxy(0,1);
				Gp.setFill(1);
				jpFiche.add(jpCrud,Gp.gbc);
				Gp.setFill(0);
			}
			jpFiche.setBorder(BorderFactory.createEtchedBorder());
		}
		this.setLayout(new BorderLayout(0,0));{
			this.add(jpFiche,BorderLayout.CENTER);
		}
		setModeMovable();
	}
	public void validateDebut(){
		setBaseListener();
		setDependants();
		setEditableColumns(this,vue.dbListe);
		validateAdapteFicheCrud();
		if (sql.taTwin!=null){
			validateAdapteListe();
		}
		validateInitSaisieEnLigne();
		validFicheComponent=true;
	}

	protected void validateAdapteFicheCrud() {}
	protected void validateAdapteListe() {}
	/**
	 * Une fois la fiche compltement charge<br>
	 * On instancie le dtail des lignes<br>
	 */
	protected void validateInitSaisieEnLigne(){}




	/**
	 *  Dfinir les controles de BASE des Edits<br>
	 *  Le format de saisie, l'existance dans la table<br>
	 */
	protected abstract void setBaseListener();
	/**
	 *  Dfinir les dpendances entre Edits<br>
	 *  de niveau directe<br>
	 *  Le contrleur calcule et gre automatique<br>
	 *  Les dpendances induites<br>
	 *  La rcursion et annule par le controleur<br>
	 */
	protected abstract void setDependants();
	public void setDebugDependant(boolean debugDependant) {
		ccs.setDebugDependant(debugDependant);
	}
	/**
	 *  met  jour de maniere contextuelle les Edits,<br>
	 *  les ranges, les valeurs acceptable en fonction des valeurs d'autres Edits<br>
	 */
	public void updateContextualListener() {
		for (int i=0;i<ccs.getESize();i++){
			updateContextualRangeAndEnable(ccs.getE(i));
		}
	}
	/**
	 *  Re-Dfinir les controles de saisie des Edits de manire contextuelle<br>
	 *  Typiquement les Ranges <br>
	 *  @param jc
	 */
	protected abstract void updateContextualRangeAndEnable(JComponent jc);

	public void load(int load){
		if (sql.isModeMovable()||sql.isModeSauve()){
			switch (load){
			case Sql.t_LoadRowid:
				loadRecordByRowId();
				break;
			case Sql.t_LoadAllField:
				loadRecordSinceIndex();
				break;
			}
			if (validFicheComponent){
				setCcsEnable(false);
				loadEAdapteGuiFiche();
				//SwingUtilities.invokeLater(new Runnable() {
				//	public void run() {
				updateContextualListener();
				//	} 
				//});
				loadEAdapteGuiSaisieEnLigne();
				setCcsEnable(true);
			}
		} else {
			notifyModifEncours("chargement");
			initFocus();
		}
	}
	private void loadRecordByRowId(){
		sql.rsLoadRecno();{
			rsLoad(Sql.t_LoadRowid);
		}
		sql.t_seek=sql.v_index;
	}
	private void loadRecordSinceIndex(){
		if (sql.v_index.equals(Sql.t_bottom)){
			sql.dBBottomByIndex();
		} else {
			if (sql.v_index.equals(Sql.t_top)) {
				sql.dBTopByIndex();
			} else {
				//System.out.println(sql.t_table+" :"+sql.v_index+":");
			}
		}
		sql.rsSoftSeek();{
			rsLoad(Sql.t_LoadAllField);
		}
		sql.t_seek=sql.v_index;
	}
	public void load(String v_index) {
		if (v_index.length()>0){
			sql.v_index=v_index;
		} else {
			sql.v_index=Sql.t_bottom; // Lors d'un append le v_index = ""
		}
		// se qui vaut un go top hors on souhaite avoir les zones vides
		// Force une valeur de recherche improbable
		load(Sql.t_LoadAllField);
	}

	// Chargement en mmoire de la fiche
	private void rsLoad(int load) {
		boolean recordExist=false;
		recordExist=sql.rsSetDatas();
		if (recordExist) {//Revalorise le t_varia
			sql.v_indexEqualData(0);
		} else {
			sql.datas.add(new Object [sql.t_nbFieldWithRowidForData]);
			softSetDatasWithNewEmpty();
		}
		softSetEditsWithDatas(load);
	}
	/**
	 *  A chaque chargement d'une fiche  l'cran<br>
	 *  Adapter l'affichage en fonction des nouvelle valeurs de la fiche<br>
	 * {@link Ccs le controleur de saisie } <code>Ccs</code> est dsactiv pendant la mise  jour des Edits<br>
	 *  Ex : ouvrir ou fermer un ou plusieurs Edits, modifier leur valeur par dfaut etc<br>
	 *  @see {@link #loadEAdapteGuiLE()}
	 *  @see {@link #loadEAdapteGuiCrud()}
	 */
	public void loadEAdapteGuiFiche() {
		loadEAdapteGuiLE();
		loadEAdapteGuiCrud();
	}
	/**
	 *  A chaque chargement d'une fiche  l'cran<br>
	 *  Adapter l'affichage en fonction des nouvelle valeurs de la fiche<br>
	 * {@link Ccs le controleur de saisie } <code>Ccs</code> est dsactiv pendant la mise  jour des Edits<br>
	 *  Ex : ouvrir ou fermer un ou plusieurs Edits, modifier leur valeur par dfaut etc<br>
	 *  @see {@link #loadEAdapteGuiSaisieEnLigne()}
	 *  @see {@link #loadEAdapteGuiFicheOnAppend()}
	 */
	public abstract void loadEAdapteGuiLE();
	/**
	 *  A chaque chargement d'une fiche  l'cran<br>
	 *  Adapter le crud en fonction des nouvelle valeurs de la fiche<br>
	 * {@link Ccs le controleur de saisie } <code>Ccs</code> est dsactiv pendant la mise  jour des Edits<br>
	 *  Ex : ouvrir ou fermer un ou plusieurs Edits, modifier leur valeur par dfaut etc<br>
	 *  @see {@link #loadEAdapteGuiSaisieEnLigne()}
	 *  @see {@link #loadEAdapteGuiFicheOnAppend()}
	 */
	public void loadEAdapteGuiCrud(){}
	/**
	 *  Idem que {@link #loadEAdapteGuiLE()} <br>
	 *  Cas particulier en Saisie en ligne<br>
	 *  Etablir les set filter de dtail en cohrence avec l'entte<br>
	 *  et reloader le dtail<br>
	 */
	protected void loadEAdapteGuiSaisieEnLigne(){}
	/**
	 *  Idem que {@link #loadEAdapteGuiLE()} <br>
	 *  Cas particulier en Mode Ajouter une Fiche<br>
	 *  Ouvrir les Edits code de cle d'index uniquement lors de l'ajout<br>
	 */
	public void loadEAdapteGuiFicheOnAppend() {}
	/**
	 * Transfert le Data buffer dans les Edits<br>
	 * {@link Ccs le controleur de saisie } <code>Ccs</code> est dsactiv pendant la mise  jour des Edits<br>
	 * @param load
	 */
	protected void softSetEditsWithDatas(int load) {
		setCcsEnable(false);
		setBufferDataBeforeSetEditsWithDatas();
		// load=Sql.t_LoadAllField charge toute la fiche
		// load#Sql.t_LoadAllField ne charge que le reste de la fiche
		boolean bIndex=false;
		JComponent jc=null;
		JTextComponent jt=null;
		JTextCheck jk=null;
		JRadio jr=null;
		JTimeDelay jpl=null;
		JPlageTimes jpls=null;
		JTextDbDate jpd=null;
		JTextDbTime jpt=null;
		Edit edit=null;
		Fma fma;
		String format=null;
		int numfield=-1;
		for (int field=0;field<ccs.getESize();field++){
			jc=(JComponent) ccs.getE(field);
			numfield=sql.getNumField(jc.getName());
			fma=sql.fields.get(numfield).t_Fma;
			format=sql.fields.get(numfield).t_fieldFormat;
			edit=(Edit) jc.getClientProperty(Edit.TYPE_FIELD);
			if (sql.t_AccesMode==Sql.t_AccesModeIndex)
				bIndex=sql.isFieldInIndex(numfield);

			if (load==Sql.t_LoadAllField) { 
				if (bIndex) {//La cl d'index
					// retraite la base
					switch (edit){
					case CHECK:
						jk=(JTextCheck) ccs.getE(field);
						if(sql.datas.get(0)[numfield].toString().equals("1"))
							jk.setSelected(true);
						else
							jk.setSelected(false);
						break;
					case RADIO:
						jr=(JRadio) ccs.getE(field);
						jr.setButton(sql.datas.get(0)[numfield].toString(), true);
						break;
					case TIMEDELAY:
						jpl=(JTimeDelay) ccs.getE(field);
						jpl.setTimeDelay(sql.datas.get(0)[numfield].toString());
						break;
					case PLAGETIMES:
						jpls=(JPlageTimes) ccs.getE(field);
						jpls.setSTime(sql.datas.get(0)[numfield].toString());
						break;
					case TIME:
						jpt=(JTextDbTime) ccs.getE(field);
						jpt.setSTime(sql.datas.get(0)[numfield].toString());
						break;
					case DATE:
						jpd=(JTextDbDate) ccs.getE(field);
						jpd.setSDate(sql.datas.get(0)[numfield].toString());
						break;
					case MONTH:
						jpd=(JTextDbDate) ccs.getE(field);
						jpd.setSDate(sql.datas.get(0)[numfield].toString());
						break;
					case YEAR:
						jpd=(JTextDbDate) ccs.getE(field);
						jpd.setSDate(sql.datas.get(0)[numfield].toString());
						break;
					default :
						// Spcifique
						// basic
						jt=(JTextComponent) ccs.getE(field);
						if (!(jt.getDocument().getProperty("loc")!=null && jt.getDocument().getProperty("loc").equals("true"))){
							jt.setText(CcsFmt.textFormat(sql.datas.get(0)[numfield].toString(),fma,format));
						}
						break;
					}
				}
			}

			if (!bIndex) {// le reste de la fiche
				switch (edit){
				case CHECK:
					jk=(JTextCheck) ccs.getE(field);
					if(sql.datas.get(0)[numfield].toString().equals("1"))
						jk.setSelected(true);
					else
						jk.setSelected(false);
					break;
				case RADIO:
					jr=(JRadio) ccs.getE(field);
					jr.setButton(sql.datas.get(0)[numfield].toString(), true);
					break;
				case TIMEDELAY:
					jpl=(JTimeDelay) ccs.getE(field);
					jpl.setTimeDelay(sql.datas.get(0)[numfield].toString());
					break;
				case PLAGETIMES:
					jpls=(JPlageTimes) ccs.getE(field);
					jpls.setSTime(sql.datas.get(0)[numfield].toString());
					break;
				case TIME:
					jpt=(JTextDbTime) ccs.getE(field);
					jpt.setSTime(sql.datas.get(0)[numfield].toString());
					break;
				case DATE:
					jpd=(JTextDbDate) ccs.getE(field);
					jpd.setSDate(sql.datas.get(0)[numfield].toString());
					break;
				case MONTH:
					jpd=(JTextDbDate) ccs.getE(field);
					jpd.setSDate(sql.datas.get(0)[numfield].toString());
					break;
				case YEAR:
					jpd=(JTextDbDate) ccs.getE(field);
					jpd.setSDate(sql.datas.get(0)[numfield].toString());
					break;
				default:
					jt=(JTextComponent) ccs.getE(field);
					jt.setText(CcsFmt.textFormat(sql.datas.get(0)[numfield].toString(),fma,format));
					break;
				}
				// si cela est un F2 
				// que ce F2 contient un libell
				// repaint le libell
				if (jc.getClientProperty(Ccs.CODEINF2)!=null){
					jt=(JTextComponent) ccs.getE(field);
					((JTextDbF2) jt).userUpdate();
				}
			}
		}
		setCcsEnable(true);
		softSetEditsWithDatasLoaded();	
	}
	protected void softSetEditsWithDatasLoaded() {}
	protected void setBufferDataBeforeSetEditsWithDatas() {}
	private void softSetDatasWithGetEdits(){
		setBufferEditsBeforeSetDatasWithGetEdits();
		JComponent jc=null;
		Edit edit=null;
		int numfield=-1;
		for (int field=0;field<ccs.getESize();field++){
			jc=(JComponent) ccs.getE(field);
			edit=(Edit) jc.getClientProperty(Edit.TYPE_FIELD);
			numfield=sql.getNumField(jc.getName());
			switch (edit){
			case CHECK:
				if (((JTextCheck)jc).isSelected())
					sql.datas.get(0)[numfield]="1";
				else
					sql.datas.get(0)[numfield]="0";
				break;
			case RADIO:
				sql.datas.get(0)[numfield]=((JRadio)jc).getButton();
				break;
			case TIMEDELAY:
				sql.datas.get(0)[numfield]=((JTimeDelay)jc).getTimeDelay();
				break;
			case PLAGETIMES:
				sql.datas.get(0)[numfield]=((JPlageTimes)jc).getSTime();

				// Spcifique
				break;
			case DATE:
				sql.datas.get(0)[numfield]=CcsFmt.formatStrDate(((JTextComponent)ccs.getE(field)).getText(),true);
				break;
			case MONTH:
				sql.datas.get(0)[numfield]=CcsFmt.formatStrMonth(((JTextComponent)ccs.getE(field)).getText(),true);
				break;
			case TIME:
				sql.datas.get(0)[numfield]=CcsFmt.formatStrTime(((JTextComponent)ccs.getE(field)).getText(),true);
				break;
			case YEAR:
				sql.datas.get(0)[numfield]=CcsFmt.formatStrYear(((JTextComponent)ccs.getE(field)).getText(),true);
				break;
			case PHONE:
				sql.datas.get(0)[numfield]=CcsFmt.formatStrPhone(((JTextComponent)ccs.getE(field)).getText(),true);
				break;
			case SECU:
				sql.datas.get(0)[numfield]=CcsFmt.formatStrSecu(((JTextComponent)ccs.getE(field)).getText(),true);
				break;
			case URSS:
				sql.datas.get(0)[numfield]=CcsFmt.formatStrUrss(((JTextComponent)ccs.getE(field)).getText(),true);
				break;
			case POSTAL:
				sql.datas.get(0)[numfield]=CcsFmt.formatStrPostal(((JTextComponent)ccs.getE(field)).getText(),true);
				break;
			default:
				// basic
				sql.datas.get(0)[numfield]=((JTextComponent)ccs.getE(field)).getText();
			}
		}
	}
	protected void setBufferEditsBeforeSetDatasWithGetEdits() {}
	/**
	 * Vide le Data buffer
	 */
	protected void softSetDatasWithNewEmpty(){
		// Vide la fiche
		for (int i=0;i<sql.datas.get(0).length;i++){
			sql.datas.get(0)[i]="";
		}
	}
	private boolean softIsDatasNewEmptyUpdateByDefault(){
		boolean ret=false;
		// si la cl d'index  t mise  jour
		ret=sql.isEmptyV_indexUpdated(0);
		return ret;
	}
	////////////////////////////////
	// Controle de la saisie USER //
	////////////////////////////////
	/**
	 * Suspend le controleur de saisie pour modifier informatiquement les textes des Edits<br>
	 * <br>
	 * Rtablie le controleur de saisie aprs modification informatique Edits<br>
	 * @param enable
	 */
	protected void setCcsEnable(boolean enable){
		ccsEnable=enable;
	}
	/**
	 * 1) Dsactive le controleur de saisie<br>
	 * 2) Modification des Edits de la fiche<br>
	 * 3) Ractive le controleur de saisie<br>
	 * 
	 * @return contoleur de saisie actif ?
	 */
	protected boolean isCcsEnable(){
		return ccsEnable;
	}
	//
	public void propertyChange(PropertyChangeEvent arg0) {
		if (this.isEnabled()){
			if (arg0.getPropertyName().equals(UserUpdate.UPDATE)){
				userUpdateNOTEdit((JComponent)arg0.getSource());
			}
		}
	}
	public void changedUpdate(DocumentEvent arg0) {	}
	public void removeUpdate(DocumentEvent arg0) {
		if (this.isEnabled()){
			if (isCcsEnable()) {
				// Evite le double appel remove puis insert lors de la lecture des tables
				//try {System.out.println("removeUpdate :"+arg0.getDocument().getText(0, arg0.getDocument().getLength())); } catch (BadLocationException e) { e.printStackTrace(); }
				userUpdateEdit(arg0.getDocument());
			}
		}
	}
	public void insertUpdate(DocumentEvent arg0) {
		if (this.isEnabled()){
			//try {System.out.println("insertUpdate :"+arg0.getDocument().getText(0, arg0.getDocument().getLength())); } catch (BadLocationException e) { e.printStackTrace(); }
			userUpdateEdit(arg0.getDocument());
		}
	}
	/**
	 * Changement du contenu d'un Edit de type TEXTE de la fiche<br>
	 * @param jc Edit venant d'tre modifi par USER
	 */
	public void userUpdateEdit(Document jdct){
		if (isCcsEnable() ){
			userUpdateMode((JTextComponent) jdct.getProperty(Ccs.JTPARENTDOC));
		}
	}
	/**
	 * Changement du contenu d'un Edit de type diffrent de TEXTE de la fiche<br>
	 * type checkbox, radiobouton etc <br> 
	 * @param jc Edit venant d'tre modifi par USER
	 */
	private void userUpdateNOTEdit(JComponent jc){
		if (isCcsEnable() ){
			userUpdateMode(jc);
		}
	}
	/**
	 * Changement du contenu d'un Edit de la fiche<br>
	 * <br>
	 * {@link UserUpdate#userUpdate}<br>
	 * {@link #computeMode()}<br>
	 * {@link #fireBaseListener(JComponent)}<br>
	 * {@link #computeDependant()}<br>
	 * {@link Ccs#setStatusFicheZone}<br>
	 * <br>
	 * @param jc Edit venant d'tre modifi par USER
	 */
	private void userUpdateMode(JComponent jc){
		boolean updatable=true;
		if (sql.isModeMovable()||sql.isModeSauve()){
			if (sql.t_eof ){
				//				String [] option=new String[]{"   Attention !!!  "};
				//				sql.notify("Nouvelle Fiche : "+sql.t_table,"  Utiliser le bouton NOUVEAU, Merci  ",option,sql.getAppliParam().JBAPPEND,0);
				//				updatable=false;
				////////////////////////////////////
				//				SwingUtilities.invokeLater(new Runnable() {
				//					public void run() {
				//						JOptionPane.showMessageDialog(null,"Utiliser le bouton NOUVEAU, Merci","Attention !!!",JOptionPane.INFORMATION_MESSAGE);
				//					}
				//				});
			}
		}
		if (updatable){
			userupdate.userUpdate();
			computeMode(); 
			fireEditListener(jc); 
			ccs.setStatusFicheEdit(jc);
			ccs.setDependant(jc);
			fireDependant(jc); 
		}
	}
	/**
	 * Dclenche toutes les dpendances d'un Edit <br>
	 * @param jc Edit
	 */
	private void fireDependant(JComponent jc) {
		if (ccs.isEUpdatable(jc) || ccs.isENotifier(jc)){
			sql.setCursorWait(true);
			setCcsEnable(false);
			if (ccs.isDependant(jc)){ 
				for (int i=0;i<ccs.getDependantSize();i++){
					if (ccs.getDependantFinal(i)==jc && ccs.getDependantCompute(i)!=null){
						computeDependant(ccs.getDependantCompute(i));
					}
				}
			}
			setCcsEnable(true); 
			sql.setCursorWait(false);
		}
	}
	/**
	 * Calcule les dits dpendants d'un Edit
	 * @param jc
	 */
	protected void computeDependant(JComponent jc){
		updateDependant(jc);
		updateContextualRangeAndEnable(jc);
		fireEditListener(jc);
	}
	/**
	 * Dclenche les controles de base et les controles contextuel d'un Edit<br>
	 * @param jc
	 */
	private void fireEditListener(JComponent jc) {
		fireBaseListener(jc); 
		fireContextualRange(jc); 
	}
	/**
	 * Gestion des Edits dpendants <br>
	 * Les Edits dpendants sont mis  jour<br>
	 * {@link Ccs le controleur de saisie } <code>Ccs</code> a t dsactiv pendant la mise  jour d'un Edit<br>
	 * Evite le "Attempt to mutate in notification"<br>
	 */
	protected abstract void updateDependant(JComponent jc);
	/**
	 * Dclenche le controle de la validit de l'Edit<br>
	 * Le FORMATAGE en particulier<br>
	 * @param jc
	 */
	protected abstract void fireBaseListener(JComponent jc);
	/**
	 * Dclenche le controle de la validit de l'Edit<br>
	 * Les RANGEs en particulier<br>
	 * @param jc
	 */
	protected abstract void fireContextualRange(JComponent jc);
	public void focusOnTwin() {
		if (sql.taTwin!=null){
			if (((JPanel)sql.taTwin).isVisible()){
				sql.taTwin.initFocus();
			}
		}
	}
	/**
	 * Dfini le premier Edit focusable d'une fiche
	 * @param jc Edit
	 */
	protected void setDefFocus(JComponent jc) {
		ccs.setDefFocus(jc);
	}
	/////////////////////////////////
	// Gestion des Boutons de l'UI //
	/////////////////////////////////
	public boolean setCrudOnlyAppend() {
		return jpCrud.setOnlyAppend();
	}
	public boolean setCrudOnlyUpdate() {
		return jpCrud.setOnlyUpdate();
	}
	public boolean setCrudOnlyOption() {
		return jpCrud.setOnlyOption();
	}
	public void setCrudOptionEnabled(String option, boolean enable) {
		jpCrud.setOptionEnabled(option,enable);
	}
	public void setCrudBasculeEnabled(String bascule, boolean enable) {
		jpCrud.setBasculeEnabled(bascule,enable);
	}
	public void setCrudVertical(){
		jpCrud.setVertical();
	}
	public void setCrudVisible(boolean enable){
		jpCrud.setVisible(enable);
	}
	public void setCrudEnabled(boolean enable){
		jpCrud.setEnabled(enable);
	}
	public void setCrudRecordVisible(boolean enable){
		jpCrud.setRecordVisible(enable);
	}
	public void userOptionAdd(String option, String fileIcon){
		jpCrud.userOptionAdd(option,fileIcon);
	}
	public void userOptionAdd(JComponent jcOption){
		jpCrud.userOptionAdd(jcOption);
	}
	///////////////////////////////
	// Action du USER
	///////////////////////////////
	public void userCancel(){
		if(sql.isModeMovable()){
			if (sql.vue==Vue.F3POINTAGE){
				userCancelOnF2();
			} else {
				vue.userEscBascule();
			}
		} else {
			userCancelOnF2();
		}
	}
	private void userCancelOnF2(){
		sql.setMode(Sql.MODE_MOVABLE);
		load(Sql.t_LoadAllField);
		loadTwin(Sql.t_LoadRowid);
		setModeMovable();
		userRetOnF2();
	}
	public void userAppend()  {
		if (sql.isModeMovable()){ 
			// La fiche n'a pas t modifie, On entre en AJOUT
			softSetDatasWithNewEmpty();  
			userAppendSetDefaultDatasStruct(); 
			softSetEditsWithDatas(Sql.t_LoadAllField); 
			if (softIsDatasNewEmptyUpdateByDefault()){
				// cl auto
				setModeAppendUpdated();
			} else {
				// cl vide
				setModeAppend(); 		
			}
			setCcsEnable(false);
			loadEAdapteGuiFiche();
			updateContextualListener();
			loadEAdapteGuiFicheOnAppend();  
			loadEAdapteGuiSaisieEnLigne();
			setCcsEnable(true);
		} else {
			// La fiche a t modifie, On interdit et notifie l'impossibilit d'AJOUT
			notifyModifEncours("ajout");
		}
		initFocus();
	}
	/**
	 * Remplie le Data buffer avec les valeurs par dfaut
	 */
	private void userAppendSetDefaultDatasStruct(){
		userAppendSetDefaultDatas();
		ccs.setDefaultDatas();
	}
	protected void userAppendSetDefaultDatas() {}
	public void userOption(String actionCommandOption)  {
		initFocus();
		if (sql.isModeMovable()){ // Si La fiche n'a pas t modifie
			userOptionDo(actionCommandOption);
		} else {
			notifyModifEncours("option");
		}
	}
	protected void userOptionDo(String actionCommandOption){}
	public void userRecord(){
		if(isUpdatableMode()){ 
			// fiche valide
			if ( sql.t_eof && !sql.isModeAppendUpdated() ){
				// Force le mode au cas ou le fichier est vide
				setModeAppendUpdated();
			}
			if (sql.isModeAppendUpdated()){
				if (isModeAppendKeyUnique()){
					// En mode AJOUTER
					// 1) Nouvelle fiche Modifie
					if (!dbInsert()){
						dbInsertFail();
					}
					if (this.isModeAutoAppend()){
						userAppend();
					} else {
						userRetOnF2();
					}
				} else {
					sql.setTextStatusFiche("Ajouter","Fichier : "+sql.t_table+" ~ Fiche : "+sql.getCodeFiche());
					String titre="Attention AJOUTER Impossible !!!";
					String mess="La fiche :'"+sql.getCodeFiche()+"' existe dj, Veuillez changer de code";
					Object[] option = {"Je corrige"};
					sql.notify(titre,mess,option,sql.getAppliParam().JBCANCEL,0);
				}
			} else {
				// En mode MODIFIER
				// 2) Fiche existante Modifie
				if (sql.isModeUpdated()){ 
					dbUpdate();
					userRetOnF2();
				}
			}
		}
	}
	protected void dbInsertFail() {}
	public void userDelete() {
		if(isUpdatableMode()&& !sql.t_eof){
			sql.setTextStatusFiche("Effacement","Fichier : "+sql.t_table+" ~ Fiche : "+sql.getCodeFiche());
			String titre="Attention !!!";
			String mess="Effacer la fiche :'"+sql.getCodeFiche()+"'";
			Object[] option = {"Oui, j'efface dfinitivement","Non, je garde"};
			int reponse=sql.notify(titre, mess, option, sql.getAppliParam().JBDELETE,1);
			switch (reponse){
			case 0:
				dbDelete();
				userRetOnF2();
				break;
			case 1:
				break;
			}
			setModeMovable();
		} else {
			initFocus();
		}
	}
	/////////
	// AIDE //
	/////////
	public void adapteAide(){
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				if (Aide.isAide(sql)){
					setAideVisible(true);
				} 
			} 
		});
	}
	public void setAideVisible(boolean enable) {
		jpCrud.setAideVisible(enable);
	}

	public void userAide() {
		new JDialogAide(sql.getMf(), sql, JDialogAide.READ_AIDE);
	}
	public void userSetAide() {
		new JDialogAide(sql.getMf(), sql, JDialogAide.SET_AIDE);
		setAideVisible(Aide.isAide(sql));
	}
	/////////
	// AIDE //
	/////////
	public boolean isModeAppendKeyUnique() {
		return true;
	}
	protected boolean isUpdatableMode(){
		JComponent jc=null;
		boolean updatable=true;
		jc=ccs.isUpdatable();
		if (jc!=null){
			updatable=false;
			String titre="Attention !!!";
			String mess="Fiche mal renseigne \n\n "+
			"J'enregistre maintenant et je corrigerai plus tard \n\n"+ 
			"     OU  \n\n"+
			"Je corrige la fiche \n\n"+
			jc.getClientProperty(Ccs.MSG_CTRL_FALSE)+"\n\n";
			Object[] option = {"J'enregistre en l'tat","Je corrige immdiatement"};
			int reponse=sql.notify(titre, mess, option, sql.getAppliParam().APPLIICON,1);

			switch (reponse){
			case 0:
				updatable=true;
				break;
			case 1:
				jc.requestFocus();
				break;
			}
		}
		return updatable;
	}

	private void userRetOnF2(){
		if (sql.vue==Vue.F2F3){
			vue.userF2F3();
		} else if (sql.vue==Vue.F3){
			focusOnTwin();
		} else if (sql.vue==Vue.F3POINTAGE){
			focusOnTwin();
		} else if (sql.vue==Vue.F3DETAIL){
			focusOnTwin();
		} else if (sql.vue==Vue.F3HIGHTDETAIL){
			focusOnTwin();
		}
	}
	public void userRecordByFireEditableColumn() {
		userRecord();
		sql.sqlTwin.taThis.initFocus();
	}
	public void removeEditableColumn() {}
	public void enableEditableColumn(boolean enable) {}

	private void userEnterMoveFocus(KeyEvent arg0){
		JComponent jc=null;
		jc=(JComponent)arg0.getComponent();
		// reformater les champs aprs validation comme sur plage date
		userSetEFormatAfterEnter(jc);
		if (jc==ccs.findLastFocus()){
			//Gp.af("dernierfocus : "+jc.getName() );
			if (this.jpCrud.isRecordable()){
				String titre="Fin de saisie";
				String mess="Enregistrer cette fiche ?";
				Object[] option = {"Oui, j'enregistre dfinitivement","Non, je ne garde pas"};
				int reponse=sql.notify(titre, mess, option, sql.getAppliParam().JBRECORD,0);

				switch (reponse){
				case 0:
					this.jpCrud.doRecordClick();
					break;
				case 1:
					break;
				}
			} else {
				focusOnTwin();
			}
		} else {
			ccs.moveFocus(jc);
		}
	}
	protected void userSetEFormatAfterEnter(JComponent jc) {
		setCcsEnable(false);
		JTextComponent jt=null;
		Edit type_field=null;
		Fma fma;
		String format=null;
		int numfield=-1;
		int afield=-1;
		for (int field=0;field<ccs.getESize();field++){
			if (jc==(JComponent) ccs.getE(field)){
				afield=field;
				field=ccs.getESize();
				numfield=sql.getNumField(jc.getName());
			}
		}
		if (numfield!=-1){
			fma=sql.fields.get(numfield).t_Fma;
			format=sql.fields.get(numfield).t_fieldFormat;
			type_field=(Edit) jc.getClientProperty(Edit.TYPE_FIELD);
			switch (type_field){
			case CHECK:
			case RADIO:
			case TIMEDELAY:
			case PLAGETIMES:
				break;
			default:
				jt=(JTextComponent) ccs.getE(afield);
				jt.setText(CcsFmt.textFormat(jt.getText(),fma,format));
				break;
			}
		}
		setCcsEnable(true);
	}
	public void keyTyped(KeyEvent arg0) {}
	public void keyReleased(KeyEvent arg0) {}
	public void keyPressed(KeyEvent arg0) { // ATTENTION MEME RACCOURCI QUE JPLAGETIMES // JTIMEDELAY
		if (arg0.isControlDown()){
			switch (arg0.getKeyCode()) {
			case KeyEvent.VK_M: 
				focusOnTwin();
				arg0.consume(); break;
			default:
				break; }
		} else {
			switch (arg0.getKeyCode()) {
			case KeyEvent.VK_F3: vue.userF2F3();arg0.consume(); break;
			case KeyEvent.VK_F5: vue.userF5Print();arg0.consume(); break;
			case KeyEvent.VK_ESCAPE: userCancel();arg0.consume(); break;
			case KeyEvent.VK_ENTER: 
				userEnterMoveFocus(arg0);arg0.consume(); break;}
		}
	}
	///////////////////////
	// Gestion des modes //
	///////////////////////
	/**
	 * Calcule le mode suivant une action USER ou une SAISIE d'Edit <br>
	 */
	private void computeMode(){
		if (sql.isModeMovable()){
			if (sql.t_eof && this.jpCrud.isAppendable()){
				String [] option=new String[]{"   Attention !!!  "};
				sql.notify("Nouvelle Fiche : "+sql.t_table,"  Utiliser le bouton NOUVEAU, Merci  ",option,sql.getAppliParam().JBAPPEND,0);
			} else {
				setModeUpdated();
			}
		} else {
			if (sql.isModeAppend()) {
				setModeAppendUpdated();
			} else {
				if (sql.isModeSauve())
					setModeRestaure();
			}
		}
	}

	public void setModeMovable(){
		sql.setMode(Sql.MODE_MOVABLE);
		jpCrud.setModeMovable();
		setCcsModeMavable(true);
		setTextStatus();
	}
	public boolean isMovable(){
		return sql.isModeMovable();
	}
	public void setTextStatus(){
		sql.setTextStatusFiche("Consultation","Fichier : "+sql.t_table);
	}
	/**
	 * Dclenche le controle de la validit sur tous les Edits de la fiche<br>
	 */
	public void setModeUpdated(){
		sql.setMode(Sql.MODE_UPDATED);
		jpCrud.setModeUpdated();
		setCcsModeMavable(false);
		sql.setTextStatusFiche("Modification","Fichier : "+sql.t_table+" ~ Fiche : "+sql.getCodeFiche());
	}
	public void setModeAppend(){
		sql.setMode(Sql.MODE_APPEND);
		jpCrud.setModeAppend();
		setCcsModeMavable(false);
		sql.setTextStatusFiche("Cration","Fichier : "+sql.t_table);
	}
	public void setModeAppendUpdated(){
		sql.setMode(Sql.MODE_APPENDUPDATED);
		jpCrud.setModeAppendUpdated();
		setCcsModeMavable(false);
		sql.setTextStatusFiche("Cration","Fichier : "+sql.t_table);
	}
	protected void setModeAutoAppend(boolean enable){
		this.autoAppend=enable;
	}
	protected boolean isModeAutoAppend(){
		return autoAppend;
	}
	private void setCcsModeMavable(boolean movable){
		ccs.setModeMovable(movable);
		if (!movable){
			activateModeCcs();
		}
	}
	private void setModeRestaure(){
		sql.setMode(sauveMode);
	}
	private void activateModeCcs(){
		JComponent jc=null;
		Edit type_field=null;
		for (int field=0;field<ccs.getESize();field++) {
			jc=(JComponent) ccs.getE(field);
			type_field=(Edit) jc.getClientProperty(Edit.TYPE_FIELD);
			if (type_field!=Edit.LIBE){
				fireEditListener(jc);
			} 
		}		
	}


	/*///////////////////////////////////////
	// LIASON FENETRE FILLE A REACTUALISER //
	///////////////////////////////////////*/
	public void loadTwin(int load){
		if (sql.taTwin!=null){
			// Remet  jour le t_varia de la liste avec le t_varia modifi de la fiche
			if (sql.t_AccesMode==Sql.t_AccesModeIndex){
				sql.sqlTwin.v_index=sql.v_index;
				loadTwinSUIL(load);
			} else {
				if (sql.t_Recno.equals(Sql.t_insert)) {// en mode ajout recharge le sql.t_Recno
					sql.dBSeekByIndex(sql.v_index);
					sql.taTwin.dbGoRecno(sql.t_Recno);
					loadTwinSUIL(load);
				} else {
					sql.taTwin.dbGoRecno(sql.t_Recno);
					loadTwinSUIL(load);
				}
			}
		}
	}
	private void loadTwinSUIL(int load){
		sql.taTwin.load(Sql.t_F2DebutFin);
		switch (load){
		case Sql.t_LoadAllField:
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					sql.taTwin.load(Sql.t_LoadAllField);
				} 
			});
			break;
		case Sql.t_LoadRowid:
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					sql.taTwin.load(Sql.t_LoadRowid);
				} 
			});
			break;
		}
	}
	public void dbGoRecno(String recno){
		sql.dBGoRecnoByRecno(recno);
	}
	public void dbFin(){
		sql.dBBottomByIndex();
	}
	public void loadSeek(String v_seek){
		sql.dBSeekByIndex(v_seek);
		if (sql.t_eof){
			softSetDatasWithNewEmpty();  
			softSetEditsWithDatas(Sql.t_LoadAllField); 
		} else {
			load(sql.v_index);
		}
	}
	/////////////////////
	// ACCES BASES SQL //
	/////////////////////

	// Ajout de fiche
	private boolean dbInsert() {
		boolean ret=true;
		dbInsertBeforeUpdateSetDatas();
		softSetDatasWithGetEdits();
		ret=dbInsertBeforeOtherTable();
		if (ret){
			ret=sql.dBInsert();
		}
		if (ret){
			ret=dbInsertAfterOtherTable();
		}
		if (ret){
			reloadAfterDbOperation();
		}
		return ret;
	}
	protected void dbInsertBeforeUpdateSetDatas(){}
	protected boolean dbInsertBeforeOtherTable() { return true; }
	protected boolean dbInsertAfterOtherTable(){ return true; }
	// Mise a jour de fiche
	private void dbUpdate(){
		if (dbUpdateBeforeOtherTable()){
			dbInsertBeforeUpdateSetDatas();
			softSetDatasWithGetEdits();
			dbUpdateBeforeSetDatas();
			String v_champ[]=new String[sql.datas.get(0).length];
			for (int i=0;i<v_champ.length;i++){
				v_champ[i]=(String) sql.datas.get(0)[i];
			}
			sql.dBUpdateByRecno(v_champ);		
			reloadAfterDbOperation();
		}
	}
	public void reloadAfterDb(){
		reloadAfterDbOperation();
	}
	public boolean dbUpdateBeforeOtherTable(){ return true; }
	protected void dbUpdateBeforeSetDatas() {}
	public boolean dbUpdateAfterOtherTable(){ return true; }

	// Effacement de fiche
	private void dbDelete()  {
		if (dbDeleteBeforeOtherTable()){
			// 1) delete
			if (sql.dBDeleteByRecno()){
				sql.dBSkapresByIndex();
				if (sql.t_eof){
					sql.dBTopByIndex();
				}
				// 2) recharge la fiche puis la liste
				load(Sql.t_LoadAllField);
				loadTwin(Sql.t_LoadAllField);
				dbDeleteAfterOtherTable();
				reloadAfterDbOperationFinal();
			}
		}
	}
	public boolean dbDeleteBeforeOtherTable() { return true; }
	public void dbDeleteAfterOtherTable() {}
	public void refreshUIWithNewIndex(String v_index){
		load(v_index);  
		loadTwin(Sql.t_LoadAllField);
	}
	// Fin de modification de fiche
	private void reloadAfterDbOperation(){
		if (dbUpdateAfterOtherTable()){
			sql.setMode(Sql.MODE_MOVABLE);

			if (sql.clauseFilter==null){
				// ATTENTION si le champ de la table mis a jour est un lement de la cle d'index il faut revaloris le t_varia
				//Revalorise le t_varia
				if (sql.isV_indexUpdated(0)){
					sql.v_indexEqualData(0);
					loadTwin(Sql.t_LoadAllField);
				} else {
					loadTwin(Sql.t_LoadRowid);
				}
			} else {
				// ATTENTION si le champ de la table mis a jour fait partie d'une clause de filtre
				//Recharge une nouvelle fiche/Liste
				sql.v_indexEqualData(0);
				sql.dBSeekByIndex(sql.v_index);
				if (!sql.t_eof){ // Les Modifications ou Ajout sont ok pour le clauseFilter on Recharge cette fiche/liste
					load(Sql.t_LoadAllField);
					loadTwin(Sql.t_LoadAllField);
				} else { // la fiche n'est plus accessible  cause du clauseFilter
					// Attention si li par le recno() sur une liste
					if (sql.t_AccesMode==Sql.t_AccesModeRecno){
						if (sql.taTwin!=null){
							sql.sqlTwin.rsSoftSeek();
							loadTwin(Sql.t_LoadAllField);
							if (sql.sqlTwin.t_eof){
								sql.sqlTwin.dBTopByIndex();
								loadTwin(Sql.t_LoadAllField);
							}
							sql.t_Recno=sql.sqlTwin.t_Recno;
							sql.dBGoRecnoByRecno(sql.t_Recno);
							load(Sql.t_LoadAllField);
						}
					} else {
						load(Sql.t_LoadAllField);
						loadTwin(Sql.t_LoadAllField);
					}
				}
			}
			setCcsEnable(false);
			loadEAdapteGuiFiche();
			updateContextualListener();
			loadEAdapteGuiSaisieEnLigne();
			setCcsEnable(true);
			setModeMovable();
			reloadAfterDbOperationFinal();
		}
	}
	protected void reloadSaveRecno(){
		sql.saveRecno();
		if (sql.taTwin!=null){
			sql.sqlTwin.saveRecno();
		}
	}
	protected boolean reloadRestoreRecno(){
		boolean ret=false;
		ret=sql.restoreRecno();
		if (ret ){
			if (sql.taTwin!=null){
				ret=sql.sqlTwin.restoreRecno();
			}
		}
		return ret;
	}
	protected void reloadAfterDbOperationFinal(){}
	///////////////
	// Bascule  // 
	///////////////
	public void beforeBasculeEnteteVersDetail() {}
	public void afterBasculeEnteteVersDetail() {}
	public void beforeBasculeDetailVersEntete() {}
	public void afterBasculeDetailVersEntete() {}
	///////////////
	// DEV Libre  // 
	///////////////
	public Object devSpe1(Object obj) {return obj; }
	public Object devSpe2(Object obj) {return obj; }
	public Object devSpe3(Object obj) {return obj; }		
	//////////////////////////////
	// class de service 
	/////////////////////////////
	private void notifyModifEncours(String action){
		String titre="Attention "+action+" impossible !!!";
		String mess="La fiche : ["+sql.getCodeFiche()+"] du fichier : ["+sql.t_table+"] est en cours de modification, Veuillez l'enregistrer";
		String[] option=new String []{"Je vrifie"};
		sql.notify(titre,mess,option,sql.getAppliParam().JBCANCEL,0);
	}
	public void setArgValue(Object argValue) {}
	public Object getReturnValue() {
		return null;
	}
	public void setEnabled(boolean enable){
		isEnable=enable;
		super.setEnabled(enable);
		// interdit/autorise la saisie 
		ccs.setEEnable(enable);
		// cache/Affiche les boutons
		jpCrud.setEnabled(enable);
	}
	public boolean isEnable(){
		return isEnable;
	}
	public void setVisible(boolean enable){
		super.setVisible(enable);
		jpCrud.setVisible(enable);
		requestFocusInWindow(true);
		requestFocusInWindow();
		initFocus();
	}
	public void setDebugDisposeTrace(boolean enable){
		debugDisposeTrace=enable;
		if (debugDisposeTrace){
			Gp.ad("initialize : "+this.getClass().getSimpleName()+" "+this.getClass().hashCode());
		}
	}
	public void dispose() {
		setEditableColumns(null,null);
		validFicheComponent=false;
		if (ccs!=null){
			ccs.dispose();
			ccs=null;
		}
		if (jpCrud!=null){
			jpCrud.dispose();
			jpCrud=null;
		}
		jpBascule=null;
		jpDbL=null;
		jpDbE=null;
		jpLibeText=null;
		jpFiche=null;
		c_opt2=null;
		sql=null;
		vue=null;
		if (debugDisposeTrace){
			Gp.ad("dispose : "+this.getClass().getSimpleName()+" "+this.getClass().hashCode());
		}
	}
	protected void finalize()  {
		if (debugDisposeTrace){
			Gp.ad("finalize : "+this.getClass().getSimpleName()+" "+this.getClass().hashCode());
		}
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
	public void setFicheLibelle() {
		setCrudVisible(false);
		ccs.setEEnable(false);
	}
}
