package template_applicatif.wFiltre;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;

import javax.swing.JComponent;
import javax.swing.JPanel;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import template_applicatif.wVue.AbstractVue;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextButton;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public abstract class AbstractFILTRE extends JPanel  implements PropertyChangeListener, ActionListener {
	private static final long serialVersionUID = 1L;
	public JTextButton jbFiltrer=null;

	private String filtrer="Filtrer";
	protected Sql sql;
	private ArrayList<JComponent> deas=null;
	private UserUpdate userupdate=null;
	private Filtre filtre=null;
	private AbstractVue vue=null;
	public AbstractFILTRE(Sql sql, Filtre filtre){
		this.sql=sql;
		this.filtre=filtre;
		this.vue=null;
		this.deas=new ArrayList<JComponent>();
		userupdate=new UserUpdate(this);
	}
	public AbstractFILTRE(Sql sql, Filtre filtre,AbstractVue vue){
		this.sql=sql;
		this.filtre=filtre;
		this.vue=vue;
		this.deas=new ArrayList<JComponent>();
		userupdate=new UserUpdate(this);
	}
	protected void appendJbFiltrer() {
		jbFiltrer=appendButtonFiltrer(filtrer);{
			jbFiltrer.setEnabled(true);
			this.addOption(jbFiltrer);
		}
	}
	public abstract void adapte();
	public void setEnabled(boolean enabled){
		// Filtre sur une fiche il faut dsactiver en cas de modif
		super.setEnabled(enabled);
		if (deas!=null){ 
			for (int i=0;i<deas.size();i++){
				deas.get(i).setEnabled(enabled);
			}
		}
	}
	public void addImprimer(){
		vue.addImprimer();
		vue.jbImprimer.setEnabled(false);
	}
	public void validate(){
		super.validate();
		this.getComponent(0).requestFocusInWindow();
	}
	public void addOption(JComponent jc){
		add(jc);
		deas.add(jc);
		jc.addPropertyChangeListener(UserUpdate.UPDATE,this);
	}
	private JTextButton appendButtonFiltrer(String ActionCommand){
		JTextButton jb=new JTextButton(ActionCommand);{
			jb.setFont(Gp.FONTTEXT18);
			jb.setPreferredSize(new Dimension(80,42));
			jb.setMinimumSize(new Dimension(80,42));
			jb.setMaximumSize(new Dimension(80,42));
			jb.addActionListener(this);
		}
		return jb;
	}
	public void actionPerformed(ActionEvent arg0) {
		if(arg0.getActionCommand().equals(filtrer)) {
			userFiltrer();
		}
	}
	private void userFiltrer(){
		filtre.setFiltre();
		if (jbFiltrer!=null){
			jbFiltrer.setEnabled(false);
		}
		if (vue!=null){
			if (vue.jbImprimer!=null){
				vue.jbImprimer.setEnabled(true);
			}
		}
	}
	public void propertyChange(PropertyChangeEvent arg0) {
		if (arg0.getPropertyName().equals(UserUpdate.UPDATE)){
			userUpdate();
		} 
	}
	public void userUpdate(){
		if (jbFiltrer!=null){
			if (!jbFiltrer.isEnabled()){
				jbFiltrer.setEnabled(true);
			}
			userupdate.userUpdate();
			if (vue!=null){
				if (vue.jbImprimer!=null){
					vue.jbImprimer.setEnabled(false);
				}
			}
			filtre.alterFiltre();
		} else {
			filtre.setFiltre();
		}
	}
	public void descendJbFiltrer(){
		Gp.getGbcListeEntete();
		Gp.sety(Gp.G_LISTEENTETE+1);
		Gp.setFill(0);
		vue.add(jbFiltrer,Gp.gbc);
	}
	public void dispose() {
		if (deas!=null){
			for (int i=0;i<deas.size();i++){
				deas.get(i).removePropertyChangeListener(UserUpdate.UPDATE,this);
			}
			deas.clear();
			deas=null;
		}
		userupdate=null;
		sql=null;
	}
}
