package template_applicatif.wListe;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.SwingUtilities;
import javax.swing.border.TitledBorder;
import javax.swing.table.TableColumn;
import javax.swing.text.Document;

import module_standard.wAide.Aide;
import module_standard.wAide.JDialogAide;
import module_standard.wListChooser.JListChooser;
import module_standard.wSerial.AbstractMS1204;
import persistance.wGlobalParam.Gp;
import persistance.wSql.Sql;
import template_applicatif.wVue.AbstractVue;
import template_applicatif.wVue.VueIAcces;
import template_applicatif.wVue.VueIMoveListener;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JPopup;
import composant_saisie.wComposant.JSb;
import composant_saisie.wComposant.JTableDb;
import composant_saisie.wComposant.JTextButton;
import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.Fma;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public abstract class AbstractDbListe extends JPanel implements VueIMoveListener,KeyListener, MouseWheelListener, MouseListener,VueIAcces,PropertyChangeListener, ListeIEditableColumn, Runnable, FocusListener {
	private static final long serialVersionUID = 1L;
	public Sql sql=null;
	public AbstractVue vue=null;
	// Acces  VarModele
	public JTableDb jt=null;
	public ListeModele lm;
	ListeSelectionListener lsl=null;
	ListeCellEditor lce=null;
	HeaderCellRenderer hcr=null;
	ListeCellRenderer lcr=null;
	public ListeButtonPlus jpPlus=null;
	public JLabel jDebug=null;
	public JPanel jpEntete=null;
	public JPanel jpDetail=null;
	public ListeButtonTools jpListeTools=null;
	JPanel jpJTable=null;
	ListeGridTable jpGridTable=null;
	public JPanel jpListe=null;
	public JSb sb=null;
	public JSb sbTable=null;
	boolean isEnable=true;
	Color colorSelectedRowBackground=null;
	Color colorSelectedRowForeground=null;
	int colSelected=-1;
	boolean pageprecedente=true;
	boolean pagesuivante=true;
	boolean precedent=true;
	boolean suivant=true;
	public AbstractDbListe(Sql sqlListe) {
		this.sql=sqlListe;
		initGlobal(); // Valorise les parametres globaux
		initComponent();
	}
	private void initGlobal() {
		if (sql.t_nbLigne==0){
			sql.t_nbLigne=4;
		}
		sql.taThis=this;
		sql.v_index="";
		sql.initFields();
		sql.initData();
		sql.v_index=sql.t_seek;
	}
	protected void initComponent() {
		jpListe=new JPanel(new BorderLayout(0,0));{
			jpGridTable = new ListeGridTable();{
				jt = new JTableDb();{
					adapteTable(jt);
					this.colorSelectedRowBackground=jt.getSelectionBackground();
					this.colorSelectedRowForeground=jt.getSelectionForeground();
				}
				jpGridTable.add(jt);
			}
			jpJTable=new JPanel(new BorderLayout(0,0));{
				jpEntete=new JPanel(new BorderLayout(0,0));{
					jpEntete.setFocusable(false);
					jpEntete.add(jt.getTableHeader(),BorderLayout.CENTER);

					jpPlus= new ListeButtonPlus();{
						jpPlus.setPreferredSize(new Dimension(jt.getTableHeader().getPreferredSize().height+4,jt.getTableHeader().getPreferredSize().height+4));
						jpPlus.addPropertyChangeListener(UserUpdate.UPDATE,this);
						jpPlus.addPropertyChangeListener(UserUpdate.PLUS_RIGHT,this);
						jpEntete.add(jpPlus,BorderLayout.EAST);
					}
				}
				jpDetail=new JPanel(new BorderLayout(0,0));{
					sb=new JSb(this,JScrollBar.VERTICAL);{
						sb.setPlayButton();
						sb.setHeight((sql.t_nbLigne)*Gp.HEIGHTCHAR*sql.t_height);
					}
					sbTable=new JSb(JScrollBar.VERTICAL);{ 
						sbTable.setHeight((sql.t_nbLigne)*Gp.HEIGHTCHAR*sql.t_height);
						sbTable.setWidth(-4);
					}
					jpDetail.add(sbTable,BorderLayout.WEST);
					jpDetail.add(jpGridTable,BorderLayout.CENTER);
					jpDetail.add(sb,BorderLayout.EAST);
				}
				jpJTable.add(jpEntete,BorderLayout.NORTH);
				jpJTable.add(jpDetail,BorderLayout.CENTER);
				jpJTable.setBorder(BorderFactory.createEtchedBorder());
				jpJTable.addMouseWheelListener(this);
			}
			jpListeTools =new  ListeButtonTools(this);{
				setToolsVisible(false);
				jpListeTools.addPropertyChangeListener(UserUpdate.UPDATE,this);
			}
			jpListe.add(jpJTable,BorderLayout.CENTER);
			jpListe.add(jpListeTools,BorderLayout.SOUTH);
		}
		this.setLayout(new BorderLayout(0,0));{
			this.add(jpListe,BorderLayout.CENTER);
		}
		this.addMouseListener(this); // Pour le popup
		adapteColor();
	}
	public void userPlus(){
		if (sql.debugF2){
			jDebug=new JLabel();{
				this.add(jDebug,BorderLayout.SOUTH);
				String debug="";
				if (sql.t_index!=null){
					debug=debug+" t_index : ";
					for (int i=0;i<sql.t_index.length;i++){
						debug=debug+"!"+sql.t_index[i];
					}
					debug=debug+"!";
				}
				if (sql.v_index!=null){
					debug=debug+" v_index : !"+sql.v_index+"!";
				}
				if (sql.v_filtre!=null){	
					debug=debug+" v_filtre : ";
					for (int i=0;i<sql.v_filtre.length;i++){
						debug=debug+"!"+sql.v_filtre[i];
					}
					debug=debug+"!";
				}
				if (sql.clauseFilter!=null)
					debug=debug+" clausfilter : !"+sql.clauseFilter+"!";
				if (sql.clauseGroupBy!=null)
					debug=debug+" clausgroup : !"+sql.clauseGroupBy+"!";
				jDebug.setText(debug);
			}
		}
		setToolsVisible(!isToolsVisible());
		if (sql.t_F2!=null){
			sql.t_F2Popup.pack();
		}
	}
	public boolean isToolsVisible(){
		return jpListeTools.isVisible();
	}
	public void setToolsVisible(boolean enable){
		if (lsl.isMovable()){
			jpListeTools.setVisible(enable);
		}
	}
	/////////
	// Aide //
	/////////
	public void adapteAide() {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				if (Aide.isAide(sql)){
					setAideVisible(true);
				} 
			} 
		});
	}
	public void setAideVisible(boolean enable){
		jpListeTools.setAideVisible(enable);
	}
	public void userAide() {
		new JDialogAide(sql.getMf(), sql, JDialogAide.READ_AIDE);
	}
	public void userSetAide() {
		new JDialogAide(sql.getMf(), sql, JDialogAide.SET_AIDE);
		setAideVisible(Aide.isAide(sql));
	}
	///////////
	// Option //
	//////////
	public void addOption(JTextButton jb) {
		jpListeTools.addOption(jb);
	}
	public int getHeightTextSeek() {
		return jpListeTools.getHeightTextSeek();
	}

	public void setTitleFiche(){
		setBorder(new TitledBorder(null,"[ Fichier : "+ sql.t_table+" ]", TitledBorder.LEFT, TitledBorder.DEFAULT_POSITION)); 
	}
	private void adapteTable(JTableDb jt){
		adapteColumn();
		lsl=new ListeSelectionListener(sql,jt);{
			lsl.addPropertyChangeListener(UserUpdate.COL_LISTESELECTION, this);
			lsl.addPropertyChangeListener(UserUpdate.RELOADTWIN, this);
		}
		jt.putClientProperty(Ccs.COLOR_TABLE_SELECTIONBACKGROUND,colorSelectedRowBackground);
		jt.addKeyListener(this);
		jt.addMouseListener(this);
		jt.setRowHeight(sql.t_height*jt.getRowHeight());
		jt.adapteHeader();
		jt.getTableHeader().addMouseListener(this);
	}
	private void adapteColumn(){
		lm = new ListeModele(sql);{
			jt.setModel(lm);
		}
		for (int field=0;field<sql.fields.size();field++){
			if(sql.fields.get(field).t_fieldLength<sql.fields.get(field).t_lib.length()){
				sql.fields.get(field).t_fieldLength=sql.fields.get(field).t_lib.length();
			}
		}

		lcr=new ListeCellRenderer(sql); {
			int nbCol=jt.getModel().getColumnCount();
			for (int i=0;i<nbCol;i++){
				if (sql.fields.get(i).t_fieldLength>0){
					jt.getColumnModel().getColumn(i).setCellRenderer(lcr);
				}
			}
			lcr.addPropertyChangeListener(UserUpdate.COL_LISTECELLRENDERER, this);
		}

		lce=new ListeCellEditor(sql); {
			int nbCol=jt.getModel().getColumnCount();
			for (int i=0;i<nbCol;i++){
				if (sql.fields.get(i).t_fieldLength>0){
					jt.getColumnModel().getColumn(i).setCellEditor(lce);
				}
			}
			lce.addPropertyChangeListener(UserUpdate.CELLEDIT, this);
			lce.addPropertyChangeListener(UserUpdate.COL_LISTECELLEDITOR, this);
		}

		hcr=new HeaderCellRenderer(sql);{
			jt.getTableHeader().setDefaultRenderer(hcr);
			setColSize();
		}
	}
	public void setHeaderSouth() {
		hcr.setHeaderSouth();
		jpJTable.add(jpEntete,BorderLayout.SOUTH);
	}
	public void addEditableColumn(JComponent jc) {
		lm.addEditableColumn(jc);
	}
	public void enableEditableColumn(String name, boolean enable) {
		lm.enableEditableColumn(name, enable);
	}
	public void removeEditableColumn(String name) {
		lm.removeEditableColumn(name);
	}
	private void setColSize(){
		int nbCol=jt.getTableHeader().getColumnModel().getColumnCount();
		for (int i=0;i<nbCol;i++){
			if (sql.fields.get(i).t_fieldLength>0){
				setColVisible(i,true);
			}
		}
	}
	public void setColVisible(String name, boolean visible) {
		int numcol=getCol(name);
		setColVisible(numcol,visible);
	}
	public void setColColor(String name, boolean b, Color background,Color foreground) {
		setColBackground(name,b,background);
		setColForeground(name,b,foreground);
	}
	public void setColBackground(String name, boolean background,Color color) {
		int numcol=getCol(name);
		lcr.setColBackground(numcol,background,color);
	}
	public void setColForeground(String name, boolean foreground, Color color) {
		int numcol=getCol(name);
		lcr.setColForeground(numcol,foreground,color);
	}
	public void setRowForeground(String name,boolean foreground, Color color, String value) {
		int numcol=getCol(name);
		lcr.setRowForeground(numcol,foreground,color,value);
	}
	public void setRowBackground(String name, boolean foreground, Color color, String value) {
		int numcol=getCol(name);
		lcr.setRowBackground(numcol,foreground,color,value);
	}
	public void setColVisible(int numcol,boolean visible){
		if (numcol>-1){
			int width=0;
			if (sql.fields.get(numcol).t_Fma==Fma.CACHE){
				width=0;
			} else if (sql.fields.get(numcol).t_Fma==Fma.INVISIBLE){
				width=0;
			} else if (!visible){
				width=0;
			} else {
				width=((sql.fields.get(numcol).t_fieldLength+2)*(Gp.WIDTHCHAR+0))+2;
			}
			if (isGetCol(numcol)){
				getCol(numcol).setMinWidth(width);
				getCol(numcol).setMaxWidth(width);
				getCol(numcol).setPreferredWidth(width);
			}
		}
	}
	private boolean isGetCol(int num){
		boolean ret=false;
		if (num>=0 && num<jt.getTableHeader().getColumnModel().getColumnCount()){
			ret=true;
		}
		return ret;
	}
	public TableColumn getCol(int num){
		return jt.getTableHeader().getColumnModel().getColumn(num);
	}
	public int getCol(String name){
		int ret=-1;
		int nbCol=jt.getTableHeader().getColumnModel().getColumnCount();
		for (int i=0;i<nbCol;i++){
			if (sql.fields.get(i).t_field.equals(name)){
				ret=i;
				break;
			}
		}
		return ret;
	}
	protected Dimension getSizeCol(int col) {
		int width=0;
		if (isGetCol(col)){
			width=getCol(col).getPreferredWidth();
		}
		return new Dimension(width,2+Gp.HEIGHTCHAR+2);
	}
	public Dimension getSizeCol(JComponent jc) {
		int width=0;
		int numCol=getCol(jc.getName());
		if (numCol!=-1){
			width=getCol(numCol).getPreferredWidth();
		}
		return new Dimension(width,2+Gp.HEIGHTCHAR+2);
	}
	protected int getWidthCol(JComponent jc) {
		int width=0;
		int numCol=getCol(jc.getName());
		if (numCol!=-1){
			width=getCol(getCol(jc.getName())).getPreferredWidth();
		}
		return width;
	}
	public void setEnabled(boolean enable){
		if (enable) {
			jt.setSelectionBackground(colorSelectedRowBackground);
			jt.setSelectionForeground(colorSelectedRowForeground);
			jt.setForeground(Gp.LABEL_FG_BLACK);
		} else {
			jt.setSelectionBackground(Gp.FILIGRANE_LGRAY);
			jt.setSelectionForeground(Gp.VERTFONCE_FG);
			jt.setForeground(Gp.FILIGRANE_LGRAY);
		}
		super.setEnabled(enable);
		isEnable=enable;
		sb.setEnabled(enable);
		jpListeTools.setEnabled(enable);
		jpPlus.setEnabled(enable);
		jt.setEnabled(enable);
		if (vue.jbImprimer!=null) {
			vue.jbImprimer.setEnabled(enable);
		}
		if (vue.jbF3!=null) {
			vue.jbF3.setEnabled(enable);
		}
	}
	public void setVisible(boolean enable){
		super.setVisible(enable);
	}
	public boolean isEnable(){
		return isEnable;
	}
	public void setForcedFocus(boolean forced){
		jt.setForcedFocus(forced);
	}
	public boolean getForcedFocus(){
		return jt.getForcedFocus();
	}
	public void incrListe(){
		if ((sql.t_nbLigne*sql.t_height)+sql.t_height<40){
			sql.t_nbLigne=sql.t_nbLigne+sql.t_height;
			resizeListe();
		}
	}
	public void decrListe(){
		if ((sql.t_nbLigne*sql.t_height)-sql.t_height>6) {
			sql.t_nbLigne=sql.t_nbLigne-sql.t_height;
			resizeListe();
		}
	}
	public void minListe(){
		sql.t_nbLigne=6/sql.t_height;
		resizeListe();
	}
	public void maxListe(){
		sql.t_nbLigne=40/sql.t_height;
		resizeListe();
	}
	public void resizeListe(){
		sb.setHeight((sql.t_nbLigne)*Gp.HEIGHTCHAR*sql.t_height);
		sbTable.setHeight((sql.t_nbLigne)*Gp.HEIGHTCHAR*sql.t_height);
		this.validate();
		load(Sql.t_LoadAllField);
		if (sql.t_F2!=null){
			sql.t_F2Popup.pack();
		}
	}

	private void like(){
		search();
		sql.v_indexEqualData(0);
		lsl.selectRow(colSelected);
		setScroolBarPos();
	}
	public void search(){
		sql.rsSeekByLike();{
			rsLoad();
		}
	}
	public boolean likeCb(){
		boolean ret=false;
		sql.rsSeekByLike();{
			if (sql.isRs()){
				ret=true;
			}
		}
		if (ret){
			search();
			sql.v_indexEqualData(0);
			lsl.selectRow(colSelected);
			setScroolBarPos();
		}
		return ret;
	}
	// BRANCHEMENT DES BOUTONS
	private void goPagenext() {
		if (jt.getSelectedRow()>=0){
			// Trouve le dernier index de la liste
			sql.v_index="";
			for (int index=0;index<sql.t_index.length;index++){
				sql.v_index=sql.v_index+(String) sql.datas.get(lm.getRowCount()-1)[sql.t_indexOrder[index]] ;
			}
			// Ne change de page que si on est pas sur la dernire page
			if (!sql.v_index.equals(sql.t_F2Fin)){
				sql.dBNextPageByIndex();
				load(Sql.t_LoadAllField);
				//Gp.afficherTrace(2,sql.t_Recno);
				loadTwin(Sql.t_LoadAllField);
			} else {
				if (jt.getSelectedRow()!=lm.getRowCount()-1){
					sql.dBBottomByIndex();
					load(Sql.t_LoadAllField);
					//Gp.afficherTrace(2,sql.t_Recno);
					loadTwin(Sql.t_LoadAllField);
				}
			}
		}
	}

	private void goPageup() {
		if (jt.getSelectedRow()>=0){
			// Trouve le premier index de la liste
			sql.v_index="";
			for (int index=0;index<sql.t_index.length;index++){
				sql.v_index=sql.v_index+(String) sql.datas.get(0)[sql.t_indexOrder[index]] ;
			}
		}
		//System.out.println(" goPageup "+sql.v_filtre);
		sql.dBUpPageByIndex();
		load(Sql.t_LoadAllField);
		loadTwin(Sql.t_LoadAllField);

	}

	public void goBottom() {
		sql.v_index=Sql.t_bottom;
		load(Sql.t_LoadAllField);
		loadTwin(Sql.t_LoadAllField);
	}

	public void goTop() {
		sql.v_index=Sql.t_top;
		load(Sql.t_LoadAllField);
		loadTwin(Sql.t_LoadAllField);
	}
	/*/////////////////////////
	// INTERFACE UTILISATEUR //
	/////////////////////////*/
	private void setScroolBarPos(){
		if (sql.v_index.equals(sql.t_F2Debut)) {
			sb.setValue(JSb.MIN);
		} else {
			if (sql.v_index.equals(sql.t_F2Fin)) {
				sb.setValue(JSb.MAX);
			} else {
				sb.setValue(JSb.MIL);
			}
		}
	}
	public void keyTyped(KeyEvent arg0) {}
	public void keyReleased(KeyEvent arg0) {}
	public void keyPressed(KeyEvent arg0) {
		if (jt.isEnabled()){
			if (arg0.isControlDown()){
				switch (arg0.getKeyCode()) {
					case KeyEvent.VK_M: focusOnTwin();arg0.consume(); break;
					case KeyEvent.VK_K: changeColor();arg0.consume(); break;
					case KeyEvent.VK_R: jpListeTools.searchActivate(true);arg0.consume(); break;
					default:
						break; }
			} else {
				switch (arg0.getKeyCode()) {
					case KeyEvent.VK_F1:
						jpListeTools.toggleVisibleAide();
						if (!isToolsVisible()){
							userPlus();
						}
						arg0.consume();
						break;
					case KeyEvent.VK_ENTER: 	exitAndReturnSel(null);arg0.consume(); break;
					case KeyEvent.VK_F2: 		exitAndReturnSel(null);arg0.consume(); break;
					case KeyEvent.VK_ESCAPE: 	exitAndAbortSel();arg0.consume(); break;
					case KeyEvent.VK_F3:
						if (sql.t_PLAGETIMES!=null){
							exitAndReturnSel(null);
						} else {
							vue.userF2F3();
						}
						arg0.consume(); 
						break;
					case KeyEvent.VK_F5: 		vue.userF5Print();arg0.consume(); break;
					case KeyEvent.VK_UP: 		precedent(1) ; arg0.consume(); break;
					case KeyEvent.VK_DOWN: 		suivant(1) ; arg0.consume(); break;
					case KeyEvent.VK_SPACE: 	suivant(1) ; arg0.consume(); break;
					case KeyEvent.VK_PAGE_UP: 	pagePrecedente();arg0.consume(); break;
					case KeyEvent.VK_PAGE_DOWN: pageSuivante();arg0.consume(); break;
					case KeyEvent.VK_END: 		dbFin();arg0.consume(); break;
					case KeyEvent.VK_INSERT: 	incrListe();arg0.consume(); break;
					case KeyEvent.VK_DELETE: 	decrListe();arg0.consume(); break;
					case KeyEvent.VK_HOME: 		debut();arg0.consume(); break;
					default:
						switch (arg0.getKeyChar()) {
							case '+':
								if (!isToolsVisible()){
									userPlus();
									arg0.consume();
								}
								break;
							case '-':
								if (isToolsVisible()){
									userPlus();
									arg0.consume();
								}
								break;
						}
						break; }
			}
		}
	}
	private void changeColor() {
		// TODO Auto-generated method stub
		if (sql.t_moduleIdF2Color.equals("color")){
			System.out.println("Couleur");
		}
	}
	public void propertyChange(PropertyChangeEvent arg0) {
		if (arg0.getPropertyName().equals(UserUpdate.UPDATE)){
			if (arg0.getSource()==jpListeTools){
				seekLike();
			}
			if (arg0.getSource()==jpPlus){
				userPlus();
			}
		}
		if (arg0.getPropertyName().equals(UserUpdate.RELOADTWIN)){
			lce.cancelCellEditing();
			userUpdateEdit(null);
			selectionChanged(colSelected);
		}
		if (arg0.getPropertyName().equals(UserUpdate.COL_LISTESELECTION)){
			lce.cancelCellEditing();
			colSelected=lsl.getColHasSelection();
			lsl.setUserAction(false);
			selectionChanged(colSelected);
			lsl.setUserAction(true);
		}
		if (arg0.getPropertyName().equals(UserUpdate.COL_LISTECELLRENDERER)){ 
			lce.cancelCellEditing();
			colSelected=lcr.getColHasFocus();
		}
		if (arg0.getPropertyName().equals(UserUpdate.COL_LISTECELLEDITOR)){
			lce.cancelCellEditing();
			colSelected=lce.getColHasEdit();
		}
		if (arg0.getPropertyName().equals(UserUpdate.CELLEDIT)){ 
			colSelected=lce.getColHasEdit();
			String nameField=lm.getName(colSelected);
			vue.userEnterLigne(nameField,jt.getValueAt(jt.getSelectedRow(),colSelected));
		}
		if (arg0.getPropertyName().equals(UserUpdate.PLUS_RIGHT)){
			chooseliste();
		}
	}
	private void chooseliste(){
		if (sql.isDevFile()){
			// TODO Auto-generated method stub
			// En cours de dev
			new JListChooser(this);
		}
	}
	public void exitAndReturnSel(String nameField){
		if (sql.t_F2!=null){  // c'est une liste d'un F2
			sql.t_Recno="";
			if (jt.getSelectedRow()>=0){
				sql.t_Recno=(String) sql.datas.get(jt.getSelectedRow())[sql.t_recnoCol];
			}
			this.vue.putClientProperty(JPopup.T_RETURN,sql.v_index);
		} else if (sql.t_PLAGETIMES!=null){  // c'est un Pointage
			this.vue.putClientProperty(JPopup.T_RETURN,vue.dbFiche.getReturnValue());
		}	else if (sql.t_F2==null) { // c'est une liste  l'ecran
			if (vue!=null){ //et une Liste twin d'une fiche
				if (jt.getSelectedRow()>=0){
					nameField=lm.getName(lce.getColHasEdit());  
					if (nameField==null){ // pas de cellule en dition donc enter sur la ligne
						if (lm.isFastListeEnable(lcr.getColHasFocus())){ // Enter sur une cellule fastedit
							nameField=lcr.getCellHasFocus();
						}
					}
				}
				// la cellule est Fastedit
				if (nameField!=null){ // Edite la cellule
					if(lce.isInEdit()){
						lce.cancelCellEditing();
					} else {
						jt.editCellAt(jt.getSelectedRow(),jt.getSelectedColumn());
					}
				} else { // Valid la ligne
					vue.userEnterLigne(null,null);
				}
			}
		}
	}
	public void exitAndAbortSel(){
		if (sql.t_F2!=null || sql.t_PLAGETIMES!=null){
			this.vue.putClientProperty(JPopup.ESCAPE, "ok");
		} else if (sql.t_F2==null){
			if (vue!=null){
				vue.userEscBascule();
			} 
		} 	

		//		if (sql.t_F2==null){
		//			if (vue!=null){
		//				vue.userEscBascule();
		//			} 
		//		} else {
		//			this.vue.putClientProperty(JPopup.ESCAPE, "ok");
		//		}
	}
	public void userF2F3() {
		vue.userF2F3();
	}
	public void userF5Print() {
		vue.userF5Print();
	}


	private void selectionChanged(int col){
		if (lsl.getRowHasSelection()>=0){
			jt.setRowSelectionInterval(lsl.getRowHasSelection(),lsl.getRowHasSelection());
			jt.changeSelection(lsl.getRowHasSelection(),col, false, false);
		}
		setScroolBarPos();
	}
	public void focusOnTwin() {
		if (sql.taTwin!=null){
			if (((JPanel)sql.taTwin).isVisible()){
				sql.taTwin.initFocus();
			}
		}
	}
	public void mouseWheelMoved(MouseWheelEvent arg0) {
		if (jt.isEnabled()){
			if (arg0.getWheelRotation()>0){
				suivant(arg0.getWheelRotation());
			} else { 
				precedent(arg0.getWheelRotation()*-1); 
			}
		}
	}

	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}
	public void mousePressed(MouseEvent arg0) {}
	public void mouseReleased(MouseEvent arg0) {}
	public void mouseClicked(MouseEvent arg0) {
		if (arg0.getSource()==jt){
			if ( SwingUtilities.isLeftMouseButton(arg0) ) { 
				if (jt.isEnabled()){
					if (arg0.getClickCount()==2){
						//int column=jt.columnAtPoint(arg0.getPoint());
						//if (lcr.isFastEdit(column)){
						//exitAndReturnSel(sql.fields.get(column).t_field);
						//} else {
						exitAndReturnSel(null);
						//}
					}
				}
			}
		} else if(arg0.getSource()==jt.getTableHeader()){
			if ( SwingUtilities.isRightMouseButton(arg0) ) {
				chooseliste();
			}
		}
	}
	public boolean isMovable(){
		return lsl.isMovable();
	}

	public void debut() {
		if (lsl.isMovable()){
			goTop();
			setScroolBarPos();
		}
	}
	public void dbFin() {
		if (lsl.isMovable()){
			goBottom();
			setScroolBarPos();
		}
	}
	public void pagePrecedente() {
		if (lsl.isMovable()){
			if (pageprecedente){
				pageprecedente=false;
				if (!sql.v_index.equals(sql.t_F2Debut)) {
					goPageup();
				}
				setScroolBarPos();
				pageprecedente=true;
			}
		}
	}
	public void pageSuivante() {
		if (lsl.isMovable()){
			if (pagesuivante){
				pagesuivante=false;
				if (!sql.v_index.equals(sql.t_F2Fin)){
					goPagenext();
				}
				setScroolBarPos();
				pagesuivante=true;
			}
		}
	}
	public void precedent(int nb) {
		if (lsl.isMovable()){
			if (precedent){
				if (nb>1){
					sql.setCursorWait(true);
				}
				precedent=false;
				if (!sql.v_index.equals(sql.t_F2Debut)){
					int selected=jt.getSelectedRow();
					if (selected-nb>=0)
						jt.setRowSelectionInterval(selected-nb,selected-nb);
					else {
						pagePrecedente();
						if (jt.getRowCount()>0)
							jt.setRowSelectionInterval(jt.getRowCount()-1,jt.getRowCount()-1);
					}
				}
				setScroolBarPos();
				precedent=true;
				if (nb>1){
					sql.setCursorWait(false);
				}
			}
		}
	}
	public void suivant(int nb) {
		if (lsl.isMovable()){
			if (suivant){
				if (nb>1){
					sql.setCursorWait(true);
				}
				suivant=false;
				if (!sql.v_index.equals(sql.t_F2Fin)){
					int selected=jt.getSelectedRow();
					if (selected+nb<=jt.getRowCount()-1)
						jt.setRowSelectionInterval(selected+nb,selected+nb);
					else 
						pageSuivante();
				}
				setScroolBarPos();
				suivant=true;
				if (nb>1){
					sql.setCursorWait(false);
				}
			}
		}
	}
	/*////////////////////////////////////
	// LIASON UTILISATEUR AUTRE FENETRE //
	////////////////////////////////////*/
	public void initFocus() {
		jt.requestFocusInWindow();
	}
	public void setResizeCol(int numCol){
		if (numCol>-1){
			TableColumn tc=jt.getTableHeader().getColumnModel().getColumn(numCol);
			int pixlenField=((sql.fields.get(numCol).t_fieldLength+2+5)*Gp.WIDTHCHAR);
			int pixlenLibe=tc.getMaxWidth();
			if (pixlenField>pixlenLibe){
				int newWidth=((sql.fields.get(numCol).t_fieldLength+2+3)*(Gp.WIDTHCHAR+0))+2;
				tc.setMinWidth(newWidth);
				tc.setMaxWidth(newWidth);
				tc.setPreferredWidth(newWidth);
			}
		}
	}

	public void seekLike(){
		if (lsl!=null){ // bug de la croix aprs saisie d'un critre de recherche
			if (lsl.isMovable()){
				sql.setCursorWait(true);
				sql.v_index=jpListeTools.getTextSeek().trim();
				like();
				loadTwin(Sql.t_LoadAllField);
				sql.setCursorWait(false);
			}
		}
	}
	/**
	 *  ATTENTION SURDEFINI
	 *  par {@link ListeRecno}
	 */
	public void loadTwin(int load){
		if (sql.taTwin!=null){
			if (load==Sql.t_LoadAllField){
				// Mise  Jour de la  fiche
				// revalorise t_varia avec le t_varia de la nouvelle selection de la liste
				//System.out.println("DbListe loadtwin "+sql.v_index); 
				sql.sqlTwin.v_index=sql.v_index;
				sql.taTwin.load(Sql.t_LoadAllField);
			}
		} 
	}
	public void loadTwin(String recno){
		if (sql.taTwin!=null){
			sql.taTwin.dbGoRecno(recno);
			loadTwinSUIL();
		}
	}
	private void loadTwinSUIL(){
	//	SwingUtilities.invokeLater(new Runnable() {
	//		public void run() {
				sql.taTwin.load(Sql.t_LoadRowid);
	//		} 
	//	});
	}
	public void dbGoRecno(String recno){
		sql.dBGoRecnoByRecno(recno);
	}
	public void loadSeek(String v_seek){
		sql.dBSeekByIndex(v_seek);
		if (sql.t_eof){
			// TODO Reste  dvelloper pas de ligne trouv afficher une ligne blanche/ remettre le code du F2  blanc ?????
		} else {
			load(sql.v_index);
		}
	}
	/*///////////////////////////
	// INTERFACE AUTRE FENETRE //
	///////////////////////////*/
	public void validateDebut(){
		load(Sql.t_F2DebutFin);
		load(Sql.t_LoadAllField);
		// Retire la zone de rechecherche si le nombre d'enregistrement
		// est infrieur au nombre de ligne de la liste
		// Valable pour la liste et le F2
		if (!sql.t_showSearch) { 
			if (isToolsVisible()) {
				userPlus();
			}
		}
	}
	public void validateAdapteListe() {}
	public void load(String v_index) {
		sql.v_index=v_index;
		load(Sql.t_LoadAllField);
	}
	public void load(int load) {
		switch (load){
			case Sql.t_LoadRowid:
				loadRowByRowId();
				break;
			case Sql.t_LoadAllField:
				loadPageSinceIndex();
				break;
			case Sql.t_F2DebutFin:
				sql.dbSetDebutFinByIndex();
				break;
		}
	}
	private void loadRowByRowId(){
		int row=lsl.getRowHasSelection();
		if (row>=0){
			colSelected=jt.getSelectedColumn();
			sql.rsSoftSeek();{
				sql.rsSetDatas(row);
			}
			for (int field=0;field<sql.datas.get(row).length-2;field++){
				jt.setValueAt((String) sql.datas.get(row)[field], row,field );
			}
			jt.setRowSelectionInterval(row,row);
			jt.changeSelection(row,colSelected, false, false);
		}
		setScroolBarPos();
	}
	private void loadPageSinceIndex(){
		if (sql.v_index.equals(Sql.t_bottom)){
			sql.dBBottomByIndex();
		} else {
			if (sql.v_index.equals(Sql.t_top)) {
				//sql.dBTopByIndex();
				sql.t_eof=true;
			} else {				
			}
		}
		if (sql.t_eof){		// CHARGE DEPUIS LE DEBUT DE FICHIER
			rsLoadPage();
			//valorise le t_varia sur la premiere ligne trouve
			sql.v_indexEqualData(0);
		} else {			//CHARGE LA LISTE EN RECULANT D'UN CRAN 
			if (! sql.v_index.equals(Sql.t_top) ) {
				sql.dBSkavantByIndex();
			}
			if (sql.t_eof ){ // PAS DE PRECEDENT CHARGE DEPUIS LA FICHE
				sql.dBSeekByIndex(sql.v_index);{
					rsLoadPage();
				}
				//valorise le t_varia sur la premiere ligne trouve
				sql.v_indexEqualData(0);
			} else { 		// UN PRECEDENT CHARGE DEPUIS LE PRECEDENT LA BONNE FICHE SE TROUVE EN NUMERO2
				// Trouve la ligne de la table egale au t_varia
			//	sql.dBGoRecnoByRecno(sql.t_Recno);{
					rsLoadPage();
			//	}
				//valorise le t_varia sur la premiere ligne trouve
				if (sql.datas.size()>1) {// Plusieurs ligne dans la liste choisi la Deuxime comme rfrence
					sql.v_indexEqualData(1);
					sql.t_Recno=sql.datas.get(1)[sql.t_recnoCol].toString();
				} else	{				// Reste sur la seule ligne de laliste
					sql.v_indexEqualData(0);
				}
			}
		}
		// la liste  t recharge
		// pose la selection et charge la ligne selectionner dans la fiche
		lsl.selectRow(colSelected);
		sql.t_seek=sql.v_index;
		setScroolBarPos();
	}
	/**
	 *  charge la liste avec le reste de la table depuis cette nouvelle ligne
	 */
	private void rsLoadPage(){
		sql.rsSoftSeek();{
			rsLoad();
		}
	}
	private void rsLoad() {
		sql.rsSetDatas();
		if (lm!=null){
			colSelected=jt.getSelectedColumn();
			lsl.setUserAction(false);
			lm.fireTableDataChanged();
			lsl.setUserAction(true);
			lsl.selectRow(colSelected);
		}
	}

	public void userUpdateEdit(Document jdct) {
		jdct=null;
		loadTwin(Sql.t_LoadAllField);
	}
	public void dispose() {
		jt=null;
		if (jpPlus!=null){
			jpPlus.removePropertyChangeListener(UserUpdate.UPDATE, this);
			jpPlus.dispose();
			jpPlus=null;
		}
		jDebug=null;
		jpEntete=null;
		jpDetail=null;
		if(jpListeTools!=null){
			jpListeTools.removePropertyChangeListener(UserUpdate.UPDATE, this);
			jpListeTools=null;
		}
		if  (jpGridTable!=null){
			jpGridTable.dispose();
			jpGridTable=null;
		}
		jpJTable=null;
		jpListe=null;
		if (sb!=null){
			sb.dispose();
			sb=null;
		}
		if (sbTable!=null){
			sbTable.dispose();
			sbTable=null;
		}
		if (lm!=null){
			lm.dispose();
			lm=null;
		}
		if (lsl!=null){
			lsl.removePropertyChangeListener(UserUpdate.COL_LISTESELECTION, this);
			lsl.removePropertyChangeListener(UserUpdate.RELOADTWIN, this);
			lsl.dispose();
			lsl=null;
		}
		if (lce!=null){
			lce.removePropertyChangeListener(UserUpdate.CELLEDIT, this);
			lce.removePropertyChangeListener(UserUpdate.COL_LISTECELLEDITOR, this);
			lce.dispose();
			lce=null;
		}
		if (hcr!=null){
			hcr.dispose();
			hcr=null;
		}
		if (lcr!=null){
			lcr.removePropertyChangeListener(UserUpdate.COL_LISTECELLRENDERER, this);
			lcr.dispose();
			lcr=null;
		}
		if (ms1204!=null){
			stopCb();
			ms1204=null;
		}

		sql=null;
		vue=null;
	}
	protected void finalize()  {
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
	///////////////////////////
	// Gestion du lecteur CB //
	///////////////////////////
	private AbstractMS1204 ms1204=null;
	public void setCbMS1204(AbstractMS1204 ms1204){
		this.ms1204=ms1204;
		if (ms1204!=null){
			jt.addFocusListener(this);
		}
	}

	public void focusGained(FocusEvent arg0) {
		startWaitCodeCb();
	}
	public void focusLost(FocusEvent arg0) {
		stopCb();
	}
	public boolean startWaitCodeCb(){
		boolean ret=true;
		if (ms1204!=null){
			if (lsl!=null){ // bug de la croix aprs saisie d'un critre de recherche
				if (lsl.isMovable()){
					if (vue.isCbEnable()){
						ms1204.setCbOn(false);
						new Thread(this).start();
					}
				}
			}
		}
		return ret;
	}
	public void run() {
		ms1204.waitCodeCb();
		while (ms1204.isWaitCodeCb()==true){
			try {  
				Thread.sleep(ms1204.getSleepSerial());
			} catch (InterruptedException arg0) { arg0.printStackTrace(); } 

		}
		// Fin du run  rception d'un code barre
		String codeCb=ms1204.readCodeCb();
		//System.out.println("ms1204 :"+codeCb);
		if (codeCb!=null){
			ms1204.setCbOff(false);
			sql.setCursorWait(true);
			vue.userCbSeek(codeCb);
			sql.setCursorWait(false);
		}
	}
	public void stopCb(){
		if (ms1204!=null){
			ms1204.stopWaitCodeCb();
			ms1204.setCbOff(false);
		}
	}
	/////////////////////////////////////
	// GESTION DE LA COULEUR DES LIGNES //
	/////////////////////////////////////
	private void adapteColor() {
		//SwingUtilities.invokeLater(new Runnable() {
		//	public void run() {
				setSlcol(sql.t_moduleIdF2Color);
		//	} 
		//});
	}
	private void setSlcol(String opt1){
		Sql sqlAbc=sql.getSqlAbc();
		if (sqlAbc.isTable("s_slcol")){
			ResultSet rsSlcol;
			String cle2="";
			String wari="";
			String colo="";
			String fond="";
			rsSlcol=sqlAbc.dBExecuteQueryOpen("SELECT c_cle2,c_wari,c_colo,c_fond FROM s_slcol WHERE c_code='"+opt1+"';");
			try {
				while (rsSlcol.next()){
					cle2=rsSlcol.getString("c_cle2");
					wari=rsSlcol.getString("c_wari");
					colo=rsSlcol.getString("c_colo");
					fond=rsSlcol.getString("c_fond");
					if (cle2.trim().length()!=0){
						setColorCond(cle2,wari,colo,fond);
					} else {
						setColorCol(wari,colo,fond);
					}
				}
			} catch (SQLException e) { e.printStackTrace(); }
			sqlAbc.dBExecuteQuerryClose(rsSlcol);
		}
	}
	private void setColorCond(String cle2,String wari, String colo, String fond) {
		Sql sqlAbc=new Sql(sql.getSqlAbc());
		String tmpcolo=sqlAbc.readStringValue("s_color", "c_code",colo,"c_colo");
		String tmpfond=sqlAbc.readStringValue("s_color", "c_code",fond,"c_colo");
		if (tmpcolo.length()>0){
			colo=tmpcolo;
		}
		if (tmpfond.length()>0){
			fond=tmpfond;
		}
		if (colo.length()>0){
			setRowForeground(wari, true,Color.decode(colo),cle2);
		}
		if (fond.length()>0){
			setRowBackground(wari, true,Color.decode(fond),cle2);
		}
	}
	private void setColorCol(String wari, String colo, String fond) {
		Sql sqlAbc=new Sql(sql.getSqlAbc());
		String tmpcolo=sqlAbc.readStringValue("s_color", "c_code",colo,"c_colo");
		String tmpfond=sqlAbc.readStringValue("s_color", "c_code",fond,"c_colo");
		if (tmpcolo.length()>0){
			colo=tmpcolo;
		}
		if (tmpfond.length()>0){
			fond=tmpfond;
		}
		if (colo.length()>0){
			setColForeground(wari, true,Color.decode(colo));
		}
		if (fond.length()>0){
			setColBackground(wari, true,Color.decode(fond));
		}
	}
}
