package template_applicatif.wListe;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;

import persistance.wGlobalParam.Gp;
import template_applicatif.wVue.VueIMoveListener;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JSb;
import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextDb;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public class ListeButtonTools extends JPanel implements VueIMoveListener, KeyListener, ActionListener, FocusListener, CaretListener, MouseListener  {
	private static final long serialVersionUID = 1L;
	private JTextDb jtxtseek=null;
	private JPanel jpOption=null;
	private JTextArea jlF1=null;
	private String fieldSeek="";
	private JSb jsb=null;
	private AbstractDbListe liste=null;
	private JTextButton jbF1=null;
	private JTextButton jbAide=null;
	private JPanel jpseek=null;
	private JTextButton jbseek=null;
	private UserUpdate userupdate=null;
	public ListeButtonTools(AbstractDbListe liste){
		this.liste=liste;
		this.userupdate=new UserUpdate(this);
		this.setLayout(new BorderLayout(0,0));{
			jsb=new JSb(this,JScrollBar.HORIZONTAL);{
				jsb.setWidth(Gp.WIDTHCHAR*9);
				// jsb.addMouseListener(this); Marche pas
			}
			jpseek= new JPanel();{
				jpseek.setLayout(new BorderLayout(0,0));
				jbseek=new JTextButton(" R "); {
					jbseek.setFocusable(false);
					jbseek.addActionListener(this);
					jbseek.setEnabled(false);
					jbseek.addMouseListener(this);
				}
				jtxtseek=new JTextDb(fieldSeek);{
					jtxtseek.addKeyListener(this);
					jtxtseek.addFocusListener(this);
					jtxtseek.addCaretListener(this);
					jtxtseek.setSuperText("Rechercher",0,JTextDb.RIGHT,JTextDb.CENTER,Gp.FILIGRANE_LGRAY);
					jtxtseek.addMouseListener(this);
				}
				jpseek.add(jbseek,BorderLayout.WEST);
				jpseek.add(jtxtseek,BorderLayout.CENTER);
			}
			jpOption= new JPanel();{
				jpOption.setLayout(new FlowLayout(0,0,0));
				jbF1=new JTextButton("F1"); {
					jbF1.setFocusable(false);
					jbF1.addActionListener(this);
				}
				jbAide=new JTextButton("Aide"); {
					jbAide.setVisible(false);
					//		
					jbAide.setFocusable(false);
					jbAide.setMnemonic('?');
					jbAide.addActionListener(this);
					jbAide.setImageIconPressed(liste.sql.getImage(liste.sql.getAppliParam().JBAIDE,true),true);
				}
				jpOption.add(jbAide);
			}
			jlF1 = new JTextArea();{
				jlF1.setText(
						"\n"+
						"  F2     : Ouvre Ferme Valide la liste  \n" +
						"  F10    : Ferme la fiche liste  \n" +
						"  Espace : avance, Ctrl+Fleche : dplace  \n" +
						"  Ctrl+M : bascule Fiche & Liste  \n" +
						"  Ctrl+R : Rechercher \n" +
						"  Insert : Augmente la taille de la liste  \n" +
						"  Suppr. : Diminue la taille de la liste  \n" +
						"  click  : sur une cellule jaune  \n" +
						"           passe en saisie rapide  \n" +
						"           Valider avant dplacement  \n" +
						" Sur la fiche click Droit  : Modifie le tooltip  \n" +
				"");
				jlF1.setWrapStyleWord(true);
				jlF1.setLineWrap(true);
				jlF1.setEnabled(false);
				jlF1.setBorder(BorderFactory.createLineBorder(Gp.LABEL_BORDER));
				jlF1.validate();
				jlF1.setVisible(false);
			}
			add(jsb,BorderLayout.WEST);
			add(jpseek,BorderLayout.CENTER);
			add(jpOption,BorderLayout.EAST);
			add(jlF1,BorderLayout.AFTER_LAST_LINE);
		}
	}
	public void toggleVisibleAide() {
		jlF1.setVisible(!jlF1.isVisible());
	}
	public void searchActivate(boolean enable){
		if (jtxtseek.isShowing()){
			jtxtseek.requestFocusInWindow();
		}
	}
	public String getTextSeek(){
		return jtxtseek.getText();
	}
	public int getHeightTextSeek() {
		return jtxtseek.getPreferredSize().height;
	}
	public void setEnabled(boolean enable){
		super.setEnabled(enable);
		for (int nbJc=0; nbJc<this.getComponentCount();nbJc++)
			this.getComponent(nbJc).setEnabled(enable);
	}
	public void setVisible(boolean enable){
		super.setVisible(enable);
		if (enable)
			liste.jpPlus.setMoins();
		else
			liste.jpPlus.setPlus();
	}
	public void setAideVisible(boolean enable) {
		jbAide.setVisible(enable);
	}

	public void addOption(JComponent jc){
		jpOption.remove(jbAide);
		jpOption.add(jc);
		jpOption.add(jbAide);
	}
	public boolean isMovable() {
		return liste.isMovable();
	}
	public void debut() {
		liste.minListe();
	}
	public void dbFin() {
		liste.maxListe();
	}
	public void pagePrecedente() {
		liste.decrListe();
	}
	public void pageSuivante() {
		liste.incrListe();
	}
	public void precedent(int nb) {
		liste.decrListe();
	}
	public void suivant(int nb) {
		liste.incrListe();
	}
	public void keyTyped(KeyEvent arg0) {}
	public void keyReleased(KeyEvent arg0) {}
	public void keyPressed(KeyEvent arg0) {
		if (liste.jt.isEnabled()){
			switch (arg0.getKeyCode()) {
				case KeyEvent.VK_ESCAPE:
					userEscape();
					arg0.consume(); 
					break;
				case KeyEvent.VK_ENTER:
					if (jbseek.isEnabled()){
						executeSeek();
					} else {
						userEnter();
					}
					arg0.consume(); 
					break;
				case KeyEvent.VK_F2: 
					userEnter();
					arg0.consume(); 
					break;
				case KeyEvent.VK_F3:
					liste.userF2F3();
					arg0.consume(); 
					break;
				case KeyEvent.VK_F5:
					liste.userF5Print();
					arg0.consume(); 
					break;
				default: break; }
		}
	}
	private void userEscape(){
		liste.exitAndAbortSel();
	}
	private void userEnter(){
		liste.exitAndReturnSel(null);
	}
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getActionCommand().contains(JTextButton.CLICK_RIGHT)){
			liste.userSetAide();
		} else
			if (arg0.getSource()==jbseek){
				executeSeek();
			} else if (arg0.getSource()==jbAide){
				liste.userAide();
			}
	}
	private void executeSeek(){
		if (liste.jt.isEnabled()){
			jbseek.setEnabled(false);
			userupdate.userUpdate();
		}

	}
	public void focusGained(FocusEvent e) {
		setJbseek(true);
	}
	public void focusLost(FocusEvent e) {
		setJbseek(false);
	}
	public void caretUpdate(CaretEvent e) {
		setJbseek(true);
	}
	private void setJbseek(boolean enable){
		if (liste.jt!=null){
			if (liste.jt.isEnabled()){
				jbseek.setEnabled(enable);
			}
		}
	}
	public void mousePressed(MouseEvent arg0) {}
	public void mouseReleased(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}
	public void mouseClicked(MouseEvent arg0) {
		if(SwingUtilities.isRightMouseButton(arg0)) {
			liste.userSetAide();
		} 
	}

}
