package template_applicatif.wListe;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.beans.PropertyChangeListener;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.border.Border;
import javax.swing.table.TableCellRenderer;

import persistance.wGlobalParam.Gp;
import persistance.wSql.Edit;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wComposant.JTimeDelay;
import composant_saisie.wSaisieFormat.Ccs;
import composant_saisie.wSaisieFormat.CcsFmt;
import composant_saisie.wSaisieFormat.Fma;
import composant_saisie.wSaisieFormat.UserIUpdate;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class ListeCellRenderer implements TableCellRenderer,UserIUpdate {
	private static final long serialVersionUID = 1L;
	private static final int STANDARD = 1;
	private static final int COULEUR = 2;
	private static final int SAISIE_RAPIDE = 3;
	private static final int COLOR = 4;
	private static final int SLCOL = 5;
	private int colorCells;
	private Sql sql=null;
	private JLabel jl=null;
	private JPanel jpcheck=null;
	private JCheckBox jcb=null; 
	private JRadioButton jrb=null; 
	private JTextDbF2 jtf2=null; 
	private JTextArea jtarea=null;
	private JTimeDelay jplagetime=null;
	private ListeFastEdit fastedit=null;
	private String cellHasFocus=null;
	private  ListeColorCol lcc=null;
	private int colHasFocus;
	private UserUpdate userupdate=null;
	public ListeCellRenderer(Sql sql){
		super();
		this.userupdate=new UserUpdate(UserUpdate.COL_LISTECELLRENDERER);
		this.sql=sql;
		this.lcc=new ListeColorCol();
		jl=new JLabel("");{
			jl.setOpaque(true);
			if (sql.t_height!=1){
				jl.setVerticalAlignment(SwingConstants.TOP);
			}
		}
		jrb=new JRadioButton();{
			jrb.setSelected(true);
		}
		jtf2=new JTextDbF2();{

		}
		jtarea=new JTextArea();{
			jtarea.setLineWrap(true);
			jtarea.setWrapStyleWord(true);
			jtarea.setEditable(false);
		}
		jpcheck=new JPanel(new BorderLayout(0,0));{
			jpcheck.setOpaque(true);
			jcb=new JCheckBox();{
				if (sql.t_height!=1){
					jcb.setVerticalAlignment(SwingConstants.TOP);
				}
			}
			jpcheck.add(jcb,BorderLayout.CENTER);
		}
		jplagetime=new JTimeDelay(sql,"","");
	}
	public void addPropertyChangeListener(String propertie,PropertyChangeListener pcl) {
		userupdate.addPropertyChangeListener(propertie,pcl);
	}
	public void removePropertyChangeListener(String propertie,PropertyChangeListener pcl) {
		userupdate.removePropertyChangeListener(propertie,pcl);
	}
	public Component getTableCellRendererComponent(JTable jt, Object cellule,boolean isSelected, boolean hasFocus, int row, int column) {
		this.fastedit=((ListeModele)jt.getModel()).getFastedit();
		JComponent ret=null;
		if (hasFocus ){
			cellHasFocus=sql.fields.get(column).t_field;
			colHasFocus=column;
			userupdate.userUpdate();
//			if (jt.getClientProperty(UserUpdate.COL_LISTECELLRENDERER).equals("basculeOn"))
//				jt.putClientProperty(UserUpdate.COL_LISTECELLRENDERER,"basculeOff" );
//			else
//				jt.putClientProperty(UserUpdate.COL_LISTECELLRENDERER,"basculeOn" );
		}

		// Renvoi le controle idoine
		Fma type=sql.fields.get(column).t_Fma;
		String Format=sql.fields.get(column).t_fieldFormat;
		String value="";
		switch (type){
		case RADIO:
			jcb.setText((String) cellule);
			ret=jcb;
			break;
		case TIMEDELAY:
			jplagetime.setTimeDelay((String) cellule);
			jl.setText(jplagetime.getSTimeDelay());
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			ret=jl;
			break;
		case CHECK: 
			jcb.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			String check=(String) cellule;
			if (check==null){
				jcb.setSelected(false);
			} else if (check.equals("0")){
				jcb.setSelected(false);
			} else { 
				jcb.setSelected(true);
			}
			ret=jpcheck;
			break;
		case NUM:
			jl.setFont(Gp.FONTNORMAL);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(CcsFmt.formatStrDecimal((String) cellule, Format, true)+" ");
			ret=jl;
			break;
		case NUMSPACE:
			jl.setFont(Gp.FONTNORMAL);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			value=CcsFmt.formatStrDecimal((String) cellule, Format, true);
			if (Gp.parseDouble(value)==0)
				jl.setText("");
			else	
				jl.setText(value+" ");
			ret=jl;
			break;
		case NUMGRAS:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(CcsFmt.formatStrDecimal((String) cellule, Format, true)+" ");
			ret=jl;
			break;
		case NUMGRASSPACE:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			value=CcsFmt.formatStrDecimal((String) cellule, Format, true);
			if (Gp.parseDouble(value)==0)
				jl.setText("");
			else	
				jl.setText(value+" ");
			ret=jl;
			break;
		case DATE:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(CcsFmt.formatStrDate((String) cellule,true)+" ");
			ret=jl;
			break;
		case MONTH:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(CcsFmt.formatStrMonth((String) cellule, true)+" ");
			ret=jl;
			break;
		case YEAR:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(CcsFmt.formatStrYear((String) cellule, true)+" ");
			ret=jl;
			break;
		case PLAGETIMES:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText((String) cellule+" ");
			ret=jl;
			break;
		case TIME:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(CcsFmt.formatStrTime((String) cellule, true)+" ");
			ret=jl;
			break;
		case SECU:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(CcsFmt.formatStrSecu((String) cellule, true)+" ");
			ret=jl;
			break;
		case URSS:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(CcsFmt.formatStrUrss((String) cellule, true)+" ");
			ret=jl;
			break;
		case POSTAL:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(CcsFmt.formatStrPostal((String) cellule, true)+" ");
			ret=jl;
			break;
		case PHONE:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(CcsFmt.formatStrPhone((String) cellule, true)+" ");
			ret=jl;
			break;
		case INTERO:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(((String) cellule));
			ret=jl;
			break;
		case F2:
			jtf2.setSize(jtf2.getWidth()-(jl.getHeight()), jl.getHeight());
			jtf2.revalidate();
			jtf2.setFont(Gp.FONTTEXT12);
			jtf2.setBorder(null);
			jtf2.setValueFromChild(" "+((String) cellule));
			ret=jtf2;
			break;
		case GRAS:
			jl.setFont(Gp.FONTTEXT12);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(" "+((String) cellule));
			ret=jl;
			break;
		case NORMAL:
			jl.setFont(Gp.FONTNORMAL);
			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(" "+((String) cellule));
			ret=jl;
			break;
		case LIBEMAX:
			jtarea.setFont(Gp.FONTTEXT12);
			jtarea.setText(((String) cellule));
			ret=jtarea;
			break;
		case INVISIBLE:
		case CACHE:
		case FIELD:
		default :{
			if (column==0)
				jl.setFont(Gp.FONTTEXT12);
			else
				jl.setFont(Gp.FONTNORMAL);

			jl.setHorizontalAlignment(Ccs.getHorizontalAlignement(type));
			jl.setText(" "+((String) cellule));
			ret=jl;
			break;}
		}

		// POLICE
		ret.setFont(Gp.FONTTEXT12);

		// BORDER
		ret.setBorder(getBorderSel(column, jt,isSelected));

		// COULEUR
		colorCells=STANDARD;
		if (!fastedit.isEmpty()){
			colorCells=SAISIE_RAPIDE;
		}
		if (lcc.isColor()){
			colorCells=COULEUR;
		}
		if (sql.t_moduleIdF2Color.equals("color")){
			colorCells=COLOR;
		}
		if  (sql.t_moduleIdF2Color.equals("slcol")){
			colorCells=SLCOL;
		}

		switch (colorCells){
		case STANDARD:
			ret.setBorder(null);
			if (isSelected ){
				ret.setBackground(jt.getSelectionBackground());
				ret.setForeground(jt.getSelectionForeground());
			} else {	
				ret.setForeground(jt.getForeground());
				ret.setBackground(getEntrelacedBackground(row,jt));
			}
			break;
		case SAISIE_RAPIDE:
			ret.setForeground(jt.getForeground());
			ret.setBackground(getEntrelacedBackground(row,jt));
			if (fastedit.isFastListe(column)){
				if (fastedit.getTypeEdit(column).equals(Edit.CHECK)){
					jpcheck.setBackground(Gp.UPDATE_BG_JAUNE);
					jcb.setBackground(Gp.UPDATE_BG_JAUNE);
					if (isSelected){
						jcb.setForeground(jcb.getForeground());
					}
				} else {
					ret.setBackground(Gp.UPDATE_BG_JAUNE);
					if (isSelected){
						ret.setForeground(jt.getForeground());
					}
				}
			}		
			break;
		case COULEUR:
			ret.setForeground(jt.getForeground());
			ret.setBackground(getEntrelacedBackground(row,jt));

			// Gestion des couleurs de cellules de colonnes et de lignes
			Color color=null;
			// Couleur de colonne
			if (lcc.isColFg()){
				color=lcc.getColForeground(column);
				if (color!=null) {
					ret.setForeground(color);
				}
			}
			if (lcc.isColBg()){
				color=lcc.getColBackground(column);
				if (color!=null) {
					ret.setBackground(color);
				} else {
					ret.setBackground(getEntrelacedBackground(row,jt));
				}
			}

			// Couleur de ligne
			if (lcc.isRowFg()){
				color=lcc.getRowForeground(sql.datas.get(row));
				if(color!=null){
					ret.setForeground(color);
				}
			}
			if (lcc.isRowBg()){
				color=lcc.getRowBackground(sql.datas.get(row));
				if(color!=null){
					ret.setBackground(color);
				} else {
					ret.setBackground(getEntrelacedBackground(row,jt));
				}
			}

			break;
		case COLOR:
			// COULEUR
			setColorBackground(jl,row,0);
			if (jl.getBackground().equals(jl.getForeground())){
				jl.setForeground(Gp.VERTFONCE_FG);
			}
			break;
		case SLCOL:
			ret.setForeground(jt.getForeground());
			ret.setBackground(getEntrelacedBackground(row,jt));
			
			setColorForeground(jl,row,3);
			setColorBackground(jl,row,4);
			if (jl.getBackground().equals(jl.getForeground())){
				jl.setForeground(Gp.VERTFONCE_FG);
			}
			break;
		}
		//	ret.setFont(Gp.FONTTEXT12);


		///////////////////////////////////////////
		// Spcial CONTROL contenu dans un panel //
		///////////////////////////////////////////
		if  (sql.fields.get(column).t_Fma==Fma.CHECK){
			jcb.setBackground(ret.getBackground());
		}
		return ret;
	}
	private void setColorBackground(JComponent jc, int row, int column){
		String colo=sql.readStringValue("s_color", "c_code",sql.datas.get(row)[column].toString(),"c_colo");
		if (colo.length()>0){
			jc.setBackground(Color.decode(colo));
		}
	}
	private void setColorForeground(JComponent jc, int row, int column){
		String colo=sql.readStringValue("s_color", "c_code",sql.datas.get(row)[column].toString(),"c_colo");
		if (colo.length()>0){
			jc.setForeground(Color.decode(colo));
		}
	}
	private Color getEntrelacedBackground(int row, JTable jt){
		int i=row*10;
		i=i/2;
		int j=row;
		j=j/2;
		j=j*10;
		if (i==j){
			return Gp.MOVE_BG_LVERT;
		} else {
			return jt.getBackground();
		}
	}
	private Border getBorderSel(int column, JTable jt, boolean isSelected){
		Border ret=null;
		if (isSelected){
			int i=0;
			if (column==0){
				i=0;
			} else if (jt.getTableHeader().getColumnModel().getColumnCount()-1==column){
				i=2;
			} else {
				i=1;
			}
			switch (i){
			case 0:
				ret=BorderFactory.createMatteBorder(1, 1, 1, 0, Gp.LABEL_FG_BLACK);
				break;
			case 1:
				ret=BorderFactory.createMatteBorder(1, 0, 1, 0, Gp.LABEL_FG_BLACK);
				break;
			case 2:
				ret=BorderFactory.createMatteBorder(1, 0, 1, 1, Gp.LABEL_FG_BLACK);
				break;
			}
		}
		return ret;
	}
	public void dispose() {
		jl=null;
		jpcheck=null;
		jcb=null; 
		jrb=null; 
		jtf2=null; 
		jtarea=null;
		userupdate=null;
		if (jplagetime!=null){
			jplagetime.dispose();
			jplagetime=null;
		}
		if (lcc!=null){
			lcc.dispose();
			lcc=null;
		}
		if (fastedit!=null){
			fastedit.dispose();
			fastedit=null;
		}
		sql=null;
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+getClass().getSimpleName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
	public void setColBackground(int numcol, boolean background, Color color) {
		lcc.setColBackground(numcol, background, color);
	}
	public void setColForeground(int numcol, boolean foreground, Color color) {
		lcc.setColForeground(numcol, foreground, color);
	}
	public void setRowForeground(int numcol, boolean foreground, Color color, String value) {
		lcc.setRowForeground(numcol, foreground,color,value);
	}
	public void setRowBackground(int numcol, boolean foreground, Color color,String value) {
		lcc.setRowBackground(numcol, foreground,color,value);
	}
	public int getColHasFocus() {
		return colHasFocus;
	}
	public String getCellHasFocus() {
		return cellHasFocus;
	}
}
