package template_applicatif.wListe;

import javax.swing.JComponent;
import javax.swing.table.AbstractTableModel;

import persistance.wSql.Edit;
import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextDbF2;
import composant_saisie.wSaisieFormat.Fma;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class ListeModele extends AbstractTableModel implements ListeIEditableColumn {
	private static final long serialVersionUID = 1L;
	private Sql sql;
	private ListeFastEdit fastedit=null;
	public ListeModele(Sql sql ) {
		this.sql=sql;
		this.fastedit=new ListeFastEdit(sql);
	}
	public int getColumnCount() {
		return sql.fields.size();
	}
	public Object getValueAt(int row, int col) {
		return sql.datas.get(row)[col];
	}
	public int getRowCount() {
		int ret=-1;
		if (sql!=null){
			if (sql.datas!=null){
				ret=sql.datas.size();
			}
		}
		return ret;
	}
	public String getColumnName(int col){
		return sql.fields.get(col).t_lib;
	}
	public boolean isCellEditable(int row, int col) {
		boolean ret=false;
		if (isFastListeEnable(col)){
			ret=true;
		}
		return ret;
	}
	public void setValueAt(Object obj, int row, int col){
		sql.datas.get(row)[col]=(String) obj;
		fireTableDataChanged();
	}
	public void addEditableColumn(JComponent jc) {
		fastedit.addEditableColumn(jc);
		if (jc.getClass()==JTextDbF2.class){
			setTypeF2(jc);
			setResizeF2Col(jc);
		}
	}
	private void setTypeF2(JComponent jc){
		for (int i=0;i<sql.fields.size();i++){
			if (jc.getName().equals(sql.fields.get(i).t_field)){
				sql.fields.get(i).t_Fma=Fma.F2;
				break;
			}
		}
	}
	private void setResizeF2Col(JComponent jc){
		int numCol=-1;
		for (int i=0;i<sql.fields.size();i++){
			if (jc.getName().equals(sql.fields.get(i).t_field)){
				numCol=i;
				break;
			}
		}
		if (numCol>-1){
			((AbstractDbListe) sql.taThis).setResizeCol(numCol);
		}
	}
	// Liste de JC en FASTEDIT
	public boolean isFastListe(int column){
		return fastedit.isFastListe(column);
	}
	public boolean isFastListeEnable(int column){
		return fastedit.isFastListeEnable(column);
	}
	public String getName(int column) {
		return fastedit.getName(column);
	}
	public int size() {
		return fastedit.size();
	}
	public Edit getType(int column) {
		return fastedit.getTypeEdit(column);
	}
	public JComponent getComponent(int column) {
		return fastedit.getComponent(column);
	}
	public void enableEditableColumn(String name, boolean enable) {
		fastedit.enableEditableColumn(name, enable);
	}
	public void removeEditableColumn(String name) {
		fastedit.removeEditableColumn(name);
	}
	public ListeFastEdit getFastedit() {
		return fastedit;
	}
	public void dispose() {
		if (fastedit!=null){
			fastedit.dispose();
			fastedit=null;
		}
		sql=null;
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+"ListModele");
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}




