package template_applicatif.wListe;

import java.beans.PropertyChangeListener;

import javax.swing.DefaultListSelectionModel;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import persistance.wSql.Sql;
import a_doc.doc.Licence;

import composant_saisie.wSaisieFormat.UserIUpdate;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class ListeSelectionListener extends DefaultListSelectionModel implements ListSelectionListener,UserIUpdate {
	private static final long serialVersionUID = 1L;
	private Sql sql=null;
	private boolean userAction=true;
	private int rowHasSelection=-1;
	private int colHasSelection=-1;
	private JTable jt=null;
	private UserUpdate userupdate=null;
	private UserUpdate userupdate2=null;
	public ListeSelectionListener(Sql sql,JTable jt) {
		this.sql=sql;
		this.jt=jt;
		this.userupdate=new UserUpdate(UserUpdate.COL_LISTESELECTION);
		this.userupdate2=new UserUpdate(UserUpdate.RELOADTWIN);
		jt.setRowSelectionAllowed(true);
		jt.setColumnSelectionAllowed(false);
		jt.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jt.getSelectionModel().addListSelectionListener(this);
	}

	public boolean isMovable(){
		boolean ret=false;
		if (sql.taTwin!=null){
			ret=sql.sqlTwin.isModeMovable();
		} else {
			ret=true;
		}
		return ret;
	}

	public void selectRow(int column){
		// Selection d'une seule ligne
		rowHasSelection=-1;
		colHasSelection=column;
		// Gestion de la Selection d'une Ligne en fonction de t_varia
		// Parcours les ligne de la liste 
		for (int ligne=0;ligne<jt.getModel().getRowCount() && rowHasSelection==-1;ligne++){
			int ficheOK=1;
			String index="";
			for(int i=0;i<sql.t_index.length;i++)
				index=index+sql.datas.get(ligne)[sql.t_indexOrder[i]];
			if (!sql.v_index.equals(index))
				ficheOK=0;

			if (ficheOK==1)
				rowHasSelection=ligne;
		}
		if (rowHasSelection>=0){
			jt.changeSelection(rowHasSelection,colHasSelection, false, false);
		}
	}

	public void addPropertyChangeListener(String propertie,PropertyChangeListener pcl) {
		if (propertie.equals(UserUpdate.COL_LISTESELECTION)) {
			userupdate.addPropertyChangeListener(propertie,pcl);
		} else {
			userupdate2.addPropertyChangeListener(propertie,pcl);
		}
	}
	public void removePropertyChangeListener(String propertie,PropertyChangeListener pcl) {
		if (propertie.equals(UserUpdate.COL_LISTESELECTION)) {
			userupdate.removePropertyChangeListener(propertie,pcl);
		} else {
			userupdate2.removePropertyChangeListener(propertie,pcl);
		}
	}
	public void valueChanged(ListSelectionEvent e) {
		//System.out.println("Liste Selection listener "+e.getFirstIndex()+":"+e.getLastIndex());
		if (userAction){
			if (rowHasSelection!=jt.getSelectedRow() ){
				if (isMovable()){
					// Enregistre la position de la nouvelle selection
					rowHasSelection=jt.getSelectedRow();

					if(rowHasSelection>=0){
						// Revalorise la cl d'index de la liste
						String index="";
						for (int i=0;i<sql.t_index.length;i++){
							index=index+(String) sql.datas.get(rowHasSelection)[sql.t_indexOrder[i]];
						}
						sql.v_index=index;
						sql.t_Recno=(String) sql.datas.get(rowHasSelection)[sql.t_recnoCol];

					} else {
						// Perte de la selection
						sql.v_index="";
						sql.t_Recno="";
					}
					userupdate2.userUpdate();
				} else {
					userupdate.userUpdate();
				}
			}
		}
	}
	public void setUserAction(boolean enable) {
		userAction=enable;
	}

	public int getColHasSelection() {
		return colHasSelection;
	}
	public int getRowHasSelection() {
		return rowHasSelection;
	}
	public void dispose() {
		userupdate=null;
		userupdate2=null;
		if (jt!=null){
			jt.getSelectionModel().removeListSelectionListener(this);
			jt=null;
		}
		sql=null;
	}
	protected void finalize()  {
		//		Gp.af("finalize : "+"ListSelectionListe");
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}

}
