package template_applicatif.wVue;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.border.TitledBorder;

import module_standard.wImprime.JDialogPrint;
import module_standard.wImprime.JPEntete;
import persistance.wGlobalParam.AbstractDefaultParam;
import persistance.wGlobalParam.Gp;
import persistance.wSql.AbstractFieldsDef;
import persistance.wSql.Field;
import persistance.wSql.Sql;
import template_applicatif.wFiche.AbstractDbFiche;
import template_applicatif.wFiche.FicheIEditableColumns;
import template_applicatif.wListe.AbstractDbListe;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JPopup;
import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextLabel;
import composant_saisie.wPtime.TimeDelay;
import composant_saisie.wSaisieFormat.Fma;
import composant_saisie.wSaisieFormat.UserUpdate;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
 */
public abstract class AbstractVue extends JPanel implements VueIBascule,ActionListener,VueIJoin,VueIEnter, PropertyChangeListener {
	private static final long serialVersionUID = 1L;
	public Sql sql=null;
	/**
	 * Notifieur de modification USER
	 */
	UserUpdate userupdate=null;
	public String t_seek=null;
	public String c_opt2=null;
	public String c_opt3=null;
	AbstractFieldsDef liste=null;
	AbstractFieldsDef fiche=null;
	public FicheIEditableColumns ffe=null;
	public Sql sqlListe=null;
	public Sql sqlFiche=null;
	public AbstractDbListe dbListe=null;
	public AbstractDbFiche dbFiche=null;
	public AbstractVue vueParent=null;
	public Vue vue;
	/**
	 * Cration de l'UI LISTE  partir de la table
	 * @return
	 */
	public abstract AbstractDbListe getDbListe();
	/**
	 * Cration de l'UI FICHE  partir de la table
	 * @return
	 */
	public abstract AbstractDbFiche getDbFiche(Vue vue);
	/**
	 * Cration de la liste des champs de la Fiche
	 * @param vue
	 * @return 
	 */
	public abstract AbstractFieldsDef getFieldsDefEcran(Vue vue);
	/**
	 * Cration de la liste des champs de la Liste
	 * @param vue
	 * @return 
	 */
	public abstract AbstractFieldsDef getFieldsDefListe(Vue vue);
	/**
	 * Cration de la liste des champs de l'impression
	 * @param vue
	 * @return lui-meme pour contruire l'identifiant de l'aide
	 */
	public abstract AbstractFieldsDef getFieldsDefPrint(Vue vue);
	/**
	 * Cration de la liste des champs de rupture pour l'impression
	 * @param vue
	 * @return lui-meme pour contruire l'identifiant de l'aide
	 */
	public abstract AbstractFieldsDef getFieldsDefRupture(Vue vue);
	/**
	 * Ajout des jointures 
	 */
	public abstract void adapteJoin(Sql sql);
	//
	public JTextButton jbEscBascule=null;	
	public JTextButton jbEnterLigne=null;	
	public JTextButton jbF3=null;	
	public JTextButton jbImprimer=null;
	public JTextButton jbCloseClear=null;
	String enteteEditionBorne="";
	//
	public JPanel jpTitre=null;
	boolean defaultBasculeChild=false;
	//
	JTextLabel jlTitreDetail=null;
	JPanel jpDetail=null;
	// Dev
	public TimeDelay td;
	boolean traceDelay=false;
	public AbstractVue(Sql sql, String t_seek, Vue vue,String c_opt2,String c_opt3) {
		this.c_opt2=c_opt2;
		this.c_opt3=c_opt3;
		initStart();
		createModule(sql,t_seek,vue);
	}
	public AbstractVue(Sql sql, String t_seek, Vue vue,String c_opt2) {
		this.c_opt2=c_opt2;
		this.c_opt3="";
		initStart();
		createModule(sql,t_seek,vue);
	}
	public AbstractVue(Sql sql, String t_seek, Vue vue) {
		this.c_opt2="";
		this.c_opt3="";
		initStart();
		createModule(sql,t_seek,vue);
	}
	/**
	 * Dispo dev
	 */
	public void initStart(){}
	/**
	 * Cr le module
	 * @param sql
	 * @param t_seek
	 * @param vue
	 */
	private void createModule(Sql sql, String t_seek, Vue vue){
		
		this.userupdate=new UserUpdate(this);
		td=new TimeDelay(vue+" "+sql.t_table,traceDelay);
		td.trace("1");
		
		this.setName(this.getClass().getSimpleName());
		this.sql=sql;
		this.t_seek=t_seek;
		this.vue=vue;
		this.setLayout(Gp.adaptePanelP()); 
		this.setFocusable(false);
		initModule();
		adapteLowLevel();
		adapteGUI();
		validateDebut();
		td.close();
	}
	///////////////////
	// Instanciation // 
	///////////////////
	private void initModule(){
		initTitre();
		initListe();
		initFiche();
	}
	private void adapteLowLevel(){
		adapteLowLevelDouble();
		adapteLowLevelSingle();
	}
	private void adapteGUI(){
		addTitre();
		addListe();
		addFiche();
		this.setOpaque(false);
	}
	private void validateDebut(){
		if (jpTitre!=null && sql.getGp().equals(sql.getGpAbc())){
			jpTitre.setBackground(Gp.MOVE_BG_LRED);
		}
		if (dbFiche!=null){
			validateAdapteFiche();
		}
		if (dbListe!=null){
			validateAdapteListe();
		}
		validateAdapte();
	}

	//////////////////////////
	// Module Instanciation // 
	//////////////////////////
	private void initTitre(){
		switch (vue){
			case F3:
			case FICHEDETAIL:
				jpTitre=sql.getPanelTitleMenuOptionText();
				break;
		}
	}
	private void initListe(){
		switch (vue){
			case F3DETAIL:
			case F3DETAILHIDDEN:
			case F3HIGHTDETAIL:
			case F3:
			case F3POINTAGE:
			case F2RECHERCHER:
			case F2F3:
			case F2:
			case F2UNIQUE1:
			case F2UNIQUE2:
				sqlListe=new Sql(sql,t_seek,vue);{
					liste=getFieldsDefListe(vue);{
						if (liste==null){ System.out.println("getFieldsListeDef() renvoi null, revoir le code du fichier appel"); }
						if (sql.isDevFile()){
							adapteListeDEVAppendFieldFiche();
						}
						liste.adapteFields();
						dbListe = getDbListe();{
							dbListe.vue=this;
							dbListe.adapteAide();
						}
					}
				}
				break;
		}
	}
	private void initFiche(){
		switch (vue){
			case FICHEDEA:
			case F3DETAIL:
			case F3DETAILHIDDEN:
			case F3HIGHTDETAIL:
			case F3:
			case F3POINTAGE:
			case F2RECHERCHER:
			case F2F3:
			case FICHE:
			case FICHEDETAIL:
				sqlFiche=new Sql(sql,t_seek,vue);{
					fiche=getFieldsDefEcran(vue);{
						if (fiche==null) { System.out.println("getFieldsDefEcran(Vue vue) renvoi null, revoir le code du fichier appel"); } 
						if (Gp.TOOLTIP){
							if (vue==Vue.FICHEDEA||vue==Vue.FICHEDETAIL||vue==Vue.FICHE){
							} else {
								loadFicheTooltipDb();
							}
						}
						fiche.adapteFields();
						dbFiche=getDbFiche(vue);{
							dbFiche.vue=this;
							dbFiche.adapteAide();
							addEnterLigne(dbFiche);
						}
					}
				}
				autoUpdateTables();
				break;
		}
	}
	private void adapteListeDEVAppendFieldFiche(){
		AbstractFieldsDef tmpliste=getFieldsDefEcran(Vue.F3);
		Field tmpfield=null;
		for (int i=0;i<tmpliste.fieldsdef.size();i++){
			tmpfield=tmpliste.fieldsdef.get(i);
			if (!liste.isContainsField(tmpfield.t_field)){
				tmpfield.t_Fma=Fma.CACHE;
				liste.addSqlField(tmpfield);
			}
		}
	}
	/**
	 * Rcupere les tools-tips utilisateur
	 */
	private void loadFicheTooltipDb() {
		ResultSet rs=sqlFiche.getSqlAbc().dBExecuteQueryOpen("SELECT c_fiel,c_aide FROM s_field WHERE c_tvue='"+vue+"' AND c_code='"+sqlFiche.t_table+"';");
		try {
			String fiel="";
			String aide="";
			while (rs.next()){
				fiel=rs.getString("c_fiel");
				aide=rs.getString("c_aide");
				for (int i=0;i<fiche.fieldsdef.size();i++){
					if (fiche.fieldsdef.get(i).t_field.equals(fiel)){
						if (aide.trim().length()>0){
							fiche.fieldsdef.get(i).t_libHelp=""+aide;
						}
						break;
					}
				}
			}
		} catch (SQLException e) {e.printStackTrace();}
		sqlFiche.dBExecuteQuerryClose(rs);
	}
	/**
	 *  VERIFICATION ET CREATION A LA VOLEE DES TABLE
	 */
	private void autoUpdateTables() {
		if (sql.isDevFile()){
			if (!fiche.sql.isTableExist()){
				switch (vue){
					case F3POINTAGE:
					case F3DETAIL:
					case F3HIGHTDETAIL:
					case F3DETAILHIDDEN:
						// Recharge la liste de champs standard
						fiche=getFieldsDefEcran(Vue.F3);
						fiche.adapteFields();
						break;
				}
				fiche.sql.createTable(true);
				switch (vue){
					case F3POINTAGE:
					case F3DETAIL:
					case F3HIGHTDETAIL:
					case F3DETAILHIDDEN:
						// Recharge la liste de champs standard
						fiche=getFieldsDefEcran(vue);
						fiche.adapteFields();
						break;
				}
			}
			fiche.sql.alterNewTableField(true);
		}
		autoUpdateTable();
	}
	/**
	 *  Permet d'effectuer un traitement sur la table <br>
	 *  avant utilisation de cette table <br>
	 *  Attention pas d'affichage<br>
	 */
	protected void autoUpdateTable() {}
	private void adapteLowLevelDouble(){
		switch (vue){
			case F2RECHERCHER:
				mapTwin();
				dbListe.setToolsVisible(true);{
					jbF3=new JTextButton("F3");{
						jbF3.setMnemonic(java.awt.event.KeyEvent.VK_F3);
						jbF3.setPreferredSize(new Dimension(dbListe.getHeightTextSeek(),dbListe.getHeightTextSeek()));
						jbF3.addActionListener(this);
						dbListe.addOption(jbF3);
					}
					dbListe.jpListe.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Gp.LABEL_FG_BLACK));
					dbListe.validateAdapteListe();
				}
				dbFiche.setVisible(true);{
					dbFiche.addMouseListener(dbListe);
					dbFiche.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Gp.LABEL_FG_BLACK));
					dbFiche.setFicheLibelle();
				}
				vueParent=this;
				dbFiche.sql.taParent=sql.taThis;
				dbListe.sql.taParent=sql.taThis;
				dbListe.initFocus();
				break;
			case F2F3:
				mapTwin();
				dbListe.setToolsVisible(true);{
					jbF3=new JTextButton("F3");{
						jbF3.setMnemonic(java.awt.event.KeyEvent.VK_F3);
						jbF3.setPreferredSize(new Dimension(dbListe.getHeightTextSeek(),dbListe.getHeightTextSeek()));
						jbF3.addActionListener(this);
						dbListe.addOption(jbF3);
					}
					dbListe.jpListe.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Gp.LABEL_FG_BLACK));
					dbListe.validateDebut();
				}
				dbFiche.setVisible(false);{
					dbFiche.addMouseListener(dbListe);
					dbFiche.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Gp.LABEL_FG_BLACK));
					dbFiche.validateDebut();
				}
				dbFiche.sql.taParent=sql.taThis;
				dbListe.sql.taParent=sql.taThis;
				dbListe.initFocus();
				break;
			case F3:
				mapTwin();
				addImprimer();
				dbListe.setTitleFiche();
				dbListe.setBorder(null);
				dbListe.validateDebut();
				dbFiche.validateDebut();
				dbListe.loadTwin(Sql.t_LoadAllField);
				dbListe.initFocus();
				break;
			case F3DETAIL:
				mapTwin();
				jbF3=new JTextButton("F3",KeyEvent.VK_F3);{
					jbF3.setPreferredSize(new Dimension(dbListe.getHeightTextSeek(),dbListe.getHeightTextSeek()));
					jbF3.addActionListener(this);
					dbFiche.add(jbF3,BorderLayout.EAST);
					jbF3.setEnabled(false);
				}
				dbListe.validateDebut();
				dbFiche.validateDebut();
				dbListe.loadTwin(Sql.t_LoadAllField);
				dbFiche.setVisible(false);
				dbFiche.setBorder(null);
				dbListe.initFocus();
				break;
			case F3DETAILHIDDEN:
				mapTwin();
				jbF3=new JTextButton("F3",KeyEvent.VK_F3);{
					jbF3.setPreferredSize(new Dimension(dbListe.getHeightTextSeek(),dbListe.getHeightTextSeek()));
					jbF3.addActionListener(this);
					dbFiche.add(jbF3,BorderLayout.EAST);
					jbF3.setEnabled(false);
				}
				dbListe.validateDebut();
				dbFiche.validateDebut();
				dbListe.loadTwin(Sql.t_LoadAllField);
				dbFiche.setVisible(false);
				dbListe.setVisible(false);
				dbFiche.setBorder(null);
				dbListe.initFocus();
				break;
			case F3HIGHTDETAIL:
				mapTwin();
				dbListe.validateDebut();
				dbFiche.validateDebut();
				dbListe.loadTwin(Sql.t_LoadAllField);
				dbFiche.setVisible(false);
				dbFiche.setBorder(null);
				dbListe.initFocus();
				break;
			case F3POINTAGE:
				mapTwin();
				dbFiche.setCrudVertical();
				dbListe.validateDebut();
				dbFiche.validateDebut();
				dbListe.loadTwin(Sql.t_LoadAllField);
				this.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Gp.LABEL_FG_BLACK));
				break;
		}		
	}
	private void mapTwin(){
		sqlFiche.taTwin=dbListe;
		sqlFiche.sqlTwin=sqlListe;
		sqlListe.taTwin=dbFiche;
		sqlListe.sqlTwin=sqlFiche;
	}
	private void adapteLowLevelSingle(){
		switch (vue){
			case F2:
			case F2UNIQUE1:
			case F2UNIQUE2:
				this.setBorder(Gp.getBorder(BorderFactory.createRaisedBevelBorder(),Gp.LABEL_FG_BLACK));
				dbListe.validateAdapteListe();
				break;
			case FICHEDEA:
				dbFiche.setBorder(null);
				dbFiche.jpDbE.setBorder(null);
				dbFiche.setCrudRecordVisible(false);
				dbFiche.setCrudVisible(false);
				dbFiche.validateDebut();
				break;
			case FICHE:
				dbFicheNoBorder();
				dbFiche.setFicheLibelle();
				dbFiche.validateDebut();
				break;
			case FICHEDETAIL:
				dbFiche.load(Sql.t_LoadAllField);
				dbFiche.validateDebut();
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {
						dbFiche.initFocus();
					}
				});
				break;
		}
	}
	private void addTitre(){
		// PLACE LE TITRE
		if (vue==Vue.F3||vue==Vue.FICHEDETAIL){
			jbCloseClear=new JTextButton("x",KeyEvent.VK_F10);{
				jbCloseClear.setNoBorder(true);
				jbCloseClear.setForeground(Color.GRAY);
				jbCloseClear.setColor();
				jbCloseClear.setFont(Gp.FONTTEXT12);
				jbCloseClear.addActionListener(this);
			}
			this.add(jpTitre,Gp.getGbcTitre());
			if (Gp.TITLE){
				JPanel jpCloseClear= new JPanel(new BorderLayout(0,0));{
					jpCloseClear.add(jbCloseClear,BorderLayout.EAST);
					jpCloseClear.setOpaque(false);
					jpCloseClear.setFocusable(false);

				}
				jpTitre.add(jpCloseClear,BorderLayout.NORTH);
			} else {
				Gp.getGbcTitre();
				Gp.setFill(GridBagConstraints.NONE);
				Gp.gbc.anchor=GridBagConstraints.NORTHEAST;
				this.add(jbCloseClear,Gp.gbc);
			}
		}
	}
	private void addListe(){
		// PLACE LA LISTE
		if (dbListe!=null){ 
			switch (vue){
				case F3DETAILHIDDEN:
				case F3DETAIL:
				case F3HIGHTDETAIL:
					setBorder(new TitledBorder(null,"[ dtail : "+ sqlListe.t_table+" ]", TitledBorder.LEFT, TitledBorder.DEFAULT_POSITION));
					this.add(dbListe,Gp.getGbcListe());
					break;
				case F3POINTAGE:
					dbListe.jpPlus.setEnabled(false);
					dbListe.setHeaderSouth();
					dbListe.add(dbFiche.jpCrud,BorderLayout.WEST);
					dbListe.setBorder(BorderFactory.createEtchedBorder());
					this.add(dbListe,Gp.getGbcFiche());
					break;
				case F3: 
				case F2F3: 
				case F2:
				case F2RECHERCHER:
				case F2UNIQUE1:
				case F2UNIQUE2:
				default:
					this.add(dbListe,Gp.getGbcListe());
			}
		}
	}
	private void addFiche(){
		// PLACE LA FICHE
		if (dbFiche!=null){ 
			switch (vue){
				case FICHE:
					Gp.gbc.insets=new Insets(0,0,0,0);
					this.add(dbFiche,Gp.getGbcFiche());
					break;
				case F3POINTAGE:
					this.add(dbFiche,Gp.getGbcListe());
					break;
				case F3HIGHTDETAIL:
					Gp.getGbcFiche();
					Gp.gbc.anchor = GridBagConstraints.NORTHEAST;
					this.add(dbFiche,Gp.gbc);
					break;
				case F3DETAILHIDDEN:
				case F3DETAIL:
					Gp.getGbcFiche();
					Gp.gbc.anchor = GridBagConstraints.NORTHWEST;
					this.add(dbFiche,Gp.gbc);
					break;
				case FICHEDEA:
				case F3: 
				case F2F3: 
				case F2RECHERCHER:
				case FICHEDETAIL:
				default:
					this.add(dbFiche,Gp.getGbcFiche());
			}
			dbFiche.addPropertyChangeListener(UserUpdate.UPDATE,this);
		}
	}
	public void validateAdapteFiche() {}
	public void validateAdapteListe() {}
	public void validateAdapte() {}
	public void propertyChange(PropertyChangeEvent arg0) {
		userupdate.userUpdate();
	}
	public void setVisible(boolean enable){
		super.setVisible(enable);
		if (jpDetail!=null){
			jpDetail.setVisible(enable);
		}
	}
	//////////////////////
	// INTERFACE PUBLIC //
	//////////////////////
	public void dbFicheNoBorder(){
		dbFiche.setBorder(null);
		dbFiche.jpFiche.setBorder(null);
		dbFiche.jpDbE.setBorder(null);
		dbFiche.jpLibeText.setBorder(null);
	}
	public void addImprimer(){
		if (dbListe!=null){
			dbListe.setToolsVisible(true);{
				jbImprimer=new JTextButton("F5 Imprimer");{
					jbImprimer.setMnemonic('I');
					jbImprimer.addActionListener(this);
					jbImprimer.setImageIconPressed(sql.getImage(sql.getAppliParam().JBPRINT,true),true);
					dbListe.addOption(jbImprimer);
				}
			}
		}
	}
	public void addEnterLigne(FicheIEditableColumns ffe){
		switch (vue){
			case F3DETAIL:
			case F3DETAILHIDDEN:
			case F3HIGHTDETAIL:
			case F3:
			case F3POINTAGE:
			case F2RECHERCHER:
			case F2F3:
				this.ffe=ffe;
				jbEnterLigne=new JTextButton("EnterLigne");{
					jbEnterLigne.setMnemonic(13);
					jbEnterLigne.addActionListener(this);
				}
				break;
		}
	}
	public void addEscBascule(){
		if (jbEscBascule==null){
			jbEscBascule=new JTextButton("EscBascule");{
				jbEscBascule.setMnemonic(27);
				jbEscBascule.addActionListener(this);
			}
		}
	}
	public void setDefaultBasculeChild(boolean enable){
		defaultBasculeChild=enable;
	}
	public boolean getDefaultBasculeChild(){
		return defaultBasculeChild;
	}
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getSource()==jbEnterLigne){
			String nameField=null;
			Object value=null;
			if (jbEnterLigne.getClientProperty(Sql.FIELDENTER)!=null){
				nameField=(String) jbEnterLigne.getClientProperty(Sql.FIELDENTER);
				value=jbEnterLigne.getClientProperty(Sql.FIELDENTER+"VALUE");
			}
			enterLigne(nameField,value);
		} else if (arg0.getSource()==jbEscBascule){
			escBascule();
		} else if (arg0.getSource()==jbF3){
			if (sqlListe.taTwin!=null){
				if (sqlFiche.isModeMovable()){
					switch (vue){
						case F3DETAIL:
						case F3DETAILHIDDEN:
						case F3HIGHTDETAIL:
						case F2RECHERCHER:
							escBascule();
							break;
						case F2F3:
							basculeF2F3();
							break;
					}
				} else {
					notify("Chargement");
					sqlFiche.taThis.initFocus();
				}
			}
		} else if (arg0.getSource()==jbImprimer){
			if (!arg0.getActionCommand().contains(JTextButton.CLICK_RIGHT))
				impListe();
		} else if (arg0.getSource()==jbCloseClear){
			sql.removeDbVue(true);
		}
	}
	public void enterLigne(String nameField,Object value){
		if (vue==Vue.F3 || 
				vue==Vue.F3POINTAGE || 
				vue==Vue.F3DETAIL|| 
				vue==Vue.F3DETAILHIDDEN|| 
				vue==Vue.FICHEDETAIL|| 
				vue==Vue.F2RECHERCHER|| 
				vue==Vue.F3HIGHTDETAIL){
			if (ffe!=null){
				ffe.fireEditableColumnUpdate(nameField,value);
			}
		} else {
			if (vue==Vue.F2F3){
				userF2F3();
			}
		}
	}
	public void userEnterLigne(String nameField,Object value){
		dbListe.focusOnTwin();
		if (jbEnterLigne!=null){
			if (jbEnterLigne.isVisible()){
				jbEnterLigne.putClientProperty(Sql.FIELDENTER,nameField);
				jbEnterLigne.putClientProperty(Sql.FIELDENTER+"VALUE",value);
				jbEnterLigne.doClick();
			}
		}
	}
	public void userEscBascule(){
		if (jbEscBascule!=null)
			if (jbEscBascule.isVisible())
				jbEscBascule.doClick();
	}
	public void userF5Print() {
		if (jbImprimer!=null)
			if (jbImprimer.isVisible())
				jbImprimer.doClick();
	}
	public void userF10CloseClear() {
		if (jbCloseClear!=null)
			if (jbCloseClear.isVisible())
				jbCloseClear.doClick();
	}
	public void userF2F3() {
		if (jbF3!=null)
			if (jbF3.isVisible())
				jbF3.doClick();
	}
	///////////////////////////////////
	// METHODES DES INTERFACE PUBLIC //
	///////////////////////////////////
	private void basculeF2F3() {
		if (!dbFiche.isVisible()) { // MONTRE LA FICHE cache la liste
			dbListe.loadTwin(Sql.t_LoadAllField);
			dbListe.setVisible(false);
			dbListe.sb.add(jbF3,BorderLayout.SOUTH);
			dbListe.sb.setHeight((sqlFiche.datas.size()+3)*Gp.HEIGHTCHAR);
			dbFiche.add(dbListe.sb,BorderLayout.EAST);
			dbFiche.setVisible(true);
			dbFiche.initFocus();
		} else {					// MONTRE LA LISTE cache la fiche
			dbFiche.loadTwin(Sql.t_LoadAllField);
			dbFiche.setVisible(false);
			dbListe.sb.setHeight((sqlListe.t_nbLigne)*Gp.HEIGHTCHAR*sqlListe.t_height);
			dbListe.jpDetail.add(dbListe.sb,BorderLayout.EAST);
			dbListe.addOption(jbF3);
			dbListe.setVisible(true);
			dbListe.initFocus();
		}
		if (this.getClientProperty(JPopup.PACK).equals("pack")) {
			this.putClientProperty(JPopup.PACK, "repack");
		} else {
			this.putClientProperty(JPopup.PACK, "pack");
		}
	}
	///////////////////////////////
	// Echap sur SAISIE EN LIGNE //
	///////////////////////////////
	public void escBascule(){
		if(dbFiche.isVisible()){
			basculeVUEF3DETAILENTETE();
		}
	}
	public void userBasculeSL(){
		basculeVUEF3DETAILENTETE();
	}
	private void basculeVUEF3DETAILENTETE() {
		if (sqlFiche.isModeMovable() && vueParent.sqlFiche.isModeMovable()){
			if (!dbFiche.isVisible()) {
				// Parent ACTIF
				// Montre FICHE ENFANT & cache FICHE PARENT
				vueParent.dbFiche.beforeBasculeEnteteVersDetail();
				basculeEnteteVersDetail();
				vueParent.dbFiche.afterBasculeEnteteVersDetail();
			} else {					
				// Enfant ACTIF
				// Montre FICHE PARENT & cache FICHE ENFANT
				vueParent.dbFiche.beforeBasculeDetailVersEntete();
				basculeDetailVersEntete();
				vueParent.dbFiche.afterBasculeDetailVersEntete();
			}
		} else {
			notify("Chargement");
			sqlFiche.taThis.initFocus();
		}
	}
	private void basculeEnteteVersDetail() {
		// CACHE la fiche PARENT
		switch (vue){
			case F3DETAILHIDDEN:
				// cache la fiche parent complete 
				vueParent.dbListe.setVisible(false);
				vueParent.dbFiche.setEnabled(false);{
					vueParent.dbFiche.setCrudVisible(false);
				}
				dbListe.setVisible(true);
				break;
			case F3HIGHTDETAIL:
				// cache la fiche parent complete 
				vueParent.dbListe.setVisible(false);
				vueParent.dbFiche.setEnabled(false);{
					vueParent.dbFiche.setCrudVisible(false);
				}
				break;
			case F2RECHERCHER:
			case F3DETAIL:
				// cache la fiche parent rduite 
				vueParent.dbListe.setEnabled(false);
				vueParent.dbFiche.setEnabled(false);{
					vueParent.dbFiche.setCrudVisible(true);
					vueParent.dbFiche.setCrudEnabled(false);
				}
				break;
		}
		// cache les autres enfants
		for (int i=0;i<vueParent.dbFiche.jpCrud.bBascule.size();i++){
			AbstractVue f=vueParent.dbFiche.jpCrud.bBascule.get(i).getVue();
			if (f != dbFiche.vue){
				f.setVisible(false);
			} else {
				f.setVisible(true);
			}
		}
		// MONTRE LA FICHE ENFANT
		dbFiche.setVisible(true);
		if (dbFiche.sql.t_eof){
			//dbFiche.userAppend();
		} else {
			dbFiche.initFocus();
		}
	}
	private void basculeDetailVersEntete(){
		// MONTRE PARENT
		switch (vue){
			case F3DETAILHIDDEN:
				// Montre la fiche parent complete
				vueParent.dbFiche.setCrudVisible(true);
				vueParent.dbListe.setVisible(true);
				dbListe.setVisible(false);
				break;
			case F3HIGHTDETAIL:
				// Montre la fiche parent complete
				vueParent.dbFiche.setCrudVisible(true);
				vueParent.dbListe.setVisible(true);
				break;
			case F2RECHERCHER:
			case F3DETAIL:
				// Montre la fiche parent rduite
				vueParent.dbListe.setEnabled(true);
				break;
		}
		vueParent.dbFiche.setEnabled(true);
		vueParent.dbFiche.loadEAdapteGuiFiche();
		vueParent.dbFiche.updateContextualListener();
		// CACHE la fiche ENFANT
		dbFiche.setVisible(false);
		vueParent.dbListe.initFocus();
		// Retour sur la premire fentre par dfaut
		// cache les autres enfants rend la premiere fenetre visible
		AbstractVue basculeChild=null;
		AbstractVue firstBasculeChild=null;
		AbstractVue defaultBasculeChild=null;
		for (int i=0;i<vueParent.dbFiche.jpCrud.bBascule.size();i++){
			AbstractVue f=vueParent.dbFiche.jpCrud.bBascule.get(i).getVue();
			f.setVisible(false);
			if (i==0){
				firstBasculeChild=f;
			}
			if (defaultBasculeChild==null && f.getDefaultBasculeChild()) {
				defaultBasculeChild=f;
			}
			if (f == dbFiche.vue && f.getDefaultBasculeChild()){
				basculeChild=f;
			}
		}
		if (basculeChild!=null){
			basculeChild.setVisible(true);
		} else if (defaultBasculeChild!=null){
			defaultBasculeChild.setVisible(true);
		} else{
			firstBasculeChild.setVisible(true);
		}
	}	
	private void notify(String action){
		String titre="Attention "+action+" impossible !!!";
		String mess="La fiche : ["+sqlFiche.getCodeFiche()+"] du fichier : ["+sqlFiche.t_table+"] est encours de modification, Veuillez l'enregistrer";
		String[] option=new String []{"Je vrifie"};
		sqlFiche.notify(titre,mess,option,sql.getAppliParam().JBCANCEL,0);
	}
	/////////////////////
	// LES CODE BARRES //
	/////////////////////
	public boolean isCbEnable() { // Cb toujours on suivant la liste encours
		//  redfinir pour une  : Cb on ailleurs que dans la liste encours
		return true;
	}
	public void userCbSeek(String codeCb) { // Analyse du CB suivant la liste encours
		//  redfinir pour une  : Analyse du CB ailleurs que dans la liste encours
		sql.v_index=codeCb;
		if (isCb(codeCb)) {
			userCbOk(codeCb);
		} else {
			notifyCb(codeCb);
		}
	}
	public boolean isCb(String codeCb) { // Recherche dans la liste encours
		//  redfinir pour une  : Recherche ailleurs que dans la liste encours
		boolean ret=false;
		ret=dbListe.likeCb();
		return ret;
	}
	public void notifyCb(String codeCb) { // Notification pour la Recherche dans la liste encours
		//  redfinir pour une : Notification ailleurs que dans la liste encours
		String titre="Attention CODE BARRE impossible !!!";
		String mess="Le code barre : ["+codeCb+"] est introuvable";
		String[] option=new String []{"Je vrifie"};
		sql.notify(titre,mess,option,sql.getAppliParam().JBCANCEL,0);
	}
	public void userCbOk(String codeCb) { // Action suite CB ok, Charge la fiche depuis la liste encours
		//  redfinir pour une  : Action suiste CB ok,ailleurs que dans la liste encours
		dbFiche.load(codeCb);
		dbFiche.loadTwin(Sql.t_LoadAllField);
		dbFiche.initFocus();
	}
	public void setEditCb() {
		VueButtonCb fb=new VueButtonCb(this);
		dbFiche.userOptionAdd(fb);
	}

	//////////////////
	// LES EDITIONS //
	//////////////////
	private void impListe() {
		AbstractFieldsDef print=getFieldsDefPrint(Vue.PRINTLISTESPE0);
		if (print==null){ // pas d'dition spcifique reprends la liste cran
			print=getFieldsDefListe(Vue.F3);
			print.adapteRemoveInvisible();
		}
		print.adaptePrints(sqlListe);
		if (sqlFiche!=null){
			print.sql.clauseFilter=sqlFiche.clauseFilter; // Recupere le filtre de l'appelant
			print.sql.clauseGroupBy=sqlFiche.clauseGroupBy;
		} else {
			print.sql.clauseFilter=sqlListe.clauseFilter; // Recupere le filtre de l'appelant
			print.sql.clauseGroupBy=sqlListe.clauseGroupBy;
		}
		AbstractFieldsDef rupture=getFieldsDefRupture(Vue.PRINTLISTESPE0);
		if (rupture!=null){ // il n'y pas toujours de rupture sur une Impression
			rupture.adapteRuptures(sqlListe);
		}
		new JDialogPrint((Window) SwingUtilities.getRoot(this),this);
	}
	public String[] getImpEntete() {
		return getImpEnteteStandard();
	}
	private String[] getImpEnteteStandard() {
		String [] ret=null;
		AbstractDefaultParam appliParam=sqlListe.getAppliParam();
		ret=new String[9];
		// nom du logiciel
		ret[JPEntete.APPLI]=appliParam.TITRE_APPLI;
		// Titre de la liste
		ret[JPEntete.TITRE]=sqlListe.getOptionText();
		// Version du logiciel
		ret[JPEntete.VERSION]="Version "+appliParam.VERSION;
		// Date ddition
		ret[JPEntete.DATE]="";{
			Locale locale = Locale.getDefault(); 
			// Construction du DateFormat en choisiant un format : 
			// * SHORT = 01/01/2002 * FULL = lundi 1 janvier 2002 
			DateFormat dateFormat = DateFormat.getDateInstance(DateFormat.FULL, locale); 
			ret[JPEntete.DATE]="Edit le "+dateFormat.format(new Date());
		}
		// Edite  heure
		ret[JPEntete.HEURE]="";{
			DateFormat heureFormat = new SimpleDateFormat("hh'h'mm");
			ret[JPEntete.HEURE]="  "+heureFormat.format(new Date());
		}
		// Numero de page
		ret[JPEntete.PAGE]="Page n ";
		ret[JPEntete.IMP_BORNE]="true";
		ret[JPEntete.IMP_CADREENTETE]="true";
		ret[JPEntete.BORNEABORNE]=getEnteteBorneaBorne();
		return ret;
	}
	public void setEnteteBorneaBorne(String borneaborne) {
		enteteEditionBorne=borneaborne;
	}
	public String getEnteteBorneaBorne() {
		return enteteEditionBorne;
	}
	/////////////////
	// Vue DEA //
	/////////////////
	public AbstractVue getVueDEA(Sql sql,String t_seek, Vue vue) {
		return null;
	}
	////////////////////////////////
	public void setTraceDelay(boolean enable){
		traceDelay=enable;
	}
	//////////////////////////////
	// Lanceur par nom de class //
	//////////////////////////////
	public static AbstractVue getVue(AbstractVue avue,Vue vue){
		AbstractVue ret=null;
		String nomClasse=avue.getClass().getCanonicalName();
		ret=getVue(nomClasse,avue.sqlListe,"",vue);
		return ret;
	}
	public static AbstractVue getVue(String nomClasse,Sql sql,String t_seek,Vue vue){
		AbstractVue ret=null;
		Class<?> classe;
		Constructor<?> cons;
		try {
			classe = Class.forName(nomClasse);
			cons = classe.getConstructor(new Class[]{Sql.class,String.class,int.class});
			ret=(AbstractVue) cons.newInstance(new Object []{sql,t_seek,vue});} 
		catch (ClassNotFoundException e) {e.printStackTrace();}
		catch (SecurityException e) {e.printStackTrace();}
		catch (NoSuchMethodException e) {e.printStackTrace();}
		catch (IllegalArgumentException e) {e.printStackTrace();}
		catch (InstantiationException e) {e.printStackTrace();}
		catch (IllegalAccessException e) {e.printStackTrace();}
		catch (InvocationTargetException e) {e.printStackTrace();}
		return ret;
	}
	//////////////////////////////////////
	// Libration de la mmoire INTERNE //
	//////////////////////////////////////
	public void dispose(){
		if (dbFiche!=null){
			userupdate=null;
			dbFiche.removePropertyChangeListener(UserUpdate.UPDATE, this);
			dbFiche.vue=null;
			dbFiche.dispose();
			dbFiche=null;
		}
		if (sqlFiche!=null){
			sqlFiche.dispose();
			sqlFiche=null;
		}
		if (dbListe!=null){
			dbListe.vue=null;
			dbListe.dispose();
			dbListe=null;
		}
		if (sqlListe!=null){
			sqlListe.dispose();
			sqlListe=null;
		}
		if (fiche!=null){
			fiche.dispose();
			fiche=null;
		}
		if (liste!=null){
			liste.dispose();
			liste=null;
		}
		t_seek=null;
		c_opt2=null;
		c_opt3=null;
		ffe=null;
		vueParent=null;
		jbEscBascule=null;	
		jbEnterLigne=null;	
		jbF3=null;	
		jbImprimer=null;
		jbCloseClear=null;
		jpTitre=null;
		jlTitreDetail=null;
		jpDetail=null;
		sql=null;
	}
	protected void finalize() {
		//		Gp.af("finalize : "+this.getName());
		try {
			super.finalize();
		} catch (Throwable arg0) {
			arg0.printStackTrace();
		}
	}
}