package template_applicatif.wVue;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JPanel;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;

import persistance.wGlobalParam.Gp;
import a_doc.doc.Licence;

import composant_saisie.wComposant.JTextButton;
import composant_saisie.wComposant.JTextDb;
/**
<br>{@link A_doc}
 <br>{@link Licence}.
*/
public class VueButtonCb extends JPanel implements 
KeyListener, 
ActionListener, 
FocusListener, 
CaretListener  {
	private static final long serialVersionUID = 1L;
	private JTextDb jtxtseek=null;
	private String fieldSeek="";
	private AbstractVue vue=null;
	private JPanel jpseek=null;
	private JTextButton jbseek=null;
	public VueButtonCb(AbstractVue vue){
		this.vue=vue;
		this.setLayout(new BorderLayout(0,0));{
			jpseek= new JPanel();{
				jpseek.setLayout(new BorderLayout(0,0));
				jbseek=new JTextButton(" R "); {
					jbseek.setFocusable(false);
					jbseek.addActionListener(this);
					jbseek.setEnabled(false);
				}
				jtxtseek=new JTextDb(fieldSeek);{
					jtxtseek.addKeyListener(this);
					jtxtseek.addFocusListener(this);
					jtxtseek.addCaretListener(this);
					jtxtseek.setSuperText("Rechercher",0,JTextDb.RIGHT,JTextDb.CENTER,Gp.FILIGRANE_LGRAY);
				}
				jpseek.add(jbseek,BorderLayout.WEST);
				jpseek.add(jtxtseek,BorderLayout.CENTER);
			}
			add(jpseek,BorderLayout.CENTER);
		}
	}
	public void setVisible(boolean enable){
		super.setVisible(enable);
		if (!enable){
			jtxtseek.setText("");
			jbseek.setEnabled(false);
		}
	}
	public String getTextSeek(){
		return jtxtseek.getText();
	}
	public void setEnabled(boolean enable){
		super.setEnabled(enable);
		jpseek.setEnabled(enable);
		jbseek.setEnabled(enable);
		jtxtseek.setEditable(enable);
	}
	public void keyTyped(KeyEvent arg0) {}
	public void keyReleased(KeyEvent arg0) {}
	public void keyPressed(KeyEvent arg0) {
		if (vue.isEnabled()){
			switch (arg0.getKeyCode()) {
			case KeyEvent.VK_ESCAPE: vue.userEscBascule();arg0.consume(); break;
			case KeyEvent.VK_F2:
			case KeyEvent.VK_ENTER:
				if (jbseek.isEnabled()){
					executeSeek();
				}
				arg0.consume(); 
				break;
			case KeyEvent.VK_F3: vue.userF2F3();arg0.consume(); break;
			case KeyEvent.VK_F5: vue.userF5Print();arg0.consume(); break;
			default: break; }
		}
	}
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getSource()==jbseek){
			executeSeek();
		}
	}
	private void executeSeek(){
		if (vue.dbFiche.isMovable()){
			jbseek.setEnabled(false);
			vue.userCbSeek(jtxtseek.getText());
		}

	}
	public void focusGained(FocusEvent e) {
		if (vue.dbFiche!=null){
			if (vue.dbFiche.isMovable()){
				jbseek.setEnabled(true);
				if (vue.dbListe!=null){
					if (vue.dbListe.isMovable()){
						vue.dbListe.startWaitCodeCb();
					}
				}
			}
		}
	}
	public void focusLost(FocusEvent e) {
		if (vue.dbFiche!=null){
			if (vue.dbFiche.isMovable()){
				jbseek.setEnabled(false);
				if (vue.dbListe!=null){
					if (vue.dbListe.isMovable()){
						vue.dbListe.stopCb();
					}
				}
			}
		}
	}
	public void caretUpdate(CaretEvent e) {
		if (vue.dbFiche!=null){
			if (vue.dbFiche.isMovable()){
				jbseek.setEnabled(true);
			}
		}
	}
}
